(* ::Package:: *)

Clear[MonomialTupleIn];
MonomialTupleIn[p_,R_,T_]:=
Module[{one=Theorema`Computation`Language`DomainOperation$TM[R,1],minus=Theorema`Computation`Language`DomainOperation$TM[R,Theorema`Computation`Language`Minus$TM],vars,tmp,pnew},

Begin["Theorema`Computation`Knowledge`"];
vars=Map[ToExpression[#]&,{"x$TM","y$TM","z$TM"}];
End[];

tmp=Cases[p,Theorema`Computation`Language`Subscript$TM[First[vars],i_Integer?Positive]:>i,Infinity];
If[tmp=!={},
vars=Table[Theorema`Computation`Language`Subscript$TM[First[vars],i],{i,Max@@tmp}],

While[Length[vars]>1&&FreeQ[p,Last[vars]],
vars=Most[vars]
]
];
pnew=p/.{Theorema`Computation`Language`Plus$TM->Plus,Theorema`Computation`Language`Subtract$TM->Subtract,Theorema`Computation`Language`Minus$TM->Minus,Theorema`Computation`Language`Times$TM->Times,Theorema`Computation`Language`Power$TM->Power};
Apply[Theorema`Computation`Language`Tuple$TM,CoefficientRules[pnew,vars]/.{Rule[{exp___},1]:>Theorema`Computation`Language`Tuple$TM[one,ParseExpTuple[exp,T]],
Rule[{exp___},-1]:>Theorema`Computation`Language`Tuple$TM[minus[one],ParseExpTuple[exp,T]],
Rule[{exp___},coeff_?Negative]:>Theorema`Computation`Language`Tuple$TM[minus[-coeff],ParseExpTuple[exp,T]],Rule[{exp___},coeff_]:>Theorema`Computation`Language`Tuple$TM[coeff,ParseExpTuple[exp,T]]}]
]


Clear[ParseExpTuple];
ParseExpTuple[exp___,T_]:=Theorema`Computation`Language`DomainOperation$TM[T,Theorema`Computation`Language`Get$TM][Theorema`Computation`Language`Tuple$TM[exp]]


Clear[SortMonomials];
SortMonomials[p_,rel_]:=Sort[p,(rel[Last[#1],Last[#2]]=!=False)&]


Clear[MonomialTupleOut];
MonomialTupleOut[p:Theorema`Computation`Language`Tuple$TM[___Theorema`Computation`Language`Tuple$TM],R_,T_]:=
With[{f=Theorema`Computation`Language`DomainOperation$TM[R,Theorema`Computation`Language`Put$TM]},
Module[{c0},
Replace[p,
h_[c_,e_]:>(
c0=f[c];
If[Head[c0]===f,c0=c];
h[c0,Theorema`Computation`Language`DomainOperation$TM[T,Theorema`Computation`Language`Put$TM][e]]
),
{1}
]
]
]


Clear[PrintPoly];
PrintPoly[Theorema`Computation`Language`Tuple$TM[]]:=0;
PrintPoly[p:Theorema`Computation`Language`Tuple$TM[Theorema`Computation`Language`Tuple$TM[_,exp_Theorema`Computation`Language`Tuple$TM],___Theorema`Computation`Language`Tuple$TM]]:=
With[{vars=If[Length[exp]<=3,
Take[{Theorema`Computation`Knowledge`x$TM,Theorema`Computation`Knowledge`y$TM,Theorema`Computation`Knowledge`z$TM},Length[exp]],
Table[Theorema`Computation`Language`Subscript$TM[Theorema`Computation`Knowledge`x$TM,i],{i,Length[exp]}]
]},
FromCoefficientRules[Replace[List@@p,_[c_,e_]:>(List@@e->c),{1}],vars]
]
