(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    919225,      24795]
NotebookOptionsPosition[    696804,      18800]
NotebookOutlinePosition[    856905,      22896]
CellTagsIndexPosition[    843764,      22545]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Algebraic Structures", "Title",
 CellChangeTimes->{{3.6554447174400597`*^9, 3.65544472294687*^9}},
 CellID->173563151],

Cell[CellGroupData[{

Cell["Preliminaries", "Section",
 CellChangeTimes->{{3.6443084245106*^9, 3.644308427083333*^9}},
 CellID->909929215],

Cell[CellGroupData[{

Cell["Theory Packages", "Subsection",
 CellChangeTimes->{{3.6561555717939477`*^9, 3.6561555751539526`*^9}},
 CellID->828602142],

Cell[BoxData[
 RowBox[{"$PackageDirectory", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
    "$RootDirectory", ",", "\"\<scratch\>\"", ",", "\"\<amaletzk\>\"", ",", 
     "\"\<Theorema Environment Data\>\""}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.666438783233775*^9, 3.666438821083324*^9}},
 CellID->498486718],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{"$PackageDirectory", ",", "\"\<LogicSets.m\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6596909836667333`*^9, 3.659690986537138*^9}, {
   3.659692225270114*^9, 3.6596922518993607`*^9}, {3.66643754706277*^9, 
   3.666437569799799*^9}, 3.666441140581069*^9},
 CellID->180362266],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6596909836667333`*^9, 3.659690986537138*^9}},
 CellID->57378981],

Cell[BoxData[
 RowBox[{"MakeTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.655457890052187*^9, 3.655457894123794*^9}},
 CellID->785761565],

Cell[BoxData[
 RowBox[{"UpdateTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.656222250540783*^9, 3.6562222536763887`*^9}},
 CellID->54631318],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DeleteCases", "[", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Quiet", "[", 
       RowBox[{"Check", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"s", "=", 
              RowBox[{"\"\<VAR$\>\"", "<>", "#", "<>", "\"\<$TM\>\""}]}], 
             "}"}], ",", 
            RowBox[{"Context", "[", "s", "]"}]}], "]"}], ";", "#"}], ",", 
         "Null"}], "]"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<A\>\"", ",", "\"\<B\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", 
       "\"\<X\>\"", ",", "\"\<Y\>\"", ",", "\"\<x\>\"", ",", "\"\<y\>\"", 
       ",", "\"\<i\>\"", ",", "\"\<j\>\"", ",", "\"\<\[ScriptCapitalD]\>\"", 
       ",", "\"\<\[Tilde]\>\"", ",", "\"\<\[Succeeds]\>\"", ",", 
       "\"\<\[SucceedsEqual]\>\""}], "}"}]}], "]"}], ",", "Null"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6592618519471025`*^9, 3.6592618631011224`*^9}, {
   3.659681175379635*^9, 3.659681185706853*^9}, 3.659683710620489*^9, 
   3.65968441725893*^9, 3.6597695015379353`*^9, {3.6597698034056654`*^9, 
   3.659769808569275*^9}, {3.6597702854721127`*^9, 3.659770290573322*^9}, {
   3.659848272310069*^9, 3.6598483467534*^9}, {3.6598515848824887`*^9, 
   3.6598516763142495`*^9}, {3.6598555136659927`*^9, 3.659855522090008*^9}, {
   3.6598559051642804`*^9, 3.659855919516306*^9}, {3.6602862205309095`*^9, 
   3.6602862222781124`*^9}, {3.660479643354128*^9, 3.660479646380533*^9}, {
   3.6610852858377895`*^9, 3.661085316413843*^9}, {3.6611649137697763`*^9, 
   3.66116493893362*^9}},
 CellID->20666029],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.6611649045175595`*^9, 3.661164940134822*^9}, {
   3.66229363854315*^9, 3.662293660149188*^9}, 3.6622936954530497`*^9, 
   3.6661748161133666`*^9},
 CellID->14529609]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Theory Analysis", "Subsection",
 CellChangeTimes->{{3.640668830437483*^9, 3.640668834318727*^9}},
 CellID->1386333768],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AnalyzeProofs", "[", "\"\<Theory\>\"", "]"}], "//", 
  "Timing"}]], "Input",
 CellChangeTimes->{{3.653223166066796*^9, 3.653223174615611*^9}, {
  3.6567561163310337`*^9, 3.656756118109437*^9}},
 CellID->239327779],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\AlgebraicStructures\\\" (\"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\AlgebraicStructures\" (", 1, " of ", "15", 
   "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596896883546286`*^9},
 CellID->675811602],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"22\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "22"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596896883546286`*^9},
 CellID->79509725],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\ConsistencyChecker\\\" (\"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\ConsistencyChecker\" (", 2, " of ", "15", 
   "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596896896026306`*^9},
 CellID->522072974],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Fields\\\" (\"\>", "\[InvisibleSpace]", 
   "3", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Fields\" (", 3, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689689633831*^9},
 CellID->201239835],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"36\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "36"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689689633831*^9},
 CellID->222985925],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Functors\\\" (\"\>", 
   "\[InvisibleSpace]", "4", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Functors\" (", 4, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689693299837*^9},
 CellID->800478382],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"34\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "34"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689693299837*^9},
 CellID->337608848],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\GroebnerRings\\\" (\"\>", 
   "\[InvisibleSpace]", "5", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\GroebnerRings\" (", 5, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596896961858425`*^9},
 CellID->630016544],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596896962170424`*^9},
 CellID->19423090],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897010842505`*^9},
 CellID->220008244],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897061230597`*^9},
 CellID->1201160],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689711364669*^9},
 CellID->16643814],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\IntegerQuotientRings\\\" (\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\IntegerQuotientRings\" (", 6, " of ", "15", 
   "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897125814714`*^9},
 CellID->612971699],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"78\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "78"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897125814714`*^9},
 CellID->7225627],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"78\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "78"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689716060277*^9},
 CellID->187436836],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Integers\\\" (\"\>", 
   "\[InvisibleSpace]", "7", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Integers\" (", 7, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689718181881*^9},
 CellID->59997816],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"85\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "85"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689718197481*^9},
 CellID->99966685],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"85\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "85"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897208650856`*^9},
 CellID->470072192],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\LogicSets\\\" (\"\>", 
   "\[InvisibleSpace]", "8", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\LogicSets\" (", 8, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897230646896`*^9},
 CellID->510733725],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897230646896`*^9},
 CellID->599346340],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689727292297*^9},
 CellID->170249141],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897319723053`*^9},
 CellID->408398655],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897366835136`*^9},
 CellID->240495407],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\NatIntExtended\\\" (\"\>", 
   "\[InvisibleSpace]", "9", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\NatIntExtended\" (", 9, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689737650715*^9},
 CellID->253536170],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"213\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "213"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897376819153`*^9},
 CellID->8538301],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"213\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "213"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897407395205`*^9},
 CellID->431449],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"213\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "213"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689743360325*^9},
 CellID->58007217],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"213\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "213"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897457471294`*^9},
 CellID->564947619],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"213\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "213"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897482587337`*^9},
 CellID->723022560],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\NatInt\\\" (\"\>", "\[InvisibleSpace]", 
   "10", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\NatInt\" (", 10, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897491947355`*^9},
 CellID->26770741],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"263\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "263"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689749225936*^9},
 CellID->34657406],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"263\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "263"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689752891942*^9},
 CellID->123896030],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"263\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "263"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897567139482`*^9},
 CellID->6440802],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"263\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "263"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897595999537`*^9},
 CellID->61871100],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"263\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "263"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689762127158*^9},
 CellID->531530781],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"263\"\>"}],
  SequenceForm["Reading proof ", 251, " of ", "263"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897632659597`*^9},
 CellID->749219828],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Polynomials\\\" (\"\>", 
   "\[InvisibleSpace]", "11", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Polynomials\" (", 11, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689763655961*^9},
 CellID->147941656],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689763671561*^9},
 CellID->648778583],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897677743683`*^9},
 CellID->1821045],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897720019755`*^9},
 CellID->209911035],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897763387833`*^9},
 CellID->122718590],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897801607895`*^9},
 CellID->55361129],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 251, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689784934398*^9},
 CellID->317108560],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 301, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897889436054`*^9},
 CellID->316505062],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\PolyTuples\\\" (\"\>", 
   "\[InvisibleSpace]", "12", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\PolyTuples\" (", 12, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897920168104`*^9},
 CellID->102482428],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897920168104`*^9},
 CellID->70100077],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596897947468157`*^9},
 CellID->764474994],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689797592021*^9},
 CellID->629138211],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689800056825*^9},
 CellID->111615212],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\ReductionRings\\\" (\"\>", 
   "\[InvisibleSpace]", "13", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\ReductionRings\" (", 13, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898008992267`*^9},
 CellID->299154259],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"250\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "250"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898009148264`*^9},
 CellID->121596178],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"250\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "250"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689804830434*^9},
 CellID->487528727],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"250\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "250"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898094792414`*^9},
 CellID->607774757],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"250\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "250"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898139564495`*^9},
 CellID->470489976],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"250\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "250"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689818745658*^9},
 CellID->47826169],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Sequences\\\" (\"\>", 
   "\[InvisibleSpace]", "14", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Sequences\" (", 14, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898236752663`*^9},
 CellID->34963455],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"48\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "48"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898236752663`*^9},
 CellID->649778663],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Tuples\\\" (\"\>", "\[InvisibleSpace]", 
   "15", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"15\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Tuples\" (", 15, " of ", "15", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898261712713`*^9},
 CellID->236951908],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"226\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "226"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689826186871*^9},
 CellID->248324543],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"226\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "226"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898285268755`*^9},
 CellID->89425482],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"226\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "226"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689830476878*^9},
 CellID->663403756],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"226\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "226"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689832473682*^9},
 CellID->35064204],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"226\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "226"],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898344704857`*^9},
 CellID->263127733],

Cell[BoxData["\<\"Creating forward rules:\"\>"], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898355624876`*^9},
 CellID->141704853],

Cell[BoxData["\<\"Preparing ...\"\>"], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898356872873`*^9},
 CellID->421689454],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689836326889*^9},
 CellID->16588],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 51, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689837918092*^9},
 CellID->303884149],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 101, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898395248947`*^9},
 CellID->134335790],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 151, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689841131697*^9},
 CellID->97740866],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 201, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898427541*^9},
 CellID->146139724],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 251, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898443453026`*^9},
 CellID->602362103],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 301, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689845905306*^9},
 CellID->422351253],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 351, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898474809084`*^9},
 CellID->230658552],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 401, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689849040911*^9},
 CellID->759903990],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 451, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689850632114*^9},
 CellID->118685951],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 501, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898521765165`*^9},
 CellID->486145549],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 551, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689853752119*^9},
 CellID->616382],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 601, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898553121223`*^9},
 CellID->843901497],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 651, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689856903325*^9},
 CellID->39274502],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 701, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689858510128*^9},
 CellID->13609283],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 751, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898601169305`*^9},
 CellID->32070279],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 801, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898617237334`*^9},
 CellID->239070082],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 851, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689863314936*^9},
 CellID->96931380],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "901", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 901, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689864921739*^9},
 CellID->140507640],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "951", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 951, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689866512942*^9},
 CellID->389183784],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1001", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1001, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689868088545*^9},
 CellID->652233815],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1051", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1051, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898696797476`*^9},
 CellID->282428911],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1101, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898712865505`*^9},
 CellID->20278982],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1151, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898728777533`*^9},
 CellID->372699181],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1201, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898744845557`*^9},
 CellID->692254989],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1251, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898760601587`*^9},
 CellID->16225313],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1301, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689877620161*^9},
 CellID->178227539],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1351, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898791801643`*^9},
 CellID->591646398],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1401, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898807401667`*^9},
 CellID->97378915],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1451, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898823469696`*^9},
 CellID->260322238],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1501, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898839381723`*^9},
 CellID->24803197],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1551, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689885529375*^9},
 CellID->949033729],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1601, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689887151778*^9},
 CellID->81124757],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1651, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689888742981*^9},
 CellID->44286772],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1701, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689890349784*^9},
 CellID->123195102],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1751, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898919565864`*^9},
 CellID->602021076],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1801, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689893547789*^9},
 CellID->56469942],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1851, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689895154592*^9},
 CellID->156796526],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1901", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1901, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689896745795*^9},
 CellID->266910185],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1951", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 1951, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898983525977`*^9},
 CellID->468673391],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2001", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2001, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596898999438004`*^9},
 CellID->40679448],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2051", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2051, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899015038033`*^9},
 CellID->54792237],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2101, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689903079406*^9},
 CellID->37085458],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2151, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689904655009*^9},
 CellID->81818704],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2201, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899062164125`*^9},
 CellID->10497171],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2251, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689907760815*^9},
 CellID->531981504],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2301, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899093052177`*^9},
 CellID->121578252],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2351, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689910849621*^9},
 CellID->239239070],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2401, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689912394023*^9},
 CellID->172679960],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2451, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689913954026*^9},
 CellID->611180130],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2501, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899155140285`*^9},
 CellID->36395113],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2551, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899171052313`*^9},
 CellID->6385849],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2601, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899186652346`*^9},
 CellID->58225509],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2651, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689920225237*^9},
 CellID->350442629],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2701, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899217852397`*^9},
 CellID->76170729],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2751, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899233608427`*^9},
 CellID->14078072],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2801, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689924920845*^9},
 CellID->396449331],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2851, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899264808483`*^9},
 CellID->127359093],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2901", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2901, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899280408506`*^9},
 CellID->1065408],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2951", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 2951, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689929600854*^9},
 CellID->198416535],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3001", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3001, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899311764565`*^9},
 CellID->385631299],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3051", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3051, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689932752059*^9},
 CellID->28800138],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3101, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689934312062*^9},
 CellID->302411191],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3151, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899358720646`*^9},
 CellID->44418373],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3201, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689937432067*^9},
 CellID->668206816],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3251, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.65968993903887*^9},
 CellID->42782857],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3301, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899406300726`*^9},
 CellID->514314070],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "3351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "3383"}],
  SequenceForm["Creating rule ", 3351, " of ", 3383],
  Editable->False]], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899422212753`*^9},
 CellID->347480091],

Cell[BoxData["\<\"Creating thinned data ...\"\>"], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.6596899432508774`*^9},
 CellID->205399375],

Cell[BoxData["\<\"Done\"\>"], "Print",
 CellChangeTimes->{3.653223175192812*^9, 3.653285213704706*^9, 
  3.6532955109545946`*^9, 3.653299279787828*^9, 3.653371830591877*^9, 
  3.6533777033145094`*^9, 3.6536251589909925`*^9, 3.6536337591091733`*^9, 
  3.653638650640164*^9, 3.653712017263381*^9, 3.6537189252935224`*^9, 
  3.6537273943079133`*^9, 3.6537296865715427`*^9, 3.655022774882429*^9, 
  3.6550381477435865`*^9, 3.6552733504079165`*^9, 3.6567561251606493`*^9, 
  3.659689943360078*^9},
 CellID->353975439]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "160.24422720000001163498382084071636199951`8.225382306288928", ",", 
   "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.65675630158136*^9, 3.659689943375678*^9},
 CellID->20144941]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComputeFormulaPositions", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.644649344001361*^9, 3.6446493476777363`*^9}},
 CellID->2077551358],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckIntegrity", "[", 
  RowBox[{"\"\<CheckPositions\>\"", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"CurrentValue", "[", "\"\<NotebookDirectory\>\"", "]"}], ",", 
       RowBox[{"CurrentValue", "[", "\"\<NotebookFileName\>\"", "]"}]}], 
      "}"}], "]"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64067003109768*^9, 3.6406700374311132`*^9}, {
   3.6406797903560762`*^9, 3.640679792950843*^9}, 3.6442220291527653`*^9},
 CellID->1909803754],

Cell[BoxData[
 RowBox[{"CheckIntegrity", "[", 
  RowBox[{"\<\"CheckPositions\"\>", "\[Rule]", 
   RowBox[{
   "{", "\<\"/home/amaletzk/Theorema Notebooks/ElementaryTheories.nb\"\>", 
    "}"}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.640670040858255*^9, 3.640670099679185*^9, 3.640670397721546*^9, 
   3.640679793300535*^9, 3.6406798406436234`*^9, 3.640679891162312*^9, 
   3.640679971009297*^9, 3.64068009182163*^9, 3.640680173340745*^9, 
   3.641037395456129*^9, 3.641116403388618*^9, 3.641286881014108*^9, 
   3.642225466578094*^9, 3.642234672070362*^9, 3.642240151894621*^9, 
   3.6423063269273643`*^9, {3.642308832539488*^9, 3.642308857563932*^9}, 
   3.642321396697977*^9, 3.6423285030212173`*^9, 3.642493582768566*^9, 
   3.642763270724422*^9, 3.642834604308413*^9, 3.643428832901271*^9, 
   3.6434441292624083`*^9, 3.643532851309215*^9, 3.6507065133125153`*^9},
 CellID->1365249879]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ps", "=", 
   RowBox[{"GetProofSize", "[", "All", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ps0", "=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Most", "[", 
       RowBox[{"Last", "[", "#", "]"}], "]"}], "]"}], "&"}], ",", "ps"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.647156479700988*^9, 3.647156479817154*^9}, {
   3.647156560839411*^9, 3.6471566309015427`*^9}, 3.6471570742150927`*^9, 
   3.6471571422253036`*^9, {3.647157728211722*^9, 3.647157728406296*^9}},
 CellID->1780799392],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Last", "::", "normal"}], "MessageName"], ":", 
  " ", "\<\"Nonatomic expression expected at position \[NoBreak]\\!\\(1\\)\
\[NoBreak] in \[NoBreak]\\!\\(Last[All]\\)\[NoBreak]. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/normal\\\", ButtonNote -> \
\\\"Last::normal\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.650706513474449*^9},
 CellID->181219027],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Last", "::", "argx"}], "MessageName"], ":", 
  " ", "\<\"\[NoBreak]\\!\\(Last\\)\[NoBreak] called with \
\[NoBreak]\\!\\(0\\)\[NoBreak] arguments; 1 argument is expected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/argx\\\", \
ButtonNote -> \\\"Last::argx\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.650706513532194*^9},
 CellID->1779137777],

Cell[BoxData[
 RowBox[{"GetProofSize", "[", "0", "]"}]], "Output",
 CellChangeTimes->{3.647157143952668*^9, 3.65070651353832*^9},
 CellID->1862161014]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{
   RowBox[{"NotebookGet", "[", "]"}], ",", 
   RowBox[{"Cell", "[", 
    RowBox[{"_", ",", "\"\<FormalTextInputFormula\>\"", ",", "___"}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6550382930110416`*^9, 3.655038363616766*^9}, {
   3.655442032762142*^9, 3.6554420535101786`*^9}, {3.6554447558181276`*^9, 
   3.6554447675961485`*^9}, {3.6554448230698457`*^9, 3.6554448240058475`*^9}, 
   3.6554448947217717`*^9},
 CellID->63220416],

Cell[BoxData["55"], "Output",
 CellChangeTimes->{3.6554448151294317`*^9},
 CellID->199537062]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Auxiliary Functions", "Subsection",
 CellChangeTimes->{{3.640668579267561*^9, 3.640668583347287*^9}},
 CellID->1454182661],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "LoadPackage", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadPackage", "[", "name_String", "]"}], ":=", 
   RowBox[{"LoadPackage", "[", 
    RowBox[{"{", "name", "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadPackage", "[", 
    RowBox[{"l", ":", 
     RowBox[{"{", "___String", "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Get", "[", 
       RowBox[{"FileNameJoin", "[", 
        RowBox[{"{", 
         RowBox[{"$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
          RowBox[{"#", "<>", "\"\<.m\>\""}]}], "}"}], "]"}], "]"}], "&"}], 
     ",", "l"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.640668603629292*^9, 3.640668727460284*^9}, 
   3.641286816086794*^9, 3.6434459961973133`*^9, {3.653223148703965*^9, 
   3.653223155365177*^9}, {3.666437381058186*^9, 3.666437421759533*^9}, 
   3.666437489129919*^9, {3.666437532226098*^9, 3.666437534185232*^9}, {
   3.666437720082859*^9, 3.6664377246344433`*^9}},
 CellID->2074904605],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "FindFormula", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindFormula", "[", "label_String", "]"}], ":=", 
   RowBox[{"NotebookLocate", "[", "label", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.640677756847624*^9, 3.6406777896243896`*^9}, 
   3.640677822869519*^9, {3.640677854902379*^9, 3.6406778579321823`*^9}},
 CellID->1980565193],

Cell[BoxData[
 RowBox[{"LoadPackage", "[", "\"\<ProofPalette\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.640668742006607*^9, 3.640668751417616*^9}},
 CellID->444074165],

Cell[BoxData[
 RowBox[{"LoadPackage", "[", "\"\<TheoryTools/TheoryTools\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.640668759133181*^9, 3.640668768089197*^9}, {
   3.6551873799276342`*^9, 3.655187380848036*^9}, {3.658204439228919*^9, 
   3.6582044425517244`*^9}, 3.666437430206933*^9},
 CellID->584704106]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
General Notions Related to Algebraic Structures (\[Checkmark])\
\>", "Section",
 CellChangeTimes->{{3.633080529393621*^9, 3.633080532689378*^9}, 
   3.633081523236761*^9, {3.6567588020861936`*^9, 3.6567588059862003`*^9}},
 CellID->1317521387],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "\[ScriptCapitalD]"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 809516830}]]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.633080719742045*^9, 3.6330807219446993`*^9}},
 CellTags->{
  "ID:809516830", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->809516830],

Cell[CellGroupData[{

Cell["Binary Relations (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.633080550664671*^9, 3.6330805532121487`*^9}, {
  3.63308152581081*^9, 3.633081528859519*^9}, {3.656758794769781*^9, 
  3.656758799356189*^9}, {3.6610815484084234`*^9, 3.6610815491104245`*^9}},
 CellID->911082209],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.6330815330902557`*^9, 3.6330815347100277`*^9}},
 CellID->800212037],

Cell["", "OpenEnvironment",
 CellID->1485541847],

Cell[CellGroupData[{

Cell["Definition: Properties of Binary Relations", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.633080559252157*^9, 3.6330805625751257`*^9}, {
  3.661082715982876*^9, 3.6610827235020885`*^9}},
 CellID->869661363],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"A", ",", "a", ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[SquareUnion]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[SmallCircle]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[Succeeds]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[SucceedsEqual]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[PrecedesEqual]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[LongRightArrow]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[Tilde]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 105808432}]]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590831022681083*^9, 3.590831052724744*^9}, {
   3.590831123270398*^9, 3.590831123528999*^9}, {3.590831396835937*^9, 
   3.590831397946486*^9}, {3.607771865681761*^9, 3.607771880773784*^9}, {
   3.608522326963874*^9, 3.608522329139662*^9}, {3.608522572306039*^9, 
   3.608522577296925*^9}, {3.610177443390703*^9, 3.610177446029519*^9}, {
   3.610177547457916*^9, 3.610177554601865*^9}, {3.610177807358287*^9, 
   3.610177817102903*^9}, {3.610177974762082*^9, 3.610177976069252*^9}, 
   3.6330782849363127`*^9, 3.633080649181746*^9, {3.63308073828061*^9, 
   3.633080746743181*^9}, {3.633080862846278*^9, 3.6330808992376823`*^9}, {
   3.6330809650666924`*^9, 3.6330810054078007`*^9}, {3.633082031308105*^9, 
   3.633082042318692*^9}, {3.6610815849436874`*^9, 3.6610815899512963`*^9}, {
   3.661081651399804*^9, 3.6610816851008635`*^9}},
 CellTags->{
  "ID:105808432", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->105808432],

Cell[BoxData[
 RowBox[{
  RowBox[{"isReflexive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SucceedsEqual]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "x", "]"}]}]], 
    RowBox[{"x", "\[SucceedsEqual]", "x"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isReflexive)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:614230936", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477504940464373`*^9, 3.6477505336593723`*^9}},
 CellTags->{
  "ID:614230936", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive"},
 CellID->614230936],

Cell[BoxData[
 RowBox[{
  RowBox[{"isAntisymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SucceedsEqual]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"x", "\[SucceedsEqual]", "y"}], "\[And]", 
        RowBox[{"y", "\[SucceedsEqual]", "x"}]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[Implies]", 
      RowBox[{"x", "\[Equal]", "y"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isAntisymmetric)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1177932670", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477508336431637`*^9, 3.647750869413816*^9}},
 CellTags->{
  "ID:1177932670", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAntisymmetric"},
 CellID->1177932670],

Cell[BoxData[
 RowBox[{
  RowBox[{"isIrreflexive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "x", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[Not]", 
      RowBox[{"x", "\[Succeeds]", "x"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isIrreflexive)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:932142776", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647750776872764*^9, 3.647750793798686*^9}},
 CellTags->{
  "ID:932142776", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isIrreflexive"},
 CellID->932142776],

Cell[BoxData[
 RowBox[{
  RowBox[{"isSymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", "\[Tilde]", "y"}], "\[Implies]", 
      RowBox[{"y", "\[Tilde]", "x"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isSymmetric)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:35541847", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661081565802454*^9, 3.661081605254923*^9}, {
  3.6610816567194138`*^9, 3.661081691000476*^9}},
 CellTags->{
  "ID:35541847", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isSymmetric"},
 CellID->35541847],

Cell[BoxData[
 RowBox[{
  RowBox[{"isAsymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", "\[Succeeds]", "y"}], "\[Implies]", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"\[Not]", 
        RowBox[{"y", "\[Succeeds]", "x"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isAsymmetric)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:291399428", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477505497169533`*^9, 3.647750602162867*^9}, {
  3.647750763772173*^9, 3.647750764950529*^9}},
 CellTags->{
  "ID:291399428", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAsymmetric"},
 CellID->291399428],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTransitive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SucceedsEqual]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y", ",", "z"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"x", "\[SucceedsEqual]", "y"}], "\[And]", 
        RowBox[{"y", "\[SucceedsEqual]", "z"}]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[Implies]", 
      RowBox[{"x", "\[SucceedsEqual]", "z"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTransitive)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:535380192", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647750898357493*^9, 3.6477509311957207`*^9}},
 CellTags->{
  "ID:535380192", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTransitive"},
 CellID->535380192],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalRelation", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", "\[Succeeds]", "y"}], "\[Or]", 
      RowBox[{"y", "\[Succeeds]", "x"}], "\[Or]", 
      RowBox[{"x", "\[Equal]", "y"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTotalRelation)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2054329379", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647924126132594*^9, 3.647924156379328*^9}, {
  3.647924205862419*^9, 3.647924207283004*^9}},
 CellTags->{
  "ID:2054329379", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalRelation"},
 CellID->2054329379],

Cell[BoxData[
 RowBox[{
  RowBox[{"isEquivalence", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y"}], "]"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{"x", "\[Tilde]", "x"}]},
         {
          RowBox[{
           RowBox[{"x", "\[Tilde]", "y"}], "\[Implies]", 
           RowBox[{"y", "\[Tilde]", "x"}]}]},
         {
          RowBox[{
           UnderscriptBox["\[ForAll]", 
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", "z", 
             "]"}]], 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{
               RowBox[{"x", "\[Tilde]", "y"}], "\[And]", 
               RowBox[{"y", "\[Tilde]", "z"}]}], 
              TagBox[")",
               "AutoParentheses"]}], "\[Implies]", 
             RowBox[{"x", "\[Tilde]", "z"}]}], 
            TagBox[")",
             "AutoParentheses"]}]}]}
        }]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isEquivalence)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:150250031", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610817119981127`*^9, 3.6610817515705814`*^9}, 
   3.6610821772661295`*^9},
 CellTags->{
  "ID:150250031", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isEquivalence"},
 CellID->150250031],

Cell[BoxData[
 RowBox[{
  RowBox[{"isPartIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y"}], "]"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{
           RowBox[{"x", "\[Succeeds]", "y"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"x", "\[NotEqual]", "y"}], "\[And]", 
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{"\[Not]", 
               RowBox[{"y", "\[Succeeds]", "x"}]}], 
              TagBox[")",
               "AutoParentheses"]}]}], ")"}]}]},
         {
          RowBox[{
           UnderscriptBox["\[ForAll]", 
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", "z", 
             "]"}]], 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{
               RowBox[{"x", "\[Succeeds]", "y"}], "\[And]", 
               RowBox[{"y", "\[Succeeds]", "z"}]}], 
              TagBox[")",
               "AutoParentheses"]}], "\[Implies]", 
             RowBox[{"x", "\[Succeeds]", "z"}]}], 
            TagBox[")",
             "AutoParentheses"]}]}]}
        }]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isPartIrreflOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1500614048", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590916032483239*^9, 3.59091612304968*^9}, {
   3.590916171082609*^9, 3.590916307304572*^9}, {3.592026062275765*^9, 
   3.592026078973278*^9}, {3.594028794406487*^9, 3.594028797396138*^9}, {
   3.596183521312983*^9, 3.596183523154222*^9}, 3.596183594457536*^9, {
   3.596190292740657*^9, 3.59619031253683*^9}, {3.606126930215056*^9, 
   3.606126992911162*^9}, {3.60777184661299*^9, 3.607771857059872*^9}, {
   3.607771887645733*^9, 3.607771899559766*^9}, {3.608522582911981*^9, 
   3.608522589637906*^9}, {3.610177450777968*^9, 3.610177457344566*^9}, {
   3.631611267776626*^9, 3.631611284429188*^9}, {3.631868579316496*^9, 
   3.631868593114346*^9}, {3.633078328379526*^9, 3.633078335404241*^9}, 
   3.633081335706375*^9},
 CellTags->{
  "ID:1500614048", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartIrreflOrder"},
 CellID->1500614048],

Cell[BoxData[
 RowBox[{
  RowBox[{"isPartReflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SucceedsEqual]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y"}], "]"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{"x", "\[SucceedsEqual]", "x"}]},
         {
          RowBox[{
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{"x", "\[SucceedsEqual]", "y"}], "\[And]", 
             RowBox[{"y", "\[SucceedsEqual]", "x"}]}], 
            TagBox[")",
             "AutoParentheses"]}], "\[Implies]", 
           RowBox[{"x", "\[Equal]", "y"}]}]},
         {
          RowBox[{
           UnderscriptBox["\[ForAll]", 
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", "z", 
             "]"}]], 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{
               RowBox[{"x", "\[SucceedsEqual]", "y"}], "\[And]", 
               RowBox[{"y", "\[SucceedsEqual]", "z"}]}], 
              TagBox[")",
               "AutoParentheses"]}], "\[Implies]", 
             RowBox[{"x", "\[SucceedsEqual]", "z"}]}], 
            TagBox[")",
             "AutoParentheses"]}]}]}
        }]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isPartReflOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1317703026", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.633078942823514*^9, 3.633078946721051*^9}, {
   3.633078988563633*^9, 3.6330790128796883`*^9}, {3.633080750579837*^9, 
   3.633080764784307*^9}, 3.6330813609625273`*^9},
 CellTags->{
  "ID:1317703026", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartReflOrder"},
 CellID->1317703026],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y"}], "]"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{
           RowBox[{"x", "\[Succeeds]", "y"}], "\[Or]", 
           RowBox[{"y", "\[Succeeds]", "x"}], "\[Or]", 
           RowBox[{"x", "\[Equal]", "y"}]}]},
         {
          RowBox[{
           RowBox[{"x", "\[Succeeds]", "y"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"x", "\[NotEqual]", "y"}], "\[And]", 
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{"\[Not]", 
               RowBox[{"y", "\[Succeeds]", "x"}]}], 
              TagBox[")",
               "AutoParentheses"]}]}], ")"}]}]},
         {
          RowBox[{
           UnderscriptBox["\[ForAll]", 
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", "z", 
             "]"}]], 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{
               RowBox[{"x", "\[Succeeds]", "y"}], "\[And]", 
               RowBox[{"y", "\[Succeeds]", "z"}]}], 
              TagBox[")",
               "AutoParentheses"]}], "\[Implies]", 
             RowBox[{"x", "\[Succeeds]", "z"}]}], 
            TagBox[")",
             "AutoParentheses"]}]}]}
        }]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTotalIrreflOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2071876542", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.60777139007678*^9, 3.607771420669433*^9}, {
   3.607771464655224*^9, 3.607771478792577*^9}, {3.60777154508692*^9, 
   3.607771547967002*^9}, {3.607771902958738*^9, 3.607771919099018*^9}, {
   3.608522591333306*^9, 3.608522598753314*^9}, {3.610177468336824*^9, 
   3.61017747782416*^9}, {3.631592478204081*^9, 3.631592498544433*^9}, {
   3.631592806285677*^9, 3.631592830353983*^9}, {3.63159297668955*^9, 
   3.631593029675083*^9}, {3.633078338014131*^9, 3.633078342646039*^9}, 
   3.633081365063994*^9},
 CellTags->{
  "ID:2071876542", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalIrreflOrder"},
 CellID->2071876542],

Cell[BoxData[
 RowBox[{
  RowBox[{"isJoin", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SquareUnion]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[PrecedesEqual]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["let", 
       RowBox[{"J", "=", 
        RowBox[{"x", "\[SquareUnion]", "y"}]}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"\[And]", 
        RowBox[{"\[Piecewise]", GridBox[{
           {
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
             RowBox[{"[", "J", "]"}]}]},
           {
            RowBox[{"x", "\[PrecedesEqual]", "J"}]},
           {
            RowBox[{"y", "\[PrecedesEqual]", "J"}]},
           {
            RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               RowBox[{
                UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
                RowBox[{"[", "z", "]"}]}]], 
              RowBox[{
               RowBox[{"x", "\[PrecedesEqual]", "z"}], "\[And]", 
               RowBox[{"y", "\[PrecedesEqual]", "z"}]}]], 
             RowBox[{"J", "\[PrecedesEqual]", "z"}]}]}
          }]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isJoin)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2048777355", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.596195099357694*^9, 3.596195117685974*^9}, {
   3.596195188521171*^9, 3.596195201635451*^9}, {3.596195279040413*^9, 
   3.596195370735536*^9}, {3.596195520209559*^9, 3.59619554112528*^9}, {
   3.606127074368487*^9, 3.606127086723521*^9}, {3.607771941228213*^9, 
   3.607771956137511*^9}, {3.608522424621905*^9, 3.608522465958012*^9}, {
   3.60852260836613*^9, 3.608522627125649*^9}, 3.610177483746707*^9, {
   3.610177559750316*^9, 3.610177562213932*^9}, {3.633078351636891*^9, 
   3.633078375196109*^9}, {3.633080872380456*^9, 3.633080910434791*^9}, {
   3.63308097583329*^9, 3.633080984709807*^9}, 3.633081389861473*^9},
 CellTags->{
  "ID:2048777355", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isJoin"},
 CellID->2048777355],

Cell[BoxData[
 RowBox[{
  RowBox[{"isMin", "[", 
   RowBox[{"a", ",", "A", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}]}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"b", "\[Element]", "A"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[Not]", 
      RowBox[{"a", "\[Succeeds]", "b"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isMin)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1924210441", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6318569956601143`*^9, 3.631857077214486*^9}, {
  3.6330803298079042`*^9, 3.6330803377424517`*^9}, {3.633081078383915*^9, 
  3.633081090589649*^9}},
 CellTags->{
  "ID:1924210441", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isMin"},
 CellID->1924210441],

Cell[BoxData[
 RowBox[{
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "S", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"nonemptySet", "[", "S", "]"}], "\[Implies]", 
      RowBox[{
       UnderscriptBox["\[Exists]", 
        RowBox[{"s", "\[Element]", "S"}]], 
       RowBox[{"isMin", "[", 
        RowBox[{"s", ",", "S", ",", 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          TagBox["\[Succeeds]",
           Identity], 
          TagBox[")",
           "AutoParentheses"]}]}], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isNoetherian)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:929796587", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.610177397302061*^9, 3.610177418899329*^9}, 
   3.610177565023344*^9, {3.610178030407286*^9, 3.610178114988305*^9}, {
   3.631856752599349*^9, 3.631856846975562*^9}, {3.631856943433864*^9, 
   3.6318569438088713`*^9}, 3.6318569828716908`*^9, {3.631857041185081*^9, 
   3.631857057464109*^9}, 3.631857103393153*^9, {3.633078399765931*^9, 
   3.63307840161442*^9}, {3.633080363662594*^9, 3.6330804004067574`*^9}, {
   3.633080681438298*^9, 3.6330806828739347`*^9}, {3.633081100224646*^9, 
   3.633081115380599*^9}},
 CellTags->{
  "ID:929796587", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNoetherian"},
 CellID->929796587],

Cell[BoxData[
 RowBox[{
  RowBox[{"isOrderEmbedding", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y", ",", "z"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{"z", "\[SmallCircle]", "x"}], "\[Succeeds]", 
             RowBox[{"z", "\[SmallCircle]", "y"}]}], 
            TagBox[")",
             "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{"x", "\[Succeeds]", "y"}], 
            TagBox[")",
             "AutoParentheses"]}]}]},
         {
          RowBox[{
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{"x", "\[SmallCircle]", "z"}], "\[Succeeds]", 
             RowBox[{"y", "\[SmallCircle]", "z"}]}], 
            TagBox[")",
             "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{"x", "\[Succeeds]", "y"}], 
            TagBox[")",
             "AutoParentheses"]}]}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isOrderEmbedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1479000424", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.607771184644443*^9, 3.607771337880099*^9}, {
  3.607771506745191*^9, 3.607771522063946*^9}, {3.607771567338225*^9, 
  3.607771596937508*^9}, {3.631592384002762*^9, 3.631592394580971*^9}, {
  3.6315925248726587`*^9, 3.631592525546661*^9}, {3.63159386955499*^9, 
  3.6315938804490013`*^9}, {3.631612199792515*^9, 3.631612200319746*^9}, {
  3.6330788547790337`*^9, 3.633078865895831*^9}, {3.633082014040214*^9, 
  3.633082057653369*^9}, {3.63574617496497*^9, 3.635746236895771*^9}, {
  3.635834937374736*^9, 3.6358349410453176`*^9}, {3.638250009920966*^9, 
  3.638250026820655*^9}},
 CellTags->{
  "ID:1479000424", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isOrderEmbedding"},
 CellID->1479000424],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1769626440]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->847702497]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Lemmas: Binary Relations and Order Embeddings (\[Checkmark])\
\>", "Subsubsection",
 CellChangeTimes->{{3.633081580983995*^9, 3.63308158184046*^9}, {
  3.656221085261536*^9, 3.656221097803958*^9}},
 CellID->1138215434],

Cell["", "OpenEnvironment",
 CellID->1536133009],

Cell[CellGroupData[{

Cell["Lemma: Properties of Binary Relations", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647751521333568*^9, 3.6477515270579767`*^9}},
 CellID->503429911],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "r"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 1224736736}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647751533025141*^9, 3.6477515418024*^9}, 
   3.647751622572359*^9, 3.661081929223694*^9},
 CellTags->{
  "ID:1224736736", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1224736736],

Cell[BoxData[
 RowBox[{
  RowBox[{"isAsymmetric", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{"isIrreflexive", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox[
        "(asymmetric \[DoubleRightArrow] irreflexive)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:663270760", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647751545864573*^9, 3.647751579971099*^9}, {
  3.6610819316728983`*^9, 3.661081933529301*^9}},
 CellTags->{
  "ID:663270760", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "asymmetric \[DoubleRightArrow] irreflexive"},
 CellID->663270760],

Cell[BoxData[
 RowBox[{
  RowBox[{"isAsymmetric", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{"isAntisymmetric", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox[
        "(asymmetric \[DoubleRightArrow] antisymmetric)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:285650760", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477614899675713`*^9, 3.6477614982043858`*^9}, {
  3.661081935214104*^9, 3.661081937273308*^9}},
 CellTags->{
  "ID:285650760", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "asymmetric \[DoubleRightArrow] antisymmetric"},
 CellID->285650760],

Cell[BoxData[
 RowBox[{
  RowBox[{"isEquivalence", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], 
  "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isReflexive", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isSymmetric", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isTransitive", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isEquivalence alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:74183342", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610819156672697`*^9, 3.661081951687733*^9}},
 CellTags->{
  "ID:74183342", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isEquivalence alternative", "IR"},
 CellID->74183342],

Cell[BoxData[
 RowBox[{
  RowBox[{"isPartReflOrder", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], 
  "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isReflexive", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isAntisymmetric", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isTransitive", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isPartReflOrder alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:238839812", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647761515170319*^9, 3.647761550384101*^9}, {
  3.64776163157752*^9, 3.647761631799721*^9}, {3.6610819539341373`*^9, 
  3.6610819596593475`*^9}},
 CellTags->{
  "ID:238839812", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartReflOrder alternative", "IR"},
 CellID->238839812],

Cell[BoxData[
 RowBox[{
  RowBox[{"isPartIrreflOrder", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], 
  "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isAsymmetric", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isTransitive", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isPartIrreflOrder alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:281023185", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647761457233267*^9, 3.6477614800004063`*^9}, {
  3.6610819614689503`*^9, 3.6610819650725565`*^9}},
 CellTags->{
  "ID:281023185", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartIrreflOrder alternative", "IR"},
 CellID->281023185],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalIrreflOrder", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], 
  "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isAsymmetric", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isTransitive", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isTotalRelation", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTotalIrreflOrder alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:816399472", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647924267340811*^9, 3.647924309471039*^9}, {
  3.66108196694456*^9, 3.661081972217369*^9}},
 CellTags->{
  "ID:816399472", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalIrreflOrder alternative", "IR"},
 CellID->816399472],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalIrreflOrder", "[", 
   RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], 
  "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isPartIrreflOrder", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isTotalRelation", "[", 
     RowBox[{"r", ",", "\[ScriptCapitalD]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTotalIrreflOrder alternative II)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1286795454", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64792404080158*^9, 3.647924059155034*^9}, {
  3.647925146073389*^9, 3.647925153605114*^9}, {3.661081974401373*^9, 
  3.661081977724179*^9}},
 CellTags->{
  "ID:1286795454", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalIrreflOrder alternative II", "IR"},
 CellID->1286795454],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->2046169743]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->280337546],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(asymmetric \[DoubleRightArrow] irreflexive)\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(asymmetric \[DoubleRightArrow] irreflexive)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isAsymmetric", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"isIrreflexive", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isAsymmetric", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"isIrreflexive", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:663270760"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p663270760-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p663270760-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:663270760", "Proof|ID:663270760-1"},
 CellID->644318390],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p663270760-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellChangeTimes->{3.6581462473078375`*^9},
 CellID->256500674]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(asymmetric \[DoubleRightArrow] antisymmetric)\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(asymmetric \[DoubleRightArrow] antisymmetric)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isAsymmetric", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"isAntisymmetric", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isAsymmetric", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"isAntisymmetric", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:285650760"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p285650760-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p285650760-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:285650760", "Proof|ID:285650760-1"},
 CellID->592867878],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p285650760-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1320062656]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isEquivalence alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isEquivalence alternative)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["r", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isEquivalence", "[", 
             RowBox[{
               StyleBox["r", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isReflexive", "[", 
                 RowBox[{
                   StyleBox["r", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isSymmetric", "[", 
                 RowBox[{
                   StyleBox["r", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["r", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["r", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isEquivalence", "[", 
             RowBox[{
               StyleBox["r", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isReflexive", "[", 
                 RowBox[{
                   StyleBox["r", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isSymmetric", "[", 
                 RowBox[{
                   StyleBox["r", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["r", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:74183342"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p74183342-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p74183342-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:74183342", "Proof|ID:74183342-1"},
 CellID->219773652],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p74183342-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->127695526]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isPartIrreflOrder alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isPartIrreflOrder alternative)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isPartIrreflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isAsymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isPartIrreflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isAsymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:281023185"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p281023185-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p281023185-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:281023185", "Proof|ID:281023185-1"},
 CellID->507210937],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p281023185-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1249385145]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isPartReflOrder alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isPartReflOrder alternative)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isPartReflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isReflexive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isAntisymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isPartReflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isReflexive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isAntisymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:238839812"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p238839812-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p238839812-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:238839812", "Proof|ID:238839812-1"},
 CellID->77499924],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p238839812-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1888292086]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isTotalIrreflOrder alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isTotalIrreflOrder alternative)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isTotalIrreflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isAsymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isTotalIrreflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isAsymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:816399472"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p816399472-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p816399472-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:816399472", "Proof|ID:816399472-1"},
 CellID->1088293951],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p816399472-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1817657225]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isTotalIrreflOrder alternative II)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isTotalIrreflOrder alternative II)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isTotalIrreflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isPartIrreflOrder", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isTotalIrreflOrder", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{"isPartIrreflOrder", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], ")"}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1286795454"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1286795454-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1286795454-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1286795454", "Proof|ID:1286795454-1"},
 CellID->2099979165],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1286795454-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->677919669]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->1465926711],

Cell[CellGroupData[{

Cell["Lemma: Embeddings", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647773114120453*^9, 3.6477731233991537`*^9}, {
  3.647773340443296*^9, 3.647773364735468*^9}},
 CellID->2020955226],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"f", ",", "\[ScriptCapitalA]", ",", "\[ScriptCapitalB]", ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[Succeeds]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[RightTriangle]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 1946807802}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647773126655322*^9, 3.6477731748978252`*^9}, {
  3.6477737246324263`*^9, 3.6477737418329077`*^9}},
 CellTags->{
  "ID:1946807802", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1946807802],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
        RowBox[{"[", "x", "]"}]}]], 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
       RowBox[{"[", 
        RowBox[{"f", "[", "x", "]"}], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[And]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
        RowBox[{"[", 
         RowBox[{"x", ",", "y"}], "]"}]}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          RowBox[{"f", "[", "x", "]"}], "\[RightTriangle]", 
          RowBox[{"f", "[", "y", "]"}]}], 
         TagBox[")",
          "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{"x", "\[Succeeds]", "y"}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 604644732}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647773186770831*^9, 3.647773283033736*^9}, {
  3.647773583930544*^9, 3.647773598533483*^9}, {3.647773843044917*^9, 
  3.647773852751904*^9}, {3.6477738958995113`*^9, 3.647773906862175*^9}},
 CellTags->{
  "ID:604644732", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->604644732],

Cell[BoxData[
 RowBox[{
  RowBox[{"isReflexive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isReflexive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isReflexive embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:883452679", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647773287285344*^9, 3.6477732948585997`*^9}, {
  3.647773407807054*^9, 3.647773429948327*^9}},
 CellTags->{
  "ID:883452679", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive embedding"},
 CellID->883452679],

Cell[BoxData[
 RowBox[{
  RowBox[{"isAsymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isAsymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isAsymmetric embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1544154211", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647774334827146*^9, 3.647774339765623*^9}},
 CellTags->{
  "ID:1544154211", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isAsymmetric embedding"},
 CellID->1544154211],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTransitive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isTransitive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTransitive embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1384519374", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64777347084546*^9, 3.647773478608062*^9}},
 CellTags->{
  "ID:1384519374", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTransitive embedding"},
 CellID->1384519374],

Cell[BoxData[
 RowBox[{
  RowBox[{"isPartIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isPartIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isPartIrreflOrder embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:646610345", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647775408551399*^9, 3.6477754193470783`*^9}},
 CellTags->{
  "ID:646610345", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartIrreflOrder embedding"},
 CellID->646610345],

Cell[BoxData[
 RowBox[{
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isNoetherian embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1746482051", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477755422503977`*^9, 3.647775550618187*^9}},
 CellTags->{
  "ID:1746482051", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isNoetherian embedding"},
 CellID->1746482051],

Cell[TextData[{
 "For the following results we additionally need injectivity of ",
 Cell[BoxData[
  FormBox["f", TraditionalForm]]],
 "."
}], "EnvironmentText",
 CellChangeTimes->{{3.647775198887204*^9, 3.6477752235071583`*^9}},
 CellID->1203488332],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"f", "[", "x", "]"}], "\[Equal]", 
        RowBox[{"f", "[", "y", "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[Implies]", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"x", "\[Equal]", "y"}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 632872799}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647774189888587*^9, 3.647774199994677*^9}, {
  3.647775180657155*^9, 3.6477751816909246`*^9}},
 CellTags->{
  "ID:632872799", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->632872799],

Cell[BoxData[
 RowBox[{
  RowBox[{"isAntisymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isAntisymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isAntisymmetric embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:123344064", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647773442583407*^9, 3.647773453937978*^9}},
 CellTags->{
  "ID:123344064", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isAntisymmetric embedding"},
 CellID->123344064],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalRelation", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isTotalRelation", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTotalRelation embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1095452192", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6479250971831617`*^9, 3.647925105229*^9}},
 CellTags->{
  "ID:1095452192", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalRelation embedding"},
 CellID->1095452192],

Cell[BoxData[
 RowBox[{
  RowBox[{"isPartReflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isPartReflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isPartReflOrder embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1770002934", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647776158994281*^9, 3.647776166067428*^9}},
 CellTags->{
  "ID:1770002934", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartReflOrder embedding"},
 CellID->1770002934],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isTotalIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTotalIrreflOrder embedding)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:741041662", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64792558017238*^9, 3.6479255970470667`*^9}},
 CellTags->{
  "ID:741041662", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalIrreflOrder embedding"},
 CellID->741041662],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->861668493]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1411278035],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isReflexive embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isReflexive embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isReflexive", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isReflexive", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isReflexive", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isReflexive", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:883452679"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p883452679-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p883452679-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:883452679", "Proof|ID:883452679-1"},
 CellID->30849742],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p883452679-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->29229487]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isAsymmetric embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isAsymmetric embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1544154211"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1544154211-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1544154211-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1544154211", "Proof|ID:1544154211-1"},
 CellID->2049393775],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1544154211-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->381037592]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isTransitive embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isTransitive embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1384519374"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1384519374-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1384519374-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1384519374", "Proof|ID:1384519374-1"},
 CellID->431921927],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1384519374-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->1726251020]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isPartIrreflOrder embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isPartIrreflOrder embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:646610345"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p646610345-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p646610345-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:646610345", "Proof|ID:646610345-1"},
 CellID->1952836459],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p646610345-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->879143390]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isNoetherian embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isNoetherian embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1746482051"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1746482051-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1746482051-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1746482051", "Proof|ID:1746482051-1"},
 CellID->8671999],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1746482051-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellChangeTimes->{{3.653298786607562*^9, 3.653298787808764*^9}},
 CellID->599184085]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isAntisymmetric embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isAntisymmetric embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isAntisymmetric", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isAntisymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isAntisymmetric", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isAntisymmetric", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:123344064"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p123344064-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p123344064-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:123344064", "Proof|ID:123344064-1"},
 CellID->1779690974],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p123344064-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->1241931864]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isTotalRelation embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isTotalRelation embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isTotalRelation", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1095452192"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1095452192-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1095452192-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1095452192", "Proof|ID:1095452192-1"},
 CellID->1752383333],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1095452192-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->632126693]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isPartReflOrder embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isPartReflOrder embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isPartReflOrder", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isPartReflOrder", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isPartReflOrder", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isPartReflOrder", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1770002934"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1770002934-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1770002934-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1770002934", "Proof|ID:1770002934-1"},
 CellID->1038034091],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1770002934-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->1184515805]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isTotalIrreflOrder embedding)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isTotalIrreflOrder embedding)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isTotalIrreflOrder", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isTotalIrreflOrder", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   "\[RightTriangle]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   StyleBox["y", "ExpressionVariable"]}]}]}], "\[Implies]", 
             RowBox[{
               RowBox[{"isTotalIrreflOrder", "[", 
                 RowBox[{
                   StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{"isTotalIrreflOrder", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:741041662"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p741041662-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p741041662-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:741041662", "Proof|ID:741041662-1"},
 CellID->1690532916],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p741041662-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->403186867]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Lemmas: Properties of Joins (\[Checkmark])\
\>", "Subsubsection",
 CellChangeTimes->{{3.6563217271819687`*^9, 3.6563217398335905`*^9}, 
   3.656321774777652*^9, {3.656322204998208*^9, 3.656322209678216*^9}},
 CellID->187230287],

Cell[BoxData[
 UnderscriptBox[
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SquareUnion]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[PrecedesEqual]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}]}]], 
  RowBox[{
   RowBox[{"isPartReflOrder", "[", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[PrecedesEqual]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
   RowBox[{"isJoin", "[", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[SquareUnion]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}], ",", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[PrecedesEqual]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], 
    "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 236772010}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.656321795759689*^9, 3.6563218574431973`*^9}},
 CellTags->{
  "ID:236772010", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->236772010],

Cell["", "OpenEnvironment",
 CellID->162324642],

Cell[CellGroupData[{

Cell["Lemma: Properties of Joins", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.656321786774073*^9, 3.6563217915944815`*^9}},
 CellID->21690211],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"x", "\[SquareUnion]", "x"}], "\[Equal]", "x"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(join absorption)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:178453409", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6563218997972717`*^9, 3.6563219418861456`*^9}},
 CellTags->{
  "ID:178453409", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "join absorption"},
 CellID->178453409],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->207725336]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->142402142],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(join absorption)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(join absorption)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SquareUnion]", "ExpressionVariable"]}, {
             StyleBox["\[PrecedesEqual]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[PrecedesEqual]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isJoin", "[", 
               RowBox[{
                 StyleBox["\[SquareUnion]", "ExpressionVariable"], ",", 
                 StyleBox["\[PrecedesEqual]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               StyleBox["x", "ExpressionVariable"], "\[SquareUnion]", 
               StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
             StyleBox[
             "x", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SquareUnion]", "ExpressionVariable"]}, {
             StyleBox["\[PrecedesEqual]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[PrecedesEqual]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isJoin", "[", 
               RowBox[{
                 StyleBox["\[SquareUnion]", "ExpressionVariable"], ",", 
                 StyleBox["\[PrecedesEqual]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               StyleBox["x", "ExpressionVariable"], "\[SquareUnion]", 
               StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
             StyleBox[
             "x", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:178453409"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p178453409-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p178453409-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:178453409", "Proof|ID:178453409-1"},
 CellID->321919587],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p178453409-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->408299053]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Lemmas: Noetherian Induction (\[Checkmark])\
\>", "Subsubsection",
 CellChangeTimes->{{3.6562211060251727`*^9, 3.6562211115007825`*^9}, {
  3.656758734148074*^9, 3.656758738094881*^9}},
 CellID->187813892],

Cell["", "OpenEnvironment",
 CellID->952601892],

Cell[CellGroupData[{

Cell["Lemma: Principle of Noetherian Induction", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.635763042885788*^9, 3.635763051586156*^9}},
 CellID->1732832893],

Cell[BoxData[
 RowBox[{
  RowBox[{"isDomain", "[", "\[ScriptCapitalD]", "]"}], 
  "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 135753527}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6567580288864355`*^9, 3.6567580351732464`*^9}},
 CellTags->{
  "ID:135753527", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->135753527],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[Succeeds]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isNoetherian", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[Succeeds]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", "P"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", "x", "]"}]}]], 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           RowBox[{
            RowBox[{
             TagBox["(",
              "AutoParentheses"], 
             RowBox[{
              UnderscriptBox[
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                 UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
                 RowBox[{"[", "y", "]"}]}]], 
               RowBox[{"x", "\[Succeeds]", "y"}]], 
              RowBox[{"P", "[", "y", "]"}]}], 
             TagBox[")",
              "AutoParentheses"]}], "\[Implies]", 
            RowBox[{"P", "[", "x", "]"}]}], 
           TagBox[")",
            "AutoParentheses"]}]}], 
         TagBox[")",
          "AutoParentheses"]}], "\[Implies]", 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", "x", "]"}]}]], 
          RowBox[{"P", "[", "x", "]"}]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Noetherian induction)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:73073670", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6567560710285544`*^9, 3.6567561062690163`*^9}, {
  3.6567570311324825`*^9, 3.656757111082623*^9}, {3.656757165854719*^9, 
  3.656757173529933*^9}},
 CellTags->{
  "ID:73073670", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction"},
 CellID->73073670],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "P"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Exists]", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox["\[Succeeds]",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"isNoetherian", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox["\[Succeeds]",
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
        RowBox[{"isPartIrreflOrder", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox["\[Succeeds]",
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", "x", "]"}]}]], 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           RowBox[{
            RowBox[{
             TagBox["(",
              "AutoParentheses"], 
             RowBox[{
              UnderscriptBox[
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                 UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
                 RowBox[{"[", "y", "]"}]}]], 
               RowBox[{"x", "\[Succeeds]", "y"}]], 
              RowBox[{"P", "[", "y", "]"}]}], 
             TagBox[")",
              "AutoParentheses"]}], "\[Implies]", 
            RowBox[{"P", "[", "x", "]"}]}], 
           TagBox[")",
            "AutoParentheses"]}]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[Implies]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
        RowBox[{"[", "x", "]"}]}]], 
      RowBox[{"P", "[", "x", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Noetherian induction')", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1991524700", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.635763066464098*^9, 3.635763230828619*^9}, {
  3.645515352859847*^9, 3.64551536838138*^9}, {3.647924781167185*^9, 
  3.647924784785164*^9}, {3.647927180551551*^9, 3.647927197077611*^9}, {
  3.6567560429017053`*^9, 3.6567560469109125`*^9}, {3.6567570214448657`*^9, 
  3.656757025001672*^9}},
 CellTags->{
  "ID:1991524700", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction'",
    "IR"},
 CellID->1991524700],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->437869757]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->2048030657],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(Noetherian induction)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(Noetherian induction)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{"isNoetherian", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  RowBox[{
                    StyleBox["P", "ExpressionVariable"]}]], 
                 RowBox[{
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["y", "ExpressionVariable"]}]], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                    "\[Implies]", 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}], 
                   "\[Implies]", 
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{"isNoetherian", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[Implies]", 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  RowBox[{
                    StyleBox["P", "ExpressionVariable"]}]], 
                 RowBox[{
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["y", "ExpressionVariable"]}]], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                    "\[Implies]", 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}], 
                   "\[Implies]", 
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:73073670"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p73073670-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p73073670-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:73073670", "Proof|ID:73073670-1"},
 CellID->183797557],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p73073670-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->675175179]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(Noetherian induction')\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(Noetherian induction')\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["P", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  RowBox[{
                    StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
                 RowBox[{
                   RowBox[{"isNoetherian", "[", 
                    RowBox[{
                    StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                    "]"}], "\[And]", 
                   RowBox[{"isPartIrreflOrder", "[", 
                    RowBox[{
                    StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                    "]"}], "\[And]", 
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["y", "ExpressionVariable"]}]], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                    "\[Implies]", 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}]}]}], 
               "\[Implies]", 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["P", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  RowBox[{
                    StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
                 RowBox[{
                   RowBox[{"isNoetherian", "[", 
                    RowBox[{
                    StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                    "]"}], "\[And]", 
                   RowBox[{"isPartIrreflOrder", "[", 
                    RowBox[{
                    StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                    "]"}], "\[And]", 
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["y", "ExpressionVariable"]}]], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                    "\[Implies]", 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}]}]}], 
               "\[Implies]", 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   StyleBox["x", "ExpressionVariable"], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1991524700"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1991524700-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1991524700-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1991524700", "Proof|ID:1991524700-1"},
 CellID->302872964],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1991524700-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->916266417]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Lemmas: Order Relations and Finite Sets (\[Checkmark])\
\>", "Subsubsection",
 CellChangeTimes->{{3.656221118598795*^9, 3.6562211304392157`*^9}, {
  3.656222233396353*^9, 3.656222237873561*^9}},
 CellID->4571880],

Cell["", "OpenEnvironment",
 CellID->2046755789],

Cell[CellGroupData[{

Cell["Lemma: Order Relations and Finite Sets", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.638527869943253*^9, 3.6385278751726007`*^9}, {
  3.6562220338242025`*^9, 3.656222035805406*^9}},
 CellID->1033951332],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   RowBox[{
    UnderscriptBox["\[Element]", 
     RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
    RowBox[{"[", "A", "]"}]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[Succeeds]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 1439528152}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.638527879764927*^9, 3.638527893001972*^9}, {
  3.638527934326619*^9, 3.638527935933707*^9}, {3.6385279710699997`*^9, 
  3.638527989178071*^9}},
 CellTags->{
  "ID:1439528152", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1439528152],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"nonemptySet", "[", "A", "]"}], "\[And]", 
   RowBox[{"isFinite", "[", "A", "]"}]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 1138027217}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.638528005933076*^9, 3.638528014920439*^9}},
 CellTags->{
  "ID:1138027217", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1138027217],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isTransitive", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[Succeeds]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isIrreflexive", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[Succeeds]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"a", "\[Element]", "A"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"b", "\[Element]", "A"}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{"\[Not]", 
       RowBox[{"a", "\[Succeeds]", "b"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(minimum isFinite)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:75332861", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.656219329781242*^9, {3.656219370450513*^9, 3.656219373679719*^9}, {
   3.6562195095247574`*^9, 3.6562195324411974`*^9}},
 CellTags->{
  "ID:75332861", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "minimum isFinite"},
 CellID->75332861],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isTransitive", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[Succeeds]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[And]", 
    RowBox[{"isIrreflexive", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[Succeeds]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"a", "\[Element]", "A"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"b", "\[Element]", "A"}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{"\[Not]", 
       RowBox[{"b", "\[Succeeds]", "a"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(maximum isFinite)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:242836600", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.656219381542133*^9, 3.6562193859725404`*^9}, 
   3.6562195379324074`*^9},
 CellTags->{
  "ID:242836600", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "maximum isFinite"},
 CellID->242836600],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"a", "\[Element]", "A"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"b", "\[Element]", "A"}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{"\[Not]", 
       RowBox[{"a", "\[Succeeds]", "b"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(minimum isFinite totalIrrefl)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:141004932", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.656219117119668*^9, 3.65621912370288*^9}},
 CellTags->{
  "ID:141004932", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "minimum isFinite totalIrrefl"},
 CellID->141004932],

Cell[BoxData[
 RowBox[{
  RowBox[{"isTotalIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"a", "\[Element]", "A"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"b", "\[Element]", "A"}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{"\[Not]", 
       RowBox[{"b", "\[Succeeds]", "a"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(maximum isFinite totalIrrefl)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:547704634", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.638527905543939*^9, 3.638528045106848*^9}, {
  3.638528081971311*^9, 3.638528105843422*^9}, {3.638528203961133*^9, 
  3.6385282294849367`*^9}},
 CellTags->{
  "ID:547704634", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "maximum isFinite totalIrrefl"},
 CellID->547704634],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->95587551]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1729245244],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(minimum isFinite)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(minimum isFinite)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isIrreflexive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["b", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isIrreflexive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["b", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:75332861"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p75332861-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p75332861-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:75332861", "Proof|ID:75332861-1"},
 CellID->124362427],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p75332861-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->286952046]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(maximum isFinite)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(maximum isFinite)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isIrreflexive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["a", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"isTransitive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}], "\[And]", 
               RowBox[{"isIrreflexive", "[", 
                 RowBox[{
                   StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                   StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["a", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:242836600"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p242836600-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p242836600-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:242836600", "Proof|ID:242836600-1"},
 CellID->125816398],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p242836600-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->441856622]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(minimum isFinite totalIrrefl)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(minimum isFinite totalIrrefl)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isTotalIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["b", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isTotalIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["b", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:141004932"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p141004932-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p141004932-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:141004932", "Proof|ID:141004932-1"},
 CellID->153836126],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p141004932-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->447780817]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(maximum isFinite totalIrrefl)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(maximum isFinite totalIrrefl)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isTotalIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["a", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}, {
             StyleBox["\[Succeeds]", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"nonemptySet", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{"isFinite", "[", 
               StyleBox["A", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             RowBox[{"isTotalIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    StyleBox["A", "ExpressionVariable"]}]}}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Succeeds]", 
                    StyleBox["a", "ExpressionVariable"]}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:547704634"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p547704634-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p547704634-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:547704634", "Proof|ID:547704634-1"},
 CellID->49243488],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p547704634-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->2248454]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Equivalence Relations and Quotient Domains (\[Checkmark])\
\>", "Subsection",
 CellChangeTimes->{{3.661082671631998*^9, 3.6610826843148203`*^9}, {
  3.6611649564368505`*^9, 3.6611649606020584`*^9}},
 CellID->189896775],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   TagBox["\[Tilde]",
    Identity], 
   TagBox[")",
    "AutoParentheses"]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 4832845}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083319235935*^9, 3.661083323057942*^9}},
 CellTags->{
  "ID:4832845", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->4832845],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.6610827035184536`*^9, 3.6610827052656565`*^9}},
 CellID->817769398],

Cell["", "OpenEnvironment",
 CellID->327803107],

Cell[CellGroupData[{

Cell["Definition: Invariant Functions and -Relations", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6610827287124977`*^9, 3.6610827288996983`*^9}, {
  3.661083336224365*^9, 3.6610833456623816`*^9}},
 CellID->25506723],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "a"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 131514176}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661082822437463*^9, 3.661082833513482*^9}, 
   3.6610833251795454`*^9},
 CellTags->{
  "ID:131514176", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->131514176],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantFunction1", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a:=b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
           UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
           RowBox[{"[", "x", "]"}]}]], 
         RowBox[{
          UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
          RowBox[{"[", 
           RowBox[{"a", "[", "x", "]"}], "]"}]}]}]},
       {
        RowBox[{
         UnderscriptBox[
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", 
             RowBox[{"x1", ",", "x2"}], "]"}]}]], 
          RowBox[{"x1", "\[Tilde]", "x2"}]], 
         RowBox[{
          RowBox[{"a", "[", "x1", "]"}], "\[Tilde]", 
          RowBox[{"a", "[", "x2", "]"}]}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isInvariantFunction1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:85261794", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6607163980451775`*^9, 3.6607164259068265`*^9}, {
   3.660716463690093*^9, 3.6607165568690567`*^9}, {3.6607185965882387`*^9, 
   3.6607185970874395`*^9}, {3.661082838848692*^9, 3.6610829162404275`*^9}, 
   3.661088361793193*^9},
 CellTags->{
  "ID:85261794", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction1"},
 CellID->85261794],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantFunction2", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a:=b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
           UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
           RowBox[{"[", 
            RowBox[{"x", ",", "y"}], "]"}]}]], 
         RowBox[{
          UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
          RowBox[{"[", 
           RowBox[{"a", "[", 
            RowBox[{"x", ",", "y"}], "]"}], "]"}]}]}]},
       {
        RowBox[{
         UnderscriptBox[
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", 
             RowBox[{"x1", ",", "x2", ",", "y"}], "]"}]}]], 
          RowBox[{"x1", "\[Tilde]", "x2"}]], 
         RowBox[{
          RowBox[{"a", "[", 
           RowBox[{"x1", ",", "y"}], "]"}], "\[Tilde]", 
          RowBox[{"a", "[", 
           RowBox[{"x2", ",", "y"}], "]"}]}]}]},
       {
        RowBox[{
         UnderscriptBox[
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", 
             RowBox[{"x", ",", "y1", ",", "y2"}], "]"}]}]], 
          RowBox[{"y1", "\[Tilde]", "y2"}]], 
         RowBox[{
          RowBox[{"a", "[", 
           RowBox[{"x", ",", "y1"}], "]"}], "\[Tilde]", 
          RowBox[{"a", "[", 
           RowBox[{"x", ",", "y2"}], "]"}]}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isInvariantFunction2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:715106769", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.660716584137904*^9, 3.6607166256027775`*^9}, {
  3.6607185997238445`*^9, 3.660718600176245*^9}, {3.6610829292352505`*^9, 
  3.6610830038345814`*^9}, {3.6610831610516577`*^9, 3.661083162986061*^9}, {
  3.661162764162199*^9, 3.6611627864546385`*^9}},
 CellTags->{
  "ID:715106769", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction2"},
 CellID->715106769],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantRelation1", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a:=b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
       RowBox[{"[", 
        RowBox[{"x1", ",", "x2"}], "]"}]}]], 
     RowBox[{"x1", "\[Tilde]", "x2"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"a", "[", "x1", "]"}], "\[Implies]", 
      RowBox[{"a", "[", "x2", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isInvariantRelation1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:218481457", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.66071869365261*^9, 3.660718749391507*^9}, 
   3.6607196437308784`*^9, {3.6607196865061536`*^9, 3.6607196895481586`*^9}, {
   3.661083045190254*^9, 3.6610830472338576`*^9}, {3.6610830878251286`*^9, 
   3.6610831386188183`*^9}, {3.661164485263823*^9, 3.6611644862934246`*^9}},
 CellTags->{
  "ID:218481457", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantRelation1"},
 CellID->218481457],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantRelation2", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a:=b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{
         UnderscriptBox[
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", 
             RowBox[{"x1", ",", "x2", ",", "y"}], "]"}]}]], 
          RowBox[{"x1", "\[Tilde]", "x2"}]], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           RowBox[{"a", "[", 
            RowBox[{"x1", ",", "y"}], "]"}], "\[Implies]", 
           RowBox[{"a", "[", 
            RowBox[{"x2", ",", "y"}], "]"}]}], 
          TagBox[")",
           "AutoParentheses"]}]}]},
       {
        RowBox[{
         UnderscriptBox[
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
            RowBox[{"[", 
             RowBox[{"x", ",", "y1", ",", "y2"}], "]"}]}]], 
          RowBox[{"y1", "\[Tilde]", "y2"}]], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           RowBox[{"a", "[", 
            RowBox[{"x", ",", "y1"}], "]"}], "\[Implies]", 
           RowBox[{"a", "[", 
            RowBox[{"x", ",", "y2"}], "]"}]}], 
          TagBox[")",
           "AutoParentheses"]}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isInvaiantRelation2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:40789237", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.66071967878414*^9, 3.6607197189230103`*^9}, {
  3.6610830491682606`*^9, 3.6610830499326625`*^9}, {3.661083090336733*^9, 
  3.6610831087603655`*^9}, {3.6610831439696274`*^9, 3.6610831815188932`*^9}, {
  3.6611627973278575`*^9, 3.6611628183722944`*^9}, {3.661164488539829*^9, 
  3.661164492096635*^9}},
 CellTags->{
  "ID:40789237", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvaiantRelation2"},
 CellID->40789237],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->560295716]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->223070624],

Cell["", "OpenEnvironment",
 CellID->34573484],

Cell[CellGroupData[{

Cell["Definition: Quotient Domain Functor", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6610810202538958`*^9, 3.6610810244191027`*^9}, {
  3.6610813257492323`*^9, 3.6610813371060524`*^9}},
 CellID->678518750],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuoDom", "[", 
   RowBox[{"\[ScriptCapitalD]", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}]}], "]"}], ":=", 
  UnderscriptBox["\[CapitalDelta]", "N"]}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 597743189}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661076905092044*^9, 3.661076937914502*^9}, {
  3.661077818928049*^9, 3.661077832110072*^9}, {3.6610813167948165`*^9, 
  3.661081321630825*^9}, {3.661083353150395*^9, 3.6610833544607973`*^9}},
 CellTags->{
  "ID:597743189", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->597743189],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "a"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 207685257}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610770515305014`*^9, 3.661077054198106*^9}, 
   3.6610771170662165`*^9, 3.6610814305658164`*^9},
 CellTags->{
  "ID:207685257", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->207685257],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["Base", "N"], ":=", 
  RowBox[{"{", 
   RowBox[{"x", 
    UnderscriptBox["|", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "x", "]"}]}]]}], "}"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom Base)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:48746434", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661077253894057*^9, 3.661077282941308*^9}, {
   3.661077445073393*^9, 3.6610774597998185`*^9}, 3.661083358750805*^9},
 CellTags->{
  "ID:48746434", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Base"},
 CellID->48746434],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Element]", "N"], 
    RowBox[{"[", "a", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a:=b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"a", "\[Element]", 
    RowBox[{"QuoSet", "[", 
     RowBox[{
      UnderscriptBox["Base", "N"], ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[Tilde]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:591224316", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610769468533173`*^9, 3.6610770027180157`*^9}, {
   3.6610770572401114`*^9, 3.6610770585505133`*^9}, {3.661077118298619*^9, 
   3.661077119468621*^9}, {3.6610772133183856`*^9, 3.661077231164817*^9}, 
   3.661077286997315*^9, {3.661077359663243*^9, 3.661077376994873*^9}, {
   3.6610774706106377`*^9, 3.6610774735122423`*^9}, {3.661081036290724*^9, 
   3.6610810366807246`*^9}},
 CellTags->{
  "ID:591224316", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom \[Element]"},
 CellID->591224316],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["EC", "N"], "[", "a", "]"}], ":=", 
  RowBox[{
   SubscriptBox["EC", 
    RowBox[{
     UnderscriptBox["Base", "N"], ",", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[Tilde]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}]}]], "[", "a", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom EC)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:91525291", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661081212602234*^9, 3.6610812319930677`*^9}, {
   3.6610863621238804`*^9, 3.6610863650410852`*^9}, 3.6610865391529913`*^9},
 CellTags->{
  "ID:91525291", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom EC"},
 CellID->91525291],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["Fun1", "N"], "[", "a", "]"}], ":=", 
  RowBox[{
   SubscriptBox["QuoFun1", 
    RowBox[{
     UnderscriptBox["Base", "N"], ",", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[Tilde]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}]}]], "[", "a", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom Fun1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:79971692", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610771038997936`*^9, 3.661077144085464*^9}, 
   3.661077186813939*^9, {3.6610772915993233`*^9, 3.6610773252797823`*^9}, {
   3.6610774753686457`*^9, 3.661077475899047*^9}, {3.6610810896896176`*^9, 
   3.661081097146431*^9}, {3.6610814339978223`*^9, 3.661081435199024*^9}, {
   3.6610832583958282`*^9, 3.6610832636842375`*^9}, 3.6610863688162923`*^9, 
   3.6610865414773955`*^9},
 CellTags->{
  "ID:79971692", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun1"},
 CellID->79971692],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["Fun2", "N"], "[", "a", "]"}], ":=", 
  RowBox[{
   SubscriptBox["QuoFun2", 
    RowBox[{
     UnderscriptBox["Base", "N"], ",", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[Tilde]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}]}]], "[", "a", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom Fun2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:211465861", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661077331597793*^9, 3.6610773391482067`*^9}, {
   3.661077478098651*^9, 3.6610774786134515`*^9}, 3.661081098675234*^9, {
   3.6610814363378267`*^9, 3.6610814373674283`*^9}, {3.6610832601118317`*^9, 
   3.661083266273842*^9}, 3.6610863700486946`*^9, 3.6610865437549996`*^9},
 CellTags->{
  "ID:211465861", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun2"},
 CellID->211465861],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["Rel1", "N"], "[", "a", "]"}], ":=", 
  RowBox[{
   UnderscriptBox["\[Lambda]", "X"], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"x", "\[Element]", "X"}]], 
     RowBox[{"a", "[", "x", "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom Rel1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:207120323", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610797193608103`*^9, 3.661079767018894*^9}, {
   3.6610810427335353`*^9, 3.6610810542151556`*^9}, 3.6610811001260357`*^9, {
   3.6610814384282303`*^9, 3.6610814426558375`*^9}, {3.6610832693782473`*^9, 
   3.661083269939849*^9}},
 CellTags->{
  "ID:207120323", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel1"},
 CellID->207120323],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["Rel2", "N"], "[", "a", "]"}], ":=", 
  RowBox[{
   UnderscriptBox["\[Lambda]", 
    RowBox[{"X", ",", "Y"}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"x", "\[Element]", "X"}]], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"y", "\[Element]", "Y"}]], 
      RowBox[{"a", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom Rel2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:726147690", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661079773680106*^9, 3.661079777642513*^9}, {
  3.661081065213175*^9, 3.6610811015768385`*^9}, {3.661081441860236*^9, 
  3.6610814437790394`*^9}, {3.661083273683855*^9, 3.661083274588657*^9}},
 CellTags->{
  "ID:726147690", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel2"},
 CellID->726147690],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->176124539]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->321936646]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.661083463616189*^9, 3.6610834644585905`*^9}, {
  3.6610835502587414`*^9, 3.661083553612747*^9}, {3.661164795145767*^9, 
  3.6611647996229753`*^9}},
 CellID->191890876],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"\[ScriptCapitalQ]", "=", 
   RowBox[{"QuoDom", "[", 
    RowBox[{"\[ScriptCapitalD]", ",", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[Tilde]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}]}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 275047301}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083557777954*^9, 3.661083573003581*^9}},
 CellTags->{
  "ID:275047301", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->275047301],

Cell["", "OpenEnvironment",
 CellID->92797286],

Cell[CellGroupData[{

Cell["Lemma: QuoDom is Domain", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6610835139730773`*^9, 3.661083528013102*^9}, {
  3.661083616621258*^9, 3.6610836210828657`*^9}},
 CellID->77689825],

Cell[BoxData[
 RowBox[{
  RowBox[{"isDomain", "[", "\[ScriptCapitalD]", "]"}], "\[Implies]", 
  RowBox[{"isSet", "[", 
   UnderscriptBox["Base", "\[ScriptCapitalQ]"], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Base isSet QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:18750149", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610837125926266`*^9, 3.6610837194566383`*^9}, {
  3.6610857239413595`*^9, 3.6610857318661737`*^9}},
 CellTags->{
  "ID:18750149", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Base isSet QuoDom", 
   "IR"},
 CellID->18750149],

Cell[BoxData[
 RowBox[{
  RowBox[{"isDomain", "[", "\[ScriptCapitalD]", "]"}], "\[Implies]", 
  RowBox[{
  "isDomain", "[", "\[ScriptCapitalQ]", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(QuoDom isDomain)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:140284862", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083531647908*^9, 3.6610835453135324`*^9}, {
  3.6610835755931854`*^9, 3.6610835777303896`*^9}},
 CellTags->{
  "ID:140284862", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom isDomain", "IR"},
 CellID->140284862],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->20927037]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->677220010],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(Base isSet QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(Base isSet QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{"isSet", "[", 
             UnderscriptBox["Base", 
              RowBox[{"QuoDom", "[", 
                RowBox[{
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                  StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{"isSet", "[", 
             UnderscriptBox["Base", 
              RowBox[{"QuoDom", "[", 
                RowBox[{
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                  StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:18750149"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p18750149-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p18750149-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:18750149", "Proof|ID:18750149-1"},
 CellID->681889395],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p18750149-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->444857482]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(QuoDom isDomain)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(QuoDom isDomain)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"QuoDom", "[", 
               RowBox[{
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                 StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"QuoDom", "[", 
               RowBox[{
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                 StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:140284862"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p140284862-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p140284862-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:140284862", "Proof|ID:140284862-1"},
 CellID->174468768],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p140284862-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellChangeTimes->{3.6664377955735598`*^9},
 CellID->409959576]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"isDomain", "[", "\[ScriptCapitalD]", "]"}], 
  "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 345419617}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083624780072*^9, 3.6610836302088814`*^9}},
 CellTags->{
  "ID:345419617", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->345419617],

Cell["", "OpenEnvironment",
 CellID->244364927],

Cell[CellGroupData[{

Cell["\<\
Lemma: Properties of Base and \[Element] in QuoDom\
\>", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6610836468385105`*^9, 3.661083656760128*^9}, {
  3.6610838621032887`*^9, 3.661083864973694*^9}},
 CellID->66443033],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "x"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"x", "\[Element]", 
      UnderscriptBox["Base", "\[ScriptCapitalQ]"]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "x", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[Element] Base QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:88311021", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610837246514473`*^9, 3.6610837494866915`*^9}},
 CellTags->{
  "ID:88311021", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "\[Element] Base QuoDom", "IR"},
 CellID->88311021],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "x"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalQ]"], 
      RowBox[{"[", "x", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Exists]", 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
        RowBox[{"[", "y", "]"}]}]], 
      RowBox[{"x", "\[Equal]", 
       RowBox[{
        UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "y", "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[Element] QuoDom alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:323838795", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610837581291065`*^9, 3.661083809031996*^9}},
 CellTags->{
  "ID:323838795", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "\[Element] QuoDom alternative", "IR"},
 CellID->323838795],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
   RowBox[{"[", "x", "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 515475604}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083926515802*^9, 3.6610839330834136`*^9}},
 CellTags->{
  "ID:515475604", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->515475604],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", "\[ScriptCapitalQ]"], 
  RowBox[{"[", 
   RowBox[{
    UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(EC \[Element] QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:394780640", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083825724025*^9, 3.6610838466436615`*^9}, 
   3.661083935579418*^9},
 CellTags->{
  "ID:394780640", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Element] QuoDom", 
   "IR"},
 CellID->394780640],

Cell[BoxData[
 RowBox[{"isSet", "[", 
  RowBox[{
   UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], 
  "]"}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(EC isSet QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:387391039", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083939682225*^9, 3.661083947482239*^9}},
 CellTags->{
  "ID:387391039", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC isSet QuoDom", "IR"},
 CellID->387391039],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "a"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"a", "\[Element]", 
      RowBox[{
       UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
       RowBox[{"[", "a", "]"}]}], "\[And]", 
      RowBox[{"x", "\[Tilde]", "a"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[Element] EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:154396855", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610868872238026`*^9, 3.6610869169418554`*^9}},
 CellTags->{
  "ID:154396855", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "\[Element] EC QuoDom", 
   "IR"},
 CellID->154396855],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", 
   RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
  RowBox[{"[", 
   RowBox[{
    UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(EC \[Element] DomainSets QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:399369070", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661083889231736*^9, 3.66108393657782*^9}},
 CellTags->{
  "ID:399369070", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "EC \[Element] DomainSets QuoDom"},
 CellID->399369070],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->592359552]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->160670001],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[Element] Base QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[Element] Base QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["x", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{"(", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Element]", 
                   UnderscriptBox["Base", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]]}], 
                 ")"}], "\[DoubleLeftRightArrow]", 
               RowBox[{"(", 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], 
                 ")"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["x", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{"(", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Element]", 
                   UnderscriptBox["Base", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]]}], 
                 ")"}], "\[DoubleLeftRightArrow]", 
               RowBox[{"(", 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], 
                 ")"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:88311021"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p88311021-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p88311021-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:88311021", "Proof|ID:88311021-1"},
 CellID->805139363],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p88311021-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->696824889]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[Element] QuoDom alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[Element] QuoDom alternative)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["x", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{"(", 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], ")"}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["x", "ExpressionVariable"]}]], 
             RowBox[{
               RowBox[{"(", 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], ")"}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:323838795"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p323838795-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p323838795-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:323838795", "Proof|ID:323838795-1"},
 CellID->19340158],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p323838795-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->150383413]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(EC \[Element] QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(EC \[Element] QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"QuoDom", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
               RowBox[{
                 UnderscriptBox["EC", 
                  RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"QuoDom", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
               RowBox[{
                 UnderscriptBox["EC", 
                  RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:394780640"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p394780640-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p394780640-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:394780640", "Proof|ID:394780640-1"},
 CellID->77476222],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p394780640-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->490225186]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(EC isSet QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(EC isSet QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{"isSet", "[", 
               RowBox[{
                 UnderscriptBox["EC", 
                  RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{"isSet", "[", 
               RowBox[{
                 UnderscriptBox["EC", 
                  RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:387391039"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p387391039-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p387391039-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:387391039", "Proof|ID:387391039-1"},
 CellID->423977867],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p387391039-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->24620625]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[Element] EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[Element] EC QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"(", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "\[And]", 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Tilde]", 
                    StyleBox["a", "ExpressionVariable"]}]}], 
                   ")"}]}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"(", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "\[And]", 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Tilde]", 
                    StyleBox["a", "ExpressionVariable"]}]}], 
                   ")"}]}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:154396855"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p154396855-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p154396855-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:154396855", "Proof|ID:154396855-1"},
 CellID->105185766],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p154396855-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->301123050]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(EC \[Element] DomainSets QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(EC \[Element] DomainSets QuoDom)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               RowBox[{
                 UnderscriptBox["EC", 
                  RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               RowBox[{
                 UnderscriptBox["EC", 
                  RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:399369070"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p399369070-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p399369070-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:399369070", "Proof|ID:399369070-1"},
 CellID->253624188],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p399369070-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->317975990]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"isEquivalence", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 286514517}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610842144787083`*^9, 3.6610842275047307`*^9}},
 CellTags->{
  "ID:286514517", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->286514517],

Cell["", "OpenEnvironment",
 CellID->916630204],

Cell[CellGroupData[{

Cell["\<\
Lemma: Properties of EC in QuoDom if \[Tilde] is Equivalence Relation\
\>", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6610842102979007`*^9, 3.66108424410316*^9}},
 CellID->61787122],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", 
     RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
    RowBox[{"[", "X", "]"}]}]], 
  RowBox[{
   UnderscriptBox["\[ForAll]", 
    RowBox[{"y", "\[Element]", "X"}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{"x1", ",", 
         RowBox[{"x2", "\[Element]", "X"}]}]], 
       RowBox[{"x1", "\[Tilde]", "x2"}]}], 
      TagBox[")",
       "AutoParentheses"]}], "\[Implies]", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        SubscriptBox["RelSet", 
         RowBox[{
          UnderscriptBox["Base", "\[ScriptCapitalQ]"], ",", 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox["\[Tilde]",
            Identity], 
           TagBox[")",
            "AutoParentheses"]}]}]], "[", "X", "]"}], "\[Equal]", 
       RowBox[{
        UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "y", "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(RelSet = EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:600914281", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661084326753105*^9, 3.6610845744131403`*^9}, {
  3.661084675236117*^9, 3.6610846901029434`*^9}},
 CellTags->{
  "ID:600914281", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "RelSet = EC QuoDom"},
 CellID->600914281],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", 
     RowBox[{"x", ",", "y"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], "\[Equal]", 
      RowBox[{
       UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "y", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"x", "\[Tilde]", "y"}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(EC = EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:315304271", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610846009955864`*^9, 3.6610846614924927`*^9}, {
  3.6610847630330715`*^9, 3.661084765279475*^9}, {3.6610848183195686`*^9, 
  3.6610848286311865`*^9}},
 CellTags->{
  "ID:315304271", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC = EC QuoDom"},
 CellID->315304271],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{"x", "\[Element]", 
   RowBox[{
    UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", 
    "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(generator \[Element] EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:18625187", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661162034080917*^9, 3.6611620497433443`*^9}},
 CellTags->{
  "ID:18625187", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "generator \[Element] EC QuoDom", "IR"},
 CellID->18625187],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   UnderscriptBox["\[ForAll]", 
    RowBox[{"a", ",", 
     RowBox[{"b", "\[Element]", 
      RowBox[{
       UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}]}]}]], 
   RowBox[{"a", "\[Tilde]", "b"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(EC \[Tilde] QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2541232", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6611623729915123`*^9, 3.6611624010247617`*^9}},
 CellTags->{
  "ID:2541232", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Tilde] QuoDom"},
 CellID->2541232],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "a"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 155852592}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661084790067919*^9, 3.66108479073872*^9}},
 CellTags->{
  "ID:155852592", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->155852592],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantFunction1", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "x", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       RowBox[{
        UnderscriptBox["Fun1", "\[ScriptCapitalQ]"], "[", "a", "]"}], "[", 
       RowBox[{
        UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], "]"}], 
      "\[Equal]", 
      RowBox[{
       UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", 
       RowBox[{"a", "[", "x", "]"}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Fun1 EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:850875018", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610847774630966`*^9, 3.661084800925538*^9}, {
  3.6610848329367943`*^9, 3.661084883512083*^9}},
 CellTags->{
  "ID:850875018", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun1 EC QuoDom"},
 CellID->850875018],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantFunction2", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       RowBox[{
        UnderscriptBox["Fun2", "\[ScriptCapitalQ]"], "[", "a", "]"}], "[", 
       RowBox[{
        RowBox[{
         UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], ",", 
        RowBox[{
         UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "y", "]"}]}], "]"}], 
      "\[Equal]", 
      RowBox[{
       UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", 
       RowBox[{"a", "[", 
        RowBox[{"x", ",", "y"}], "]"}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Fun2 EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:660096993", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.661084908612527*^9, 3.661084924664955*^9}},
 CellTags->{
  "ID:660096993", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun2 EC QuoDom"},
 CellID->660096993],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantRelation1", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "x", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       RowBox[{
        UnderscriptBox["Rel1", "\[ScriptCapitalQ]"], "[", "a", "]"}], "[", 
       RowBox[{
        UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], "]"}], 
      "\[DoubleLongLeftRightArrow]", 
      RowBox[{"a", "[", "x", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Rel1 EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:579696921", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6610849290953627`*^9, 3.6610849573002124`*^9}},
 CellTags->{
  "ID:579696921", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel1 EC QuoDom"},
 CellID->579696921],

Cell[BoxData[
 RowBox[{
  RowBox[{"isInvariantRelation2", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Tilde]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", 
       RowBox[{"x", ",", "y"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       RowBox[{
        UnderscriptBox["Rel2", "\[ScriptCapitalQ]"], "[", "a", "]"}], "[", 
       RowBox[{
        RowBox[{
         UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "x", "]"}], ",", 
        RowBox[{
         UnderscriptBox["EC", "\[ScriptCapitalQ]"], "[", "y", "]"}]}], "]"}], 
      "\[DoubleLongLeftRightArrow]", 
      RowBox[{"a", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Rel2 EC QuoDom)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:121665751", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.66108497313424*^9, 3.661084988547067*^9}},
 CellTags->{
  "ID:121665751", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel2 EC QuoDom"},
 CellID->121665751],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->645916226]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->123398104],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(RelSet = EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(RelSet = EC QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["X", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["y", "ExpressionVariable"], "\[Element]", 
                    StyleBox["X", "ExpressionVariable"]}]}}]], 
                 RowBox[{
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["x1", "ExpressionVariable"], "\[Element]", 
                    StyleBox["X", "ExpressionVariable"]}]}, {
                    RowBox[{
                    StyleBox["x2", "ExpressionVariable"], "\[Element]", 
                    StyleBox["X", "ExpressionVariable"]}]}}]], 
                    RowBox[{
                    StyleBox["x1", "ExpressionVariable"], "\[Tilde]", 
                    StyleBox["x2", "ExpressionVariable"]}]}], "\[Implies]", 
                   RowBox[{
                    RowBox[{
                    SubscriptBox["RelSet", 
                    RowBox[{
                    UnderscriptBox["Base", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}]], "[", 
                    StyleBox["X", "ExpressionVariable"], "]"}], "\[Equal]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["X", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["y", "ExpressionVariable"], "\[Element]", 
                    StyleBox["X", "ExpressionVariable"]}]}}]], 
                 RowBox[{
                   RowBox[{
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["x1", "ExpressionVariable"], "\[Element]", 
                    StyleBox["X", "ExpressionVariable"]}]}, {
                    RowBox[{
                    StyleBox["x2", "ExpressionVariable"], "\[Element]", 
                    StyleBox["X", "ExpressionVariable"]}]}}]], 
                    RowBox[{
                    StyleBox["x1", "ExpressionVariable"], "\[Tilde]", 
                    StyleBox["x2", "ExpressionVariable"]}]}], "\[Implies]", 
                   RowBox[{
                    RowBox[{
                    SubscriptBox["RelSet", 
                    RowBox[{
                    UnderscriptBox["Base", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}]], "[", 
                    StyleBox["X", "ExpressionVariable"], "]"}], "\[Equal]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:600914281"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p600914281-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p600914281-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:600914281", "Proof|ID:600914281-1"},
 CellID->59538394],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p600914281-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->742827071]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(EC = EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(EC = EC QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Tilde]", 
                   StyleBox[
                   "y", "ExpressionVariable"]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
                   RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Tilde]", 
                   StyleBox[
                   "y", "ExpressionVariable"]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:315304271"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p315304271-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p315304271-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:315304271", "Proof|ID:315304271-1"},
 CellID->10277787],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p315304271-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->75820694]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(generator \[Element] EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(generator \[Element] EC QuoDom)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[Element]", 
                 RowBox[{
                   UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[Element]", 
                 RowBox[{
                   UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:18625187"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p18625187-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p18625187-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:18625187", "Proof|ID:18625187-1"},
 CellID->248846673],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p18625187-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->584557824]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(EC \[Tilde] QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(EC \[Tilde] QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}, {
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}}]], 
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], "\[Tilde]", 
                   StyleBox[
                   "b", "ExpressionVariable"]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}, {
                    RowBox[{
                    StyleBox["b", "ExpressionVariable"], "\[Element]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}]}}]], 
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], "\[Tilde]", 
                   StyleBox[
                   "b", "ExpressionVariable"]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:2541232"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p2541232-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p2541232-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:2541232", "Proof|ID:2541232-1"},
 CellID->71970252],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p2541232-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->207017478]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(Fun1 EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(Fun1 EC QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantFunction1", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Fun1", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "]"}], 
                    "\[Equal]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantFunction1", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Fun1", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "]"}], 
                    "\[Equal]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:850875018"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p850875018-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p850875018-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:850875018", "Proof|ID:850875018-1"},
 CellID->229274292],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p850875018-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellChangeTimes->{
  3.6611628455319424`*^9, {3.661163857907721*^9, 3.6611638651617336`*^9}},
 CellID->690541569]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(Fun2 EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(Fun2 EC QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantFunction2", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Fun2", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], "]"}], 
                    "\[Equal]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], ",", 
                    StyleBox["y", "ExpressionVariable"]}], "]"}], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantFunction2", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Fun2", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], "]"}], 
                    "\[Equal]", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], ",", 
                    StyleBox["y", "ExpressionVariable"]}], "]"}], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:660096993"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p660096993-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p660096993-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:660096993", "Proof|ID:660096993-1"},
 CellID->461529143],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p660096993-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {46., 52.}}]], "ProofInfoBody",
 CellID->130417206]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(Rel1 EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(Rel1 EC QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantRelation1", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Rel1", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "]"}], 
                    "\[DoubleLeftRightArrow]", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantRelation1", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Rel1", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], "]"}], 
                    "\[DoubleLeftRightArrow]", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:579696921"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p579696921-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p579696921-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:579696921", "Proof|ID:579696921-1"},
 CellID->547752486],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p579696921-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->75339468]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(Rel2 EC QuoDom)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(Rel2 EC QuoDom)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantRelation2", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Rel2", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], "]"}], 
                    "\[DoubleLeftRightArrow]", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], ",", 
                    StyleBox["y", "ExpressionVariable"]}], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Tilde]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{"isEquivalence", "[", 
               RowBox[{
                 StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                RowBox[{
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{"isInvariantRelation2", "[", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"], ",", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
                   "]"}], "\[Implies]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["Rel2", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    UnderscriptBox["EC", 
                    RowBox[{"QuoDom", "[", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                    StyleBox["\[Tilde]", "ExpressionVariable"]}], "]"}]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}], "]"}], 
                    "\[DoubleLeftRightArrow]", 
                    RowBox[{
                    StyleBox["a", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["x", "ExpressionVariable"], ",", 
                    StyleBox["y", "ExpressionVariable"]}], 
                    "]"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:121665751"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p121665751-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p121665751-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:121665751", "Proof|ID:121665751-1"},
 CellID->91275895],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p121665751-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->54682895]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Groups/Rings/Fields (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.633078178021634*^9, 3.6330781870695457`*^9}, {
   3.633081130516672*^9, 3.633081133635795*^9}, {3.633081553492838*^9, 
   3.633081568268673*^9}, 3.634885643564721*^9, {3.6567560118576508`*^9, 
   3.656756015976058*^9}},
 CellID->79741596],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.6330782053310623`*^9, 3.633078207150723*^9}},
 CellID->454028482],

Cell["", "OpenEnvironment",
 CellID->70404381],

Cell[CellGroupData[{

Cell["Definition: General Properties of Algebraic Structures", \
"EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.59083100042077*^9, 3.590831014960652*^9}, {
  3.590833771845526*^9, 3.59083378295602*^9}},
 CellID->31332229],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"n", ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[SmallCircle]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[Diamond]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 531967789}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590831022681083*^9, 3.590831052724744*^9}, {
   3.590831123270398*^9, 3.590831123528999*^9}, {3.590831396835937*^9, 
   3.590831397946486*^9}, {3.607771865681761*^9, 3.607771880773784*^9}, {
   3.608522326963874*^9, 3.608522329139662*^9}, {3.608522572306039*^9, 
   3.608522577296925*^9}, {3.610177443390703*^9, 3.610177446029519*^9}, {
   3.610177547457916*^9, 3.610177554601865*^9}, {3.610177807358287*^9, 
   3.610177817102903*^9}, {3.610177974762082*^9, 3.610177976069252*^9}, 
   3.6330782849363127`*^9, {3.633081140588142*^9, 3.6330811681513557`*^9}},
 CellTags->{
  "ID:531967789", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->531967789],

Cell[BoxData[
 RowBox[{
  RowBox[{"isClosed", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y"}], "]"}]], 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"x", "\[SmallCircle]", "y"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isClosed)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1523090696", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590831033774263*^9, 3.590831078123509*^9}, {
   3.590831160056157*^9, 3.590831160610365*^9}, {3.590831670483637*^9, 
   3.59083167088869*^9}, {3.591429354413585*^9, 3.591429356374602*^9}, {
   3.591429399551398*^9, 3.591429400067265*^9}, {3.59402877867028*^9, 
   3.594028780992165*^9}, {3.596183487807451*^9, 3.59618349016342*^9}, 
   3.596183572343792*^9, {3.596190204009095*^9, 3.596190229486225*^9}, {
   3.606126894078319*^9, 3.606126906950875*^9}, {3.607771775233108*^9, 
   3.607771789901367*^9}, {3.633078291448181*^9, 3.633078294438486*^9}, 
   3.6330812787689466`*^9},
 CellTags->{
  "ID:1523090696", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isClosed"},
 CellID->1523090696],

Cell[BoxData[
 RowBox[{
  RowBox[{"isNeutral", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "n", ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", "n", "]"}]}], "\[And]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", "x", "]"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          RowBox[{"x", "\[SmallCircle]", "n"}], "\[Equal]", "x"}], 
         TagBox[")",
          "AutoParentheses"]}], "\[And]", 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          RowBox[{"n", "\[SmallCircle]", "x"}], "\[Equal]", "x"}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isNeutral)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:665775613", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590831105195242*^9, 3.59083118130782*^9}, {
   3.590831674196454*^9, 3.590831676294731*^9}, {3.591429358696491*^9, 
   3.591429360473604*^9}, {3.591429398058796*^9, 3.591429415533786*^9}, 
   3.594028784050385*^9, {3.596183495830089*^9, 3.596183499145763*^9}, 
   3.596183575844386*^9, {3.596190210234045*^9, 3.596190235680421*^9}, {
   3.596190342011857*^9, 3.596190366867577*^9}, {3.606126897030244*^9, 
   3.606126909203772*^9}, {3.60612695882596*^9, 3.606126960599719*^9}, {
   3.607771780740753*^9, 3.607771796148823*^9}, {3.633078296133213*^9, 
   3.633078298235371*^9}, 3.6330812760342712`*^9, {3.633085271795457*^9, 
   3.633085285442295*^9}},
 CellTags->{
  "ID:665775613", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNeutral"},
 CellID->665775613],

Cell[BoxData[
 RowBox[{
  RowBox[{"isAssoc", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y", ",", "z"}], "]"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "\[SmallCircle]", "y"}], ")"}], "\[SmallCircle]", "z"}], 
      "\[Equal]", 
      RowBox[{"x", "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{"y", "\[SmallCircle]", "z"}], ")"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isAssoc)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:154995644", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590831232556038*^9, 3.59083127813177*^9}, {
   3.59083131589331*^9, 3.590831330606875*^9}, {3.590831678206272*^9, 
   3.59083168328612*^9}, {3.591429364155743*^9, 3.591429365417667*^9}, {
   3.591429396474023*^9, 3.591429397137294*^9}, 3.594028785783302*^9, {
   3.596183505872711*^9, 3.596183507639941*^9}, 3.596183579500762*^9, {
   3.596190214358062*^9, 3.596190246518126*^9}, {3.606126901824703*^9, 
   3.606126912983866*^9}, {3.606126962223451*^9, 3.606126962372246*^9}, {
   3.607771800097927*^9, 3.607771810242773*^9}, {3.633078301098525*^9, 
   3.6330783022850637`*^9}, 3.633081290135001*^9},
 CellTags->{
  "ID:154995644", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAssoc"},
 CellID->154995644],

Cell[BoxData[
 RowBox[{
  RowBox[{"isDistr", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Diamond]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y", ",", "z"}], "]"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"x", "\[SmallCircle]", 
         RowBox[{"(", 
          RowBox[{"y", "\[Diamond]", "z"}], ")"}]}], "\[Equal]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"x", "\[SmallCircle]", "y"}], ")"}], "\[Diamond]", 
         RowBox[{"(", 
          RowBox[{"x", "\[SmallCircle]", "z"}], ")"}]}]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[And]", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"y", "\[Diamond]", "z"}], ")"}], "\[SmallCircle]", "x"}], 
        "\[Equal]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"y", "\[SmallCircle]", "x"}], ")"}], "\[Diamond]", 
         RowBox[{"(", 
          RowBox[{"z", "\[SmallCircle]", "x"}], ")"}]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isDistr)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1959021758", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590831356221592*^9, 3.590831486394136*^9}, {
   3.590831685344972*^9, 3.590831690758466*^9}, {3.590832819924406*^9, 
   3.590832844114721*^9}, 3.594028788362924*^9, {3.596183510513295*^9, 
   3.596183512318112*^9}, {3.596183583889386*^9, 3.596183589320064*^9}, {
   3.596190219261135*^9, 3.59619027307067*^9}, {3.606126918111416*^9, 
   3.606126923718458*^9}, {3.606126964329207*^9, 3.60612696628704*^9}, {
   3.607771812054527*^9, 3.607771827478059*^9}, {3.608522331720332*^9, 
   3.608522361256377*^9}, {3.6330783042734747`*^9, 3.633078305264246*^9}, {
   3.6330811709469852`*^9, 3.6330811854369183`*^9}, 3.633081295562923*^9},
 CellTags->{
  "ID:1959021758", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isDistr"},
 CellID->1959021758],

Cell[BoxData[
 RowBox[{
  RowBox[{"isComm", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
      RowBox[{"x", ",", "y"}], "]"}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", "\[SmallCircle]", "y"}], "\[Equal]", 
      RowBox[{"y", "\[SmallCircle]", "x"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isComm)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2052928557", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590831497973439*^9, 3.590831533950834*^9}, {
   3.5908316922663*^9, 3.59083169355672*^9}, 3.594028791787387*^9, {
   3.596183516290776*^9, 3.596183518769471*^9}, 3.596183591791681*^9, {
   3.596190275830871*^9, 3.596190290048154*^9}, {3.606126925672315*^9, 
   3.606126928956295*^9}, {3.606126968277116*^9, 3.606126968426206*^9}, {
   3.607771839866067*^9, 3.607771844543073*^9}, {3.633078307579176*^9, 
   3.633078308941502*^9}, 3.633081301031955*^9},
 CellTags->{
  "ID:2052928557", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isComm"},
 CellID->2052928557],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[Square]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isInverse", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[SmallCircle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[Square]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "n", ",", "\[ScriptCapitalD]"}], "]"}], 
    TagBox[
     RowBox[{
     ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
      "\[DoubleLongLeftRightArrow]"}],
     Identity,
     SyntaxForm->"a\[Implies]b"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
        RowBox[{"[", "x", "]"}]}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"\[And]", 
        RowBox[{"\[Piecewise]", GridBox[{
           {
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
             RowBox[{"[", 
              RowBox[{"\[Square]", " ", "x"}], "]"}]}]},
           {
            RowBox[{
             RowBox[{"x", "\[SmallCircle]", 
              RowBox[{"(", 
               RowBox[{"\[Square]", " ", "x"}], ")"}]}], "\[Equal]", "n"}]},
           {
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\[Square]", " ", "x"}], ")"}], "\[SmallCircle]", 
              "x"}], "\[Equal]", "n"}]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isInverse)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1343138992", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.641635220576708*^9, 3.641635295621551*^9}, {
  3.641635336965167*^9, 3.641635396255747*^9}, {3.641635510789794*^9, 
  3.641635557619995*^9}},
 CellTags->{
  "ID:1343138992", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInverse"},
 CellID->1343138992],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1977433743]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1292223339]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Algebraic Structures (\[Checkmark])", "Section",
 CellChangeTimes->{{3.633078143050215*^9, 3.633078147673259*^9}, {
  3.6537195388778005`*^9, 3.6537195406562033`*^9}, {3.6596943183425975`*^9, 
  3.659694322383004*^9}},
 CellID->1842935737],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "\[ScriptCapitalD]"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 1192467176}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.63307827368983*^9, 3.633078277323882*^9}},
 CellTags->{
  "ID:1192467176", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1192467176],

Cell[CellGroupData[{

Cell["\<\
Cancellative Commutative Monoids (\[Checkmark])\
\>", "Subsection",
 CellChangeTimes->{{3.635485174138318*^9, 3.6354851795993633`*^9}, {
   3.63548540335502*^9, 3.6354854052694273`*^9}, {3.64708069128756*^9, 
   3.647080694864292*^9}, 3.647080835766474*^9, {3.655444987619935*^9, 
   3.6554449915355415`*^9}},
 CellID->385590292],

Cell[CellGroupData[{

Cell["Informal Explanation", "Subsubsection",
 CellChangeTimes->{{3.590833645749285*^9, 3.590833648996198*^9}},
 CellID->1072816],

Cell[TextData[{
 "The \[OpenCurlyDoubleQuote]CCMonoid\[CloseCurlyDoubleQuote] category \
describes the properties of cancellative, commutative monoids \
\[ScriptCapitalD]. These are, of course, the usual properties of the binary \
relation ",
 Cell[BoxData[
  FormBox[
   UnderscriptBox["*", "\[ScriptCapitalD]"], TraditionalForm]]],
 " (closure, associativity, commutativity, neutral element), and additionally \
the requirement that ",
 "\[ScriptCapitalD]",
 " is ",
 StyleBox["cancellative",
  FontSlant->"Italic"],
 ", meaning that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"z", 
     UnderscriptBox["*", "\[ScriptCapitalD]"], "x"}], "\[Equal]", 
    RowBox[{"z", 
     UnderscriptBox["*", "\[ScriptCapitalD]"], "y"}]}], TraditionalForm]]],
 " holds precisely when ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "\[Equal]", "y"}], TraditionalForm]]],
 " holds."
}], "Text",
 CellChangeTimes->{{3.5910743452297297`*^9, 3.591074435009406*^9}, {
   3.59107490535327*^9, 3.591075040809174*^9}, 3.591075074552953*^9, {
   3.592036044096687*^9, 3.59203604773177*^9}, {3.635746328751608*^9, 
   3.635746411487939*^9}, {3.635746472226101*^9, 3.635746520953753*^9}, {
   3.6357465897441187`*^9, 3.635746600848241*^9}, {3.6357466711050243`*^9, 
   3.635746674221189*^9}},
 CellID->1141537016]
}, Closed]],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.635746556623991*^9, 3.635746558461013*^9}},
 CellID->1008704052],

Cell["", "OpenEnvironment",
 CellID->2095126507],

Cell[CellGroupData[{

Cell["Definition: CCMonoid", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.63574656614685*^9, 3.635746568923665*^9}},
 CellID->448781018],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"f", ",", "n"}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isCCMonoid", "[", 
     RowBox[{"\[ScriptCapitalD]", ",", "f", ",", "n"}], "]"}], 
    TagBox[
     RowBox[{
     ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
      "\[DoubleLongLeftRightArrow]"}],
     Identity,
     SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{"isDomain", "[", "\[ScriptCapitalD]", "]"}]},
         {
          RowBox[{"isClosed", "[", 
           RowBox[{"f", ",", "\[ScriptCapitalD]"}], "]"}]},
         {
          RowBox[{"isAssoc", "[", 
           RowBox[{"f", ",", "\[ScriptCapitalD]"}], "]"}]},
         {
          RowBox[{"isComm", "[", 
           RowBox[{"f", ",", "\[ScriptCapitalD]"}], "]"}]},
         {
          RowBox[{"isNeutral", "[", 
           RowBox[{"f", ",", "n", ",", "\[ScriptCapitalD]"}], "]"}]},
         {
          RowBox[{
           UnderscriptBox["\[ForAll]", 
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
             RowBox[{"[", 
              RowBox[{"x", ",", "y", ",", "z"}], "]"}]}]], 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{
               RowBox[{"f", "[", 
                RowBox[{"z", ",", "x"}], "]"}], "\[Equal]", 
               RowBox[{"f", "[", 
                RowBox[{"z", ",", "y"}], "]"}]}], 
              TagBox[")",
               "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{"x", "\[Equal]", "y"}], 
              TagBox[")",
               "AutoParentheses"]}]}], 
            TagBox[")",
             "AutoParentheses"]}]}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCCMonoid)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1597214241", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.639972958215788*^9, 3.63997303328535*^9}, {
  3.6533727368356686`*^9, 3.6533727434812803`*^9}},
 CellTags->{
  "ID:1597214241", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid"},
 CellID->1597214241],

Cell["\<\
We add an abbreviation for multiplicative cancellative commutative monoids, \
since they are needed very frequently.\
\>", "EnvironmentText",
 CellChangeTimes->{{3.63997309431462*^9, 3.639973118517292*^9}},
 CellID->530717929],

Cell[BoxData[
 RowBox[{
  RowBox[{"isCCMonoid", "[", "\[ScriptCapitalD]", "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{"isCCMonoid", "[", 
   RowBox[{"\[ScriptCapitalD]", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["*", "\[ScriptCapitalD]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    UnderscriptBox["1", "\[ScriptCapitalD]"]}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCCMonoid *)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1972933949", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.635746576464059*^9, 3.635746688660664*^9}, {
  3.635746728815113*^9, 3.635746780661043*^9}, {3.639973058828493*^9, 
  3.639973078348372*^9}},
 CellTags->{
  "ID:1972933949", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid *"},
 CellID->1972933949],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1324680537]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->98904843]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Groups (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.641636608460051*^9, 3.641636609839221*^9}, {
  3.6596921956768622`*^9, 3.659692199732869*^9}},
 CellID->1719323837],

Cell["Informal Explanation", "Subsubsection",
 CellChangeTimes->{{3.641636619879401*^9, 3.64163662339817*^9}},
 CellID->341932562],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.64163662870765*^9, 3.641636630509673*^9}},
 CellID->1274281857],

Cell["", "OpenEnvironment",
 CellID->556578949],

Cell[CellGroupData[{

Cell["Definition: Group", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6416366462212954`*^9, 3.641636647858337*^9}},
 CellID->465362497],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"f", ",", "i", ",", "n"}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isGroup", "[", 
     RowBox[{"\[ScriptCapitalD]", ",", "f", ",", "i", ",", "n"}], "]"}], 
    TagBox[
     RowBox[{
     ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
      "\[DoubleLongLeftRightArrow]"}],
     Identity,
     SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{"isDomain", "[", "\[ScriptCapitalD]", "]"}]},
         {
          RowBox[{"isClosed", "[", 
           RowBox[{"f", ",", "\[ScriptCapitalD]"}], "]"}]},
         {
          RowBox[{"isAssoc", "[", 
           RowBox[{"f", ",", "\[ScriptCapitalD]"}], "]"}]},
         {
          RowBox[{"isNeutral", "[", 
           RowBox[{"f", ",", "n", ",", "\[ScriptCapitalD]"}], "]"}]},
         {
          RowBox[{"isInverse", "[", 
           RowBox[{"f", ",", "i", ",", "n", ",", "\[ScriptCapitalD]"}], "]"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isGroup)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1964463139", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.641636655378145*^9, 3.641636710017202*^9}, {
  3.653378070539154*^9, 3.6533780759523635`*^9}},
 CellTags->{
  "ID:1964463139", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup"},
 CellID->1964463139],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->129487384]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->932182300]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.641636634868945*^9, 3.6416366356984463`*^9}, {
  3.6596921887660503`*^9, 3.659692192697257*^9}},
 CellID->288465208],

Cell["", "OpenEnvironment",
 CellID->870533616],

Cell[CellGroupData[{

Cell["Lemma", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{3.641636742675777*^9},
 CellID->296738308],

Cell[BoxData[
 UnderscriptBox[
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Square]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "n"}]], 
  RowBox[{"isGroup", "[", 
   RowBox[{"\[ScriptCapitalD]", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[SmallCircle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Square]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "n"}], "]"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 1561309471}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.641636754941815*^9, 3.6416368197773867`*^9}, {
  3.641636895853747*^9, 3.641636901026046*^9}},
 CellTags->{
  "ID:1561309471", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1561309471],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
   RowBox[{"[", 
    RowBox[{"x", ",", "y"}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 603470889}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.641637043638365*^9, 3.6416370515742397`*^9}},
 CellTags->{
  "ID:603470889", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->603470889],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"x", "\[SmallCircle]", "y"}], "\[Equal]", "n"}], "\[Implies]", 
  RowBox[{"y", "\[Equal]", 
   RowBox[{"\[Square]", " ", "x"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isGroup 2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1714531538", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64163691883842*^9, 3.641636939809841*^9}, {
  3.6416370537201347`*^9, 3.641637056408231*^9}},
 CellTags->{
  "ID:1714531538", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 2"},
 CellID->1714531538],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Square]", 
   RowBox[{"(", 
    RowBox[{"x", "\[SmallCircle]", "y"}], ")"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"\[Square]", " ", "y"}], ")"}], "\[SmallCircle]", 
   RowBox[{"(", 
    RowBox[{"\[Square]", " ", "x"}], ")"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isGroup 3)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1593316744", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6416368262822857`*^9, 3.641636868609964*^9}, 
   3.641637057739628*^9, {3.641637152635352*^9, 3.641637154149786*^9}},
 CellTags->{
  "ID:1593316744", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 3"},
 CellID->1593316744],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Square]", "n"}], "\[Equal]", "n"}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isGroup 0)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:60508897", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6596785098761406`*^9, 3.6596785142285485`*^9}},
 CellTags->{
  "ID:60508897", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 0"},
 CellID->60508897],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Square]", 
   RowBox[{"(", 
    RowBox[{"\[Square]", " ", "x"}], ")"}]}], "\[Equal]", 
  "x"}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isGroup 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:446590811", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64163703504183*^9, 3.6416370727275677`*^9}},
 CellTags->{
  "ID:446590811", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 1"},
 CellID->446590811],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->874309540]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->937494369],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isGroup 2)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isGroup 2)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SmallCircle]", "ExpressionVariable"]}, {
             StyleBox["\[Square]", "ExpressionVariable"]}, {
             StyleBox["n", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isGroup", "[", 
               RowBox[{
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                 StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
                 StyleBox["\[Square]", "ExpressionVariable"], ",", 
                 StyleBox["n", "ExpressionVariable"]}], "]"}], "\[And]", 
             RowBox[{
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[SmallCircle]", 
                 StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
               StyleBox["n", "ExpressionVariable"]}]}], "\[Implies]", 
           RowBox[{
             StyleBox["y", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[Square]", 
               StyleBox[
               "x", "ExpressionVariable"]}]}]}]}], $CellContext`TheoremaForm],
       DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SmallCircle]", "ExpressionVariable"]}, {
             StyleBox["\[Square]", "ExpressionVariable"]}, {
             StyleBox["n", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isGroup", "[", 
               RowBox[{
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
                 StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
                 StyleBox["\[Square]", "ExpressionVariable"], ",", 
                 StyleBox["n", "ExpressionVariable"]}], "]"}], "\[And]", 
             RowBox[{
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[SmallCircle]", 
                 StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
               StyleBox["n", "ExpressionVariable"]}]}], "\[Implies]", 
           RowBox[{
             StyleBox["y", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[Square]", 
               StyleBox[
               "x", "ExpressionVariable"]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1714531538"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1714531538-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1714531538-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1714531538", "Proof|ID:1714531538-1"},
 CellID->319112690],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1714531538-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->174654720]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isGroup 3)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isGroup 3)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SmallCircle]", "ExpressionVariable"]}, {
             StyleBox["\[Square]", "ExpressionVariable"]}, {
             StyleBox["n", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
               StyleBox["\[Square]", "ExpressionVariable"], ",", 
               StyleBox["n", "ExpressionVariable"]}], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{"\[Square]", 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[SmallCircle]", 
                 StyleBox["y", "ExpressionVariable"]}]}], "\[Equal]", 
             RowBox[{
               RowBox[{"\[Square]", 
                 StyleBox["y", "ExpressionVariable"]}], "\[SmallCircle]", 
               RowBox[{"\[Square]", 
                 StyleBox[
                 "x", "ExpressionVariable"]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SmallCircle]", "ExpressionVariable"]}, {
             StyleBox["\[Square]", "ExpressionVariable"]}, {
             StyleBox["n", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
               StyleBox["\[Square]", "ExpressionVariable"], ",", 
               StyleBox["n", "ExpressionVariable"]}], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{"\[Square]", 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[SmallCircle]", 
                 StyleBox["y", "ExpressionVariable"]}]}], "\[Equal]", 
             RowBox[{
               RowBox[{"\[Square]", 
                 StyleBox["y", "ExpressionVariable"]}], "\[SmallCircle]", 
               RowBox[{"\[Square]", 
                 StyleBox[
                 "x", "ExpressionVariable"]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1593316744"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1593316744-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1593316744-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1593316744", "Proof|ID:1593316744-1"},
 CellID->46511985],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1593316744-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->170432487]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isGroup 0)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isGroup 0)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
            StyleBox["\[Square]", "ExpressionVariable"], ",", 
            StyleBox["n", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
               StyleBox["\[Square]", "ExpressionVariable"], ",", 
               StyleBox["n", "ExpressionVariable"]}], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{"\[Square]", 
               StyleBox["n", "ExpressionVariable"]}], "\[Equal]", 
             StyleBox[
             "n", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
            StyleBox["\[Square]", "ExpressionVariable"], ",", 
            StyleBox["n", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
               StyleBox["\[Square]", "ExpressionVariable"], ",", 
               StyleBox["n", "ExpressionVariable"]}], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{"\[Square]", 
               StyleBox["n", "ExpressionVariable"]}], "\[Equal]", 
             StyleBox[
             "n", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:60508897"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p60508897-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p60508897-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:60508897", "Proof|ID:60508897-1"},
 CellID->133380493],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p60508897-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->308748448]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isGroup 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isGroup 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SmallCircle]", "ExpressionVariable"]}, {
             StyleBox["\[Square]", "ExpressionVariable"]}, {
             StyleBox["n", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
               StyleBox["\[Square]", "ExpressionVariable"], ",", 
               StyleBox["n", "ExpressionVariable"]}], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{"\[Square]", 
               RowBox[{"\[Square]", 
                 StyleBox["x", "ExpressionVariable"]}]}], "\[Equal]", 
             StyleBox[
             "x", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["\[SmallCircle]", "ExpressionVariable"]}, {
             StyleBox["\[Square]", "ExpressionVariable"]}, {
             StyleBox["n", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               StyleBox["\[SmallCircle]", "ExpressionVariable"], ",", 
               StyleBox["\[Square]", "ExpressionVariable"], ",", 
               StyleBox["n", "ExpressionVariable"]}], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{"\[Square]", 
               RowBox[{"\[Square]", 
                 StyleBox["x", "ExpressionVariable"]}]}], "\[Equal]", 
             StyleBox[
             "x", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:446590811"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p446590811-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p446590811-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:446590811", "Proof|ID:446590811-1"},
 CellID->4186777],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p446590811-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->211077589]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Rings (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.590833638982542*^9, 3.590833639650928*^9}, 
   3.6330821094940987`*^9, {3.6596924062324324`*^9, 3.6596924106472397`*^9}},
 CellID->1653589144],

Cell[CellGroupData[{

Cell["Informal Explanation", "Subsubsection",
 CellChangeTimes->{{3.590833645749285*^9, 3.590833648996198*^9}},
 CellID->1532797853],

Cell[TextData[{
 "The \[OpenCurlyDoubleQuote]Ring\[CloseCurlyDoubleQuote] category describes \
the properties of (non-commutative) rings (possibly without unit) ",
 Cell[BoxData[
  FormBox["D", TraditionalForm]]],
 ". These are, of course, the usual properties of addition and multiplication \
(closure, associativity, ...). Also, the inverse operation to addition is \
introduced."
}], "Text",
 CellChangeTimes->{{3.5910743452297297`*^9, 3.591074435009406*^9}, {
   3.59107490535327*^9, 3.591075040809174*^9}, 3.591075074552953*^9, {
   3.592036044096687*^9, 3.59203604773177*^9}, 3.635746435053729*^9},
 CellID->2087072197]
}, Closed]],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.590833654212758*^9, 3.590833656302037*^9}},
 CellID->1979879689],

Cell["", "OpenEnvironment",
 CellID->1632404590],

Cell[CellGroupData[{

Cell["Definition: Ring", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.590832725239908*^9, 3.59083272640959*^9}},
 CellID->1892848015],

Cell[BoxData[
 RowBox[{
  RowBox[{"isRing", "[", "\[ScriptCapitalD]", "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"isDomain", "[", "\[ScriptCapitalD]", "]"}]},
       {
        RowBox[{"isClosed", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["+", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isClosed", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["*", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isAssoc", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["+", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isAssoc", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["*", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isNeutral", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["+", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", 
          UnderscriptBox["0", "\[ScriptCapitalD]"], ",", 
          "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isComm", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["+", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isDistr", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["*", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["+", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isInverse", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["+", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["Minus", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", 
          UnderscriptBox["0", "\[ScriptCapitalD]"], ",", 
          "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
           UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
           RowBox[{"x", ",", "y"}], "]"}]], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           RowBox[{"x", 
            UnderscriptBox["-", "\[ScriptCapitalD]"], "y"}], "\[Equal]", 
           RowBox[{"x", 
            UnderscriptBox["+", "\[ScriptCapitalD]"], 
            RowBox[{"(", 
             RowBox[{
              UnderscriptBox["-", "\[ScriptCapitalD]"], "y"}], ")"}]}]}], 
          TagBox[")",
           "AutoParentheses"]}]}]}
      }]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isRing)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1169392713", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590832741809259*^9, 3.590832747195848*^9}, {
   3.590832793018791*^9, 3.590832802966559*^9}, 3.590917819826722*^9, 
   3.590917858932265*^9, {3.590917895993748*^9, 3.590917903314828*^9}, {
   3.591429461038522*^9, 3.591429484654622*^9}, {3.59203279366397*^9, 
   3.592032805362544*^9}, {3.592032837252611*^9, 3.592032874780755*^9}, {
   3.59203565937129*^9, 3.59203571967171*^9}, {3.592035995489941*^9, 
   3.592036016982795*^9}, {3.594028725557138*^9, 3.5940287361709*^9}, {
   3.596183625351639*^9, 3.596183716827507*^9}, {3.596190382298172*^9, 
   3.596190428891182*^9}, {3.606127112279264*^9, 3.606127165031748*^9}, {
   3.607771969627269*^9, 3.607771988507678*^9}, {3.607772073441674*^9, 
   3.607772081189036*^9}, {3.63307841549026*^9, 3.633078442508026*^9}, 
   3.6357466116548986`*^9, {3.640508573688407*^9, 3.640508595462512*^9}, {
   3.640508638041829*^9, 3.640508655022592*^9}, {3.641635617388494*^9, 
   3.641635677564227*^9}, {3.6533780183570623`*^9, 3.6533780243006725`*^9}},
 CellTags->{
  "ID:1169392713", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing"},
 CellID->1169392713],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1784089539]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->33654702]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.641811981803969*^9, 3.64181198258911*^9}, {
  3.659692399696021*^9, 3.6596924036896276`*^9}},
 CellID->2143828374],

Cell["", "OpenEnvironment",
 CellID->839963059],

Cell[CellGroupData[{

Cell["Lemma: Elementary Properties of Rings", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.641811992577785*^9, 3.641811999177535*^9}},
 CellID->1778478693],

Cell[BoxData[
 RowBox[{
  RowBox[{"isRing", "[", "\[ScriptCapitalD]", "]"}], 
  "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 1019439434}]]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6418120073120317`*^9, 3.641812012195035*^9}},
 CellTags->{
  "ID:1019439434", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1019439434],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"f", ",", "P"}]], 
  RowBox[{"isSet", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], 
     UnderscriptBox["|", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
       RowBox[{"[", "x", "]"}]}]], 
     RowBox[{"P", "[", "x", "]"}]}], "}"}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isRing isSet)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:68765473", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647934619398505*^9, 3.6479346402932873`*^9}, {
  3.64793467294037*^9, 3.647934687256269*^9}, {3.659692278653408*^9, 
  3.6596922817110133`*^9}},
 CellTags->{
  "ID:68765473", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing isSet"},
 CellID->68765473],

Cell[BoxData[
 RowBox[{"isGroup", "[", 
  RowBox[{"\[ScriptCapitalD]", ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox[
     UnderscriptBox["+", "\[ScriptCapitalD]"],
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox[
     UnderscriptBox["Minus", "\[ScriptCapitalD]"],
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
  "]"}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isRing 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:713491381", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.641812020381777*^9, 3.641812052539609*^9}},
 CellTags->{
  "ID:713491381", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 1"},
 CellID->713491381],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["0", "\[ScriptCapitalD]"], 
     UnderscriptBox["*", "\[ScriptCapitalD]"], "x"}], "\[Equal]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isRing 2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:491734364", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{3.659692473968751*^9},
 CellTags->{
  "ID:491734364", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 2"},
 CellID->491734364],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1404566399]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1708344039],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isRing isSet)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isRing isSet)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isRing", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["f", "ExpressionVariable"], ",", 
                StyleBox["P", "ExpressionVariable"]}]], 
             RowBox[{"isSet", "[", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   UnderscriptBox["|", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}], "}"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isRing", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              RowBox[{
                StyleBox["f", "ExpressionVariable"], ",", 
                StyleBox["P", "ExpressionVariable"]}]], 
             RowBox[{"isSet", "[", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}], 
                   UnderscriptBox["|", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}], "}"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:68765473"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p68765473-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p68765473-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:68765473", "Proof|ID:68765473-1"},
 CellID->156840741],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p68765473-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->16895151]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isRing 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isRing 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isRing", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               UnderscriptBox["+", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], ",", 
               UnderscriptBox["Minus", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], ",", 
               UnderscriptBox["0", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isRing", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{"isGroup", "[", 
             RowBox[{
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
               UnderscriptBox["+", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], ",", 
               UnderscriptBox["Minus", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], ",", 
               UnderscriptBox["0", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:713491381"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p713491381-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p713491381-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:713491381", "Proof|ID:713491381-1"},
 CellID->125917763],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p713491381-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellChangeTimes->{{3.666526411530093*^9, 3.666526413921568*^9}},
 CellID->510196875]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isRing 2)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isRing 2)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isRing", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 UnderscriptBox["*", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox[
                "\[ScriptCapitalD]", 
                 "ExpressionVariable"]]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isRing", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 UnderscriptBox["*", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox[
                "\[ScriptCapitalD]", 
                 "ExpressionVariable"]]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:491734364"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p491734364-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p491734364-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:491734364", "Proof|ID:491734364-1"},
 CellID->397105211],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p491734364-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->21005898]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Commutative Rings with Unit (\[Checkmark])\
\>", "Subsection",
 CellChangeTimes->{{3.590833679227898*^9, 3.590833685203985*^9}, {
   3.593492616460446*^9, 3.593492620590591*^9}, 3.633082110155882*^9, {
   3.6385220145463657`*^9, 3.6385220171668043`*^9}, {3.659694309512982*^9, 
   3.6596943138497896`*^9}},
 CellID->318314069],

Cell[CellGroupData[{

Cell["Informal Explanation", "Subsubsection",
 CellChangeTimes->{{3.590833691045287*^9, 3.590833694192359*^9}},
 CellID->1603202234],

Cell["\<\
The category \[OpenCurlyDoubleQuote]Unitary Commutative Ring\
\[CloseCurlyDoubleQuote] extends the \[OpenCurlyDoubleQuote]Ring\
\[CloseCurlyDoubleQuote] category by stipulating that multiplication must be \
commutative and that multiplication also needs to have a neutral element.\
\>", "Text",
 CellChangeTimes->{{3.591336809573991*^9, 3.591336920313495*^9}, {
  3.593492627579422*^9, 3.593492631857827*^9}},
 CellID->427358887]
}, Closed]],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.590833700592705*^9, 3.590833702274025*^9}},
 CellID->2011211919],

Cell["", "OpenEnvironment",
 CellID->1438655325],

Cell[CellGroupData[{

Cell["Definition: Unitary Commutative Ring", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.59083062365738*^9, 3.590830628517631*^9}, {
  3.590833789972748*^9, 3.5908337904213*^9}, {3.593492644870606*^9, 
  3.593492648818308*^9}},
 CellID->1089966505],

Cell[BoxData[
 RowBox[{
  RowBox[{"isCommRing1", "[", "\[ScriptCapitalD]", "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"isRing", "[", "\[ScriptCapitalD]", "]"}]},
       {
        RowBox[{"isNeutral", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["*", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["1", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]},
       {
        RowBox[{"isComm", "[", 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           TagBox[
            UnderscriptBox["*", "\[ScriptCapitalD]"],
            Identity], 
           TagBox[")",
            "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}]}
      }]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCommRing1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:812208573", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590830954490796*^9, 3.590830967498824*^9}, {
   3.590831596064627*^9, 3.590831650955051*^9}, {3.590831696240106*^9, 
   3.590831852546905*^9}, {3.590832366302812*^9, 3.590832434252629*^9}, 
   3.590832750184868*^9, {3.590832888605303*^9, 3.5908329133667*^9}, {
   3.596183732404561*^9, 3.596183748333991*^9}, {3.596190479549482*^9, 
   3.596190480580113*^9}, {3.606127283973016*^9, 3.606127285080035*^9}, {
   3.607772093697968*^9, 3.607772095690081*^9}, {3.633081630371752*^9, 
   3.633081637108612*^9}},
 CellTags->{
  "ID:812208573", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1"},
 CellID->812208573],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1261940483]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1298597111],

Cell["", "OpenEnvironment",
 CellID->765232050],

Cell[CellGroupData[{

Cell["Definition: Unit", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.650620101423242*^9, 3.650620102482575*^9}},
 CellID->958556015],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "u", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["isUnit", "\[ScriptCapitalD]"], "[", "u", "]"}], 
    TagBox[
     RowBox[{
     ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
      "\[DoubleLongLeftRightArrow]"}],
     Identity,
     SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Exists]", 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
        RowBox[{"[", "v", "]"}]}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"u", 
         UnderscriptBox["*", "\[ScriptCapitalD]"], "v"}], "\[Equal]", 
        UnderscriptBox["1", "\[ScriptCapitalD]"]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isUnit)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1005941388", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.650620109344823*^9, 3.650620163761639*^9}, {
  3.650620206593532*^9, 3.650620218014369*^9}, {3.650620326269929*^9, 
  3.650620330365822*^9}},
 CellTags->{
  "ID:1005941388", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isUnit"},
 CellID->1005941388],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->970354891]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1252126296]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.639713696358903*^9, 3.639713697230093*^9}, {
  3.6596943024617696`*^9, 3.6596943065177765`*^9}},
 CellID->1011648899],

Cell["", "OpenEnvironment",
 CellID->1205229592],

Cell[CellGroupData[{

Cell["Lemma: Elementary Properties of Commutative Rings with Unit", \
"EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.639713702839057*^9, 3.639713718967901*^9}},
 CellID->168077255],

Cell[BoxData[
 RowBox[{
  RowBox[{"isCommRing1", "[", "\[ScriptCapitalD]", "]"}], 
  "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 1603254219}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6397137273643503`*^9, 3.639713733227503*^9}},
 CellTags->{
  "ID:1603254219", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1603254219],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["0", "\[ScriptCapitalD]"], 
     UnderscriptBox["*", "\[ScriptCapitalD]"], "x"}], "\[Equal]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCommRing1 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:616379398", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6397137466671257`*^9, 3.639713770519959*^9}},
 CellTags->{
  "ID:616379398", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 1"},
 CellID->616379398],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["1", "\[ScriptCapitalD]"], "\[Equal]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "x", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"x", "\[Equal]", 
      UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCommRing1 2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1787433797", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.639713780976866*^9, 3.639713814066217*^9}},
 CellTags->{
  "ID:1787433797", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 2"},
 CellID->1787433797],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", 
     RowBox[{"u", ",", "x"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["isUnit", "\[ScriptCapitalD]"], "[", "u", "]"}], 
    "\[Implies]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"u", 
         UnderscriptBox["*", "\[ScriptCapitalD]"], "x"}], "\[Equal]", 
        UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"x", "\[Equal]", 
        UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCommRing1 3)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1086651396", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.650620251195348*^9, 3.650620309220883*^9}, {
   3.650620388394937*^9, 3.650620390529303*^9}, 3.650622262801776*^9},
 CellTags->{
  "ID:1086651396", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 3"},
 CellID->1086651396],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["1", "\[ScriptCapitalD]"], "\[NotEqual]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
      RowBox[{"[", "u", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       UnderscriptBox["isUnit", "\[ScriptCapitalD]"], "[", "u", "]"}], 
      "\[Implies]", 
      RowBox[{"u", "\[NotEqual]", 
       UnderscriptBox["0", "\[ScriptCapitalD]"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCommRing1 4)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:357550885", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.650620730539261*^9, 3.650620778417454*^9}},
 CellTags->{
  "ID:357550885", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 4"},
 CellID->357550885],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", 
     RowBox[{"u", ",", "v"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       UnderscriptBox["isUnit", "\[ScriptCapitalD]"], "[", "u", "]"}], 
      "\[And]", 
      RowBox[{
       UnderscriptBox["isUnit", "\[ScriptCapitalD]"], "[", "v", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[Implies]", 
    RowBox[{
     UnderscriptBox["isUnit", "\[ScriptCapitalD]"], "[", 
     RowBox[{"u", 
      UnderscriptBox["*", "\[ScriptCapitalD]"], "v"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isCommRing1 5)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2088302303", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.65078622457358*^9, 3.6507862613105097`*^9}},
 CellTags->{
  "ID:2088302303", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 5"},
 CellID->2088302303],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->2107571198]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->678439284],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isCommRing1 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isCommRing1 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 UnderscriptBox["*", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox[
                "\[ScriptCapitalD]", 
                 "ExpressionVariable"]]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 UnderscriptBox["*", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox[
                "\[ScriptCapitalD]", 
                 "ExpressionVariable"]]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:616379398"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p616379398-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p616379398-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:616379398", "Proof|ID:616379398-1"},
 CellID->65009391],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p616379398-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->54585264]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isCommRing1 2)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isCommRing1 2)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["1", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
               "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
             "\[DoubleLeftRightArrow]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox[
                  "\[ScriptCapitalD]", 
                   "ExpressionVariable"]]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["1", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
               "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
             "\[DoubleLeftRightArrow]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox[
                  "\[ScriptCapitalD]", 
                   "ExpressionVariable"]]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1787433797"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1787433797-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1787433797-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1787433797", "Proof|ID:1787433797-1"},
 CellID->60427408],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1787433797-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->480407126]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isCommRing1 3)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isCommRing1 3)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["isUnit", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 StyleBox["u", "ExpressionVariable"], "]"}], "\[Implies]", 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["u", "ExpressionVariable"], 
                    UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                    StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
                   UnderscriptBox["0", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   UnderscriptBox["0", 
                    StyleBox[
                    "\[ScriptCapitalD]", 
                    "ExpressionVariable"]]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["isUnit", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 StyleBox["u", "ExpressionVariable"], "]"}], "\[Implies]", 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["u", "ExpressionVariable"], 
                    UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                    StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
                   UnderscriptBox["0", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
                 "\[DoubleLeftRightArrow]", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   UnderscriptBox["0", 
                    StyleBox[
                    "\[ScriptCapitalD]", 
                    "ExpressionVariable"]]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1086651396"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1086651396-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1086651396-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1086651396", "Proof|ID:1086651396-1"},
 CellID->307947317],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1086651396-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->122088504]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isCommRing1 4)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isCommRing1 4)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["1", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
               "\[NotEqual]", 
               UnderscriptBox["0", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["u", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   UnderscriptBox["isUnit", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}], "\[Implies]", 
                 RowBox[{
                   StyleBox["u", "ExpressionVariable"], "\[NotEqual]", 
                   UnderscriptBox["0", 
                    StyleBox[
                    "\[ScriptCapitalD]", 
                    "ExpressionVariable"]]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["1", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
               "\[NotEqual]", 
               UnderscriptBox["0", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["u", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   UnderscriptBox["isUnit", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}], "\[Implies]", 
                 RowBox[{
                   StyleBox["u", "ExpressionVariable"], "\[NotEqual]", 
                   UnderscriptBox["0", 
                    StyleBox[
                    "\[ScriptCapitalD]", 
                    "ExpressionVariable"]]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:357550885"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p357550885-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p357550885-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:357550885", "Proof|ID:357550885-1"},
 CellID->683270508],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p357550885-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->856423138]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isCommRing1 5)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isCommRing1 5)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["v", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   UnderscriptBox["isUnit", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["isUnit", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["v", "ExpressionVariable"], "]"}]}], "\[Implies]", 
               RowBox[{
                 UnderscriptBox["isUnit", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["u", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["v", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isCommRing1", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["v", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   UnderscriptBox["isUnit", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["isUnit", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["v", "ExpressionVariable"], "]"}]}], "\[Implies]", 
               RowBox[{
                 UnderscriptBox["isUnit", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["u", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["v", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:2088302303"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p2088302303-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p2088302303-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:2088302303", "Proof|ID:2088302303-1"},
 CellID->321492677],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p2088302303-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->192269402]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fields (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.590833724938846*^9, 3.590833725719407*^9}, 
   3.6330821106349897`*^9, {3.655444966169897*^9, 3.6554449702259045`*^9}},
 CellID->850281858],

Cell[CellGroupData[{

Cell["Informal Explanation", "Subsubsection",
 CellChangeTimes->{{3.590833730654747*^9, 3.590833734586418*^9}},
 CellID->1433152330],

Cell[TextData[{
 "The \[OpenCurlyDoubleQuote]Field\[CloseCurlyDoubleQuote] category extends \
the \[OpenCurlyDoubleQuote]Commutative Ring with Unit\[CloseCurlyDoubleQuote] \
category by introducing a new function symbol \[OpenCurlyDoubleQuote]inv\
\[CloseCurlyDoubleQuote] which should have the property of giving the \
multiplicative inverse of a non-zero element ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 ". Also, a binary function symbol \[OpenCurlyDoubleQuote]/\
\[CloseCurlyDoubleQuote] is introduced which should be an abbreviation for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "*", 
    RowBox[{"inv", "[", "y", "]"}]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.591336946772573*^9, 3.591337080034335*^9}},
 CellID->737915736],

Cell["\<\
Well-definedness of \[OpenCurlyDoubleQuote]inv\[CloseCurlyDoubleQuote] \
follows readily from well-definedness of the other operations and from the \
other axioms.\
\>", "Text",
 CellChangeTimes->{{3.592037288979552*^9, 3.592037320302041*^9}},
 CellID->1027255413]
}, Closed]],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.590833739994986*^9, 3.590833741747384*^9}},
 CellID->1155951610],

Cell["", "OpenEnvironment",
 CellID->523344353],

Cell[CellGroupData[{

Cell["Definition: Field", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.590830648538013*^9, 3.590830649815052*^9}},
 CellID->265440682],

Cell[BoxData[
 RowBox[{
  RowBox[{"isField", "[", "\[ScriptCapitalD]", "]"}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[Implies]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"isCommRing1", "[", "\[ScriptCapitalD]", "]"}]},
       {
        RowBox[{
         UnderscriptBox["1", "\[ScriptCapitalD]"], "\[NotEqual]", 
         UnderscriptBox["0", "\[ScriptCapitalD]"]}]},
       {
        RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
           UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", 
           RowBox[{"x", ",", "y"}], "]"}]], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           RowBox[{"y", "\[NotEqual]", 
            UnderscriptBox["0", "\[ScriptCapitalD]"]}], "\[Implies]", 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{"\[And]", 
             RowBox[{"\[Piecewise]", GridBox[{
                {
                 RowBox[{
                  UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
                  RowBox[{"[", 
                   RowBox[{"y", 
                    UnderscriptBox["^", "\[ScriptCapitalD]"], 
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}]}], "]"}]}]},
                {
                 RowBox[{
                  RowBox[{"x", 
                   UnderscriptBox["/", "\[ScriptCapitalD]"], "y"}], 
                  "\[Equal]", 
                  RowBox[{"x", 
                   UnderscriptBox["*", "\[ScriptCapitalD]"], 
                   RowBox[{"(", 
                    RowBox[{"y", 
                    UnderscriptBox["^", "\[ScriptCapitalD]"], 
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}]}], ")"}]}]}]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
            TagBox[")",
             "AutoParentheses"]}]}], 
          TagBox[")",
           "AutoParentheses"]}]}]},
       {
        RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
           UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], "[", "x", 
           "]"}]], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           RowBox[{"x", "\[NotEqual]", 
            UnderscriptBox["0", "\[ScriptCapitalD]"]}], "\[Implies]", 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             RowBox[{"x", 
              UnderscriptBox["/", "\[ScriptCapitalD]"], "x"}], "\[Equal]", 
             UnderscriptBox["1", "\[ScriptCapitalD]"]}], 
            TagBox[")",
             "AutoParentheses"]}]}], 
          TagBox[")",
           "AutoParentheses"]}]}]}
      }]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1231884360", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.590832276767426*^9, 3.590832334668718*^9}, {
   3.590832470840479*^9, 3.590832560456169*^9}, {3.590832592854358*^9, 
   3.590832607140534*^9}, 3.590832920167913*^9, {3.593492385677334*^9, 
   3.593492389035779*^9}, {3.594028760235623*^9, 3.594028762851985*^9}, {
   3.606127295629252*^9, 3.606127339866234*^9}, {3.607772114344306*^9, 
   3.607772137791591*^9}, {3.633081655147279*^9, 3.633081667848714*^9}, {
   3.650785345783072*^9, 3.650785377474769*^9}, {3.662275854316517*^9, 
   3.6622758767493563`*^9}},
 CellTags->{
  "ID:1231884360", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField"},
 CellID->1231884360],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1051823196]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->680590308]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.662274339818057*^9, 3.6622743406916585`*^9}, {
  3.662293626702729*^9, 3.662293630680736*^9}},
 CellID->255705131],

Cell["", "OpenEnvironment",
 CellID->219164290],

Cell[CellGroupData[{

Cell["Lemma: Some Facts about Fields", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6622743486944723`*^9, 3.662274355698885*^9}, {
  3.6622900759890294`*^9, 3.6622900765662303`*^9}},
 CellID->305611509],

Cell[BoxData[
 RowBox[{
  RowBox[{"isField", "[", "\[ScriptCapitalD]", "]"}], 
  "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\AlgebraicStructures.nb", 15476569}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.66227435886569*^9, 3.6622743642320995`*^9}, {
  3.662274400424163*^9, 3.6622744080993767`*^9}},
 CellTags->{
  "ID:15476569", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->15476569],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", 
     RowBox[{"x", ",", "y"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"y", "\[NotEqual]", 
      UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[Implies]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"x", 
       UnderscriptBox["/", "\[ScriptCapitalD]"], "y"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField membership /)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2036492268", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6622744319674187`*^9, 3.66227448374391*^9}},
 CellTags->{
  "ID:2036492268", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField membership /", 
   "IR"},
 CellID->2036492268],

Cell[BoxData[
 RowBox[{
  UnderscriptBox[
   UnderscriptBox["\[ForAll]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"x", ",", "y"}], "]"}]}]], 
   RowBox[{"y", "\[NotEqual]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", 
       UnderscriptBox["*", "\[ScriptCapitalD]"], "y"}], ")"}], 
     UnderscriptBox["/", "\[ScriptCapitalD]"], "y"}], "\[Equal]", "x"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 4)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1399031260", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.662275610050288*^9, 3.6622756230451107`*^9}},
 CellTags->{
  "ID:1399031260", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4"},
 CellID->1399031260],

Cell[BoxData[
 RowBox[{
  UnderscriptBox[
   UnderscriptBox["\[ForAll]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"x", ",", "y"}], "]"}]}]], 
   RowBox[{"y", "\[NotEqual]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", 
       UnderscriptBox["/", "\[ScriptCapitalD]"], "y"}], ")"}], 
     UnderscriptBox["*", "\[ScriptCapitalD]"], "y"}], "\[Equal]", "x"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 4')", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1519132486", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6622749877183948`*^9, 3.662275026500063*^9}},
 CellTags->{
  "ID:1519132486", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4'"},
 CellID->1519132486],

Cell[BoxData[
 RowBox[{
  UnderscriptBox[
   UnderscriptBox["\[ForAll]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", "x", "]"}]}]], 
   RowBox[{"x", "\[NotEqual]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["0", "\[ScriptCapitalD]"], 
     UnderscriptBox["/", "\[ScriptCapitalD]"], "x"}], "\[Equal]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 6)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:23853891", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6622747289451404`*^9, 3.662274762344799*^9}},
 CellTags->{
  "ID:23853891", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 6"},
 CellID->23853891],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", 
     RowBox[{"x", ",", "y"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", 
       UnderscriptBox["*", "\[ScriptCapitalD]"], "y"}], "\[Equal]", 
      UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", "\[Equal]", 
       UnderscriptBox["0", "\[ScriptCapitalD]"]}], "\[Or]", 
      RowBox[{"y", "\[Equal]", 
       UnderscriptBox["0", "\[ScriptCapitalD]"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:214934627", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6622753417142167`*^9, 3.662275373195072*^9}},
 CellTags->{
  "ID:214934627", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1"},
 CellID->214934627],

Cell[BoxData[
 RowBox[{
  UnderscriptBox[
   UnderscriptBox["\[ForAll]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"x", ",", "y"}], "]"}]}]], 
   RowBox[{"y", "\[NotEqual]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", 
       UnderscriptBox["/", "\[ScriptCapitalD]"], "y"}], "\[Equal]", 
      UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"x", "\[Equal]", 
      UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 1')", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1629111293", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6622752128735905`*^9, 3.662275256772067*^9}},
 CellTags->{
  "ID:1629111293", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1'"},
 CellID->1629111293],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "u", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["isUnit", "\[ScriptCapitalD]"], "[", "u", "]"}], 
    "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"u", "\[NotEqual]", 
      UnderscriptBox["0", "\[ScriptCapitalD]"]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:567921874", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.662275115326619*^9, 3.662275142111866*^9}},
 CellTags->{
  "ID:567921874", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 2"},
 CellID->567921874],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", 
     RowBox[{"x", ",", "y"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", 
       UnderscriptBox["*", "\[ScriptCapitalD]"], "y"}], "\[Equal]", 
      UnderscriptBox["1", "\[ScriptCapitalD]"]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[Implies]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"x", "\[Equal]", 
       RowBox[{"y", 
        UnderscriptBox["^", "\[ScriptCapitalD]"], 
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}]}]}], "\[And]", 
      RowBox[{"y", "\[Equal]", 
       RowBox[{"x", 
        UnderscriptBox["^", "\[ScriptCapitalD]"], 
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}]}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 3)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2078845477", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6622754553604164`*^9, 3.66227550885291*^9}},
 CellTags->{
  "ID:2078845477", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 3"},
 CellID->2078845477],

Cell[BoxData[
 RowBox[{
  UnderscriptBox[
   UnderscriptBox["\[ForAll]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"x", ",", "y", ",", "z"}], "]"}]}]], 
   RowBox[{"z", "\[NotEqual]", 
    UnderscriptBox["0", "\[ScriptCapitalD]"]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", 
       UnderscriptBox["+", "\[ScriptCapitalD]"], "y"}], ")"}], 
     UnderscriptBox["/", "\[ScriptCapitalD]"], "z"}], "\[Equal]", 
    RowBox[{
     RowBox[{"x", 
      UnderscriptBox["/", "\[ScriptCapitalD]"], "z"}], 
     UnderscriptBox["+", "\[ScriptCapitalD]"], 
     RowBox[{"y", 
      UnderscriptBox["/", "\[ScriptCapitalD]"], "z"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isField 5)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:170294828", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.662275687145623*^9, 3.6622757442573233`*^9}},
 CellTags->{
  "ID:170294828", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 5"},
 CellID->170294828],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->360165426]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->87659551],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField membership /)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField membership /)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[Implies]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[Implies]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:2036492268"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p2036492268-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p2036492268-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:2036492268", "Proof|ID:2036492268-1"},
 CellID->511497596],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p2036492268-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->192729812]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 4)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 4)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 UnderscriptBox["/", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
               StyleBox[
               "x", "ExpressionVariable"]}]}]}]}], $CellContext`TheoremaForm],
       DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 UnderscriptBox["/", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
               StyleBox[
               "x", "ExpressionVariable"]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1399031260"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1399031260-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1399031260-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1399031260", "Proof|ID:1399031260-1"},
 CellID->563098],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1399031260-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellChangeTimes->{3.6622897486380544`*^9},
 CellID->908463839]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 4')\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 4')\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 UnderscriptBox["*", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
               StyleBox[
               "x", "ExpressionVariable"]}]}]}]}], $CellContext`TheoremaForm],
       DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 UnderscriptBox["*", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
               StyleBox[
               "x", "ExpressionVariable"]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1519132486"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1519132486-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1519132486-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1519132486", "Proof|ID:1519132486-1"},
 CellID->266927180],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1519132486-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->116538041]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 6)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 6)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["x", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 UnderscriptBox["/", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox[
                "\[ScriptCapitalD]", 
                 "ExpressionVariable"]]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["x", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 UnderscriptBox["/", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["x", "ExpressionVariable"]}], "\[Equal]", 
               UnderscriptBox["0", 
                StyleBox[
                "\[ScriptCapitalD]", 
                 "ExpressionVariable"]]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:23853891"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p23853891-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p23853891-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:23853891", "Proof|ID:23853891-1"},
 CellID->358679361],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p23853891-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->2528211]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{"(", 
                 RowBox[{
                   RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                    UnderscriptBox["0", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
                   "\[Or]", 
                   RowBox[{
                    StyleBox["y", "ExpressionVariable"], "\[Equal]", 
                    UnderscriptBox["0", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]}], 
                 ")"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{"(", 
                 RowBox[{
                   RowBox[{
                    StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                    UnderscriptBox["0", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
                   "\[Or]", 
                   RowBox[{
                    StyleBox["y", "ExpressionVariable"], "\[Equal]", 
                    UnderscriptBox["0", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]}], 
                 ")"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1629111293"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p214934627-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p214934627-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:214934627", "Proof|ID:214934627-1"},
 CellID->59879918],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1629111293-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->9940439]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 1')\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 1')\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox[
                  "\[ScriptCapitalD]", 
                   "ExpressionVariable"]]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["y", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{
                 StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                 UnderscriptBox["0", 
                  StyleBox[
                  "\[ScriptCapitalD]", 
                   "ExpressionVariable"]]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1629111293"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1629111293-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1629111293-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1629111293", "Proof|ID:1629111293-1"},
 CellID->522111781],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1629111293-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->341081766]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 2)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 2)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["isUnit", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 StyleBox["u", "ExpressionVariable"], "]"}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{
                 StyleBox["u", "ExpressionVariable"], "\[NotEqual]", 
                 UnderscriptBox["0", 
                  StyleBox[
                  "\[ScriptCapitalD]", 
                   "ExpressionVariable"]]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["u", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 UnderscriptBox["isUnit", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                 StyleBox["u", "ExpressionVariable"], "]"}], 
               "\[DoubleLeftRightArrow]", 
               RowBox[{
                 StyleBox["u", "ExpressionVariable"], "\[NotEqual]", 
                 UnderscriptBox["0", 
                  StyleBox[
                  "\[ScriptCapitalD]", 
                   "ExpressionVariable"]]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:567921874"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p567921874-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p567921874-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:567921874", "Proof|ID:567921874-1"},
 CellID->54163083],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p567921874-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->488460890]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 3)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 3)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
                 UnderscriptBox["1", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[Implies]", 
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{
                    StyleBox["y", "ExpressionVariable"], 
                    UnderscriptBox["^", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                    RowBox[{"-", "1"}]}]}], "\[And]", 
                 RowBox[{
                   StyleBox["y", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{
                    StyleBox["x", "ExpressionVariable"], 
                    UnderscriptBox["^", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                    
                    RowBox[{
                    "-", "1"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["*", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], "\[Equal]", 
                 UnderscriptBox["1", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}], 
               "\[Implies]", 
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{
                    StyleBox["y", "ExpressionVariable"], 
                    UnderscriptBox["^", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                    RowBox[{"-", "1"}]}]}], "\[And]", 
                 RowBox[{
                   StyleBox["y", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{
                    StyleBox["x", "ExpressionVariable"], 
                    UnderscriptBox["^", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                    
                    RowBox[{
                    "-", "1"}]}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:2078845477"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p2078845477-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p2078845477-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:2078845477", "Proof|ID:2078845477-1"},
 CellID->19379211],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p2078845477-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->336923892]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isField 5)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isField 5)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["z", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["z", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["+", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 UnderscriptBox["/", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["z", "ExpressionVariable"]}], "\[Equal]", 
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["z", "ExpressionVariable"]}], 
                 UnderscriptBox["+", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 RowBox[{
                   StyleBox["y", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox[
                   "z", "ExpressionVariable"]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isField", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["y", "ExpressionVariable"], "]"}]}, {
                  RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["z", "ExpressionVariable"], "]"}]}}]], 
              RowBox[{
                StyleBox["z", "ExpressionVariable"], "\[NotEqual]", 
                UnderscriptBox["0", 
                 StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["+", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["y", "ExpressionVariable"]}], 
                 UnderscriptBox["/", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 StyleBox["z", "ExpressionVariable"]}], "\[Equal]", 
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox["z", "ExpressionVariable"]}], 
                 UnderscriptBox["+", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                 RowBox[{
                   StyleBox["y", "ExpressionVariable"], 
                   UnderscriptBox["/", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], 
                   StyleBox[
                   "z", "ExpressionVariable"]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:170294828"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p170294828-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p170294828-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:170294828", "Proof|ID:170294828-1"},
 CellID->284220434],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p170294828-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->159835187]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{1388, 761},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.,
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Theorema"}, "TheoremaCore.nb"]]], 
   Cell["Modify the definitions below to change the default appearance of all \
cells in a given style. \nMake modifications to any definition using commands \
in the Format menu.", "Text"], 
   Cell[
    CellGroupData[{
      Cell["Notebook Options Settings", "Section"], 
      Cell[
      "The options defined for the style below will be used at the Notebook \
level.", "Text"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Notebook"], InputAliases -> {"and" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[And]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "or" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", "\[Or]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "not" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Not]", "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "impl" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[Implies]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[DoubleLongLeftRightArrow]", 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                "\[SelectionPlaceholder]", "\[Equal]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox[
                  
                  RowBox[{
                   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
                    "\[DoubleLongLeftRightArrow]"}], Identity, SyntaxForm -> 
                  "a:=b"], "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", ":=", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "andn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[And]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "orn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Or]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "equivn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[DoubleLeftRightArrow]", "\[Piecewise]", 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "cdist" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Piecewise]", 
                 
                 GridBox[{{
                   "\[SelectionPlaceholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}, {
                   "\[Placeholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "far" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exr" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "farc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exrc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "let" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["let", 
                  RowBox[{"\[Placeholder]", "=", "\[Placeholder]"}]], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "app" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293a", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "prep" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293b", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "join" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22c8", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "elemT" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22ff", Identity, SyntaxForm -> "a+b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "subop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "supop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SuperscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "subsupop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubsuperscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "oop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "uoop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               UnderoverscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "osop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox[
                OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
                "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "op" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               TagBox["\[SelectionPlaceholder]", Identity], 
               TagBox[")", "AutoParentheses"]}], "[]" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:e114", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:e115", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "()" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:fd3e", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:fd3f", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "<>" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27e8", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27e9", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "{}" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:e117", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:e118", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "[[]]" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27e6", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27e7", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "(())" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:2e28", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:2e29", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "<<>>" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27ea", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27eb", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "{{}}" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:2983", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:2984", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "(" -> 
            TagBox["(", "AutoParentheses"], ")" -> 
            TagBox[")", "AutoParentheses"]}, Background -> 
          RGBColor[0.957, 0.96, 0.97]], 
         Cell[
          StyleData["Notebook", "Printout"], Background -> None]}, Open]]}, 
     Open]], 
   Cell[
    CellGroupData[{
      Cell["Style Environment Names", "Section"], 
      Cell[
       StyleData[All, "Working"], DockedCells -> {
         Cell[
         "Theorema 2.0", "SBO", FontTracking -> 8, 
          CellMargins -> {{0, 0}, {0, 0}}, 
          CellFrameMargins -> {{0, 50}, {0, 0}}, FontSize -> 28, FontSlant -> 
          "Plain", FontColor -> RGBColor[0.29, 0.46, 0.6], TextAlignment -> 
          Right, Background -> RGBColor[0.36, 0.54, 0.69]]}], 
      Cell[
       StyleData[
       All, "Layout", StyleDefinitions -> StyleData[All, "Working"]], 
       MenuSortingValue -> 1200]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Styles for Title and Section Cells", "Section"], 
      Cell[
       CellGroupData[{
         Cell["Title", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{27, 27}, {10, 30}}, 
             TextAlignment -> Center, MenuSortingValue -> 1100, 
             MenuCommandKey -> "1", FontFamily -> "Bitstream Charter", 
             FontSize -> 36, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Title", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{6, 10}, {5, 30}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], CellMargins -> {{27, 27}, {20, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1150, FontFamily -> 
             "Bitstream Charter", FontSize -> 24, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{6, 10}, {5, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], CellMargins -> {{27, 27}, {8, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Author"], CellMargins -> {{27, 27}, {18, 20}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Sectioning", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], ShowGroupOpener -> True, MenuSortingValue -> 
             1250, MenuCommandKey -> "4", FontFamily -> "Bitstream Charter", 
             FontSize -> 20, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Section", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{2, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {8, 12}}, 
             MenuSortingValue -> 1300, MenuCommandKey -> "5", FontFamily -> 
             "Bitstream Charter", FontSize -> 14, FontWeight -> "Bold", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Subsection", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{9, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {2, 10}}, 
             MenuSortingValue -> 1350, MenuCommandKey -> "6", FontFamily -> 
             "Bitstream Charter", FontSize -> 12, FontWeight -> "Bold", 
             FontSlant -> "Italic", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsection", "Printout"], ShowGroupOpener -> False,
              CellMargins -> {{35, 0}, {7, 14}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsubsection"], CellDingbat -> None, 
             ShowGroupOpener -> True, 
             CellMargins -> {{27, Inherited}, {Inherited, Inherited}}, 
             FontFamily -> "Bitstream Charter", FontSize -> 11, FontWeight -> 
             "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsubsection", "Printout"], 
             CellMargins -> {{50, 0}, {7, 14}}]}, Closed]]}, Open]]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Styles for Publication\[Hyphen]ready Documents", "Section"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Author"], CellMargins -> {{27, 30}, {20, 5}}, 
          MenuSortingValue -> 1900, FontFamily -> "Helvetica", FontSize -> 14,
           FontSlant -> "Italic"], 
         Cell[
          StyleData["Author", "Printout"], CellMargins -> {{6, 10}, {0, 10}}, 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Abstract"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
          CellMargins -> {{27, 140}, {20, 20}}, LineSpacing -> {0.9, 0}, 
          MenuSortingValue -> 2050, FontFamily -> "Times", FontSize -> 12], 
         Cell[
          StyleData["Abstract", "Printout"], Hyphenation -> True, 
          LineSpacing -> {1, 2}, FontSize -> 10]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Text", "Section"], 
      Cell[
       StyleData["Text"], CellMargins -> {{27, 27}, {Inherited, Inherited}}, 
       TextJustification -> 1., ParagraphIndent -> 15, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["EnvironmentText"], ShowCellBracket -> Automatic, 
       CellMargins -> {{82, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextJustification -> 1., ParagraphSpacing -> {0.3, 0.}, 
       MenuSortingValue -> 1480, MenuCommandKey -> "T", FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Item"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "Item", 
          CounterAssignments -> {{"Subitem", 0}, {"Subsubitem", 0}}, 
          MenuSortingValue -> 1600, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Item", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemParagraph"], CellMargins -> {{81, 10}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          DefaultNewCellStyle -> "Item", MenuSortingValue -> 1600, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemParagraph", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "Subitem", 
          CounterAssignments -> {{"Subsubitem", 0}}, MenuSortingValue -> 1610,
           FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subitem", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemParagraph"], CellMargins -> {{105, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subitem", 
          MenuSortingValue -> 1610, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemParagraph", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subsubitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1620, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subsubitem", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemParagraph"], 
          CellMargins -> {{129, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1625, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemParagraph", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "ItemNumbered", 
          CounterAssignments -> {{"SubitemNumbered", 0}, {
            "SubsubitemNumbered", 0}}, MenuSortingValue -> 1630, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemNumbered", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "SubitemNumbered", 
          CounterAssignments -> {{"SubsubitemNumbered", 0}}, MenuSortingValue -> 
          1640, FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemNumbered", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], ".", 
              CounterBox["SubsubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> 
          "SubitemNumbered", CounterIncrements -> "SubsubitemNumbered", 
          MenuSortingValue -> 1645, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemNumbered", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Theorema", "Section"], 
      Cell[
       StyleData["GlobalDeclaration"], CellFrame -> {{0, 2}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 3}, {2, 2}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       InitializationCell -> True, CellFrameMargins -> 10, CellFrameColor -> 
       RGBColor[0.73, 0.65, 0.61], CellFrameLabelMargins -> {{33, 7}, {1, 1}},
        ShowAutoStyles -> False, MenuSortingValue -> 1441, MenuCommandKey -> 
       "G", FontSize -> 14], 
      Cell[
       StyleData["OpenEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {-4, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       StyleData["EnvironmentHeader"], 
       CellFrame -> {{False, False}, {False, False}}, 
       CellMargins -> {{76, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 6, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       ShowAutoStyles -> False, MenuSortingValue -> 1450, FontSize -> 14, 
       FontWeight -> "Bold", FontVariations -> {"CapsType" -> "SmallCaps"}, 
       Background -> RGBColor[0.89, 0.8, 0.69]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FormalTextInputFormula"], ShowCellBracket -> Automatic, 
          CellMargins -> {{96, 10}, {2, 2}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
          InitializationCell -> True, CellFrameLabelMargins -> 53, 
          ShowAutoStyles -> False, LimitsPositioningTokens -> {}, 
          MenuSortingValue -> 1470, MenuCommandKey -> "F", FontWeight -> 
          "Bold", FontColor -> RGBColor[0.25, 0.19, 0.2]], 
         Cell[
          StyleData["FormalTextInputFormula", "Layout"], Editable -> False], 
         Cell[
          StyleData["FormalTextInputFormula", "Presentation"], Editable -> 
          False]}, Open]], 
      Cell[
       StyleData["EndEnvironmentMarker"], 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextAlignment -> Right, MenuSortingValue -> 1480], 
      Cell[
       StyleData["CloseEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {False, True}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {Inherited, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Computation"], CellFrame -> {{1.5, 0}, {0, 0}}, 
          ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 7}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
          CellFrameMargins -> {{8, 8}, {3, 4}}, CellFrameColor -> 
          RGBColor[0.486, 0.33, 0.32], ShowAutoStyles -> False, 
          MenuSortingValue -> 1510, FontWeight -> "Bold", FontColor -> 
          RGBColor[0.23, 0.25, 0.34], Background -> 
          RGBColor[0.88, 0.88, 0.92]], 
         Cell[
          StyleData["Computation", "Layout"], Editable -> False], 
         Cell[
          StyleData["Computation", "Presentation"], Editable -> False]}, 
        Open]], 
      Cell[
       StyleData["ComputationResult"], CellFrame -> {{1.5, 0}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
       CellFrameMargins -> {{8, 8}, {4, 3}}, CellFrameColor -> 
       RGBColor[0.486, 0.33, 0.32], StyleMenuListing -> None, FontColor -> 
       RGBColor[0.23, 0.25, 0.34], Background -> RGBColor[0.88, 0.88, 0.92]], 
      Cell[
       StyleData["ComputationInfo"], ShowCellBracket -> False, 
       CellMargins -> {{120, 10}, {10, 2}}, StyleMenuListing -> None, 
       FontFamily -> $CellContext`Arial], 
      Cell[
       StyleData["ComputationInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{144, 10}, {10, 2}}, StyleMenuListing -> None], 
      Cell[
       StyleData["ProofInfo"], ShowCellBracket -> False, 
       CellMargins -> {{76, 10}, {6, 6}}, CellFrameLabelMargins -> 15, 
       StyleMenuListing -> None, FontFamily -> "Arial"], 
      Cell[
       StyleData["ProofInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{100, 10}, {0, 0}}, StyleMenuListing -> None], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FrameLabel"], LanguageCategory -> None, StyleMenuListing -> 
          None, FontFamily -> "Times New Roman", FontSize -> 10, FontWeight -> 
          "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
          RGBColor[0.55, 0.44, 0.42], Background -> None], 
         Cell[
          StyleData["FrameLabel", "Printout"]]}, Open]], 
      Cell[
       StyleData["OpenArchive"], CellFrame -> {{False, False}, {False, True}},
        ShowCellBracket -> Automatic, CellMargins -> {{70, 70}, {0, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 20}, CellFrameMargins -> 3, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], CellFrameLabelMargins -> 1, 
       DefaultFormatType -> DefaultInputFormatType, ShowAutoStyles -> False, 
       MenuSortingValue -> 1210, FontWeight -> Bold, Background -> 
       RGBColor[0.73, 0.74, 0.84]], 
      Cell[
       StyleData["ArchiveInfo"], ShowCellBracket -> Automatic, 
       CellMargins -> {{70, 70}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 5, CellFrameLabelMargins -> 3, ShowCellTags -> 
       False, ShowAutoStyles -> False, MenuSortingValue -> 1220, FontWeight -> 
       "Bold", Background -> RGBColor[0.88, 0.88, 0.92]], 
      Cell[
       StyleData["CloseArchive"], 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> 
       Automatic, CellMargins -> {{0, 0}, {5, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 25}, CellFrameMargins -> 2, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], TextAlignment -> Center, 
       MenuSortingValue -> 1230, FontFamily -> "Arial Black", FontSize -> 24, 
       FontWeight -> "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       Background -> RGBColor[0.73, 0.65, 0.61]], 
      Cell[
       StyleData["IncludeArchive"], CellFrame -> {{4, 0}, {False, False}}, 
       ShowCellBracket -> Automatic, 
       CellMargins -> {{81, 100}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameColor -> RGBColor[0.55, 0.44, 0.42], 
       CellFrameLabels -> {{"\[RightSkeleton]", None}, {None, None}}, 
       CellFrameLabelMargins -> 25, MenuSortingValue -> 1445], 
      Cell[
       StyleData["ExpressionVariable"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionABF"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionMeta"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["AutoParentheses"], Editable -> False, SpanMaxSize -> 3, 
          FontOpacity -> 0.15], 
         Cell[
          StyleData["AutoParentheses", "Layout"], FontOpacity -> 0], 
         Cell[
          StyleData["AutoParentheses", "SlideShow"], FontOpacity -> 0]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Emphasized"], MenuCommandKey -> "E", FontSlant -> 
          "Italic"], 
         Cell[
          StyleData["Emphasized", "SlideShow"], FontSlant -> "Plain", 
          FontColor -> RGBColor[0.36, 0.54, 0.69]]}, Open]], 
      Cell[
       StyleData["GenericButton"], FontFamily -> "Bitstream Charter", 
       FontWeight -> "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
       FontVariations -> {
        "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
         "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
       RGBColor[0.23, 0.25, 0.34]], 
      Cell[
       StyleData["TheoremaForm"], "TwoByteSyntaxCharacterAutoReplacement" -> 
       True, LineSpacing -> {1.25, 0, 2}, SingleLetterItalics -> True, 
       StyleMenuListing -> None, FontFamily -> "Courier"], 
      Cell[
       StyleData["ComponentActive"], FontFamily -> "Times New Roman"], 
      Cell[
       StyleData["ComponentInactive"], FontFamily -> "Times New Roman", 
       FontOpacity -> 0.4], 
      Cell[
       StyleData["ComponentEmpty"], FontFamily -> "Times New Roman", 
       FontVariations -> {"StrikeThrough" -> True}], 
      Cell[
       StyleData["TabView"], FontFamily -> "Times New Roman", FontSize -> 10], 
      Cell[
       StyleData["TabViewLabel"], FontFamily -> "Times New Roman", FontSize -> 
       10, FontWeight -> "Bold"], 
      Cell[
       StyleData["FormReference", StyleDefinitions -> StyleData["Text"]], 
       FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> "Plain",
        FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["FormReferenceHover", StyleDefinitions -> StyleData["Text"]],
        FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> 
       "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> True}, 
       FontColor -> RGBColor[0.404, 0.43, 0.545]], 
      Cell[
       StyleData["DisplayFormula"], CellMargins -> {{36, 6}, {7, 7}}, 
       ConversionRules :> {
        "HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}}, 
       CellHorizontalScrolling -> True, DefaultFormatType -> TraditionalForm, 
       InputAutoReplacements -> {}, TextAlignment -> Center, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       ButtonBoxOptions -> {Appearance -> {Automatic, None}}]}, Open]]}, 
  Visible -> False, FrontEndVersion -> 
  "9.0 for Linux x86 (64-bit) (February 7, 2013)", StyleDefinitions -> 
  "StylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ID:809516830"->{
  Cell[113750, 2417, 651, 17, 31, "GlobalDeclaration",
   CellTags->{
    "ID:809516830", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->809516830]},
 "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"->{
  Cell[113750, 2417, 651, 17, 31, "GlobalDeclaration",
   CellTags->{
    "ID:809516830", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->809516830],
  Cell[115392, 2467, 2488, 78, 34, "GlobalDeclaration",
   CellTags->{
    "ID:105808432", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->105808432],
  Cell[117883, 2547, 1445, 46, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:614230936", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive"},
   CellID->614230936],
  Cell[119331, 2595, 1852, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:1177932670", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAntisymmetric"},
   CellID->1177932670],
  Cell[121186, 2658, 1568, 52, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:932142776", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isIrreflexive"},
   CellID->932142776],
  Cell[122757, 2712, 1675, 55, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:35541847", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isSymmetric"},
   CellID->35541847],
  Cell[124435, 2769, 1833, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:291399428", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAsymmetric"},
   CellID->291399428],
  Cell[126271, 2832, 1858, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:535380192", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTransitive"},
   CellID->535380192],
  Cell[128132, 2895, 1743, 56, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:2054329379", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalRelation"},
   CellID->2054329379],
  Cell[129878, 2953, 2480, 81, 74, "FormalTextInputFormula",
   CellTags->{
    "ID:150250031", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isEquivalence"},
   CellID->150250031],
  Cell[132361, 3036, 3407, 97, 59, "FormalTextInputFormula",
   CellTags->{
    "ID:1500614048", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartIrreflOrder"},
   CellID->1500614048],
  Cell[135771, 3135, 2858, 89, 75, "FormalTextInputFormula",
   CellTags->{
    "ID:1317703026", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartReflOrder"},
   CellID->1317703026],
  Cell[138632, 3226, 3379, 99, 75, "FormalTextInputFormula",
   CellTags->{
    "ID:2071876542", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalIrreflOrder"},
   CellID->2071876542],
  Cell[142014, 3327, 3272, 97, 118, "FormalTextInputFormula",
   CellTags->{
    "ID:2048777355", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isJoin"},
   CellID->2048777355],
  Cell[145289, 3426, 1579, 52, 37, "FormalTextInputFormula",
   CellTags->{
    "ID:1924210441", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isMin"},
   CellID->1924210441],
  Cell[146871, 3480, 2424, 72, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:929796587", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNoetherian"},
   CellID->929796587],
  Cell[149298, 3554, 3504, 104, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:1479000424", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isOrderEmbedding"},
   CellID->1479000424],
  Cell[153670, 3693, 706, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1224736736", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1224736736],
  Cell[154379, 3712, 1051, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:663270760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "asymmetric \[DoubleRightArrow] irreflexive"},
   CellID->663270760],
  Cell[155433, 3741, 1059, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:285650760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "asymmetric \[DoubleRightArrow] antisymmetric"},
   CellID->285650760],
  Cell[156495, 3770, 1287, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:74183342", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isEquivalence alternative", "IR"},
   CellID->74183342],
  Cell[157785, 3808, 1399, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:238839812", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartReflOrder alternative", "IR"},
   CellID->238839812],
  Cell[159187, 3848, 1259, 35, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:281023185", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartIrreflOrder alternative", "IR"},
   CellID->281023185],
  Cell[160449, 3885, 1356, 37, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:816399472", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative", "IR"},
   CellID->816399472],
  Cell[161808, 3924, 1321, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1286795454", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative II", "IR"},
   CellID->1286795454],
  Cell[193556, 4805, 1077, 32, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1946807802", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1946807802],
  Cell[194636, 4839, 2192, 69, 70, "GlobalDeclaration",
   CellTags->{
    "ID:604644732", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->604644732],
  Cell[196831, 4910, 1288, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:883452679", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive embedding"},
   CellID->883452679],
  Cell[198122, 4952, 1248, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1544154211", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isAsymmetric embedding"},
   CellID->1544154211],
  Cell[199373, 4994, 1247, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1384519374", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTransitive embedding"},
   CellID->1384519374],
  Cell[200623, 5036, 1267, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:646610345", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartIrreflOrder embedding"},
   CellID->646610345],
  Cell[201893, 5078, 1250, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1746482051", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isNoetherian embedding"},
   CellID->1746482051],
  Cell[203398, 5129, 1480, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:632872799", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->632872799],
  Cell[204881, 5179, 1257, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:123344064", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isAntisymmetric embedding"},
   CellID->123344064],
  Cell[206141, 5221, 1259, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1095452192", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalRelation embedding"},
   CellID->1095452192],
  Cell[207403, 5263, 1260, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1770002934", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartReflOrder embedding"},
   CellID->1770002934],
  Cell[208666, 5305, 1270, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:741041662", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder embedding"},
   CellID->741041662],
  Cell[289147, 7240, 1666, 59, 70, "GlobalDeclaration",
   CellTags->{
    "ID:236772010", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->236772010],
  Cell[291271, 7317, 1053, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:178453409", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "join absorption"},
   CellID->178453409],
  Cell[298007, 7512, 710, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:135753527", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->135753527],
  Cell[298720, 7532, 3050, 99, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:73073670", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction"},
   CellID->73073670],
  Cell[301773, 7633, 3523, 111, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1991524700", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction'",
      "IR"},
   CellID->1991524700],
  Cell[321938, 8174, 1054, 30, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1439528152", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1439528152],
  Cell[322995, 8206, 758, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1138027217", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1138027217],
  Cell[323756, 8227, 1900, 64, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:75332861", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "minimum isFinite"},
   CellID->75332861],
  Cell[325659, 8293, 1854, 63, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:242836600", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "maximum isFinite"},
   CellID->242836600],
  Cell[327516, 8358, 1476, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:141004932", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "minimum isFinite totalIrrefl"},
   CellID->141004932],
  Cell[328995, 8408, 1577, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:547704634", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "maximum isFinite totalIrrefl"},
   CellID->547704634],
  Cell[355946, 9130, 777, 23, 33, "GlobalDeclaration",
   CellTags->{
    "ID:4832845", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->4832845],
  Cell[357405, 9178, 685, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:131514176", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->131514176],
  Cell[358093, 9197, 2394, 71, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:85261794", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction1"},
   CellID->85261794],
  Cell[360490, 9270, 3047, 89, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:715106769", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction2"},
   CellID->715106769],
  Cell[363540, 9361, 1936, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:218481457", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantRelation1"},
   CellID->218481457],
  Cell[365479, 9422, 2955, 88, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:40789237", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvaiantRelation2"},
   CellID->40789237],
  Cell[369087, 9536, 1048, 28, 70, "GlobalDeclaration",
   CellTags->{
    "ID:597743189", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->597743189],
  Cell[370138, 9566, 711, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:207685257", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->207685257],
  Cell[370852, 9585, 1025, 28, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:48746434", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Base"},
   CellID->48746434],
  Cell[371880, 9615, 1793, 55, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:591224316", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom \[Element]"},
   CellID->591224316],
  Cell[373676, 9672, 1139, 34, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:91525291", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom EC"},
   CellID->91525291],
  Cell[374818, 9708, 1406, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:79971692", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun1"},
   CellID->79971692],
  Cell[376227, 9748, 1303, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:211465861", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun2"},
   CellID->211465861],
  Cell[377533, 9786, 1271, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:207120323", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel1"},
   CellID->207120323],
  Cell[378807, 9824, 1381, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:726147690", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel2"},
   CellID->726147690],
  Cell[380595, 9882, 912, 26, 33, "GlobalDeclaration",
   CellTags->{
    "ID:275047301", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->275047301],
  Cell[382012, 9927, 973, 26, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:18750149", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Base isSet QuoDom", 
     "IR"},
   CellID->18750149],
  Cell[382988, 9955, 940, 24, 21, "FormalTextInputFormula",
   CellTags->{
    "ID:140284862", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom isDomain", "IR"},
   CellID->140284862],
  Cell[390951, 10189, 708, 18, 23, "GlobalDeclaration",
   CellTags->{
    "ID:345419617", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->345419617],
  Cell[392200, 10228, 1349, 43, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:88311021", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] Base QuoDom", "IR"},
   CellID->88311021],
  Cell[393552, 10273, 1560, 49, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:323838795", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] QuoDom alternative", "IR"},
   CellID->323838795],
  Cell[395115, 10324, 751, 19, 42, "GlobalDeclaration",
   CellTags->{
    "ID:515475604", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->515475604],
  Cell[395869, 10345, 956, 27, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:394780640", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Element] QuoDom", 
     "IR"},
   CellID->394780640],
  Cell[396828, 10374, 853, 23, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:387391039", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC isSet QuoDom", "IR"},
   CellID->387391039],
  Cell[397684, 10399, 1447, 46, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:154396855", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "\[Element] EC QuoDom", 
     "IR"},
   CellID->154396855],
  Cell[399134, 10447, 981, 27, 36, "FormalTextInputFormula",
   CellTags->{
    "ID:399369070", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "EC \[Element] DomainSets QuoDom"},
   CellID->399369070],
  Cell[430389, 11290, 879, 26, 23, "GlobalDeclaration",
   CellTags->{
    "ID:286514517", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->286514517],
  Cell[431776, 11336, 2028, 64, 52, "FormalTextInputFormula",
   CellTags->{
    "ID:600914281", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "RelSet = EC QuoDom"},
   CellID->600914281],
  Cell[433807, 11402, 1590, 49, 49, "FormalTextInputFormula",
   CellTags->{
    "ID:315304271", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC = EC QuoDom"},
   CellID->315304271],
  Cell[435400, 11453, 1035, 29, 42, "FormalTextInputFormula",
   CellTags->{
    "ID:18625187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "generator \[Element] EC QuoDom", "IR"},
   CellID->18625187],
  Cell[436438, 11484, 1111, 31, 42, "FormalTextInputFormula",
   CellTags->{
    "ID:2541232", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Tilde] QuoDom"},
   CellID->2541232],
  Cell[437552, 11517, 656, 16, 30, "GlobalDeclaration",
   CellTags->{
    "ID:155852592", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->155852592],
  Cell[438211, 11535, 1757, 55, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:850875018", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun1 EC QuoDom"},
   CellID->850875018],
  Cell[439971, 11592, 1873, 59, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:660096993", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun2 EC QuoDom"},
   CellID->660096993],
  Cell[441847, 11653, 1648, 52, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:579696921", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel1 EC QuoDom"},
   CellID->579696921],
  Cell[443498, 11707, 1811, 57, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:121665751", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel2 EC QuoDom"},
   CellID->121665751],
  Cell[505206, 13265, 1478, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:531967789", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->531967789],
  Cell[506687, 13305, 2059, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1523090696", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isClosed"},
   CellID->1523090696],
  Cell[508749, 13364, 2769, 82, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:665775613", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNeutral"},
   CellID->665775613],
  Cell[511521, 13448, 2310, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:154995644", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAssoc"},
   CellID->154995644],
  Cell[513834, 13516, 3166, 95, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1959021758", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isDistr"},
   CellID->1959021758],
  Cell[517003, 13613, 2005, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2052928557", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isComm"},
   CellID->2052928557],
  Cell[519011, 13674, 2898, 96, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1343138992", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInverse"},
   CellID->1343138992],
  Cell[522351, 13790, 675, 16, 31, "GlobalDeclaration",
   CellTags->{
    "ID:1192467176", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1192467176],
  Cell[525453, 13884, 3065, 91, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1597214241", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid"},
   CellID->1597214241],
  Cell[528760, 13984, 1394, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1972933949", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid \[RawStar]"},
   CellID->1972933949],
  Cell[531245, 14069, 2115, 62, 91, "FormalTextInputFormula",
   CellTags->{
    "ID:1964463139", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup"},
   CellID->1964463139],
  Cell[534125, 14164, 1437, 49, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1561309471", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1561309471],
  Cell[535565, 14215, 776, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:603470889", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->603470889],
  Cell[536344, 14237, 944, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1714531538", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 2"},
   CellID->1714531538],
  Cell[537291, 14264, 1075, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1593316744", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 3"},
   CellID->1593316744],
  Cell[538369, 14295, 787, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:60508897", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 0"},
   CellID->60508897],
  Cell[539159, 14318, 847, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:446590811", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 1"},
   CellID->446590811],
  Cell[560644, 14905, 5996, 177, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1169392713", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing"},
   CellID->1169392713],
  Cell[567460, 15115, 685, 19, 23, "GlobalDeclaration",
   CellTags->{
    "ID:1019439434", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1019439434],
  Cell[568148, 15136, 1182, 33, 50, "FormalTextInputFormula",
   CellTags->{
    "ID:68765473", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing isSet"},
   CellID->68765473],
  Cell[569333, 15171, 1207, 39, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:713491381", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 1"},
   CellID->713491381],
  Cell[570543, 15212, 1126, 34, 49, "FormalTextInputFormula",
   CellTags->{
    "ID:491734364", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 2"},
   CellID->491734364],
  Cell[586180, 15665, 2544, 74, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:812208573", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1"},
   CellID->812208573],
  Cell[589304, 15764, 1885, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1005941388", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isUnit"},
   CellID->1005941388],
  Cell[592037, 15857, 714, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1603254219", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1603254219],
  Cell[592754, 15877, 1162, 34, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:616379398", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 1"},
   CellID->616379398],
  Cell[593919, 15913, 1425, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1787433797", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 2"},
   CellID->1787433797],
  Cell[595347, 15960, 1812, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1086651396", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 3"},
   CellID->1086651396],
  Cell[597162, 16019, 1537, 49, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:357550885", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 4"},
   CellID->357550885],
  Cell[598702, 16070, 1492, 46, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2088302303", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 5"},
   CellID->2088302303],
  Cell[627751, 16877, 4268, 117, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1231884360", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField"},
   CellID->1231884360],
  Cell[632887, 17028, 754, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:15476569", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->15476569],
  Cell[633644, 17049, 1416, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2036492268", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField membership /", 
     "IR"},
   CellID->2036492268],
  Cell[635063, 17095, 1301, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1399031260", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4"},
   CellID->1399031260],
  Cell[636367, 17136, 1303, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1519132486", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4'"},
   CellID->1519132486],
  Cell[637673, 17177, 1255, 37, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:23853891", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 6"},
   CellID->23853891],
  Cell[638931, 17216, 1589, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:214934627", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1"},
   CellID->214934627],
  Cell[640523, 17268, 1588, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1629111293", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1'"},
   CellID->1629111293],
  Cell[642114, 17320, 1284, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:567921874", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 2"},
   CellID->567921874],
  Cell[643401, 17362, 1741, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2078845477", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 3"},
   CellID->2078845477],
  Cell[645145, 17420, 1516, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:170294828", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 5"},
   CellID->170294828]},
 "ID:105808432"->{
  Cell[115392, 2467, 2488, 78, 34, "GlobalDeclaration",
   CellTags->{
    "ID:105808432", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->105808432]},
 "ID:614230936"->{
  Cell[117883, 2547, 1445, 46, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:614230936", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive"},
   CellID->614230936]},
 "isReflexive"->{
  Cell[117883, 2547, 1445, 46, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:614230936", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive"},
   CellID->614230936]},
 "ID:1177932670"->{
  Cell[119331, 2595, 1852, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:1177932670", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAntisymmetric"},
   CellID->1177932670]},
 "isAntisymmetric"->{
  Cell[119331, 2595, 1852, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:1177932670", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAntisymmetric"},
   CellID->1177932670]},
 "ID:932142776"->{
  Cell[121186, 2658, 1568, 52, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:932142776", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isIrreflexive"},
   CellID->932142776]},
 "isIrreflexive"->{
  Cell[121186, 2658, 1568, 52, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:932142776", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isIrreflexive"},
   CellID->932142776]},
 "ID:35541847"->{
  Cell[122757, 2712, 1675, 55, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:35541847", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isSymmetric"},
   CellID->35541847]},
 "isSymmetric"->{
  Cell[122757, 2712, 1675, 55, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:35541847", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isSymmetric"},
   CellID->35541847]},
 "ID:291399428"->{
  Cell[124435, 2769, 1833, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:291399428", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAsymmetric"},
   CellID->291399428]},
 "isAsymmetric"->{
  Cell[124435, 2769, 1833, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:291399428", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAsymmetric"},
   CellID->291399428]},
 "ID:535380192"->{
  Cell[126271, 2832, 1858, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:535380192", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTransitive"},
   CellID->535380192]},
 "isTransitive"->{
  Cell[126271, 2832, 1858, 61, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:535380192", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTransitive"},
   CellID->535380192]},
 "ID:2054329379"->{
  Cell[128132, 2895, 1743, 56, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:2054329379", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalRelation"},
   CellID->2054329379]},
 "isTotalRelation"->{
  Cell[128132, 2895, 1743, 56, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:2054329379", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalRelation"},
   CellID->2054329379]},
 "ID:150250031"->{
  Cell[129878, 2953, 2480, 81, 74, "FormalTextInputFormula",
   CellTags->{
    "ID:150250031", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isEquivalence"},
   CellID->150250031]},
 "isEquivalence"->{
  Cell[129878, 2953, 2480, 81, 74, "FormalTextInputFormula",
   CellTags->{
    "ID:150250031", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isEquivalence"},
   CellID->150250031]},
 "ID:1500614048"->{
  Cell[132361, 3036, 3407, 97, 59, "FormalTextInputFormula",
   CellTags->{
    "ID:1500614048", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartIrreflOrder"},
   CellID->1500614048]},
 "isPartIrreflOrder"->{
  Cell[132361, 3036, 3407, 97, 59, "FormalTextInputFormula",
   CellTags->{
    "ID:1500614048", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartIrreflOrder"},
   CellID->1500614048]},
 "ID:1317703026"->{
  Cell[135771, 3135, 2858, 89, 75, "FormalTextInputFormula",
   CellTags->{
    "ID:1317703026", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartReflOrder"},
   CellID->1317703026]},
 "isPartReflOrder"->{
  Cell[135771, 3135, 2858, 89, 75, "FormalTextInputFormula",
   CellTags->{
    "ID:1317703026", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartReflOrder"},
   CellID->1317703026]},
 "ID:2071876542"->{
  Cell[138632, 3226, 3379, 99, 75, "FormalTextInputFormula",
   CellTags->{
    "ID:2071876542", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalIrreflOrder"},
   CellID->2071876542]},
 "isTotalIrreflOrder"->{
  Cell[138632, 3226, 3379, 99, 75, "FormalTextInputFormula",
   CellTags->{
    "ID:2071876542", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalIrreflOrder"},
   CellID->2071876542]},
 "ID:2048777355"->{
  Cell[142014, 3327, 3272, 97, 118, "FormalTextInputFormula",
   CellTags->{
    "ID:2048777355", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isJoin"},
   CellID->2048777355]},
 "isJoin"->{
  Cell[142014, 3327, 3272, 97, 118, "FormalTextInputFormula",
   CellTags->{
    "ID:2048777355", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isJoin"},
   CellID->2048777355]},
 "ID:1924210441"->{
  Cell[145289, 3426, 1579, 52, 37, "FormalTextInputFormula",
   CellTags->{
    "ID:1924210441", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isMin"},
   CellID->1924210441]},
 "isMin"->{
  Cell[145289, 3426, 1579, 52, 37, "FormalTextInputFormula",
   CellTags->{
    "ID:1924210441", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isMin"},
   CellID->1924210441]},
 "ID:929796587"->{
  Cell[146871, 3480, 2424, 72, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:929796587", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNoetherian"},
   CellID->929796587]},
 "isNoetherian"->{
  Cell[146871, 3480, 2424, 72, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:929796587", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNoetherian"},
   CellID->929796587]},
 "ID:1479000424"->{
  Cell[149298, 3554, 3504, 104, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:1479000424", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isOrderEmbedding"},
   CellID->1479000424]},
 "isOrderEmbedding"->{
  Cell[149298, 3554, 3504, 104, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:1479000424", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isOrderEmbedding"},
   CellID->1479000424]},
 "ID:1224736736"->{
  Cell[153670, 3693, 706, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1224736736", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1224736736]},
 "ID:663270760"->{
  Cell[154379, 3712, 1051, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:663270760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "asymmetric \[DoubleRightArrow] irreflexive"},
   CellID->663270760]},
 "asymmetric \[DoubleRightArrow] irreflexive"->{
  Cell[154379, 3712, 1051, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:663270760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "asymmetric \[DoubleRightArrow] irreflexive"},
   CellID->663270760]},
 "ID:285650760"->{
  Cell[155433, 3741, 1059, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:285650760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "asymmetric \[DoubleRightArrow] antisymmetric"},
   CellID->285650760]},
 "asymmetric \[DoubleRightArrow] antisymmetric"->{
  Cell[155433, 3741, 1059, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:285650760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "asymmetric \[DoubleRightArrow] antisymmetric"},
   CellID->285650760]},
 "ID:74183342"->{
  Cell[156495, 3770, 1287, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:74183342", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isEquivalence alternative", "IR"},
   CellID->74183342]},
 "isEquivalence alternative"->{
  Cell[156495, 3770, 1287, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:74183342", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isEquivalence alternative", "IR"},
   CellID->74183342]},
 "IR"->{
  Cell[156495, 3770, 1287, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:74183342", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isEquivalence alternative", "IR"},
   CellID->74183342],
  Cell[157785, 3808, 1399, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:238839812", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartReflOrder alternative", "IR"},
   CellID->238839812],
  Cell[159187, 3848, 1259, 35, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:281023185", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartIrreflOrder alternative", "IR"},
   CellID->281023185],
  Cell[160449, 3885, 1356, 37, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:816399472", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative", "IR"},
   CellID->816399472],
  Cell[161808, 3924, 1321, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1286795454", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative II", "IR"},
   CellID->1286795454],
  Cell[301773, 7633, 3523, 111, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1991524700", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction'",
      "IR"},
   CellID->1991524700],
  Cell[382012, 9927, 973, 26, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:18750149", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Base isSet QuoDom", 
     "IR"},
   CellID->18750149],
  Cell[382988, 9955, 940, 24, 21, "FormalTextInputFormula",
   CellTags->{
    "ID:140284862", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom isDomain", "IR"},
   CellID->140284862],
  Cell[392200, 10228, 1349, 43, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:88311021", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] Base QuoDom", "IR"},
   CellID->88311021],
  Cell[393552, 10273, 1560, 49, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:323838795", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] QuoDom alternative", "IR"},
   CellID->323838795],
  Cell[395869, 10345, 956, 27, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:394780640", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Element] QuoDom", 
     "IR"},
   CellID->394780640],
  Cell[396828, 10374, 853, 23, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:387391039", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC isSet QuoDom", "IR"},
   CellID->387391039],
  Cell[397684, 10399, 1447, 46, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:154396855", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "\[Element] EC QuoDom", 
     "IR"},
   CellID->154396855],
  Cell[435400, 11453, 1035, 29, 42, "FormalTextInputFormula",
   CellTags->{
    "ID:18625187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "generator \[Element] EC QuoDom", "IR"},
   CellID->18625187],
  Cell[633644, 17049, 1416, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2036492268", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField membership /", 
     "IR"},
   CellID->2036492268]},
 "ID:238839812"->{
  Cell[157785, 3808, 1399, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:238839812", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartReflOrder alternative", "IR"},
   CellID->238839812]},
 "isPartReflOrder alternative"->{
  Cell[157785, 3808, 1399, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:238839812", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartReflOrder alternative", "IR"},
   CellID->238839812]},
 "ID:281023185"->{
  Cell[159187, 3848, 1259, 35, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:281023185", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartIrreflOrder alternative", "IR"},
   CellID->281023185]},
 "isPartIrreflOrder alternative"->{
  Cell[159187, 3848, 1259, 35, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:281023185", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartIrreflOrder alternative", "IR"},
   CellID->281023185]},
 "ID:816399472"->{
  Cell[160449, 3885, 1356, 37, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:816399472", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative", "IR"},
   CellID->816399472]},
 "isTotalIrreflOrder alternative"->{
  Cell[160449, 3885, 1356, 37, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:816399472", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative", "IR"},
   CellID->816399472]},
 "ID:1286795454"->{
  Cell[161808, 3924, 1321, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1286795454", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative II", "IR"},
   CellID->1286795454]},
 "isTotalIrreflOrder alternative II"->{
  Cell[161808, 3924, 1321, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1286795454", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder alternative II", "IR"},
   CellID->1286795454]},
 "Proof|ID:663270760"->{
  Cell[163286, 3971, 3053, 84, 70, "ProofInfo",
   CellTags->{"Proof|ID:663270760", "Proof|ID:663270760-1"},
   CellID->644318390]},
 "Proof|ID:663270760-1"->{
  Cell[163286, 3971, 3053, 84, 70, "ProofInfo",
   CellTags->{"Proof|ID:663270760", "Proof|ID:663270760-1"},
   CellID->644318390]},
 "Proof|ID:285650760"->{
  Cell[166903, 4075, 3061, 84, 70, "ProofInfo",
   CellTags->{"Proof|ID:285650760", "Proof|ID:285650760-1"},
   CellID->592867878]},
 "Proof|ID:285650760-1"->{
  Cell[166903, 4075, 3061, 84, 70, "ProofInfo",
   CellTags->{"Proof|ID:285650760", "Proof|ID:285650760-1"},
   CellID->592867878]},
 "Proof|ID:74183342"->{
  Cell[170485, 4178, 4090, 107, 70, "ProofInfo",
   CellTags->{"Proof|ID:74183342", "Proof|ID:74183342-1"},
   CellID->219773652]},
 "Proof|ID:74183342-1"->{
  Cell[170485, 4178, 4090, 107, 70, "ProofInfo",
   CellTags->{"Proof|ID:74183342", "Proof|ID:74183342-1"},
   CellID->219773652]},
 "Proof|ID:281023185"->{
  Cell[175094, 4304, 3709, 97, 70, "ProofInfo",
   CellTags->{"Proof|ID:281023185", "Proof|ID:281023185-1"},
   CellID->507210937]},
 "Proof|ID:281023185-1"->{
  Cell[175094, 4304, 3709, 97, 70, "ProofInfo",
   CellTags->{"Proof|ID:281023185", "Proof|ID:281023185-1"},
   CellID->507210937]},
 "Proof|ID:238839812"->{
  Cell[179324, 4420, 4210, 107, 70, "ProofInfo",
   CellTags->{"Proof|ID:238839812", "Proof|ID:238839812-1"},
   CellID->77499924]},
 "Proof|ID:238839812-1"->{
  Cell[179324, 4420, 4210, 107, 70, "ProofInfo",
   CellTags->{"Proof|ID:238839812", "Proof|ID:238839812-1"},
   CellID->77499924]},
 "Proof|ID:816399472"->{
  Cell[184055, 4546, 4234, 108, 70, "ProofInfo",
   CellTags->{"Proof|ID:816399472", "Proof|ID:816399472-1"},
   CellID->1088293951]},
 "Proof|ID:816399472-1"->{
  Cell[184055, 4546, 4234, 108, 70, "ProofInfo",
   CellTags->{"Proof|ID:816399472", "Proof|ID:816399472-1"},
   CellID->1088293951]},
 "Proof|ID:1286795454"->{
  Cell[188810, 4673, 3749, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1286795454", "Proof|ID:1286795454-1"},
   CellID->2099979165]},
 "Proof|ID:1286795454-1"->{
  Cell[188810, 4673, 3749, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1286795454", "Proof|ID:1286795454-1"},
   CellID->2099979165]},
 "ID:1946807802"->{
  Cell[193556, 4805, 1077, 32, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1946807802", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1946807802]},
 "ID:604644732"->{
  Cell[194636, 4839, 2192, 69, 70, "GlobalDeclaration",
   CellTags->{
    "ID:604644732", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->604644732]},
 "ID:883452679"->{
  Cell[196831, 4910, 1288, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:883452679", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive embedding"},
   CellID->883452679]},
 "isReflexive embedding"->{
  Cell[196831, 4910, 1288, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:883452679", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive embedding"},
   CellID->883452679]},
 "ID:1544154211"->{
  Cell[198122, 4952, 1248, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1544154211", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isAsymmetric embedding"},
   CellID->1544154211]},
 "isAsymmetric embedding"->{
  Cell[198122, 4952, 1248, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1544154211", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isAsymmetric embedding"},
   CellID->1544154211]},
 "ID:1384519374"->{
  Cell[199373, 4994, 1247, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1384519374", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTransitive embedding"},
   CellID->1384519374]},
 "isTransitive embedding"->{
  Cell[199373, 4994, 1247, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1384519374", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTransitive embedding"},
   CellID->1384519374]},
 "ID:646610345"->{
  Cell[200623, 5036, 1267, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:646610345", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartIrreflOrder embedding"},
   CellID->646610345]},
 "isPartIrreflOrder embedding"->{
  Cell[200623, 5036, 1267, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:646610345", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartIrreflOrder embedding"},
   CellID->646610345]},
 "ID:1746482051"->{
  Cell[201893, 5078, 1250, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1746482051", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isNoetherian embedding"},
   CellID->1746482051]},
 "isNoetherian embedding"->{
  Cell[201893, 5078, 1250, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1746482051", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isNoetherian embedding"},
   CellID->1746482051]},
 "ID:632872799"->{
  Cell[203398, 5129, 1480, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:632872799", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->632872799]},
 "ID:123344064"->{
  Cell[204881, 5179, 1257, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:123344064", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isAntisymmetric embedding"},
   CellID->123344064]},
 "isAntisymmetric embedding"->{
  Cell[204881, 5179, 1257, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:123344064", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isAntisymmetric embedding"},
   CellID->123344064]},
 "ID:1095452192"->{
  Cell[206141, 5221, 1259, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1095452192", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalRelation embedding"},
   CellID->1095452192]},
 "isTotalRelation embedding"->{
  Cell[206141, 5221, 1259, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1095452192", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalRelation embedding"},
   CellID->1095452192]},
 "ID:1770002934"->{
  Cell[207403, 5263, 1260, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1770002934", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartReflOrder embedding"},
   CellID->1770002934]},
 "isPartReflOrder embedding"->{
  Cell[207403, 5263, 1260, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1770002934", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isPartReflOrder embedding"},
   CellID->1770002934]},
 "ID:741041662"->{
  Cell[208666, 5305, 1270, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:741041662", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder embedding"},
   CellID->741041662]},
 "isTotalIrreflOrder embedding"->{
  Cell[208666, 5305, 1270, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:741041662", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "isTotalIrreflOrder embedding"},
   CellID->741041662]},
 "Proof|ID:883452679"->{
  Cell[210093, 5356, 7164, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:883452679", "Proof|ID:883452679-1"},
   CellID->30849742]},
 "Proof|ID:883452679-1"->{
  Cell[210093, 5356, 7164, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:883452679", "Proof|ID:883452679-1"},
   CellID->30849742]},
 "Proof|ID:1544154211"->{
  Cell[217776, 5543, 7177, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1544154211", "Proof|ID:1544154211-1"},
   CellID->2049393775]},
 "Proof|ID:1544154211-1"->{
  Cell[217776, 5543, 7177, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1544154211", "Proof|ID:1544154211-1"},
   CellID->2049393775]},
 "Proof|ID:1384519374"->{
  Cell[225474, 5730, 7176, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1384519374", "Proof|ID:1384519374-1"},
   CellID->431921927]},
 "Proof|ID:1384519374-1"->{
  Cell[225474, 5730, 7176, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1384519374", "Proof|ID:1384519374-1"},
   CellID->431921927]},
 "Proof|ID:646610345"->{
  Cell[233172, 5917, 7202, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:646610345", "Proof|ID:646610345-1"},
   CellID->1952836459]},
 "Proof|ID:646610345-1"->{
  Cell[233172, 5917, 7202, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:646610345", "Proof|ID:646610345-1"},
   CellID->1952836459]},
 "Proof|ID:1746482051"->{
  Cell[240894, 6104, 7174, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1746482051", "Proof|ID:1746482051-1"},
   CellID->8671999]},
 "Proof|ID:1746482051-1"->{
  Cell[240894, 6104, 7174, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1746482051", "Proof|ID:1746482051-1"},
   CellID->8671999]},
 "Proof|ID:123344064"->{
  Cell[248655, 6292, 9532, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:123344064", "Proof|ID:123344064-1"},
   CellID->1779690974]},
 "Proof|ID:123344064-1"->{
  Cell[248655, 6292, 9532, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:123344064", "Proof|ID:123344064-1"},
   CellID->1779690974]},
 "Proof|ID:1095452192"->{
  Cell[258708, 6527, 9537, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:1095452192", "Proof|ID:1095452192-1"},
   CellID->1752383333]},
 "Proof|ID:1095452192-1"->{
  Cell[258708, 6527, 9537, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:1095452192", "Proof|ID:1095452192-1"},
   CellID->1752383333]},
 "Proof|ID:1770002934"->{
  Cell[268766, 6762, 9537, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:1770002934", "Proof|ID:1770002934-1"},
   CellID->1038034091]},
 "Proof|ID:1770002934-1"->{
  Cell[268766, 6762, 9537, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:1770002934", "Proof|ID:1770002934-1"},
   CellID->1038034091]},
 "Proof|ID:741041662"->{
  Cell[278825, 6997, 9550, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:741041662", "Proof|ID:741041662-1"},
   CellID->1690532916]},
 "Proof|ID:741041662-1"->{
  Cell[278825, 6997, 9550, 216, 70, "ProofInfo",
   CellTags->{"Proof|ID:741041662", "Proof|ID:741041662-1"},
   CellID->1690532916]},
 "ID:236772010"->{
  Cell[289147, 7240, 1666, 59, 70, "GlobalDeclaration",
   CellTags->{
    "ID:236772010", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->236772010]},
 "ID:178453409"->{
  Cell[291271, 7317, 1053, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:178453409", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "join absorption"},
   CellID->178453409]},
 "join absorption"->{
  Cell[291271, 7317, 1053, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:178453409", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "join absorption"},
   CellID->178453409]},
 "Proof|ID:178453409"->{
  Cell[292480, 7359, 4308, 110, 70, "ProofInfo",
   CellTags->{"Proof|ID:178453409", "Proof|ID:178453409-1"},
   CellID->321919587]},
 "Proof|ID:178453409-1"->{
  Cell[292480, 7359, 4308, 110, 70, "ProofInfo",
   CellTags->{"Proof|ID:178453409", "Proof|ID:178453409-1"},
   CellID->321919587]},
 "ID:135753527"->{
  Cell[298007, 7512, 710, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:135753527", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->135753527]},
 "ID:73073670"->{
  Cell[298720, 7532, 3050, 99, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:73073670", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction"},
   CellID->73073670]},
 "Noetherian induction"->{
  Cell[298720, 7532, 3050, 99, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:73073670", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction"},
   CellID->73073670]},
 "ID:1991524700"->{
  Cell[301773, 7633, 3523, 111, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1991524700", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction'",
      "IR"},
   CellID->1991524700]},
 "Noetherian induction'"->{
  Cell[301773, 7633, 3523, 111, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1991524700", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction'",
      "IR"},
   CellID->1991524700]},
 "Proof|ID:73073670"->{
  Cell[305453, 7755, 7085, 174, 70, "ProofInfo",
   CellTags->{"Proof|ID:73073670", "Proof|ID:73073670-1"},
   CellID->183797557]},
 "Proof|ID:73073670-1"->{
  Cell[305453, 7755, 7085, 174, 70, "ProofInfo",
   CellTags->{"Proof|ID:73073670", "Proof|ID:73073670-1"},
   CellID->183797557]},
 "Proof|ID:1991524700"->{
  Cell[313057, 7948, 7602, 182, 70, "ProofInfo",
   CellTags->{"Proof|ID:1991524700", "Proof|ID:1991524700-1"},
   CellID->302872964]},
 "Proof|ID:1991524700-1"->{
  Cell[313057, 7948, 7602, 182, 70, "ProofInfo",
   CellTags->{"Proof|ID:1991524700", "Proof|ID:1991524700-1"},
   CellID->302872964]},
 "ID:1439528152"->{
  Cell[321938, 8174, 1054, 30, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1439528152", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1439528152]},
 "ID:1138027217"->{
  Cell[322995, 8206, 758, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1138027217", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1138027217]},
 "ID:75332861"->{
  Cell[323756, 8227, 1900, 64, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:75332861", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "minimum isFinite"},
   CellID->75332861]},
 "minimum isFinite"->{
  Cell[323756, 8227, 1900, 64, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:75332861", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "minimum isFinite"},
   CellID->75332861]},
 "ID:242836600"->{
  Cell[325659, 8293, 1854, 63, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:242836600", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "maximum isFinite"},
   CellID->242836600]},
 "maximum isFinite"->{
  Cell[325659, 8293, 1854, 63, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:242836600", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "maximum isFinite"},
   CellID->242836600]},
 "ID:141004932"->{
  Cell[327516, 8358, 1476, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:141004932", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "minimum isFinite totalIrrefl"},
   CellID->141004932]},
 "minimum isFinite totalIrrefl"->{
  Cell[327516, 8358, 1476, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:141004932", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "minimum isFinite totalIrrefl"},
   CellID->141004932]},
 "ID:547704634"->{
  Cell[328995, 8408, 1577, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:547704634", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "maximum isFinite totalIrrefl"},
   CellID->547704634]},
 "maximum isFinite totalIrrefl"->{
  Cell[328995, 8408, 1577, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:547704634", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "maximum isFinite totalIrrefl"},
   CellID->547704634]},
 "Proof|ID:75332861"->{
  Cell[330728, 8469, 5990, 150, 70, "ProofInfo",
   CellTags->{"Proof|ID:75332861", "Proof|ID:75332861-1"},
   CellID->124362427]},
 "Proof|ID:75332861-1"->{
  Cell[330728, 8469, 5990, 150, 70, "ProofInfo",
   CellTags->{"Proof|ID:75332861", "Proof|ID:75332861-1"},
   CellID->124362427]},
 "Proof|ID:242836600"->{
  Cell[337237, 8638, 5995, 150, 70, "ProofInfo",
   CellTags->{"Proof|ID:242836600", "Proof|ID:242836600-1"},
   CellID->125816398]},
 "Proof|ID:242836600-1"->{
  Cell[337237, 8638, 5995, 150, 70, "ProofInfo",
   CellTags->{"Proof|ID:242836600", "Proof|ID:242836600-1"},
   CellID->125816398]},
 "Proof|ID:141004932"->{
  Cell[343752, 8807, 5451, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:141004932", "Proof|ID:141004932-1"},
   CellID->153836126]},
 "Proof|ID:141004932-1"->{
  Cell[343752, 8807, 5451, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:141004932", "Proof|ID:141004932-1"},
   CellID->153836126]},
 "Proof|ID:547704634"->{
  Cell[349723, 8964, 5450, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:547704634", "Proof|ID:547704634-1"},
   CellID->49243488]},
 "Proof|ID:547704634-1"->{
  Cell[349723, 8964, 5450, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:547704634", "Proof|ID:547704634-1"},
   CellID->49243488]},
 "ID:4832845"->{
  Cell[355946, 9130, 777, 23, 33, "GlobalDeclaration",
   CellTags->{
    "ID:4832845", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->4832845]},
 "ID:131514176"->{
  Cell[357405, 9178, 685, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:131514176", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->131514176]},
 "ID:85261794"->{
  Cell[358093, 9197, 2394, 71, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:85261794", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction1"},
   CellID->85261794]},
 "isInvariantFunction1"->{
  Cell[358093, 9197, 2394, 71, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:85261794", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction1"},
   CellID->85261794]},
 "ID:715106769"->{
  Cell[360490, 9270, 3047, 89, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:715106769", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction2"},
   CellID->715106769]},
 "isInvariantFunction2"->{
  Cell[360490, 9270, 3047, 89, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:715106769", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction2"},
   CellID->715106769]},
 "ID:218481457"->{
  Cell[363540, 9361, 1936, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:218481457", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantRelation1"},
   CellID->218481457]},
 "isInvariantRelation1"->{
  Cell[363540, 9361, 1936, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:218481457", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantRelation1"},
   CellID->218481457]},
 "ID:40789237"->{
  Cell[365479, 9422, 2955, 88, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:40789237", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvaiantRelation2"},
   CellID->40789237]},
 "isInvaiantRelation2"->{
  Cell[365479, 9422, 2955, 88, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:40789237", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvaiantRelation2"},
   CellID->40789237]},
 "ID:597743189"->{
  Cell[369087, 9536, 1048, 28, 70, "GlobalDeclaration",
   CellTags->{
    "ID:597743189", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->597743189]},
 "ID:207685257"->{
  Cell[370138, 9566, 711, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:207685257", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->207685257]},
 "ID:48746434"->{
  Cell[370852, 9585, 1025, 28, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:48746434", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Base"},
   CellID->48746434]},
 "QuoDom Base"->{
  Cell[370852, 9585, 1025, 28, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:48746434", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Base"},
   CellID->48746434]},
 "ID:591224316"->{
  Cell[371880, 9615, 1793, 55, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:591224316", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom \[Element]"},
   CellID->591224316]},
 "QuoDom \[Element]"->{
  Cell[371880, 9615, 1793, 55, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:591224316", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom \[Element]"},
   CellID->591224316]},
 "ID:91525291"->{
  Cell[373676, 9672, 1139, 34, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:91525291", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom EC"},
   CellID->91525291]},
 "QuoDom EC"->{
  Cell[373676, 9672, 1139, 34, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:91525291", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom EC"},
   CellID->91525291]},
 "ID:79971692"->{
  Cell[374818, 9708, 1406, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:79971692", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun1"},
   CellID->79971692]},
 "QuoDom Fun1"->{
  Cell[374818, 9708, 1406, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:79971692", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun1"},
   CellID->79971692]},
 "ID:211465861"->{
  Cell[376227, 9748, 1303, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:211465861", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun2"},
   CellID->211465861]},
 "QuoDom Fun2"->{
  Cell[376227, 9748, 1303, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:211465861", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun2"},
   CellID->211465861]},
 "ID:207120323"->{
  Cell[377533, 9786, 1271, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:207120323", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel1"},
   CellID->207120323]},
 "QuoDom Rel1"->{
  Cell[377533, 9786, 1271, 36, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:207120323", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel1"},
   CellID->207120323]},
 "ID:726147690"->{
  Cell[378807, 9824, 1381, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:726147690", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel2"},
   CellID->726147690]},
 "QuoDom Rel2"->{
  Cell[378807, 9824, 1381, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:726147690", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel2"},
   CellID->726147690]},
 "ID:275047301"->{
  Cell[380595, 9882, 912, 26, 33, "GlobalDeclaration",
   CellTags->{
    "ID:275047301", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->275047301]},
 "ID:18750149"->{
  Cell[382012, 9927, 973, 26, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:18750149", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Base isSet QuoDom", 
     "IR"},
   CellID->18750149]},
 "Base isSet QuoDom"->{
  Cell[382012, 9927, 973, 26, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:18750149", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Base isSet QuoDom", 
     "IR"},
   CellID->18750149]},
 "ID:140284862"->{
  Cell[382988, 9955, 940, 24, 21, "FormalTextInputFormula",
   CellTags->{
    "ID:140284862", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom isDomain", "IR"},
   CellID->140284862]},
 "QuoDom isDomain"->{
  Cell[382988, 9955, 940, 24, 21, "FormalTextInputFormula",
   CellTags->{
    "ID:140284862", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom isDomain", "IR"},
   CellID->140284862]},
 "Proof|ID:18750149"->{
  Cell[384083, 9990, 2942, 82, 28, "ProofInfo",
   CellTags->{"Proof|ID:18750149", "Proof|ID:18750149-1"},
   CellID->681889395]},
 "Proof|ID:18750149-1"->{
  Cell[384083, 9990, 2942, 82, 28, "ProofInfo",
   CellTags->{"Proof|ID:18750149", "Proof|ID:18750149-1"},
   CellID->681889395]},
 "Proof|ID:140284862"->{
  Cell[387544, 10091, 2865, 80, 26, "ProofInfo",
   CellTags->{"Proof|ID:140284862", "Proof|ID:140284862-1"},
   CellID->174468768]},
 "Proof|ID:140284862-1"->{
  Cell[387544, 10091, 2865, 80, 26, "ProofInfo",
   CellTags->{"Proof|ID:140284862", "Proof|ID:140284862-1"},
   CellID->174468768]},
 "ID:345419617"->{
  Cell[390951, 10189, 708, 18, 23, "GlobalDeclaration",
   CellTags->{
    "ID:345419617", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->345419617]},
 "ID:88311021"->{
  Cell[392200, 10228, 1349, 43, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:88311021", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] Base QuoDom", "IR"},
   CellID->88311021]},
 "\[Element] Base QuoDom"->{
  Cell[392200, 10228, 1349, 43, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:88311021", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] Base QuoDom", "IR"},
   CellID->88311021]},
 "ID:323838795"->{
  Cell[393552, 10273, 1560, 49, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:323838795", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] QuoDom alternative", "IR"},
   CellID->323838795]},
 "\[Element] QuoDom alternative"->{
  Cell[393552, 10273, 1560, 49, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:323838795", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "\[Element] QuoDom alternative", "IR"},
   CellID->323838795]},
 "ID:515475604"->{
  Cell[395115, 10324, 751, 19, 42, "GlobalDeclaration",
   CellTags->{
    "ID:515475604", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->515475604]},
 "ID:394780640"->{
  Cell[395869, 10345, 956, 27, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:394780640", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Element] QuoDom", 
     "IR"},
   CellID->394780640]},
 "EC \[Element] QuoDom"->{
  Cell[395869, 10345, 956, 27, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:394780640", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Element] QuoDom", 
     "IR"},
   CellID->394780640]},
 "ID:387391039"->{
  Cell[396828, 10374, 853, 23, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:387391039", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC isSet QuoDom", "IR"},
   CellID->387391039]},
 "EC isSet QuoDom"->{
  Cell[396828, 10374, 853, 23, 34, "FormalTextInputFormula",
   CellTags->{
    "ID:387391039", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC isSet QuoDom", "IR"},
   CellID->387391039]},
 "ID:154396855"->{
  Cell[397684, 10399, 1447, 46, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:154396855", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "\[Element] EC QuoDom", 
     "IR"},
   CellID->154396855]},
 "\[Element] EC QuoDom"->{
  Cell[397684, 10399, 1447, 46, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:154396855", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "\[Element] EC QuoDom", 
     "IR"},
   CellID->154396855]},
 "ID:399369070"->{
  Cell[399134, 10447, 981, 27, 36, "FormalTextInputFormula",
   CellTags->{
    "ID:399369070", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "EC \[Element] DomainSets QuoDom"},
   CellID->399369070]},
 "EC \[Element] DomainSets QuoDom"->{
  Cell[399134, 10447, 981, 27, 36, "FormalTextInputFormula",
   CellTags->{
    "ID:399369070", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "EC \[Element] DomainSets QuoDom"},
   CellID->399369070]},
 "Proof|ID:88311021"->{
  Cell[400271, 10485, 4124, 108, 28, "ProofInfo",
   CellTags->{"Proof|ID:88311021", "Proof|ID:88311021-1"},
   CellID->805139363]},
 "Proof|ID:88311021-1"->{
  Cell[400271, 10485, 4124, 108, 28, "ProofInfo",
   CellTags->{"Proof|ID:88311021", "Proof|ID:88311021-1"},
   CellID->805139363]},
 "Proof|ID:323838795"->{
  Cell[404914, 10612, 5237, 132, 26, "ProofInfo",
   CellTags->{"Proof|ID:323838795", "Proof|ID:323838795-1"},
   CellID->19340158]},
 "Proof|ID:323838795-1"->{
  Cell[404914, 10612, 5237, 132, 26, "ProofInfo",
   CellTags->{"Proof|ID:323838795", "Proof|ID:323838795-1"},
   CellID->19340158]},
 "Proof|ID:394780640"->{
  Cell[410671, 10763, 4308, 110, 26, "ProofInfo",
   CellTags->{"Proof|ID:394780640", "Proof|ID:394780640-1"},
   CellID->77476222]},
 "Proof|ID:394780640-1"->{
  Cell[410671, 10763, 4308, 110, 26, "ProofInfo",
   CellTags->{"Proof|ID:394780640", "Proof|ID:394780640-1"},
   CellID->77476222]},
 "Proof|ID:387391039"->{
  Cell[415499, 10892, 3785, 100, 26, "ProofInfo",
   CellTags->{"Proof|ID:387391039", "Proof|ID:387391039-1"},
   CellID->423977867]},
 "Proof|ID:387391039-1"->{
  Cell[415499, 10892, 3785, 100, 26, "ProofInfo",
   CellTags->{"Proof|ID:387391039", "Proof|ID:387391039-1"},
   CellID->423977867]},
 "Proof|ID:154396855"->{
  Cell[419803, 11011, 5391, 134, 26, "ProofInfo",
   CellTags->{"Proof|ID:154396855", "Proof|ID:154396855-1"},
   CellID->105185766]},
 "Proof|ID:154396855-1"->{
  Cell[419803, 11011, 5391, 134, 26, "ProofInfo",
   CellTags->{"Proof|ID:154396855", "Proof|ID:154396855-1"},
   CellID->105185766]},
 "Proof|ID:399369070"->{
  Cell[425714, 11164, 4177, 109, 26, "ProofInfo",
   CellTags->{"Proof|ID:399369070", "Proof|ID:399369070-1"},
   CellID->253624188]},
 "Proof|ID:399369070-1"->{
  Cell[425714, 11164, 4177, 109, 26, "ProofInfo",
   CellTags->{"Proof|ID:399369070", "Proof|ID:399369070-1"},
   CellID->253624188]},
 "ID:286514517"->{
  Cell[430389, 11290, 879, 26, 23, "GlobalDeclaration",
   CellTags->{
    "ID:286514517", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->286514517]},
 "ID:600914281"->{
  Cell[431776, 11336, 2028, 64, 52, "FormalTextInputFormula",
   CellTags->{
    "ID:600914281", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "RelSet = EC QuoDom"},
   CellID->600914281]},
 "RelSet = EC QuoDom"->{
  Cell[431776, 11336, 2028, 64, 52, "FormalTextInputFormula",
   CellTags->{
    "ID:600914281", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "RelSet = EC QuoDom"},
   CellID->600914281]},
 "ID:315304271"->{
  Cell[433807, 11402, 1590, 49, 49, "FormalTextInputFormula",
   CellTags->{
    "ID:315304271", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC = EC QuoDom"},
   CellID->315304271]},
 "EC = EC QuoDom"->{
  Cell[433807, 11402, 1590, 49, 49, "FormalTextInputFormula",
   CellTags->{
    "ID:315304271", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC = EC QuoDom"},
   CellID->315304271]},
 "ID:18625187"->{
  Cell[435400, 11453, 1035, 29, 42, "FormalTextInputFormula",
   CellTags->{
    "ID:18625187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "generator \[Element] EC QuoDom", "IR"},
   CellID->18625187]},
 "generator \[Element] EC QuoDom"->{
  Cell[435400, 11453, 1035, 29, 42, "FormalTextInputFormula",
   CellTags->{
    "ID:18625187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
     "generator \[Element] EC QuoDom", "IR"},
   CellID->18625187]},
 "ID:2541232"->{
  Cell[436438, 11484, 1111, 31, 42, "FormalTextInputFormula",
   CellTags->{
    "ID:2541232", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Tilde] QuoDom"},
   CellID->2541232]},
 "EC \[Tilde] QuoDom"->{
  Cell[436438, 11484, 1111, 31, 42, "FormalTextInputFormula",
   CellTags->{
    "ID:2541232", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Tilde] QuoDom"},
   CellID->2541232]},
 "ID:155852592"->{
  Cell[437552, 11517, 656, 16, 30, "GlobalDeclaration",
   CellTags->{
    "ID:155852592", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->155852592]},
 "ID:850875018"->{
  Cell[438211, 11535, 1757, 55, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:850875018", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun1 EC QuoDom"},
   CellID->850875018]},
 "Fun1 EC QuoDom"->{
  Cell[438211, 11535, 1757, 55, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:850875018", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun1 EC QuoDom"},
   CellID->850875018]},
 "ID:660096993"->{
  Cell[439971, 11592, 1873, 59, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:660096993", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun2 EC QuoDom"},
   CellID->660096993]},
 "Fun2 EC QuoDom"->{
  Cell[439971, 11592, 1873, 59, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:660096993", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun2 EC QuoDom"},
   CellID->660096993]},
 "ID:579696921"->{
  Cell[441847, 11653, 1648, 52, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:579696921", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel1 EC QuoDom"},
   CellID->579696921]},
 "Rel1 EC QuoDom"->{
  Cell[441847, 11653, 1648, 52, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:579696921", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel1 EC QuoDom"},
   CellID->579696921]},
 "ID:121665751"->{
  Cell[443498, 11707, 1811, 57, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:121665751", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel2 EC QuoDom"},
   CellID->121665751]},
 "Rel2 EC QuoDom"->{
  Cell[443498, 11707, 1811, 57, 51, "FormalTextInputFormula",
   CellTags->{
    "ID:121665751", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel2 EC QuoDom"},
   CellID->121665751]},
 "Proof|ID:600914281"->{
  Cell[445465, 11775, 7389, 176, 70, "ProofInfo",
   CellTags->{"Proof|ID:600914281", "Proof|ID:600914281-1"},
   CellID->59538394]},
 "Proof|ID:600914281-1"->{
  Cell[445465, 11775, 7389, 176, 70, "ProofInfo",
   CellTags->{"Proof|ID:600914281", "Proof|ID:600914281-1"},
   CellID->59538394]},
 "Proof|ID:315304271"->{
  Cell[453374, 11970, 5996, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:315304271", "Proof|ID:315304271-1"},
   CellID->10277787]},
 "Proof|ID:315304271-1"->{
  Cell[453374, 11970, 5996, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:315304271", "Proof|ID:315304271-1"},
   CellID->10277787]},
 "Proof|ID:18625187"->{
  Cell[459889, 12135, 4496, 115, 70, "ProofInfo",
   CellTags->{"Proof|ID:18625187", "Proof|ID:18625187-1"},
   CellID->248846673]},
 "Proof|ID:18625187-1"->{
  Cell[459889, 12135, 4496, 115, 70, "ProofInfo",
   CellTags->{"Proof|ID:18625187", "Proof|ID:18625187-1"},
   CellID->248846673]},
 "Proof|ID:2541232"->{
  Cell[464904, 12269, 5952, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:2541232", "Proof|ID:2541232-1"},
   CellID->71970252]},
 "Proof|ID:2541232-1"->{
  Cell[464904, 12269, 5952, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:2541232", "Proof|ID:2541232-1"},
   CellID->71970252]},
 "Proof|ID:850875018"->{
  Cell[471374, 12434, 7226, 172, 70, "ProofInfo",
   CellTags->{"Proof|ID:850875018", "Proof|ID:850875018-1"},
   CellID->229274292]},
 "Proof|ID:850875018-1"->{
  Cell[471374, 12434, 7226, 172, 70, "ProofInfo",
   CellTags->{"Proof|ID:850875018", "Proof|ID:850875018-1"},
   CellID->229274292]},
 "Proof|ID:660096993"->{
  Cell[479215, 12627, 8674, 200, 70, "ProofInfo",
   CellTags->{"Proof|ID:660096993", "Proof|ID:660096993-1"},
   CellID->461529143]},
 "Proof|ID:660096993-1"->{
  Cell[479215, 12627, 8674, 200, 70, "ProofInfo",
   CellTags->{"Proof|ID:660096993", "Proof|ID:660096993-1"},
   CellID->461529143]},
 "Proof|ID:579696921"->{
  Cell[488409, 12846, 6636, 160, 70, "ProofInfo",
   CellTags->{"Proof|ID:579696921", "Proof|ID:579696921-1"},
   CellID->547752486]},
 "Proof|ID:579696921-1"->{
  Cell[488409, 12846, 6636, 160, 70, "ProofInfo",
   CellTags->{"Proof|ID:579696921", "Proof|ID:579696921-1"},
   CellID->547752486]},
 "Proof|ID:121665751"->{
  Cell[495564, 13025, 8083, 188, 70, "ProofInfo",
   CellTags->{"Proof|ID:121665751", "Proof|ID:121665751-1"},
   CellID->91275895]},
 "Proof|ID:121665751-1"->{
  Cell[495564, 13025, 8083, 188, 70, "ProofInfo",
   CellTags->{"Proof|ID:121665751", "Proof|ID:121665751-1"},
   CellID->91275895]},
 "ID:531967789"->{
  Cell[505206, 13265, 1478, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:531967789", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->531967789]},
 "ID:1523090696"->{
  Cell[506687, 13305, 2059, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1523090696", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isClosed"},
   CellID->1523090696]},
 "isClosed"->{
  Cell[506687, 13305, 2059, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1523090696", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isClosed"},
   CellID->1523090696]},
 "ID:665775613"->{
  Cell[508749, 13364, 2769, 82, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:665775613", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNeutral"},
   CellID->665775613]},
 "isNeutral"->{
  Cell[508749, 13364, 2769, 82, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:665775613", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNeutral"},
   CellID->665775613]},
 "ID:154995644"->{
  Cell[511521, 13448, 2310, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:154995644", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAssoc"},
   CellID->154995644]},
 "isAssoc"->{
  Cell[511521, 13448, 2310, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:154995644", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAssoc"},
   CellID->154995644]},
 "ID:1959021758"->{
  Cell[513834, 13516, 3166, 95, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1959021758", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isDistr"},
   CellID->1959021758]},
 "isDistr"->{
  Cell[513834, 13516, 3166, 95, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1959021758", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isDistr"},
   CellID->1959021758]},
 "ID:2052928557"->{
  Cell[517003, 13613, 2005, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2052928557", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isComm"},
   CellID->2052928557]},
 "isComm"->{
  Cell[517003, 13613, 2005, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2052928557", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isComm"},
   CellID->2052928557]},
 "ID:1343138992"->{
  Cell[519011, 13674, 2898, 96, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1343138992", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInverse"},
   CellID->1343138992]},
 "isInverse"->{
  Cell[519011, 13674, 2898, 96, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1343138992", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInverse"},
   CellID->1343138992]},
 "ID:1192467176"->{
  Cell[522351, 13790, 675, 16, 31, "GlobalDeclaration",
   CellTags->{
    "ID:1192467176", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1192467176]},
 "ID:1597214241"->{
  Cell[525453, 13884, 3065, 91, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1597214241", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid"},
   CellID->1597214241]},
 "isCCMonoid"->{
  Cell[525453, 13884, 3065, 91, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1597214241", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid"},
   CellID->1597214241]},
 "ID:1972933949"->{
  Cell[528760, 13984, 1394, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1972933949", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid \[RawStar]"},
   CellID->1972933949]},
 "isCCMonoid \[RawStar]"->{
  Cell[528760, 13984, 1394, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1972933949", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid \[RawStar]"},
   CellID->1972933949]},
 "ID:1964463139"->{
  Cell[531245, 14069, 2115, 62, 91, "FormalTextInputFormula",
   CellTags->{
    "ID:1964463139", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup"},
   CellID->1964463139]},
 "isGroup"->{
  Cell[531245, 14069, 2115, 62, 91, "FormalTextInputFormula",
   CellTags->{
    "ID:1964463139", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup"},
   CellID->1964463139]},
 "ID:1561309471"->{
  Cell[534125, 14164, 1437, 49, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1561309471", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1561309471]},
 "ID:603470889"->{
  Cell[535565, 14215, 776, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:603470889", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->603470889]},
 "ID:1714531538"->{
  Cell[536344, 14237, 944, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1714531538", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 2"},
   CellID->1714531538]},
 "isGroup 2"->{
  Cell[536344, 14237, 944, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1714531538", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 2"},
   CellID->1714531538]},
 "ID:1593316744"->{
  Cell[537291, 14264, 1075, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1593316744", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 3"},
   CellID->1593316744]},
 "isGroup 3"->{
  Cell[537291, 14264, 1075, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1593316744", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 3"},
   CellID->1593316744]},
 "ID:60508897"->{
  Cell[538369, 14295, 787, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:60508897", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 0"},
   CellID->60508897]},
 "isGroup 0"->{
  Cell[538369, 14295, 787, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:60508897", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 0"},
   CellID->60508897]},
 "ID:446590811"->{
  Cell[539159, 14318, 847, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:446590811", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 1"},
   CellID->446590811]},
 "isGroup 1"->{
  Cell[539159, 14318, 847, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:446590811", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 1"},
   CellID->446590811]},
 "Proof|ID:1714531538"->{
  Cell[540162, 14353, 4771, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:1714531538", "Proof|ID:1714531538-1"},
   CellID->319112690]},
 "Proof|ID:1714531538-1"->{
  Cell[540162, 14353, 4771, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:1714531538", "Proof|ID:1714531538-1"},
   CellID->319112690]},
 "Proof|ID:1593316744"->{
  Cell[545454, 14490, 4755, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:1593316744", "Proof|ID:1593316744-1"},
   CellID->46511985]},
 "Proof|ID:1593316744-1"->{
  Cell[545454, 14490, 4755, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:1593316744", "Proof|ID:1593316744-1"},
   CellID->46511985]},
 "Proof|ID:60508897"->{
  Cell[550730, 14627, 3371, 90, 70, "ProofInfo",
   CellTags->{"Proof|ID:60508897", "Proof|ID:60508897-1"},
   CellID->133380493]},
 "Proof|ID:60508897-1"->{
  Cell[550730, 14627, 3371, 90, 70, "ProofInfo",
   CellTags->{"Proof|ID:60508897", "Proof|ID:60508897-1"},
   CellID->133380493]},
 "Proof|ID:446590811"->{
  Cell[554620, 14736, 3862, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:446590811", "Proof|ID:446590811-1"},
   CellID->4186777]},
 "Proof|ID:446590811-1"->{
  Cell[554620, 14736, 3862, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:446590811", "Proof|ID:446590811-1"},
   CellID->4186777]},
 "ID:1169392713"->{
  Cell[560644, 14905, 5996, 177, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1169392713", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing"},
   CellID->1169392713]},
 "isRing"->{
  Cell[560644, 14905, 5996, 177, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1169392713", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing"},
   CellID->1169392713]},
 "ID:1019439434"->{
  Cell[567460, 15115, 685, 19, 23, "GlobalDeclaration",
   CellTags->{
    "ID:1019439434", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1019439434]},
 "ID:68765473"->{
  Cell[568148, 15136, 1182, 33, 50, "FormalTextInputFormula",
   CellTags->{
    "ID:68765473", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing isSet"},
   CellID->68765473]},
 "isRing isSet"->{
  Cell[568148, 15136, 1182, 33, 50, "FormalTextInputFormula",
   CellTags->{
    "ID:68765473", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing isSet"},
   CellID->68765473]},
 "ID:713491381"->{
  Cell[569333, 15171, 1207, 39, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:713491381", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 1"},
   CellID->713491381]},
 "isRing 1"->{
  Cell[569333, 15171, 1207, 39, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:713491381", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 1"},
   CellID->713491381]},
 "ID:491734364"->{
  Cell[570543, 15212, 1126, 34, 49, "FormalTextInputFormula",
   CellTags->{
    "ID:491734364", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 2"},
   CellID->491734364]},
 "isRing 2"->{
  Cell[570543, 15212, 1126, 34, 49, "FormalTextInputFormula",
   CellTags->{
    "ID:491734364", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 2"},
   CellID->491734364]},
 "Proof|ID:68765473"->{
  Cell[571827, 15257, 4068, 108, 28, "ProofInfo",
   CellTags->{"Proof|ID:68765473", "Proof|ID:68765473-1"},
   CellID->156840741]},
 "Proof|ID:68765473-1"->{
  Cell[571827, 15257, 4068, 108, 28, "ProofInfo",
   CellTags->{"Proof|ID:68765473", "Proof|ID:68765473-1"},
   CellID->156840741]},
 "Proof|ID:713491381"->{
  Cell[576413, 15384, 3171, 86, 26, "ProofInfo",
   CellTags->{"Proof|ID:713491381", "Proof|ID:713491381-1"},
   CellID->125917763]},
 "Proof|ID:713491381-1"->{
  Cell[576413, 15384, 3171, 86, 26, "ProofInfo",
   CellTags->{"Proof|ID:713491381", "Proof|ID:713491381-1"},
   CellID->125917763]},
 "Proof|ID:491734364"->{
  Cell[580170, 15490, 3790, 104, 26, "ProofInfo",
   CellTags->{"Proof|ID:491734364", "Proof|ID:491734364-1"},
   CellID->397105211]},
 "Proof|ID:491734364-1"->{
  Cell[580170, 15490, 3790, 104, 26, "ProofInfo",
   CellTags->{"Proof|ID:491734364", "Proof|ID:491734364-1"},
   CellID->397105211]},
 "ID:812208573"->{
  Cell[586180, 15665, 2544, 74, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:812208573", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1"},
   CellID->812208573]},
 "isCommRing1"->{
  Cell[586180, 15665, 2544, 74, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:812208573", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1"},
   CellID->812208573]},
 "ID:1005941388"->{
  Cell[589304, 15764, 1885, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1005941388", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isUnit"},
   CellID->1005941388]},
 "isUnit"->{
  Cell[589304, 15764, 1885, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1005941388", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isUnit"},
   CellID->1005941388]},
 "ID:1603254219"->{
  Cell[592037, 15857, 714, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1603254219", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->1603254219]},
 "ID:616379398"->{
  Cell[592754, 15877, 1162, 34, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:616379398", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 1"},
   CellID->616379398]},
 "isCommRing1 1"->{
  Cell[592754, 15877, 1162, 34, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:616379398", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 1"},
   CellID->616379398]},
 "ID:1787433797"->{
  Cell[593919, 15913, 1425, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1787433797", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 2"},
   CellID->1787433797]},
 "isCommRing1 2"->{
  Cell[593919, 15913, 1425, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1787433797", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 2"},
   CellID->1787433797]},
 "ID:1086651396"->{
  Cell[595347, 15960, 1812, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1086651396", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 3"},
   CellID->1086651396]},
 "isCommRing1 3"->{
  Cell[595347, 15960, 1812, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1086651396", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 3"},
   CellID->1086651396]},
 "ID:357550885"->{
  Cell[597162, 16019, 1537, 49, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:357550885", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 4"},
   CellID->357550885]},
 "isCommRing1 4"->{
  Cell[597162, 16019, 1537, 49, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:357550885", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 4"},
   CellID->357550885]},
 "ID:2088302303"->{
  Cell[598702, 16070, 1492, 46, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2088302303", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 5"},
   CellID->2088302303]},
 "isCommRing1 5"->{
  Cell[598702, 16070, 1492, 46, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2088302303", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 5"},
   CellID->2088302303]},
 "Proof|ID:616379398"->{
  Cell[600351, 16127, 3809, 104, 70, "ProofInfo",
   CellTags->{"Proof|ID:616379398", "Proof|ID:616379398-1"},
   CellID->65009391]},
 "Proof|ID:616379398-1"->{
  Cell[600351, 16127, 3809, 104, 70, "ProofInfo",
   CellTags->{"Proof|ID:616379398", "Proof|ID:616379398-1"},
   CellID->65009391]},
 "Proof|ID:1787433797"->{
  Cell[604679, 16250, 4007, 110, 70, "ProofInfo",
   CellTags->{"Proof|ID:1787433797", "Proof|ID:1787433797-1"},
   CellID->60427408]},
 "Proof|ID:1787433797-1"->{
  Cell[604679, 16250, 4007, 110, 70, "ProofInfo",
   CellTags->{"Proof|ID:1787433797", "Proof|ID:1787433797-1"},
   CellID->60427408]},
 "Proof|ID:1086651396"->{
  Cell[609207, 16379, 5260, 132, 70, "ProofInfo",
   CellTags->{"Proof|ID:1086651396", "Proof|ID:1086651396-1"},
   CellID->307947317]},
 "Proof|ID:1086651396-1"->{
  Cell[609207, 16379, 5260, 132, 70, "ProofInfo",
   CellTags->{"Proof|ID:1086651396", "Proof|ID:1086651396-1"},
   CellID->307947317]},
 "Proof|ID:357550885"->{
  Cell[614988, 16530, 4521, 120, 70, "ProofInfo",
   CellTags->{"Proof|ID:357550885", "Proof|ID:357550885-1"},
   CellID->683270508]},
 "Proof|ID:357550885-1"->{
  Cell[614988, 16530, 4521, 120, 70, "ProofInfo",
   CellTags->{"Proof|ID:357550885", "Proof|ID:357550885-1"},
   CellID->683270508]},
 "Proof|ID:2088302303"->{
  Cell[620029, 16669, 5144, 126, 70, "ProofInfo",
   CellTags->{"Proof|ID:2088302303", "Proof|ID:2088302303-1"},
   CellID->321492677]},
 "Proof|ID:2088302303-1"->{
  Cell[620029, 16669, 5144, 126, 70, "ProofInfo",
   CellTags->{"Proof|ID:2088302303", "Proof|ID:2088302303-1"},
   CellID->321492677]},
 "ID:1231884360"->{
  Cell[627751, 16877, 4268, 117, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1231884360", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField"},
   CellID->1231884360]},
 "isField"->{
  Cell[627751, 16877, 4268, 117, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1231884360", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField"},
   CellID->1231884360]},
 "ID:15476569"->{
  Cell[632887, 17028, 754, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:15476569", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
   CellID->15476569]},
 "ID:2036492268"->{
  Cell[633644, 17049, 1416, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2036492268", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField membership /", 
     "IR"},
   CellID->2036492268]},
 "isField membership /"->{
  Cell[633644, 17049, 1416, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2036492268", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField membership /", 
     "IR"},
   CellID->2036492268]},
 "ID:1399031260"->{
  Cell[635063, 17095, 1301, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1399031260", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4"},
   CellID->1399031260]},
 "isField 4"->{
  Cell[635063, 17095, 1301, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1399031260", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4"},
   CellID->1399031260]},
 "ID:1519132486"->{
  Cell[636367, 17136, 1303, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1519132486", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4'"},
   CellID->1519132486]},
 "isField 4'"->{
  Cell[636367, 17136, 1303, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1519132486", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4'"},
   CellID->1519132486]},
 "ID:23853891"->{
  Cell[637673, 17177, 1255, 37, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:23853891", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 6"},
   CellID->23853891]},
 "isField 6"->{
  Cell[637673, 17177, 1255, 37, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:23853891", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 6"},
   CellID->23853891]},
 "ID:214934627"->{
  Cell[638931, 17216, 1589, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:214934627", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1"},
   CellID->214934627]},
 "isField 1"->{
  Cell[638931, 17216, 1589, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:214934627", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1"},
   CellID->214934627]},
 "ID:1629111293"->{
  Cell[640523, 17268, 1588, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1629111293", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1'"},
   CellID->1629111293]},
 "isField 1'"->{
  Cell[640523, 17268, 1588, 50, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1629111293", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1'"},
   CellID->1629111293]},
 "ID:567921874"->{
  Cell[642114, 17320, 1284, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:567921874", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 2"},
   CellID->567921874]},
 "isField 2"->{
  Cell[642114, 17320, 1284, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:567921874", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 2"},
   CellID->567921874]},
 "ID:2078845477"->{
  Cell[643401, 17362, 1741, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2078845477", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 3"},
   CellID->2078845477]},
 "isField 3"->{
  Cell[643401, 17362, 1741, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2078845477", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 3"},
   CellID->2078845477]},
 "ID:170294828"->{
  Cell[645145, 17420, 1516, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:170294828", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 5"},
   CellID->170294828]},
 "isField 5"->{
  Cell[645145, 17420, 1516, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:170294828", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 5"},
   CellID->170294828]},
 "Proof|ID:2036492268"->{
  Cell[646816, 17476, 4672, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:2036492268", "Proof|ID:2036492268-1"},
   CellID->511497596]},
 "Proof|ID:2036492268-1"->{
  Cell[646816, 17476, 4672, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:2036492268", "Proof|ID:2036492268-1"},
   CellID->511497596]},
 "Proof|ID:1399031260"->{
  Cell[652009, 17613, 4862, 124, 70, "ProofInfo",
   CellTags->{"Proof|ID:1399031260", "Proof|ID:1399031260-1"},
   CellID->563098]},
 "Proof|ID:1399031260-1"->{
  Cell[652009, 17613, 4862, 124, 70, "ProofInfo",
   CellTags->{"Proof|ID:1399031260", "Proof|ID:1399031260-1"},
   CellID->563098]},
 "Proof|ID:1519132486"->{
  Cell[657436, 17757, 4867, 124, 70, "ProofInfo",
   CellTags->{"Proof|ID:1519132486", "Proof|ID:1519132486-1"},
   CellID->266927180]},
 "Proof|ID:1519132486-1"->{
  Cell[657436, 17757, 4867, 124, 70, "ProofInfo",
   CellTags->{"Proof|ID:1519132486", "Proof|ID:1519132486-1"},
   CellID->266927180]},
 "Proof|ID:23853891"->{
  Cell[662824, 17900, 4265, 114, 70, "ProofInfo",
   CellTags->{"Proof|ID:23853891", "Proof|ID:23853891-1"},
   CellID->358679361]},
 "Proof|ID:23853891-1"->{
  Cell[662824, 17900, 4265, 114, 70, "ProofInfo",
   CellTags->{"Proof|ID:23853891", "Proof|ID:23853891-1"},
   CellID->358679361]},
 "Proof|ID:214934627"->{
  Cell[667606, 18033, 5293, 132, 70, "ProofInfo",
   CellTags->{"Proof|ID:214934627", "Proof|ID:214934627-1"},
   CellID->59879918]},
 "Proof|ID:214934627-1"->{
  Cell[667606, 18033, 5293, 132, 70, "ProofInfo",
   CellTags->{"Proof|ID:214934627", "Proof|ID:214934627-1"},
   CellID->59879918]},
 "Proof|ID:1629111293"->{
  Cell[673418, 18184, 5186, 132, 70, "ProofInfo",
   CellTags->{"Proof|ID:1629111293", "Proof|ID:1629111293-1"},
   CellID->522111781]},
 "Proof|ID:1629111293-1"->{
  Cell[673418, 18184, 5186, 132, 70, "ProofInfo",
   CellTags->{"Proof|ID:1629111293", "Proof|ID:1629111293-1"},
   CellID->522111781]},
 "Proof|ID:567921874"->{
  Cell[679125, 18335, 3862, 106, 70, "ProofInfo",
   CellTags->{"Proof|ID:567921874", "Proof|ID:567921874-1"},
   CellID->54163083]},
 "Proof|ID:567921874-1"->{
  Cell[679125, 18335, 3862, 106, 70, "ProofInfo",
   CellTags->{"Proof|ID:567921874", "Proof|ID:567921874-1"},
   CellID->54163083]},
 "Proof|ID:2078845477"->{
  Cell[683507, 18460, 5722, 144, 70, "ProofInfo",
   CellTags->{"Proof|ID:2078845477", "Proof|ID:2078845477-1"},
   CellID->19379211]},
 "Proof|ID:2078845477-1"->{
  Cell[683507, 18460, 5722, 144, 70, "ProofInfo",
   CellTags->{"Proof|ID:2078845477", "Proof|ID:2078845477-1"},
   CellID->19379211]},
 "Proof|ID:170294828"->{
  Cell[689750, 18623, 6507, 156, 70, "ProofInfo",
   CellTags->{"Proof|ID:170294828", "Proof|ID:170294828-1"},
   CellID->284220434]},
 "Proof|ID:170294828-1"->{
  Cell[689750, 18623, 6507, 156, 70, "ProofInfo",
   CellTags->{"Proof|ID:170294828", "Proof|ID:170294828-1"},
   CellID->284220434]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ID:809516830", 734347, 19560},
 {"Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 734647, 19568},
 {"ID:105808432", 763598, 20345},
 {"ID:614230936", 763827, 20352},
 {"isReflexive", 764075, 20359},
 {"ID:1177932670", 764325, 20366},
 {"isAntisymmetric", 764583, 20373},
 {"ID:932142776", 764838, 20380},
 {"isIrreflexive", 765090, 20387},
 {"ID:35541847", 765340, 20394},
 {"isSymmetric", 765586, 20401},
 {"ID:291399428", 765833, 20408},
 {"isAsymmetric", 766083, 20415},
 {"ID:535380192", 766333, 20422},
 {"isTransitive", 766583, 20429},
 {"ID:2054329379", 766834, 20436},
 {"isTotalRelation", 767092, 20443},
 {"ID:150250031", 767347, 20450},
 {"isEquivalence", 767599, 20457},
 {"ID:1500614048", 767851, 20464},
 {"isPartIrreflOrder", 768113, 20471},
 {"ID:1317703026", 768371, 20478},
 {"isPartReflOrder", 768629, 20485},
 {"ID:2071876542", 768885, 20492},
 {"isTotalIrreflOrder", 769149, 20499},
 {"ID:2048777355", 769408, 20506},
 {"isJoin", 769649, 20513},
 {"ID:1924210441", 769897, 20520},
 {"isMin", 770135, 20527},
 {"ID:929796587", 770380, 20534},
 {"isNoetherian", 770630, 20541},
 {"ID:1479000424", 770881, 20548},
 {"isOrderEmbedding", 771142, 20555},
 {"ID:1224736736", 771400, 20562},
 {"ID:663270760", 771630, 20569},
 {"asymmetric \[DoubleRightArrow] irreflexive", 771946, 20577},
 {"ID:285650760", 772232, 20585},
 {"asymmetric \[DoubleRightArrow] antisymmetric", 772552, 20593},
 {"ID:74183342", 772839, 20601},
 {"isEquivalence alternative", 773125, 20609},
 {"IR", 773388, 20617},
 {"ID:238839812", 777201, 20721},
 {"isPartReflOrder alternative", 777493, 20729},
 {"ID:281023185", 777770, 20737},
 {"isPartIrreflOrder alternative", 778066, 20745},
 {"ID:816399472", 778345, 20753},
 {"isTotalIrreflOrder alternative", 778643, 20761},
 {"ID:1286795454", 778924, 20769},
 {"isTotalIrreflOrder alternative II", 779230, 20777},
 {"Proof|ID:663270760", 779521, 20785},
 {"Proof|ID:663270760-1", 779681, 20789},
 {"Proof|ID:285650760", 779839, 20793},
 {"Proof|ID:285650760-1", 779999, 20797},
 {"Proof|ID:74183342", 780156, 20801},
 {"Proof|ID:74183342-1", 780314, 20805},
 {"Proof|ID:281023185", 780471, 20809},
 {"Proof|ID:281023185-1", 780631, 20813},
 {"Proof|ID:238839812", 780789, 20817},
 {"Proof|ID:238839812-1", 780949, 20821},
 {"Proof|ID:816399472", 781107, 20825},
 {"Proof|ID:816399472-1", 781269, 20829},
 {"Proof|ID:1286795454", 781430, 20833},
 {"Proof|ID:1286795454-1", 781594, 20837},
 {"ID:1946807802", 781750, 20841},
 {"ID:604644732", 781981, 20848},
 {"ID:883452679", 782210, 20855},
 {"isReflexive embedding", 782478, 20862},
 {"ID:1544154211", 782738, 20869},
 {"isAsymmetric embedding", 783016, 20877},
 {"ID:1384519374", 783285, 20885},
 {"isTransitive embedding", 783563, 20893},
 {"ID:646610345", 783831, 20901},
 {"isPartIrreflOrder embedding", 784117, 20909},
 {"ID:1746482051", 784389, 20917},
 {"isNoetherian embedding", 784667, 20925},
 {"ID:632872799", 784935, 20933},
 {"ID:123344064", 785164, 20940},
 {"isAntisymmetric embedding", 785446, 20948},
 {"ID:1095452192", 785716, 20956},
 {"isTotalRelation embedding", 786000, 20964},
 {"ID:1770002934", 786272, 20972},
 {"isPartReflOrder embedding", 786556, 20980},
 {"ID:741041662", 786827, 20988},
 {"isTotalIrreflOrder embedding", 787115, 20996},
 {"Proof|ID:883452679", 787393, 21004},
 {"Proof|ID:883452679-1", 787553, 21008},
 {"Proof|ID:1544154211", 787712, 21012},
 {"Proof|ID:1544154211-1", 787877, 21016},
 {"Proof|ID:1384519374", 788040, 21020},
 {"Proof|ID:1384519374-1", 788204, 21024},
 {"Proof|ID:646610345", 788365, 21028},
 {"Proof|ID:646610345-1", 788527, 21032},
 {"Proof|ID:1746482051", 788688, 21036},
 {"Proof|ID:1746482051-1", 788850, 21040},
 {"Proof|ID:123344064", 789009, 21044},
 {"Proof|ID:123344064-1", 789171, 21048},
 {"Proof|ID:1095452192", 789332, 21052},
 {"Proof|ID:1095452192-1", 789497, 21056},
 {"Proof|ID:1770002934", 789660, 21060},
 {"Proof|ID:1770002934-1", 789825, 21064},
 {"Proof|ID:741041662", 789987, 21068},
 {"Proof|ID:741041662-1", 790149, 21072},
 {"ID:236772010", 790303, 21076},
 {"ID:178453409", 790532, 21083},
 {"join absorption", 790788, 21090},
 {"Proof|ID:178453409", 791047, 21097},
 {"Proof|ID:178453409-1", 791208, 21101},
 {"ID:135753527", 791361, 21105},
 {"ID:73073670", 791588, 21112},
 {"Noetherian induction", 791852, 21119},
 {"ID:1991524700", 792109, 21126},
 {"Noetherian induction'", 792392, 21134},
 {"Proof|ID:73073670", 792671, 21142},
 {"Proof|ID:73073670-1", 792829, 21146},
 {"Proof|ID:1991524700", 792987, 21150},
 {"Proof|ID:1991524700-1", 793151, 21154},
 {"ID:1439528152", 793307, 21158},
 {"ID:1138027217", 793539, 21165},
 {"ID:75332861", 793768, 21172},
 {"minimum isFinite", 794024, 21179},
 {"ID:242836600", 794276, 21186},
 {"maximum isFinite", 794534, 21193},
 {"ID:141004932", 794788, 21200},
 {"minimum isFinite totalIrrefl", 795076, 21208},
 {"ID:547704634", 795348, 21216},
 {"maximum isFinite totalIrrefl", 795636, 21224},
 {"Proof|ID:75332861", 795913, 21232},
 {"Proof|ID:75332861-1", 796071, 21236},
 {"Proof|ID:242836600", 796228, 21240},
 {"Proof|ID:242836600-1", 796389, 21244},
 {"Proof|ID:141004932", 796548, 21248},
 {"Proof|ID:141004932-1", 796709, 21252},
 {"Proof|ID:547704634", 796868, 21256},
 {"Proof|ID:547704634-1", 797028, 21260},
 {"ID:4832845", 797178, 21264},
 {"ID:131514176", 797402, 21271},
 {"ID:85261794", 797629, 21278},
 {"isInvariantFunction1", 797893, 21285},
 {"ID:715106769", 798149, 21292},
 {"isInvariantFunction2", 798415, 21299},
 {"ID:218481457", 798673, 21306},
 {"isInvariantRelation1", 798939, 21313},
 {"ID:40789237", 799196, 21320},
 {"isInvaiantRelation2", 799458, 21327},
 {"ID:597743189", 799713, 21334},
 {"ID:207685257", 799942, 21341},
 {"ID:48746434", 800169, 21348},
 {"QuoDom Base", 800415, 21355},
 {"ID:591224316", 800662, 21362},
 {"QuoDom \[Element]", 800922, 21369},
 {"ID:91525291", 801176, 21376},
 {"QuoDom EC", 801418, 21383},
 {"ID:79971692", 801662, 21390},
 {"QuoDom Fun1", 801908, 21397},
 {"ID:211465861", 802155, 21404},
 {"QuoDom Fun2", 802403, 21411},
 {"ID:207120323", 802652, 21418},
 {"QuoDom Rel1", 802900, 21425},
 {"ID:726147690", 803149, 21432},
 {"QuoDom Rel2", 803397, 21439},
 {"ID:275047301", 803646, 21446},
 {"ID:18750149", 803873, 21453},
 {"Base isSet QuoDom", 804142, 21461},
 {"ID:140284862", 804406, 21469},
 {"QuoDom isDomain", 804667, 21476},
 {"Proof|ID:18750149", 804930, 21483},
 {"Proof|ID:18750149-1", 805087, 21487},
 {"Proof|ID:140284862", 805243, 21491},
 {"Proof|ID:140284862-1", 805404, 21495},
 {"ID:345419617", 805557, 21499},
 {"ID:88311021", 805785, 21506},
 {"\[Element] Base QuoDom", 806066, 21514},
 {"ID:323838795", 806337, 21522},
 {"\[Element] QuoDom alternative", 806634, 21530},
 {"ID:515475604", 806914, 21538},
 {"ID:394780640", 807143, 21545},
 {"EC \[Element] QuoDom", 807421, 21553},
 {"ID:387391039", 807691, 21561},
 {"EC isSet QuoDom", 807953, 21568},
 {"ID:154396855", 808212, 21575},
 {"\[Element] EC QuoDom", 808491, 21583},
 {"ID:399369070", 808762, 21591},
 {"EC \[Element] DomainSets QuoDom", 809056, 21599},
 {"Proof|ID:88311021", 809336, 21607},
 {"Proof|ID:88311021-1", 809495, 21611},
 {"Proof|ID:323838795", 809653, 21615},
 {"Proof|ID:323838795-1", 809814, 21619},
 {"Proof|ID:394780640", 809973, 21623},
 {"Proof|ID:394780640-1", 810134, 21627},
 {"Proof|ID:387391039", 810293, 21631},
 {"Proof|ID:387391039-1", 810455, 21635},
 {"Proof|ID:154396855", 810615, 21639},
 {"Proof|ID:154396855-1", 810777, 21643},
 {"Proof|ID:399369070", 810937, 21647},
 {"Proof|ID:399369070-1", 811099, 21651},
 {"ID:286514517", 811253, 21655},
 {"ID:600914281", 811482, 21662},
 {"RelSet = EC QuoDom", 811745, 21669},
 {"ID:315304271", 812002, 21676},
 {"EC = EC QuoDom", 812257, 21683},
 {"ID:18625187", 812509, 21690},
 {"generator \[Element] EC QuoDom", 812806, 21698},
 {"ID:2541232", 813083, 21706},
 {"EC \[Tilde] QuoDom", 813342, 21713},
 {"ID:155852592", 813595, 21720},
 {"ID:850875018", 813824, 21727},
 {"Fun1 EC QuoDom", 814079, 21734},
 {"ID:660096993", 814332, 21741},
 {"Fun2 EC QuoDom", 814587, 21748},
 {"ID:579696921", 814840, 21755},
 {"Rel1 EC QuoDom", 815095, 21762},
 {"ID:121665751", 815348, 21769},
 {"Rel2 EC QuoDom", 815603, 21776},
 {"Proof|ID:600914281", 815862, 21783},
 {"Proof|ID:600914281-1", 816023, 21787},
 {"Proof|ID:315304271", 816182, 21791},
 {"Proof|ID:315304271-1", 816343, 21795},
 {"Proof|ID:18625187", 816501, 21799},
 {"Proof|ID:18625187-1", 816660, 21803},
 {"Proof|ID:2541232", 816816, 21807},
 {"Proof|ID:2541232-1", 816971, 21811},
 {"Proof|ID:850875018", 817126, 21815},
 {"Proof|ID:850875018-1", 817288, 21819},
 {"Proof|ID:660096993", 817448, 21823},
 {"Proof|ID:660096993-1", 817610, 21827},
 {"Proof|ID:579696921", 817770, 21831},
 {"Proof|ID:579696921-1", 817932, 21835},
 {"Proof|ID:121665751", 818092, 21839},
 {"Proof|ID:121665751-1", 818253, 21843},
 {"ID:531967789", 818406, 21847},
 {"ID:1523090696", 818637, 21854},
 {"isClosed", 818882, 21861},
 {"ID:665775613", 819131, 21868},
 {"isNeutral", 819376, 21875},
 {"ID:154995644", 819624, 21882},
 {"isAssoc", 819865, 21889},
 {"ID:1959021758", 820112, 21896},
 {"isDistr", 820355, 21903},
 {"ID:2052928557", 820604, 21910},
 {"isComm", 820845, 21917},
 {"ID:1343138992", 821093, 21924},
 {"isInverse", 821340, 21931},
 {"ID:1192467176", 821591, 21938},
 {"ID:1597214241", 821823, 21945},
 {"isCCMonoid", 822072, 21952},
 {"ID:1972933949", 822324, 21959},
 {"isCCMonoid \[RawStar]", 822595, 21966},
 {"ID:1964463139", 822858, 21973},
 {"isGroup", 823101, 21980},
 {"ID:1561309471", 823350, 21987},
 {"ID:603470889", 823582, 21994},
 {"ID:1714531538", 823812, 22001},
 {"isGroup 2", 824058, 22008},
 {"ID:1593316744", 824308, 22015},
 {"isGroup 3", 824555, 22022},
 {"ID:60508897", 824804, 22029},
 {"isGroup 0", 825046, 22036},
 {"ID:446590811", 825291, 22043},
 {"isGroup 1", 825535, 22050},
 {"Proof|ID:1714531538", 825789, 22057},
 {"Proof|ID:1714531538-1", 825954, 22061},
 {"Proof|ID:1593316744", 826117, 22065},
 {"Proof|ID:1593316744-1", 826281, 22069},
 {"Proof|ID:60508897", 826441, 22073},
 {"Proof|ID:60508897-1", 826599, 22077},
 {"Proof|ID:446590811", 826756, 22081},
 {"Proof|ID:446590811-1", 826916, 22085},
 {"ID:1169392713", 827069, 22089},
 {"isRing", 827311, 22096},
 {"ID:1019439434", 827560, 22103},
 {"ID:68765473", 827790, 22110},
 {"isRing isSet", 828039, 22117},
 {"ID:713491381", 828288, 22124},
 {"isRing 1", 828531, 22131},
 {"ID:491734364", 828778, 22138},
 {"isRing 2", 829021, 22145},
 {"Proof|ID:68765473", 829273, 22152},
 {"Proof|ID:68765473-1", 829432, 22156},
 {"Proof|ID:713491381", 829590, 22160},
 {"Proof|ID:713491381-1", 829751, 22164},
 {"Proof|ID:491734364", 829910, 22168},
 {"Proof|ID:491734364-1", 830072, 22172},
 {"ID:812208573", 830226, 22176},
 {"isCommRing1", 830475, 22183},
 {"ID:1005941388", 830726, 22190},
 {"isUnit", 830967, 22197},
 {"ID:1603254219", 831215, 22204},
 {"ID:616379398", 831446, 22211},
 {"isCommRing1 1", 831699, 22218},
 {"ID:1787433797", 831952, 22225},
 {"isCommRing1 2", 832207, 22232},
 {"ID:1086651396", 832462, 22239},
 {"isCommRing1 3", 832717, 22246},
 {"ID:357550885", 832971, 22253},
 {"isCommRing1 4", 833224, 22260},
 {"ID:2088302303", 833477, 22267},
 {"isCommRing1 5", 833732, 22274},
 {"Proof|ID:616379398", 833992, 22281},
 {"Proof|ID:616379398-1", 834153, 22285},
 {"Proof|ID:1787433797", 834313, 22289},
 {"Proof|ID:1787433797-1", 834477, 22293},
 {"Proof|ID:1086651396", 834639, 22297},
 {"Proof|ID:1086651396-1", 834804, 22301},
 {"Proof|ID:357550885", 834966, 22305},
 {"Proof|ID:357550885-1", 835128, 22309},
 {"Proof|ID:2088302303", 835289, 22313},
 {"Proof|ID:2088302303-1", 835454, 22317},
 {"ID:1231884360", 835611, 22321},
 {"isField", 835855, 22328},
 {"ID:15476569", 836103, 22335},
 {"ID:2036492268", 836331, 22342},
 {"isField membership /", 836612, 22350},
 {"ID:1399031260", 836886, 22358},
 {"isField 4", 837133, 22365},
 {"ID:1519132486", 837384, 22372},
 {"isField 4'", 837633, 22379},
 {"ID:23853891", 837883, 22386},
 {"isField 6", 838126, 22393},
 {"ID:214934627", 838372, 22400},
 {"isField 1", 838617, 22407},
 {"ID:1629111293", 838866, 22414},
 {"isField 1'", 839115, 22421},
 {"ID:567921874", 839366, 22428},
 {"isField 2", 839611, 22435},
 {"ID:2078845477", 839860, 22442},
 {"isField 3", 840107, 22449},
 {"ID:170294828", 840357, 22456},
 {"isField 5", 840602, 22463},
 {"Proof|ID:2036492268", 840857, 22470},
 {"Proof|ID:2036492268-1", 841022, 22474},
 {"Proof|ID:1399031260", 841185, 22478},
 {"Proof|ID:1399031260-1", 841347, 22482},
 {"Proof|ID:1519132486", 841507, 22486},
 {"Proof|ID:1519132486-1", 841672, 22490},
 {"Proof|ID:23853891", 841833, 22494},
 {"Proof|ID:23853891-1", 841992, 22498},
 {"Proof|ID:214934627", 842150, 22502},
 {"Proof|ID:214934627-1", 842311, 22506},
 {"Proof|ID:1629111293", 842471, 22510},
 {"Proof|ID:1629111293-1", 842636, 22514},
 {"Proof|ID:567921874", 842798, 22518},
 {"Proof|ID:567921874-1", 842959, 22522},
 {"Proof|ID:2078845477", 843119, 22526},
 {"Proof|ID:2078845477-1", 843283, 22530},
 {"Proof|ID:170294828", 843444, 22534},
 {"Proof|ID:170294828-1", 843606, 22538}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 124, 2, 84, "Title",
 CellID->173563151],
Cell[CellGroupData[{
Cell[728, 28, 116, 2, 73, "Section",
 CellID->909929215],
Cell[CellGroupData[{
Cell[869, 34, 127, 2, 38, "Subsection",
 CellID->828602142],
Cell[999, 38, 344, 8, 32, "Input",
 CellID->498486718],
Cell[1346, 48, 406, 9, 32, "Input",
 CellID->180362266],
Cell[1755, 59, 152, 3, 32, "Input",
 CellID->57378981],
Cell[1910, 64, 151, 3, 32, "Input",
 CellID->785761565],
Cell[2064, 69, 154, 3, 32, "Input",
 CellID->54631318],
Cell[CellGroupData[{
Cell[2243, 76, 1666, 36, 55, "Input",
 CellID->20666029],
Cell[3912, 114, 233, 5, 32, "Output",
 CellID->14529609]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4194, 125, 124, 2, 30, "Subsection",
 CellID->1386333768],
Cell[CellGroupData[{
Cell[4343, 131, 248, 6, 32, "Input",
 CellID->239327779],
Cell[CellGroupData[{
Cell[4616, 141, 1026, 19, 70, "Print",
 CellID->675811602],
Cell[5645, 162, 729, 13, 70, "Print",
 CellID->79509725],
Cell[6377, 177, 1024, 19, 70, "Print",
 CellID->522072974],
Cell[7404, 198, 994, 18, 70, "Print",
 CellID->201239835],
Cell[8401, 218, 728, 13, 70, "Print",
 CellID->222985925],
Cell[9132, 233, 998, 18, 70, "Print",
 CellID->800478382],
Cell[10133, 253, 728, 13, 70, "Print",
 CellID->337608848],
Cell[10864, 268, 1010, 18, 70, "Print",
 CellID->630016544],
Cell[11877, 288, 731, 13, 70, "Print",
 CellID->19423090],
Cell[12611, 303, 734, 13, 70, "Print",
 CellID->220008244],
Cell[13348, 318, 734, 13, 70, "Print",
 CellID->1201160],
Cell[14085, 333, 733, 13, 70, "Print",
 CellID->16643814],
Cell[14821, 348, 1028, 19, 70, "Print",
 CellID->612971699],
Cell[15852, 369, 728, 13, 70, "Print",
 CellID->7225627],
Cell[16583, 384, 730, 13, 70, "Print",
 CellID->187436836],
Cell[17316, 399, 997, 18, 70, "Print",
 CellID->59997816],
Cell[18316, 419, 727, 13, 70, "Print",
 CellID->99966685],
Cell[19046, 434, 732, 13, 70, "Print",
 CellID->470072192],
Cell[19781, 449, 1002, 18, 70, "Print",
 CellID->510733725],
Cell[20786, 469, 732, 13, 70, "Print",
 CellID->599346340],
Cell[21521, 484, 732, 13, 70, "Print",
 CellID->170249141],
Cell[22256, 499, 736, 13, 70, "Print",
 CellID->408398655],
Cell[22995, 514, 736, 13, 70, "Print",
 CellID->240495407],
Cell[23734, 529, 1010, 18, 70, "Print",
 CellID->253536170],
Cell[24747, 549, 730, 13, 70, "Print",
 CellID->8538301],
Cell[25480, 564, 731, 13, 70, "Print",
 CellID->431449],
Cell[26214, 579, 733, 13, 70, "Print",
 CellID->58007217],
Cell[26950, 594, 736, 13, 70, "Print",
 CellID->564947619],
Cell[27689, 609, 736, 13, 70, "Print",
 CellID->723022560],
Cell[28428, 624, 997, 18, 70, "Print",
 CellID->26770741],
Cell[29428, 644, 729, 13, 70, "Print",
 CellID->34657406],
Cell[30160, 659, 732, 13, 70, "Print",
 CellID->123896030],
Cell[30895, 674, 734, 13, 70, "Print",
 CellID->6440802],
Cell[31632, 689, 735, 13, 70, "Print",
 CellID->61871100],
Cell[32370, 704, 734, 13, 70, "Print",
 CellID->531530781],
Cell[33107, 719, 736, 13, 70, "Print",
 CellID->749219828],
Cell[33846, 734, 1006, 18, 70, "Print",
 CellID->147941656],
Cell[34855, 754, 730, 13, 70, "Print",
 CellID->648778583],
Cell[35588, 769, 732, 13, 70, "Print",
 CellID->1821045],
Cell[36323, 784, 736, 13, 70, "Print",
 CellID->209911035],
Cell[37062, 799, 736, 13, 70, "Print",
 CellID->122718590],
Cell[37801, 814, 735, 13, 70, "Print",
 CellID->55361129],
Cell[38539, 829, 734, 13, 70, "Print",
 CellID->317108560],
Cell[39276, 844, 736, 13, 70, "Print",
 CellID->316505062],
Cell[40015, 859, 1006, 18, 70, "Print",
 CellID->102482428],
Cell[41024, 879, 731, 13, 70, "Print",
 CellID->70100077],
Cell[41758, 894, 734, 13, 70, "Print",
 CellID->764474994],
Cell[42495, 909, 734, 13, 70, "Print",
 CellID->629138211],
Cell[43232, 924, 734, 13, 70, "Print",
 CellID->111615212],
Cell[43969, 939, 1014, 18, 70, "Print",
 CellID->299154259],
Cell[44986, 959, 732, 13, 70, "Print",
 CellID->121596178],
Cell[45721, 974, 732, 13, 70, "Print",
 CellID->487528727],
Cell[46456, 989, 736, 13, 70, "Print",
 CellID->607774757],
Cell[47195, 1004, 736, 13, 70, "Print",
 CellID->470489976],
Cell[47934, 1019, 733, 13, 70, "Print",
 CellID->47826169],
Cell[48670, 1034, 1003, 18, 70, "Print",
 CellID->34963455],
Cell[49676, 1054, 730, 13, 70, "Print",
 CellID->649778663],
Cell[50409, 1069, 998, 18, 70, "Print",
 CellID->236951908],
Cell[51410, 1089, 730, 13, 70, "Print",
 CellID->248324543],
Cell[52143, 1104, 733, 13, 70, "Print",
 CellID->89425482],
Cell[52879, 1119, 734, 13, 70, "Print",
 CellID->663403756],
Cell[53616, 1134, 733, 13, 70, "Print",
 CellID->35064204],
Cell[54352, 1149, 736, 13, 70, "Print",
 CellID->263127733],
Cell[55091, 1164, 533, 8, 70, "Print",
 CellID->141704853],
Cell[55627, 1174, 523, 8, 70, "Print",
 CellID->421689454],
Cell[56153, 1184, 718, 13, 70, "Print",
 CellID->16588],
Cell[56874, 1199, 724, 13, 70, "Print",
 CellID->303884149],
Cell[57601, 1214, 728, 13, 70, "Print",
 CellID->134335790],
Cell[58332, 1229, 725, 13, 70, "Print",
 CellID->97740866],
Cell[59060, 1244, 724, 13, 70, "Print",
 CellID->146139724],
Cell[59787, 1259, 728, 13, 70, "Print",
 CellID->602362103],
Cell[60518, 1274, 726, 13, 70, "Print",
 CellID->422351253],
Cell[61247, 1289, 728, 13, 70, "Print",
 CellID->230658552],
Cell[61978, 1304, 726, 13, 70, "Print",
 CellID->759903990],
Cell[62707, 1319, 726, 13, 70, "Print",
 CellID->118685951],
Cell[63436, 1334, 728, 13, 70, "Print",
 CellID->486145549],
Cell[64167, 1349, 723, 13, 70, "Print",
 CellID->616382],
Cell[64893, 1364, 728, 13, 70, "Print",
 CellID->843901497],
Cell[65624, 1379, 725, 13, 70, "Print",
 CellID->39274502],
Cell[66352, 1394, 725, 13, 70, "Print",
 CellID->13609283],
Cell[67080, 1409, 727, 13, 70, "Print",
 CellID->32070279],
Cell[67810, 1424, 728, 13, 70, "Print",
 CellID->239070082],
Cell[68541, 1439, 725, 13, 70, "Print",
 CellID->96931380],
Cell[69269, 1454, 726, 13, 70, "Print",
 CellID->140507640],
Cell[69998, 1469, 726, 13, 70, "Print",
 CellID->389183784],
Cell[70727, 1484, 728, 13, 70, "Print",
 CellID->652233815],
Cell[71458, 1499, 730, 13, 70, "Print",
 CellID->282428911],
Cell[72191, 1514, 729, 13, 70, "Print",
 CellID->20278982],
Cell[72923, 1529, 730, 13, 70, "Print",
 CellID->372699181],
Cell[73656, 1544, 730, 13, 70, "Print",
 CellID->692254989],
Cell[74389, 1559, 729, 13, 70, "Print",
 CellID->16225313],
Cell[75121, 1574, 728, 13, 70, "Print",
 CellID->178227539],
Cell[75852, 1589, 730, 13, 70, "Print",
 CellID->591646398],
Cell[76585, 1604, 729, 13, 70, "Print",
 CellID->97378915],
Cell[77317, 1619, 730, 13, 70, "Print",
 CellID->260322238],
Cell[78050, 1634, 729, 13, 70, "Print",
 CellID->24803197],
Cell[78782, 1649, 728, 13, 70, "Print",
 CellID->949033729],
Cell[79513, 1664, 727, 13, 70, "Print",
 CellID->81124757],
Cell[80243, 1679, 727, 13, 70, "Print",
 CellID->44286772],
Cell[80973, 1694, 728, 13, 70, "Print",
 CellID->123195102],
Cell[81704, 1709, 730, 13, 70, "Print",
 CellID->602021076],
Cell[82437, 1724, 727, 13, 70, "Print",
 CellID->56469942],
Cell[83167, 1739, 728, 13, 70, "Print",
 CellID->156796526],
Cell[83898, 1754, 728, 13, 70, "Print",
 CellID->266910185],
Cell[84629, 1769, 730, 13, 70, "Print",
 CellID->468673391],
Cell[85362, 1784, 729, 13, 70, "Print",
 CellID->40679448],
Cell[86094, 1799, 729, 13, 70, "Print",
 CellID->54792237],
Cell[86826, 1814, 727, 13, 70, "Print",
 CellID->37085458],
Cell[87556, 1829, 727, 13, 70, "Print",
 CellID->81818704],
Cell[88286, 1844, 729, 13, 70, "Print",
 CellID->10497171],
Cell[89018, 1859, 728, 13, 70, "Print",
 CellID->531981504],
Cell[89749, 1874, 730, 13, 70, "Print",
 CellID->121578252],
Cell[90482, 1889, 728, 13, 70, "Print",
 CellID->239239070],
Cell[91213, 1904, 728, 13, 70, "Print",
 CellID->172679960],
Cell[91944, 1919, 728, 13, 70, "Print",
 CellID->611180130],
Cell[92675, 1934, 729, 13, 70, "Print",
 CellID->36395113],
Cell[93407, 1949, 728, 13, 70, "Print",
 CellID->6385849],
Cell[94138, 1964, 729, 13, 70, "Print",
 CellID->58225509],
Cell[94870, 1979, 728, 13, 70, "Print",
 CellID->350442629],
Cell[95601, 1994, 729, 13, 70, "Print",
 CellID->76170729],
Cell[96333, 2009, 729, 13, 70, "Print",
 CellID->14078072],
Cell[97065, 2024, 728, 13, 70, "Print",
 CellID->396449331],
Cell[97796, 2039, 730, 13, 70, "Print",
 CellID->127359093],
Cell[98529, 2054, 728, 13, 70, "Print",
 CellID->1065408],
Cell[99260, 2069, 728, 13, 70, "Print",
 CellID->198416535],
Cell[99991, 2084, 730, 13, 70, "Print",
 CellID->385631299],
Cell[100724, 2099, 727, 13, 70, "Print",
 CellID->28800138],
Cell[101454, 2114, 728, 13, 70, "Print",
 CellID->302411191],
Cell[102185, 2129, 729, 13, 70, "Print",
 CellID->44418373],
Cell[102917, 2144, 728, 13, 70, "Print",
 CellID->668206816],
Cell[103648, 2159, 726, 13, 70, "Print",
 CellID->42782857],
Cell[104377, 2174, 730, 13, 70, "Print",
 CellID->514314070],
Cell[105110, 2189, 730, 13, 70, "Print",
 CellID->347480091],
Cell[105843, 2204, 535, 8, 70, "Print",
 CellID->205399375],
Cell[106381, 2214, 512, 8, 70, "Print",
 CellID->353975439]
}, Open  ]],
Cell[106908, 2225, 224, 6, 70, "Output",
 CellID->20144941]
}, Closed]],
Cell[107147, 2234, 178, 4, 26, "Input",
 CellID->2077551358],
Cell[CellGroupData[{
Cell[107350, 2242, 541, 12, 55, "Input",
 CellID->1909803754],
Cell[107894, 2256, 894, 16, 32, "Output",
 CellID->1365249879]
}, Open  ]],
Cell[CellGroupData[{
Cell[108825, 2277, 586, 15, 55, "Input",
 CellID->1780799392],
Cell[109414, 2294, 504, 10, 23, "Message",
 CellID->181219027],
Cell[109921, 2306, 495, 10, 23, "Message",
 CellID->1779137777],
Cell[110419, 2318, 150, 3, 32, "Output",
 CellID->1862161014]
}, Open  ]],
Cell[CellGroupData[{
Cell[110606, 2326, 554, 13, 32, "Input",
 CellID->63220416],
Cell[111163, 2341, 93, 2, 32, "Output",
 CellID->199537062]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[111305, 2349, 128, 2, 30, "Subsection",
 CellID->1454182661],
Cell[111436, 2353, 1107, 27, 77, "Input",
 CellID->2074904605],
Cell[112546, 2382, 416, 9, 55, "Input",
 CellID->1980565193],
Cell[112965, 2393, 169, 3, 32, "Input",
 CellID->444074165],
Cell[113137, 2398, 309, 6, 32, "Input",
 CellID->584704106]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[113495, 2410, 252, 5, 43, "Section",
 CellID->1317521387],
Cell[113750, 2417, 651, 17, 31, "GlobalDeclaration",
 CellTags->{
  "ID:809516830", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->809516830],
Cell[CellGroupData[{
Cell[114426, 2438, 288, 4, 38, "Subsection",
 CellID->911082209],
Cell[CellGroupData[{
Cell[114739, 2446, 126, 2, 28, "Subsubsection",
 CellID->800212037],
Cell[114868, 2450, 48, 1, 12, "OpenEnvironment",
 CellID->1485541847],
Cell[CellGroupData[{
Cell[114941, 2455, 448, 10, 43, "EnvironmentHeader",
 CellID->869661363],
Cell[115392, 2467, 2488, 78, 34, "GlobalDeclaration",
 CellTags->{
  "ID:105808432", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->105808432],
Cell[117883, 2547, 1445, 46, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:614230936", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive"},
 CellID->614230936],
Cell[119331, 2595, 1852, 61, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:1177932670", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAntisymmetric"},
 CellID->1177932670],
Cell[121186, 2658, 1568, 52, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:932142776", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isIrreflexive"},
 CellID->932142776],
Cell[122757, 2712, 1675, 55, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:35541847", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isSymmetric"},
 CellID->35541847],
Cell[124435, 2769, 1833, 61, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:291399428", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAsymmetric"},
 CellID->291399428],
Cell[126271, 2832, 1858, 61, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:535380192", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTransitive"},
 CellID->535380192],
Cell[128132, 2895, 1743, 56, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:2054329379", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalRelation"},
 CellID->2054329379],
Cell[129878, 2953, 2480, 81, 74, "FormalTextInputFormula",
 CellTags->{
  "ID:150250031", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isEquivalence"},
 CellID->150250031],
Cell[132361, 3036, 3407, 97, 59, "FormalTextInputFormula",
 CellTags->{
  "ID:1500614048", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartIrreflOrder"},
 CellID->1500614048],
Cell[135771, 3135, 2858, 89, 75, "FormalTextInputFormula",
 CellTags->{
  "ID:1317703026", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isPartReflOrder"},
 CellID->1317703026],
Cell[138632, 3226, 3379, 99, 75, "FormalTextInputFormula",
 CellTags->{
  "ID:2071876542", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isTotalIrreflOrder"},
 CellID->2071876542],
Cell[142014, 3327, 3272, 97, 118, "FormalTextInputFormula",
 CellTags->{
  "ID:2048777355", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isJoin"},
 CellID->2048777355],
Cell[145289, 3426, 1579, 52, 37, "FormalTextInputFormula",
 CellTags->{
  "ID:1924210441", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isMin"},
 CellID->1924210441],
Cell[146871, 3480, 2424, 72, 53, "FormalTextInputFormula",
 CellTags->{
  "ID:929796587", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNoetherian"},
 CellID->929796587],
Cell[149298, 3554, 3504, 104, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:1479000424", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isOrderEmbedding"},
 CellID->1479000424],
Cell[152805, 3660, 66, 1, 26, "EndEnvironmentMarker",
 CellID->1769626440]
}, Open  ]],
Cell[152886, 3664, 48, 1, 16, "CloseEnvironment",
 CellID->847702497]
}, Closed]],
Cell[CellGroupData[{
Cell[152971, 3670, 228, 5, 22, "Subsubsection",
 CellID->1138215434],
Cell[153202, 3677, 48, 1, 70, "OpenEnvironment",
 CellID->1536133009],
Cell[CellGroupData[{
Cell[153275, 3682, 392, 9, 70, "EnvironmentHeader",
 CellID->503429911],
Cell[153670, 3693, 706, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1224736736", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1224736736],
Cell[154379, 3712, 1051, 27, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:663270760", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "asymmetric \[DoubleRightArrow] irreflexive"},
 CellID->663270760],
Cell[155433, 3741, 1059, 27, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:285650760", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "asymmetric \[DoubleRightArrow] antisymmetric"},
 CellID->285650760],
Cell[156495, 3770, 1287, 36, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:74183342", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isEquivalence alternative", "IR"},
 CellID->74183342],
Cell[157785, 3808, 1399, 38, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:238839812", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartReflOrder alternative", "IR"},
 CellID->238839812],
Cell[159187, 3848, 1259, 35, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:281023185", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartIrreflOrder alternative", "IR"},
 CellID->281023185],
Cell[160449, 3885, 1356, 37, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:816399472", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalIrreflOrder alternative", "IR"},
 CellID->816399472],
Cell[161808, 3924, 1321, 36, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1286795454", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalIrreflOrder alternative II", "IR"},
 CellID->1286795454],
Cell[163132, 3962, 66, 1, 70, "EndEnvironmentMarker",
 CellID->2046169743]
}, Open  ]],
Cell[163213, 3966, 48, 1, 70, "CloseEnvironment",
 CellID->280337546],
Cell[CellGroupData[{
Cell[163286, 3971, 3053, 84, 70, "ProofInfo",
 CellTags->{"Proof|ID:663270760", "Proof|ID:663270760-1"},
 CellID->644318390],
Cell[166342, 4057, 524, 13, 70, "ProofInfoBody",
 CellID->256500674]
}, Closed]],
Cell[CellGroupData[{
Cell[166903, 4075, 3061, 84, 70, "ProofInfo",
 CellTags->{"Proof|ID:285650760", "Proof|ID:285650760-1"},
 CellID->592867878],
Cell[169967, 4161, 481, 12, 70, "ProofInfoBody",
 CellID->1320062656]
}, Closed]],
Cell[CellGroupData[{
Cell[170485, 4178, 4090, 107, 70, "ProofInfo",
 CellTags->{"Proof|ID:74183342", "Proof|ID:74183342-1"},
 CellID->219773652],
Cell[174578, 4287, 479, 12, 70, "ProofInfoBody",
 CellID->127695526]
}, Closed]],
Cell[CellGroupData[{
Cell[175094, 4304, 3709, 97, 70, "ProofInfo",
 CellTags->{"Proof|ID:281023185", "Proof|ID:281023185-1"},
 CellID->507210937],
Cell[178806, 4403, 481, 12, 70, "ProofInfoBody",
 CellID->1249385145]
}, Closed]],
Cell[CellGroupData[{
Cell[179324, 4420, 4210, 107, 70, "ProofInfo",
 CellTags->{"Proof|ID:238839812", "Proof|ID:238839812-1"},
 CellID->77499924],
Cell[183537, 4529, 481, 12, 70, "ProofInfoBody",
 CellID->1888292086]
}, Closed]],
Cell[CellGroupData[{
Cell[184055, 4546, 4234, 108, 70, "ProofInfo",
 CellTags->{"Proof|ID:816399472", "Proof|ID:816399472-1"},
 CellID->1088293951],
Cell[188292, 4656, 481, 12, 70, "ProofInfoBody",
 CellID->1817657225]
}, Closed]],
Cell[CellGroupData[{
Cell[188810, 4673, 3749, 98, 70, "ProofInfo",
 CellTags->{"Proof|ID:1286795454", "Proof|ID:1286795454-1"},
 CellID->2099979165],
Cell[192562, 4773, 481, 12, 70, "ProofInfoBody",
 CellID->677919669]
}, Closed]],
Cell[193058, 4788, 48, 1, 70, "OpenEnvironment",
 CellID->1465926711],
Cell[CellGroupData[{
Cell[193131, 4793, 422, 10, 70, "EnvironmentHeader",
 CellID->2020955226],
Cell[193556, 4805, 1077, 32, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1946807802", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1946807802],
Cell[194636, 4839, 2192, 69, 70, "GlobalDeclaration",
 CellTags->{
  "ID:604644732", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->604644732],
Cell[196831, 4910, 1288, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:883452679", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isReflexive embedding"},
 CellID->883452679],
Cell[198122, 4952, 1248, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1544154211", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isAsymmetric embedding"},
 CellID->1544154211],
Cell[199373, 4994, 1247, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1384519374", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTransitive embedding"},
 CellID->1384519374],
Cell[200623, 5036, 1267, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:646610345", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartIrreflOrder embedding"},
 CellID->646610345],
Cell[201893, 5078, 1250, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1746482051", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isNoetherian embedding"},
 CellID->1746482051],
Cell[203146, 5120, 249, 7, 70, "EnvironmentText",
 CellID->1203488332],
Cell[203398, 5129, 1480, 48, 70, "GlobalDeclaration",
 CellTags->{
  "ID:632872799", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->632872799],
Cell[204881, 5179, 1257, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:123344064", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isAntisymmetric embedding"},
 CellID->123344064],
Cell[206141, 5221, 1259, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1095452192", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalRelation embedding"},
 CellID->1095452192],
Cell[207403, 5263, 1260, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1770002934", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isPartReflOrder embedding"},
 CellID->1770002934],
Cell[208666, 5305, 1270, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:741041662", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "isTotalIrreflOrder embedding"},
 CellID->741041662],
Cell[209939, 5347, 65, 1, 70, "EndEnvironmentMarker",
 CellID->861668493]
}, Open  ]],
Cell[210019, 5351, 49, 1, 70, "CloseEnvironment",
 CellID->1411278035],
Cell[CellGroupData[{
Cell[210093, 5356, 7164, 168, 70, "ProofInfo",
 CellTags->{"Proof|ID:883452679", "Proof|ID:883452679-1"},
 CellID->30849742],
Cell[217260, 5526, 479, 12, 70, "ProofInfoBody",
 CellID->29229487]
}, Closed]],
Cell[CellGroupData[{
Cell[217776, 5543, 7177, 168, 70, "ProofInfo",
 CellTags->{"Proof|ID:1544154211", "Proof|ID:1544154211-1"},
 CellID->2049393775],
Cell[224956, 5713, 481, 12, 70, "ProofInfoBody",
 CellID->381037592]
}, Closed]],
Cell[CellGroupData[{
Cell[225474, 5730, 7176, 168, 70, "ProofInfo",
 CellTags->{"Proof|ID:1384519374", "Proof|ID:1384519374-1"},
 CellID->431921927],
Cell[232653, 5900, 482, 12, 70, "ProofInfoBody",
 CellID->1726251020]
}, Closed]],
Cell[CellGroupData[{
Cell[233172, 5917, 7202, 168, 70, "ProofInfo",
 CellTags->{"Proof|ID:646610345", "Proof|ID:646610345-1"},
 CellID->1952836459],
Cell[240377, 6087, 480, 12, 70, "ProofInfoBody",
 CellID->879143390]
}, Closed]],
Cell[CellGroupData[{
Cell[240894, 6104, 7174, 168, 70, "ProofInfo",
 CellTags->{"Proof|ID:1746482051", "Proof|ID:1746482051-1"},
 CellID->8671999],
Cell[248071, 6274, 547, 13, 70, "ProofInfoBody",
 CellID->599184085]
}, Closed]],
Cell[CellGroupData[{
Cell[248655, 6292, 9532, 216, 70, "ProofInfo",
 CellTags->{"Proof|ID:123344064", "Proof|ID:123344064-1"},
 CellID->1779690974],
Cell[258190, 6510, 481, 12, 70, "ProofInfoBody",
 CellID->1241931864]
}, Closed]],
Cell[CellGroupData[{
Cell[258708, 6527, 9537, 216, 70, "ProofInfo",
 CellTags->{"Proof|ID:1095452192", "Proof|ID:1095452192-1"},
 CellID->1752383333],
Cell[268248, 6745, 481, 12, 70, "ProofInfoBody",
 CellID->632126693]
}, Closed]],
Cell[CellGroupData[{
Cell[268766, 6762, 9537, 216, 70, "ProofInfo",
 CellTags->{"Proof|ID:1770002934", "Proof|ID:1770002934-1"},
 CellID->1038034091],
Cell[278306, 6980, 482, 12, 70, "ProofInfoBody",
 CellID->1184515805]
}, Closed]],
Cell[CellGroupData[{
Cell[278825, 6997, 9550, 216, 70, "ProofInfo",
 CellTags->{"Proof|ID:741041662", "Proof|ID:741041662-1"},
 CellID->1690532916],
Cell[288378, 7215, 480, 12, 70, "ProofInfoBody",
 CellID->403186867]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[288907, 7233, 237, 5, 22, "Subsubsection",
 CellID->187230287],
Cell[289147, 7240, 1666, 59, 70, "GlobalDeclaration",
 CellTags->{
  "ID:236772010", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->236772010],
Cell[290816, 7301, 47, 1, 70, "OpenEnvironment",
 CellID->162324642],
Cell[CellGroupData[{
Cell[290888, 7306, 380, 9, 70, "EnvironmentHeader",
 CellID->21690211],
Cell[291271, 7317, 1053, 31, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:178453409", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "join absorption"},
 CellID->178453409],
Cell[292327, 7350, 65, 1, 70, "EndEnvironmentMarker",
 CellID->207725336]
}, Open  ]],
Cell[292407, 7354, 48, 1, 70, "CloseEnvironment",
 CellID->142402142],
Cell[CellGroupData[{
Cell[292480, 7359, 4308, 110, 70, "ProofInfo",
 CellTags->{"Proof|ID:178453409", "Proof|ID:178453409-1"},
 CellID->321919587],
Cell[296791, 7471, 480, 12, 70, "ProofInfoBody",
 CellID->408299053]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[297320, 7489, 215, 5, 22, "Subsubsection",
 CellID->187813892],
Cell[297538, 7496, 47, 1, 70, "OpenEnvironment",
 CellID->952601892],
Cell[CellGroupData[{
Cell[297610, 7501, 394, 9, 70, "EnvironmentHeader",
 CellID->1732832893],
Cell[298007, 7512, 710, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:135753527", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->135753527],
Cell[298720, 7532, 3050, 99, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:73073670", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction"},
 CellID->73073670],
Cell[301773, 7633, 3523, 111, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1991524700", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Noetherian induction'",
    "IR"},
 CellID->1991524700],
Cell[305299, 7746, 65, 1, 70, "EndEnvironmentMarker",
 CellID->437869757]
}, Open  ]],
Cell[305379, 7750, 49, 1, 70, "CloseEnvironment",
 CellID->2048030657],
Cell[CellGroupData[{
Cell[305453, 7755, 7085, 174, 70, "ProofInfo",
 CellTags->{"Proof|ID:73073670", "Proof|ID:73073670-1"},
 CellID->183797557],
Cell[312541, 7931, 479, 12, 70, "ProofInfoBody",
 CellID->675175179]
}, Closed]],
Cell[CellGroupData[{
Cell[313057, 7948, 7602, 182, 70, "ProofInfo",
 CellTags->{"Proof|ID:1991524700", "Proof|ID:1991524700-1"},
 CellID->302872964],
Cell[320662, 8132, 481, 12, 70, "ProofInfoBody",
 CellID->916266417]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[321192, 8150, 222, 5, 22, "Subsubsection",
 CellID->4571880],
Cell[321417, 8157, 48, 1, 70, "OpenEnvironment",
 CellID->2046755789],
Cell[CellGroupData[{
Cell[321490, 8162, 445, 10, 70, "EnvironmentHeader",
 CellID->1033951332],
Cell[321938, 8174, 1054, 30, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1439528152", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1439528152],
Cell[322995, 8206, 758, 19, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1138027217", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1138027217],
Cell[323756, 8227, 1900, 64, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:75332861", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "minimum isFinite"},
 CellID->75332861],
Cell[325659, 8293, 1854, 63, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:242836600", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "maximum isFinite"},
 CellID->242836600],
Cell[327516, 8358, 1476, 48, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:141004932", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "minimum isFinite totalIrrefl"},
 CellID->141004932],
Cell[328995, 8408, 1577, 50, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:547704634", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "maximum isFinite totalIrrefl"},
 CellID->547704634],
Cell[330575, 8460, 64, 1, 70, "EndEnvironmentMarker",
 CellID->95587551]
}, Open  ]],
Cell[330654, 8464, 49, 1, 70, "CloseEnvironment",
 CellID->1729245244],
Cell[CellGroupData[{
Cell[330728, 8469, 5990, 150, 70, "ProofInfo",
 CellTags->{"Proof|ID:75332861", "Proof|ID:75332861-1"},
 CellID->124362427],
Cell[336721, 8621, 479, 12, 70, "ProofInfoBody",
 CellID->286952046]
}, Closed]],
Cell[CellGroupData[{
Cell[337237, 8638, 5995, 150, 70, "ProofInfo",
 CellTags->{"Proof|ID:242836600", "Proof|ID:242836600-1"},
 CellID->125816398],
Cell[343235, 8790, 480, 12, 70, "ProofInfoBody",
 CellID->441856622]
}, Closed]],
Cell[CellGroupData[{
Cell[343752, 8807, 5451, 138, 70, "ProofInfo",
 CellTags->{"Proof|ID:141004932", "Proof|ID:141004932-1"},
 CellID->153836126],
Cell[349206, 8947, 480, 12, 70, "ProofInfoBody",
 CellID->447780817]
}, Closed]],
Cell[CellGroupData[{
Cell[349723, 8964, 5450, 138, 70, "ProofInfo",
 CellTags->{"Proof|ID:547704634", "Proof|ID:547704634-1"},
 CellID->49243488],
Cell[355176, 9104, 478, 12, 70, "ProofInfoBody",
 CellID->2248454]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[355715, 9123, 228, 5, 30, "Subsection",
 CellID->189896775],
Cell[355946, 9130, 777, 23, 33, "GlobalDeclaration",
 CellTags->{
  "ID:4832845", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->4832845],
Cell[CellGroupData[{
Cell[356748, 9157, 126, 2, 28, "Subsubsection",
 CellID->817769398],
Cell[356877, 9161, 47, 1, 70, "OpenEnvironment",
 CellID->327803107],
Cell[CellGroupData[{
Cell[356949, 9166, 453, 10, 70, "EnvironmentHeader",
 CellID->25506723],
Cell[357405, 9178, 685, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:131514176", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->131514176],
Cell[358093, 9197, 2394, 71, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:85261794", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction1"},
 CellID->85261794],
Cell[360490, 9270, 3047, 89, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:715106769", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantFunction2"},
 CellID->715106769],
Cell[363540, 9361, 1936, 59, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:218481457", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvariantRelation1"},
 CellID->218481457],
Cell[365479, 9422, 2955, 88, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:40789237", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInvaiantRelation2"},
 CellID->40789237],
Cell[368437, 9512, 65, 1, 70, "EndEnvironmentMarker",
 CellID->560295716]
}, Open  ]],
Cell[368517, 9516, 48, 1, 70, "CloseEnvironment",
 CellID->223070624],
Cell[368568, 9519, 46, 1, 70, "OpenEnvironment",
 CellID->34573484],
Cell[CellGroupData[{
Cell[368639, 9524, 445, 10, 70, "EnvironmentHeader",
 CellID->678518750],
Cell[369087, 9536, 1048, 28, 70, "GlobalDeclaration",
 CellTags->{
  "ID:597743189", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->597743189],
Cell[370138, 9566, 711, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:207685257", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->207685257],
Cell[370852, 9585, 1025, 28, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:48746434", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Base"},
 CellID->48746434],
Cell[371880, 9615, 1793, 55, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:591224316", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom \[Element]"},
 CellID->591224316],
Cell[373676, 9672, 1139, 34, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:91525291", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom EC"},
 CellID->91525291],
Cell[374818, 9708, 1406, 38, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:79971692", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun1"},
 CellID->79971692],
Cell[376227, 9748, 1303, 36, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:211465861", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Fun2"},
 CellID->211465861],
Cell[377533, 9786, 1271, 36, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:207120323", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel1"},
 CellID->207120323],
Cell[378807, 9824, 1381, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:726147690", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom Rel2"},
 CellID->726147690],
Cell[380191, 9866, 65, 1, 70, "EndEnvironmentMarker",
 CellID->176124539]
}, Open  ]],
Cell[380271, 9870, 48, 1, 70, "CloseEnvironment",
 CellID->321936646]
}, Closed]],
Cell[CellGroupData[{
Cell[380356, 9876, 236, 4, 22, "Subsubsection",
 CellID->191890876],
Cell[380595, 9882, 912, 26, 33, "GlobalDeclaration",
 CellTags->{
  "ID:275047301", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->275047301],
Cell[381510, 9910, 46, 1, 12, "OpenEnvironment",
 CellID->92797286],
Cell[CellGroupData[{
Cell[381581, 9915, 428, 10, 43, "EnvironmentHeader",
 CellID->77689825],
Cell[382012, 9927, 973, 26, 34, "FormalTextInputFormula",
 CellTags->{
  "ID:18750149", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Base isSet QuoDom", 
   "IR"},
 CellID->18750149],
Cell[382988, 9955, 940, 24, 21, "FormalTextInputFormula",
 CellTags->{
  "ID:140284862", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "QuoDom isDomain", "IR"},
 CellID->140284862],
Cell[383931, 9981, 64, 1, 26, "EndEnvironmentMarker",
 CellID->20927037]
}, Open  ]],
Cell[384010, 9985, 48, 1, 16, "CloseEnvironment",
 CellID->677220010],
Cell[CellGroupData[{
Cell[384083, 9990, 2942, 82, 28, "ProofInfo",
 CellTags->{"Proof|ID:18750149", "Proof|ID:18750149-1"},
 CellID->681889395],
Cell[387028, 10074, 479, 12, 56, "ProofInfoBody",
 CellID->444857482]
}, Closed]],
Cell[CellGroupData[{
Cell[387544, 10091, 2865, 80, 26, "ProofInfo",
 CellTags->{"Proof|ID:140284862", "Proof|ID:140284862-1"},
 CellID->174468768],
Cell[390412, 10173, 524, 13, 68, "ProofInfoBody",
 CellID->409959576]
}, Closed]],
Cell[390951, 10189, 708, 18, 23, "GlobalDeclaration",
 CellTags->{
  "ID:345419617", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->345419617],
Cell[391662, 10209, 47, 1, 12, "OpenEnvironment",
 CellID->244364927],
Cell[CellGroupData[{
Cell[391734, 10214, 463, 12, 43, "EnvironmentHeader",
 CellID->66443033],
Cell[392200, 10228, 1349, 43, 38, "FormalTextInputFormula",
 CellTags->{
  "ID:88311021", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "\[Element] Base QuoDom", "IR"},
 CellID->88311021],
Cell[393552, 10273, 1560, 49, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:323838795", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "\[Element] QuoDom alternative", "IR"},
 CellID->323838795],
Cell[395115, 10324, 751, 19, 42, "GlobalDeclaration",
 CellTags->{
  "ID:515475604", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->515475604],
Cell[395869, 10345, 956, 27, 34, "FormalTextInputFormula",
 CellTags->{
  "ID:394780640", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Element] QuoDom", 
   "IR"},
 CellID->394780640],
Cell[396828, 10374, 853, 23, 34, "FormalTextInputFormula",
 CellTags->{
  "ID:387391039", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC isSet QuoDom", "IR"},
 CellID->387391039],
Cell[397684, 10399, 1447, 46, 38, "FormalTextInputFormula",
 CellTags->{
  "ID:154396855", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "\[Element] EC QuoDom", 
   "IR"},
 CellID->154396855],
Cell[399134, 10447, 981, 27, 36, "FormalTextInputFormula",
 CellTags->{
  "ID:399369070", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "EC \[Element] DomainSets QuoDom"},
 CellID->399369070],
Cell[400118, 10476, 65, 1, 26, "EndEnvironmentMarker",
 CellID->592359552]
}, Open  ]],
Cell[400198, 10480, 48, 1, 16, "CloseEnvironment",
 CellID->160670001],
Cell[CellGroupData[{
Cell[400271, 10485, 4124, 108, 28, "ProofInfo",
 CellTags->{"Proof|ID:88311021", "Proof|ID:88311021-1"},
 CellID->805139363],
Cell[404398, 10595, 479, 12, 70, "ProofInfoBody",
 CellID->696824889]
}, Closed]],
Cell[CellGroupData[{
Cell[404914, 10612, 5237, 132, 26, "ProofInfo",
 CellTags->{"Proof|ID:323838795", "Proof|ID:323838795-1"},
 CellID->19340158],
Cell[410154, 10746, 480, 12, 70, "ProofInfoBody",
 CellID->150383413]
}, Closed]],
Cell[CellGroupData[{
Cell[410671, 10763, 4308, 110, 26, "ProofInfo",
 CellTags->{"Proof|ID:394780640", "Proof|ID:394780640-1"},
 CellID->77476222],
Cell[414982, 10875, 480, 12, 70, "ProofInfoBody",
 CellID->490225186]
}, Closed]],
Cell[CellGroupData[{
Cell[415499, 10892, 3785, 100, 26, "ProofInfo",
 CellTags->{"Proof|ID:387391039", "Proof|ID:387391039-1"},
 CellID->423977867],
Cell[419287, 10994, 479, 12, 70, "ProofInfoBody",
 CellID->24620625]
}, Closed]],
Cell[CellGroupData[{
Cell[419803, 11011, 5391, 134, 26, "ProofInfo",
 CellTags->{"Proof|ID:154396855", "Proof|ID:154396855-1"},
 CellID->105185766],
Cell[425197, 11147, 480, 12, 70, "ProofInfoBody",
 CellID->301123050]
}, Closed]],
Cell[CellGroupData[{
Cell[425714, 11164, 4177, 109, 26, "ProofInfo",
 CellTags->{"Proof|ID:399369070", "Proof|ID:399369070-1"},
 CellID->253624188],
Cell[429894, 11275, 480, 12, 70, "ProofInfoBody",
 CellID->317975990]
}, Closed]],
Cell[430389, 11290, 879, 26, 23, "GlobalDeclaration",
 CellTags->{
  "ID:286514517", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->286514517],
Cell[431271, 11318, 47, 1, 12, "OpenEnvironment",
 CellID->916630204],
Cell[CellGroupData[{
Cell[431343, 11323, 430, 11, 43, "EnvironmentHeader",
 CellID->61787122],
Cell[431776, 11336, 2028, 64, 52, "FormalTextInputFormula",
 CellTags->{
  "ID:600914281", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "RelSet = EC QuoDom"},
 CellID->600914281],
Cell[433807, 11402, 1590, 49, 49, "FormalTextInputFormula",
 CellTags->{
  "ID:315304271", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC = EC QuoDom"},
 CellID->315304271],
Cell[435400, 11453, 1035, 29, 42, "FormalTextInputFormula",
 CellTags->{
  "ID:18625187", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", 
   "generator \[Element] EC QuoDom", "IR"},
 CellID->18625187],
Cell[436438, 11484, 1111, 31, 42, "FormalTextInputFormula",
 CellTags->{
  "ID:2541232", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "EC \[Tilde] QuoDom"},
 CellID->2541232],
Cell[437552, 11517, 656, 16, 30, "GlobalDeclaration",
 CellTags->{
  "ID:155852592", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->155852592],
Cell[438211, 11535, 1757, 55, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:850875018", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun1 EC QuoDom"},
 CellID->850875018],
Cell[439971, 11592, 1873, 59, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:660096993", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Fun2 EC QuoDom"},
 CellID->660096993],
Cell[441847, 11653, 1648, 52, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:579696921", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel1 EC QuoDom"},
 CellID->579696921],
Cell[443498, 11707, 1811, 57, 51, "FormalTextInputFormula",
 CellTags->{
  "ID:121665751", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "Rel2 EC QuoDom"},
 CellID->121665751],
Cell[445312, 11766, 65, 1, 70, "EndEnvironmentMarker",
 CellID->645916226]
}, Open  ]],
Cell[445392, 11770, 48, 1, 70, "CloseEnvironment",
 CellID->123398104],
Cell[CellGroupData[{
Cell[445465, 11775, 7389, 176, 70, "ProofInfo",
 CellTags->{"Proof|ID:600914281", "Proof|ID:600914281-1"},
 CellID->59538394],
Cell[452857, 11953, 480, 12, 70, "ProofInfoBody",
 CellID->742827071]
}, Closed]],
Cell[CellGroupData[{
Cell[453374, 11970, 5996, 146, 70, "ProofInfo",
 CellTags->{"Proof|ID:315304271", "Proof|ID:315304271-1"},
 CellID->10277787],
Cell[459373, 12118, 479, 12, 70, "ProofInfoBody",
 CellID->75820694]
}, Closed]],
Cell[CellGroupData[{
Cell[459889, 12135, 4496, 115, 70, "ProofInfo",
 CellTags->{"Proof|ID:18625187", "Proof|ID:18625187-1"},
 CellID->248846673],
Cell[464388, 12252, 479, 12, 70, "ProofInfoBody",
 CellID->584557824]
}, Closed]],
Cell[CellGroupData[{
Cell[464904, 12269, 5952, 146, 70, "ProofInfo",
 CellTags->{"Proof|ID:2541232", "Proof|ID:2541232-1"},
 CellID->71970252],
Cell[470859, 12417, 478, 12, 70, "ProofInfoBody",
 CellID->207017478]
}, Closed]],
Cell[CellGroupData[{
Cell[471374, 12434, 7226, 172, 70, "ProofInfo",
 CellTags->{"Proof|ID:850875018", "Proof|ID:850875018-1"},
 CellID->229274292],
Cell[478603, 12608, 575, 14, 70, "ProofInfoBody",
 CellID->690541569]
}, Closed]],
Cell[CellGroupData[{
Cell[479215, 12627, 8674, 200, 70, "ProofInfo",
 CellTags->{"Proof|ID:660096993", "Proof|ID:660096993-1"},
 CellID->461529143],
Cell[487892, 12829, 480, 12, 70, "ProofInfoBody",
 CellID->130417206]
}, Closed]],
Cell[CellGroupData[{
Cell[488409, 12846, 6636, 160, 70, "ProofInfo",
 CellTags->{"Proof|ID:579696921", "Proof|ID:579696921-1"},
 CellID->547752486],
Cell[495048, 13008, 479, 12, 70, "ProofInfoBody",
 CellID->75339468]
}, Closed]],
Cell[CellGroupData[{
Cell[495564, 13025, 8083, 188, 70, "ProofInfo",
 CellTags->{"Proof|ID:121665751", "Proof|ID:121665751-1"},
 CellID->91275895],
Cell[503650, 13215, 479, 12, 70, "ProofInfoBody",
 CellID->54682895]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[504190, 13234, 317, 5, 30, "Subsection",
 CellID->79741596],
Cell[CellGroupData[{
Cell[504532, 13243, 124, 2, 70, "Subsubsection",
 CellID->454028482],
Cell[504659, 13247, 46, 1, 70, "OpenEnvironment",
 CellID->70404381],
Cell[CellGroupData[{
Cell[504730, 13252, 473, 11, 70, "EnvironmentHeader",
 CellID->31332229],
Cell[505206, 13265, 1478, 38, 70, "GlobalDeclaration",
 CellTags->{
  "ID:531967789", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->531967789],
Cell[506687, 13305, 2059, 57, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1523090696", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isClosed"},
 CellID->1523090696],
Cell[508749, 13364, 2769, 82, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:665775613", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isNeutral"},
 CellID->665775613],
Cell[511521, 13448, 2310, 66, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:154995644", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isAssoc"},
 CellID->154995644],
Cell[513834, 13516, 3166, 95, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1959021758", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isDistr"},
 CellID->1959021758],
Cell[517003, 13613, 2005, 59, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:2052928557", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isComm"},
 CellID->2052928557],
Cell[519011, 13674, 2898, 96, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1343138992", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isInverse"},
 CellID->1343138992],
Cell[521912, 13772, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1977433743]
}, Open  ]],
Cell[521993, 13776, 49, 1, 70, "CloseEnvironment",
 CellID->1292223339]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[522103, 13784, 245, 4, 43, "Section",
 CellID->1842935737],
Cell[522351, 13790, 675, 16, 31, "GlobalDeclaration",
 CellTags->{
  "ID:1192467176", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1192467176],
Cell[CellGroupData[{
Cell[523051, 13810, 339, 7, 38, "Subsection",
 CellID->385590292],
Cell[CellGroupData[{
Cell[523415, 13821, 129, 2, 70, "Subsubsection",
 CellID->1072816],
Cell[523547, 13825, 1295, 34, 70, "Text",
 CellID->1141537016]
}, Closed]],
Cell[CellGroupData[{
Cell[524879, 13864, 123, 2, 70, "Subsubsection",
 CellID->1008704052],
Cell[525005, 13868, 48, 1, 70, "OpenEnvironment",
 CellID->2095126507],
Cell[CellGroupData[{
Cell[525078, 13873, 372, 9, 70, "EnvironmentHeader",
 CellID->448781018],
Cell[525453, 13884, 3065, 91, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1597214241", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid"},
 CellID->1597214241],
Cell[528521, 13977, 236, 5, 70, "EnvironmentText",
 CellID->530717929],
Cell[528760, 13984, 1394, 41, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1972933949", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCCMonoid \[RawStar]"},
 CellID->1972933949],
Cell[530157, 14027, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1324680537]
}, Open  ]],
Cell[530238, 14031, 47, 1, 70, "CloseEnvironment",
 CellID->98904843]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[530334, 14038, 181, 3, 30, "Subsection",
 CellID->1719323837],
Cell[530518, 14043, 130, 2, 28, "Subsubsection",
 CellID->341932562],
Cell[CellGroupData[{
Cell[530673, 14049, 122, 2, 22, "Subsubsection",
 CellID->1274281857],
Cell[530798, 14053, 47, 1, 12, "OpenEnvironment",
 CellID->556578949],
Cell[CellGroupData[{
Cell[530870, 14058, 372, 9, 43, "EnvironmentHeader",
 CellID->465362497],
Cell[531245, 14069, 2115, 62, 91, "FormalTextInputFormula",
 CellTags->{
  "ID:1964463139", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup"},
 CellID->1964463139],
Cell[533363, 14133, 65, 1, 26, "EndEnvironmentMarker",
 CellID->129487384]
}, Open  ]],
Cell[533443, 14137, 48, 1, 16, "CloseEnvironment",
 CellID->932182300]
}, Closed]],
Cell[CellGroupData[{
Cell[533528, 14143, 185, 3, 22, "Subsubsection",
 CellID->288465208],
Cell[533716, 14148, 47, 1, 70, "OpenEnvironment",
 CellID->870533616],
Cell[CellGroupData[{
Cell[533788, 14153, 334, 9, 70, "EnvironmentHeader",
 CellID->296738308],
Cell[534125, 14164, 1437, 49, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1561309471", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1561309471],
Cell[535565, 14215, 776, 20, 70, "GlobalDeclaration",
 CellTags->{
  "ID:603470889", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->603470889],
Cell[536344, 14237, 944, 25, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1714531538", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 2"},
 CellID->1714531538],
Cell[537291, 14264, 1075, 29, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1593316744", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 3"},
 CellID->1593316744],
Cell[538369, 14295, 787, 21, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:60508897", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 0"},
 CellID->60508897],
Cell[539159, 14318, 847, 24, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:446590811", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isGroup 1"},
 CellID->446590811],
Cell[540009, 14344, 65, 1, 70, "EndEnvironmentMarker",
 CellID->874309540]
}, Open  ]],
Cell[540089, 14348, 48, 1, 70, "CloseEnvironment",
 CellID->937494369],
Cell[CellGroupData[{
Cell[540162, 14353, 4771, 118, 70, "ProofInfo",
 CellTags->{"Proof|ID:1714531538", "Proof|ID:1714531538-1"},
 CellID->319112690],
Cell[544936, 14473, 481, 12, 70, "ProofInfoBody",
 CellID->174654720]
}, Closed]],
Cell[CellGroupData[{
Cell[545454, 14490, 4755, 118, 70, "ProofInfo",
 CellTags->{"Proof|ID:1593316744", "Proof|ID:1593316744-1"},
 CellID->46511985],
Cell[550212, 14610, 481, 12, 70, "ProofInfoBody",
 CellID->170432487]
}, Closed]],
Cell[CellGroupData[{
Cell[550730, 14627, 3371, 90, 70, "ProofInfo",
 CellTags->{"Proof|ID:60508897", "Proof|ID:60508897-1"},
 CellID->133380493],
Cell[554104, 14719, 479, 12, 70, "ProofInfoBody",
 CellID->308748448]
}, Closed]],
Cell[CellGroupData[{
Cell[554620, 14736, 3862, 100, 70, "ProofInfo",
 CellTags->{"Proof|ID:446590811", "Proof|ID:446590811-1"},
 CellID->4186777],
Cell[558485, 14838, 480, 12, 70, "ProofInfoBody",
 CellID->211077589]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[559026, 14857, 207, 3, 30, "Subsection",
 CellID->1653589144],
Cell[CellGroupData[{
Cell[559258, 14864, 132, 2, 28, "Subsubsection",
 CellID->1532797853],
Cell[559393, 14868, 625, 12, 70, "Text",
 CellID->2087072197]
}, Closed]],
Cell[CellGroupData[{
Cell[560055, 14885, 123, 2, 22, "Subsubsection",
 CellID->1979879689],
Cell[560181, 14889, 48, 1, 70, "OpenEnvironment",
 CellID->1632404590],
Cell[CellGroupData[{
Cell[560254, 14894, 387, 9, 70, "EnvironmentHeader",
 CellID->1892848015],
Cell[560644, 14905, 5996, 177, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1169392713", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing"},
 CellID->1169392713],
Cell[566643, 15084, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1784089539]
}, Open  ]],
Cell[566724, 15088, 47, 1, 70, "CloseEnvironment",
 CellID->33654702]
}, Closed]],
Cell[CellGroupData[{
Cell[566808, 15094, 183, 3, 22, "Subsubsection",
 CellID->2143828374],
Cell[566994, 15099, 47, 1, 12, "OpenEnvironment",
 CellID->839963059],
Cell[CellGroupData[{
Cell[567066, 15104, 391, 9, 43, "EnvironmentHeader",
 CellID->1778478693],
Cell[567460, 15115, 685, 19, 23, "GlobalDeclaration",
 CellTags->{
  "ID:1019439434", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1019439434],
Cell[568148, 15136, 1182, 33, 50, "FormalTextInputFormula",
 CellTags->{
  "ID:68765473", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing isSet"},
 CellID->68765473],
Cell[569333, 15171, 1207, 39, 38, "FormalTextInputFormula",
 CellTags->{
  "ID:713491381", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 1"},
 CellID->713491381],
Cell[570543, 15212, 1126, 34, 49, "FormalTextInputFormula",
 CellTags->{
  "ID:491734364", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isRing 2"},
 CellID->491734364],
Cell[571672, 15248, 66, 1, 26, "EndEnvironmentMarker",
 CellID->1404566399]
}, Open  ]],
Cell[571753, 15252, 49, 1, 16, "CloseEnvironment",
 CellID->1708344039],
Cell[CellGroupData[{
Cell[571827, 15257, 4068, 108, 28, "ProofInfo",
 CellTags->{"Proof|ID:68765473", "Proof|ID:68765473-1"},
 CellID->156840741],
Cell[575898, 15367, 478, 12, 56, "ProofInfoBody",
 CellID->16895151]
}, Closed]],
Cell[CellGroupData[{
Cell[576413, 15384, 3171, 86, 26, "ProofInfo",
 CellTags->{"Proof|ID:713491381", "Proof|ID:713491381-1"},
 CellID->125917763],
Cell[579587, 15472, 546, 13, 56, "ProofInfoBody",
 CellID->510196875]
}, Closed]],
Cell[CellGroupData[{
Cell[580170, 15490, 3790, 104, 26, "ProofInfo",
 CellTags->{"Proof|ID:491734364", "Proof|ID:491734364-1"},
 CellID->397105211],
Cell[583963, 15596, 479, 12, 56, "ProofInfoBody",
 CellID->21005898]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[584503, 15615, 336, 7, 30, "Subsection",
 CellID->318314069],
Cell[CellGroupData[{
Cell[584864, 15626, 132, 2, 70, "Subsubsection",
 CellID->1603202234],
Cell[584999, 15630, 439, 8, 70, "Text",
 CellID->427358887]
}, Closed]],
Cell[CellGroupData[{
Cell[585475, 15643, 123, 2, 70, "Subsubsection",
 CellID->2011211919],
Cell[585601, 15647, 48, 1, 70, "OpenEnvironment",
 CellID->1438655325],
Cell[CellGroupData[{
Cell[585674, 15652, 503, 11, 70, "EnvironmentHeader",
 CellID->1089966505],
Cell[586180, 15665, 2544, 74, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:812208573", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1"},
 CellID->812208573],
Cell[588727, 15741, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1261940483]
}, Open  ]],
Cell[588808, 15745, 49, 1, 70, "CloseEnvironment",
 CellID->1298597111],
Cell[588860, 15748, 47, 1, 70, "OpenEnvironment",
 CellID->765232050],
Cell[CellGroupData[{
Cell[588932, 15753, 369, 9, 70, "EnvironmentHeader",
 CellID->958556015],
Cell[589304, 15764, 1885, 59, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1005941388", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isUnit"},
 CellID->1005941388],
Cell[591192, 15825, 65, 1, 70, "EndEnvironmentMarker",
 CellID->970354891]
}, Open  ]],
Cell[591272, 15829, 49, 1, 70, "CloseEnvironment",
 CellID->1252126296]
}, Closed]],
Cell[CellGroupData[{
Cell[591358, 15835, 186, 3, 70, "Subsubsection",
 CellID->1011648899],
Cell[591547, 15840, 48, 1, 70, "OpenEnvironment",
 CellID->1205229592],
Cell[CellGroupData[{
Cell[591620, 15845, 414, 10, 70, "EnvironmentHeader",
 CellID->168077255],
Cell[592037, 15857, 714, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1603254219", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->1603254219],
Cell[592754, 15877, 1162, 34, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:616379398", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 1"},
 CellID->616379398],
Cell[593919, 15913, 1425, 45, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1787433797", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 2"},
 CellID->1787433797],
Cell[595347, 15960, 1812, 57, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1086651396", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 3"},
 CellID->1086651396],
Cell[597162, 16019, 1537, 49, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:357550885", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 4"},
 CellID->357550885],
Cell[598702, 16070, 1492, 46, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:2088302303", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isCommRing1 5"},
 CellID->2088302303],
Cell[600197, 16118, 66, 1, 70, "EndEnvironmentMarker",
 CellID->2107571198]
}, Open  ]],
Cell[600278, 16122, 48, 1, 70, "CloseEnvironment",
 CellID->678439284],
Cell[CellGroupData[{
Cell[600351, 16127, 3809, 104, 70, "ProofInfo",
 CellTags->{"Proof|ID:616379398", "Proof|ID:616379398-1"},
 CellID->65009391],
Cell[604163, 16233, 479, 12, 70, "ProofInfoBody",
 CellID->54585264]
}, Closed]],
Cell[CellGroupData[{
Cell[604679, 16250, 4007, 110, 70, "ProofInfo",
 CellTags->{"Proof|ID:1787433797", "Proof|ID:1787433797-1"},
 CellID->60427408],
Cell[608689, 16362, 481, 12, 70, "ProofInfoBody",
 CellID->480407126]
}, Closed]],
Cell[CellGroupData[{
Cell[609207, 16379, 5260, 132, 70, "ProofInfo",
 CellTags->{"Proof|ID:1086651396", "Proof|ID:1086651396-1"},
 CellID->307947317],
Cell[614470, 16513, 481, 12, 70, "ProofInfoBody",
 CellID->122088504]
}, Closed]],
Cell[CellGroupData[{
Cell[614988, 16530, 4521, 120, 70, "ProofInfo",
 CellTags->{"Proof|ID:357550885", "Proof|ID:357550885-1"},
 CellID->683270508],
Cell[619512, 16652, 480, 12, 70, "ProofInfoBody",
 CellID->856423138]
}, Closed]],
Cell[CellGroupData[{
Cell[620029, 16669, 5144, 126, 70, "ProofInfo",
 CellTags->{"Proof|ID:2088302303", "Proof|ID:2088302303-1"},
 CellID->321492677],
Cell[625176, 16797, 481, 12, 70, "ProofInfoBody",
 CellID->192269402]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[625718, 16816, 205, 3, 30, "Subsection",
 CellID->850281858],
Cell[CellGroupData[{
Cell[625948, 16823, 132, 2, 70, "Subsubsection",
 CellID->1433152330],
Cell[626083, 16827, 765, 17, 70, "Text",
 CellID->737915736],
Cell[626851, 16846, 274, 6, 70, "Text",
 CellID->1027255413]
}, Closed]],
Cell[CellGroupData[{
Cell[627162, 16857, 123, 2, 70, "Subsubsection",
 CellID->1155951610],
Cell[627288, 16861, 47, 1, 70, "OpenEnvironment",
 CellID->523344353],
Cell[CellGroupData[{
Cell[627360, 16866, 388, 9, 70, "EnvironmentHeader",
 CellID->265440682],
Cell[627751, 16877, 4268, 117, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1231884360", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField"},
 CellID->1231884360],
Cell[632022, 16996, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1051823196]
}, Open  ]],
Cell[632103, 17000, 48, 1, 70, "CloseEnvironment",
 CellID->680590308]
}, Closed]],
Cell[CellGroupData[{
Cell[632188, 17006, 183, 3, 70, "Subsubsection",
 CellID->255705131],
Cell[632374, 17011, 47, 1, 70, "OpenEnvironment",
 CellID->219164290],
Cell[CellGroupData[{
Cell[632446, 17016, 438, 10, 70, "EnvironmentHeader",
 CellID->305611509],
Cell[632887, 17028, 754, 19, 70, "GlobalDeclaration",
 CellTags->{
  "ID:15476569", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb"},
 CellID->15476569],
Cell[633644, 17049, 1416, 44, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:2036492268", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField membership /", 
   "IR"},
 CellID->2036492268],
Cell[635063, 17095, 1301, 39, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1399031260", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4"},
 CellID->1399031260],
Cell[636367, 17136, 1303, 39, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1519132486", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 4'"},
 CellID->1519132486],
Cell[637673, 17177, 1255, 37, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:23853891", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 6"},
 CellID->23853891],
Cell[638931, 17216, 1589, 50, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:214934627", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1"},
 CellID->214934627],
Cell[640523, 17268, 1588, 50, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1629111293", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 1'"},
 CellID->1629111293],
Cell[642114, 17320, 1284, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:567921874", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 2"},
 CellID->567921874],
Cell[643401, 17362, 1741, 56, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:2078845477", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 3"},
 CellID->2078845477],
Cell[645145, 17420, 1516, 45, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:170294828", 
   "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/AlgebraicStructures.nb", "isField 5"},
 CellID->170294828],
Cell[646664, 17467, 65, 1, 70, "EndEnvironmentMarker",
 CellID->360165426]
}, Open  ]],
Cell[646744, 17471, 47, 1, 70, "CloseEnvironment",
 CellID->87659551],
Cell[CellGroupData[{
Cell[646816, 17476, 4672, 118, 70, "ProofInfo",
 CellTags->{"Proof|ID:2036492268", "Proof|ID:2036492268-1"},
 CellID->511497596],
Cell[651491, 17596, 481, 12, 70, "ProofInfoBody",
 CellID->192729812]
}, Closed]],
Cell[CellGroupData[{
Cell[652009, 17613, 4862, 124, 70, "ProofInfo",
 CellTags->{"Proof|ID:1399031260", "Proof|ID:1399031260-1"},
 CellID->563098],
Cell[656874, 17739, 525, 13, 70, "ProofInfoBody",
 CellID->908463839]
}, Closed]],
Cell[CellGroupData[{
Cell[657436, 17757, 4867, 124, 70, "ProofInfo",
 CellTags->{"Proof|ID:1519132486", "Proof|ID:1519132486-1"},
 CellID->266927180],
Cell[662306, 17883, 481, 12, 70, "ProofInfoBody",
 CellID->116538041]
}, Closed]],
Cell[CellGroupData[{
Cell[662824, 17900, 4265, 114, 70, "ProofInfo",
 CellTags->{"Proof|ID:23853891", "Proof|ID:23853891-1"},
 CellID->358679361],
Cell[667092, 18016, 477, 12, 70, "ProofInfoBody",
 CellID->2528211]
}, Closed]],
Cell[CellGroupData[{
Cell[667606, 18033, 5293, 132, 70, "ProofInfo",
 CellTags->{"Proof|ID:214934627", "Proof|ID:214934627-1"},
 CellID->59879918],
Cell[672902, 18167, 479, 12, 70, "ProofInfoBody",
 CellID->9940439]
}, Closed]],
Cell[CellGroupData[{
Cell[673418, 18184, 5186, 132, 70, "ProofInfo",
 CellTags->{"Proof|ID:1629111293", "Proof|ID:1629111293-1"},
 CellID->522111781],
Cell[678607, 18318, 481, 12, 70, "ProofInfoBody",
 CellID->341081766]
}, Closed]],
Cell[CellGroupData[{
Cell[679125, 18335, 3862, 106, 70, "ProofInfo",
 CellTags->{"Proof|ID:567921874", "Proof|ID:567921874-1"},
 CellID->54163083],
Cell[682990, 18443, 480, 12, 70, "ProofInfoBody",
 CellID->488460890]
}, Closed]],
Cell[CellGroupData[{
Cell[683507, 18460, 5722, 144, 70, "ProofInfo",
 CellTags->{"Proof|ID:2078845477", "Proof|ID:2078845477-1"},
 CellID->19379211],
Cell[689232, 18606, 481, 12, 70, "ProofInfoBody",
 CellID->336923892]
}, Closed]],
Cell[CellGroupData[{
Cell[689750, 18623, 6507, 156, 70, "ProofInfo",
 CellTags->{"Proof|ID:170294828", "Proof|ID:170294828-1"},
 CellID->284220434],
Cell[696260, 18781, 480, 12, 70, "ProofInfoBody",
 CellID->159835187]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
