(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    580880,      15531]
NotebookOptionsPosition[    435139,      11685]
NotebookOutlinePosition[    544235,      14409]
CellTagsIndexPosition[    536067,      14203]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Functors", "Title",
 CellChangeTimes->{{3.63574597029145*^9, 3.6357459745542183`*^9}, {
  3.6554492121568403`*^9, 3.6554492134204426`*^9}},
 CellID->1472320091],

Cell[CellGroupData[{

Cell["Preliminaries", "Section",
 CellChangeTimes->{{3.6443084245106*^9, 3.644308427083333*^9}},
 CellID->909929215],

Cell[CellGroupData[{

Cell["Theory Packages", "Subsection",
 CellChangeTimes->{{3.6554586827139797`*^9, 3.655458685896385*^9}},
 CellID->304735566],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6554585102472763`*^9, 3.655458512977281*^9}},
 CellID->848912120],

Cell[BoxData[
 RowBox[{"$PackageDirectory", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
    "$RootDirectory", ",", "\"\<scratch\>\"", ",", "\"\<amaletzk\>\"", ",", 
     "\"\<Theorema Environment Data\>\""}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.666437877102172*^9, 3.666437921544471*^9}},
 CellID->254769439],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{"$PackageDirectory", ",", "\"\<LogicSets.m\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6554587000612097`*^9, 3.655458766142926*^9}, {
  3.6664378652645807`*^9, 3.666437867195784*^9}, {3.6664379252243633`*^9, 
  3.6664379296870813`*^9}},
 CellID->34967564],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{"$PackageDirectory", ",", "\"\<NatInt.m\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6554588452984653`*^9, 3.65545884810647*^9}, 
   3.666437932888214*^9},
 CellID->242592210],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{"$PackageDirectory", ",", "\"\<Tuples.m\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6554588452984653`*^9, 3.65545884810647*^9}, {
   3.655463004534171*^9, 3.6554630055013723`*^9}, 3.666437934096171*^9},
 CellID->268120864],

Cell[BoxData[
 RowBox[{"MakeTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6554584971588535`*^9, 3.6554585052708673`*^9}},
 CellID->307882976],

Cell[BoxData[
 RowBox[{"UpdateTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6554624389151773`*^9, 3.6554624425031834`*^9}},
 CellID->634255394]
}, Closed]],

Cell[CellGroupData[{

Cell["Theory Analysis", "Subsection",
 CellChangeTimes->{{3.640668830437483*^9, 3.640668834318727*^9}},
 CellID->1386333768],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AnalyzeProofs", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"FileNameJoin", "[", 
       RowBox[{"{", 
        RowBox[{
        "$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", "#"}], 
        "}"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<ElementaryTheories\>\"", ",", "\"\<Reduction Ring Theory\>\""}], 
      "}"}]}], "]"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.653223166066796*^9, 3.653223174615611*^9}, {
  3.666438387914599*^9, 3.6664384531559563`*^9}},
 CellID->239327779],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\AlgebraicStructures\\\" (\"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\AlgebraicStructures\" (", 1, " of ", "11", 
   "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519342474384`*^9},
 CellID->231074188],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"15\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "15"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519342474384`*^9},
 CellID->235399543],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\ConsistencyChecker\\\" (\"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\ConsistencyChecker\" (", 2, " of ", "11", 
   "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451934372239*^9},
 CellID->74228564],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Fields\\\" (\"\>", "\[InvisibleSpace]", 
   "3", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Fields\" (", 3, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451934387839*^9},
 CellID->52740732],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"36\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "36"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451934387839*^9},
 CellID->174797361],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Functors\\\" (\"\>", 
   "\[InvisibleSpace]", "4", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Functors\" (", 4, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519353706408`*^9},
 CellID->189035512],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"30\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "30"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519353862405`*^9},
 CellID->173771855],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\GroebnerRings\\\" (\"\>", 
   "\[InvisibleSpace]", "5", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\GroebnerRings\" (", 5, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519360882416`*^9},
 CellID->319542108],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"164\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "164"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451936103842*^9},
 CellID->303606234],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"164\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "164"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519376170444`*^9},
 CellID->57640752],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"164\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "164"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519390678473`*^9},
 CellID->134635643],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"164\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "164"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519405342493`*^9},
 CellID->406213841],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\LogicSets\\\" (\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\LogicSets\" (", 6, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519409710503`*^9},
 CellID->69157529],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"51\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "51"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519409866505`*^9},
 CellID->492543894],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"51\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "51"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451941407851*^9},
 CellID->473149805],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\NatInt\\\" (\"\>", "\[InvisibleSpace]", 
   "7", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\NatInt\" (", 7, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451941439051*^9},
 CellID->253932889],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"118\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "118"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451941439051*^9},
 CellID->117224106],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"118\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "118"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519420786524`*^9},
 CellID->107200411],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"118\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "118"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519427338533`*^9},
 CellID->241953319],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Polynomials\\\" (\"\>", 
   "\[InvisibleSpace]", "8", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Polynomials\" (", 8, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451942952254*^9},
 CellID->122444630],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"342\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "342"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519429834538`*^9},
 CellID->806172405],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"342\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "342"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519438726554`*^9},
 CellID->356623074],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"342\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "342"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451944839857*^9},
 CellID->1502692],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"342\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "342"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451945775859*^9},
 CellID->46282536],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"342\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "342"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451946805461*^9},
 CellID->171440827],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"342\"\>"}],
  SequenceForm["Reading proof ", 251, " of ", "342"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519479442625`*^9},
 CellID->62930444],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"342\"\>"}],
  SequenceForm["Reading proof ", 301, " of ", "342"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451948817864*^9},
 CellID->92091199],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\ReductionRings\\\" (\"\>", 
   "\[InvisibleSpace]", "9", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\ReductionRings\" (", 9, " of ", "11", "):"],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519496290655`*^9},
 CellID->140574753],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"245\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "245"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519496446657`*^9},
 CellID->112619049],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"245\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "245"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519506898675`*^9},
 CellID->21818011],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"245\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "245"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451951719469*^9},
 CellID->434096050],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"245\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "245"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451952873871*^9},
 CellID->156161373],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"245\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "245"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451953997073*^9},
 CellID->267176890],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Sequences\\\" (\"\>", 
   "\[InvisibleSpace]", "10", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Sequences\" (", 10, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451955042275*^9},
 CellID->64091394],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"46\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "46"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451955057875*^9},
 CellID->5691558],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Tuples\\\" (\"\>", "\[InvisibleSpace]", 
   "11", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"11\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Tuples\" (", 11, " of ", "11", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451955650676*^9},
 CellID->186593265],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"185\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "185"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451955650676*^9},
 CellID->34313527],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"185\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "185"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451956259077*^9},
 CellID->118518],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"185\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "185"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451956851878*^9},
 CellID->319115275],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"185\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "185"],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451957413479*^9},
 CellID->693325999],

Cell[BoxData["\<\"Creating forward rules:\"\>"], "Print",
 CellChangeTimes->{3.65545195778788*^9},
 CellID->106341091],

Cell[BoxData["\<\"Preparing ...\"\>"], "Print",
 CellChangeTimes->{3.65545195786588*^9},
 CellID->103393720],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519582090807`*^9},
 CellID->324871125],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 51, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451959394683*^9},
 CellID->61897625],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 101, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451960564685*^9},
 CellID->230972936],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 151, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451961734687*^9},
 CellID->157118787],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 201, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451962904689*^9},
 CellID->435797633],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 251, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451964090291*^9},
 CellID->174803739],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 301, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451965260293*^9},
 CellID->370066886],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 351, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451966430295*^9},
 CellID->25912622],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 401, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451967615897*^9},
 CellID->180366616],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 451, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451968848299*^9},
 CellID->534735304],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 501, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451970018301*^9},
 CellID->230748884],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 551, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519711727037`*^9},
 CellID->124731382],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 601, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519723271055`*^9},
 CellID->756925856],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 651, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519735127077`*^9},
 CellID->593677906],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 701, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519746671095`*^9},
 CellID->164174786],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 751, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519758527117`*^9},
 CellID->478359904],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 801, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451977038314*^9},
 CellID->82331956],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 851, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451978208316*^9},
 CellID->34366134],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "901", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 901, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451979393918*^9},
 CellID->56164485],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "951", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 951, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.65545198056392*^9},
 CellID->683135210],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1001", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1001, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451981718322*^9},
 CellID->127805],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1051", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1051, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451982872724*^9},
 CellID->51646120],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1101, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519840271263`*^9},
 CellID->165867777],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1151, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451985181528*^9},
 CellID->266526958],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1201, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.65545198633593*^9},
 CellID->407414415],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1251, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451987474732*^9},
 CellID->308206403],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1301, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451988644734*^9},
 CellID->135952013],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1351, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655451989799136*^9},
 CellID->315920781],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1401, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519910003386`*^9},
 CellID->151317848],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1451, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519922015405`*^9},
 CellID->500119495],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1501, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519933715425`*^9},
 CellID->458982690],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1551, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519945259447`*^9},
 CellID->359534940],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1601, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519956803465`*^9},
 CellID->120613399],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1651, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519968347483`*^9},
 CellID->114102864],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1701, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.65545199798915*^9},
 CellID->149819274],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1751, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554519991435523`*^9},
 CellID->304159966],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1801, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554520002823544`*^9},
 CellID->87983146],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1851, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554520014523563`*^9},
 CellID->674154617],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1901", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1901, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.6554520026067586`*^9},
 CellID->138442590],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1951", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 1951, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655452003792361*^9},
 CellID->42611772],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2001", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2049"}],
  SequenceForm["Creating rule ", 2001, " of ", 2049],
  Editable->False]], "Print",
 CellChangeTimes->{3.655452004962363*^9},
 CellID->242925013],

Cell[BoxData["\<\"Creating thinned data ...\"\>"], "Print",
 CellChangeTimes->{3.655452006101165*^9},
 CellID->174649905],

Cell[BoxData["\<\"Done\"\>"], "Print",
 CellChangeTimes->{3.655452006194765*^9},
 CellID->334581406]
}, Open  ]]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComputeFormulaPositions", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.644649344001361*^9, 3.6446493476777363`*^9}},
 CellID->2077551358],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckIntegrity", "[", 
  RowBox[{"\"\<CheckPositions\>\"", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"CurrentValue", "[", "\"\<NotebookDirectory\>\"", "]"}], ",", 
       RowBox[{"CurrentValue", "[", "\"\<NotebookFileName\>\"", "]"}]}], 
      "}"}], "]"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64067003109768*^9, 3.6406700374311132`*^9}, {
   3.6406797903560762`*^9, 3.640679792950843*^9}, 3.6442220291527653`*^9},
 CellID->1909803754],

Cell[BoxData[
 RowBox[{"CheckIntegrity", "[", 
  RowBox[{"\<\"CheckPositions\"\>", "\[Rule]", 
   RowBox[{
   "{", "\<\"/home/amaletzk/Theorema Notebooks/ElementaryTheories.nb\"\>", 
    "}"}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.640670040858255*^9, 3.640670099679185*^9, 3.640670397721546*^9, 
   3.640679793300535*^9, 3.6406798406436234`*^9, 3.640679891162312*^9, 
   3.640679971009297*^9, 3.64068009182163*^9, 3.640680173340745*^9, 
   3.641037395456129*^9, 3.641116403388618*^9, 3.641286881014108*^9, 
   3.642225466578094*^9, 3.642234672070362*^9, 3.642240151894621*^9, 
   3.6423063269273643`*^9, {3.642308832539488*^9, 3.642308857563932*^9}, 
   3.642321396697977*^9, 3.6423285030212173`*^9, 3.642493582768566*^9, 
   3.642763270724422*^9, 3.642834604308413*^9, 3.643428832901271*^9, 
   3.6434441292624083`*^9, 3.643532851309215*^9, 3.6507065133125153`*^9},
 CellID->1365249879]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ps", "=", 
   RowBox[{"GetProofSize", "[", "All", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ps0", "=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Most", "[", 
       RowBox[{"Last", "[", "#", "]"}], "]"}], "]"}], "&"}], ",", "ps"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.647156479700988*^9, 3.647156479817154*^9}, {
   3.647156560839411*^9, 3.6471566309015427`*^9}, 3.6471570742150927`*^9, 
   3.6471571422253036`*^9, {3.647157728211722*^9, 3.647157728406296*^9}},
 CellID->1780799392],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{
   RowBox[{"NotebookGet", "[", "]"}], ",", 
   RowBox[{"Cell", "[", 
    RowBox[{"_", ",", "\"\<FormalTextInputFormula\>\"", ",", "___"}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6550382930110416`*^9, 3.655038363616766*^9}, {
   3.655442032762142*^9, 3.6554420535101786`*^9}, {3.6554492440120964`*^9, 
   3.6554492537621136`*^9}, 3.655449332982053*^9},
 CellID->63220416],

Cell[BoxData["49"], "Output",
 CellChangeTimes->{3.655449333481254*^9, 3.655464765719865*^9},
 CellID->13465628]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Auxiliary Functions", "Subsection",
 CellChangeTimes->{{3.640668579267561*^9, 3.640668583347287*^9}},
 CellID->1454182661],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "LoadPackage", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadPackage", "[", "name_String", "]"}], ":=", 
   RowBox[{"LoadPackage", "[", 
    RowBox[{"{", "name", "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadPackage", "[", 
    RowBox[{"l", ":", 
     RowBox[{"{", "___String", "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Get", "[", 
       RowBox[{"FileNameJoin", "[", 
        RowBox[{"{", 
         RowBox[{"$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
          RowBox[{"#", "<>", "\"\<.m\>\""}]}], "}"}], "]"}], "]"}], "&"}], 
     ",", "l"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.640668603629292*^9, 3.640668727460284*^9}, 
   3.641286816086794*^9, 3.6434459961973133`*^9, {3.653223148703965*^9, 
   3.653223155365177*^9}, {3.666437944276445*^9, 3.666437955355873*^9}},
 CellID->2074904605],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "FindFormula", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindFormula", "[", "label_String", "]"}], ":=", 
   RowBox[{"NotebookLocate", "[", "label", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.640677756847624*^9, 3.6406777896243896`*^9}, 
   3.640677822869519*^9, {3.640677854902379*^9, 3.6406778579321823`*^9}},
 CellID->1980565193],

Cell[BoxData[
 RowBox[{"LoadPackage", "[", "\"\<ProofPalette\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.640668742006607*^9, 3.640668751417616*^9}},
 CellID->444074165],

Cell[BoxData[
 RowBox[{"LoadPackage", "[", "\"\<TheoryTools/TheoryTools\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.640668759133181*^9, 3.640668768089197*^9}, {
  3.6551873799276342`*^9, 3.655187380848036*^9}, {3.6585758607079563`*^9, 
  3.6585758632507606`*^9}, {3.666437964135839*^9, 3.666437969687437*^9}},
 CellID->584704106]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Product Functors (\[Checkmark])", "Section",
 CellChangeTimes->{{3.655463024065405*^9, 3.655463025375808*^9}, {
  3.6554630898039207`*^9, 3.655463092190725*^9}, {3.6597017542334623`*^9, 
  3.659701758164669*^9}},
 CellID->284088374],

Cell[CellGroupData[{

Cell["General Products (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.6554630635646744`*^9, 3.65546306654428*^9}, {
  3.655464742007823*^9, 3.6554647462198305`*^9}},
 CellID->107685530],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.6554634885670214`*^9, 3.6554634902050242`*^9}},
 CellID->515936865],

Cell["", "OpenEnvironment",
 CellID->400670803],

Cell[CellGroupData[{

Cell["Definition: Product of Two Domains", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6554630780415*^9, 3.6554630782443004`*^9}, {
  3.655463109647156*^9, 3.655463114561164*^9}},
 CellID->403870778],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
  "\[ScriptCapitalA]", ",", "\[ScriptCapitalB]"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
          13590416}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6554631203955746`*^9, 3.655463124716782*^9}},
 CellTags->{
  "ID:13590416", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->13590416],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProdDomain", "[", 
   RowBox[{"\[ScriptCapitalA]", ",", "\[ScriptCapitalB]"}], "]"}], ":=", 
  UnderscriptBox["\[CapitalDelta]", "N"]}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
          52891026}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6554631317679944`*^9, 3.65546314627602*^9}},
 CellTags->{
  "ID:52891026", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->52891026],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "x"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
          556284720}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.655463161735647*^9, 3.6554631625156484`*^9}},
 CellTags->{
  "ID:556284720", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->556284720],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Element]", "N"], 
    RowBox[{"[", "x", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"isTuple", "[", "x", "]"}]},
       {
        RowBox[{
         RowBox[{"\[LeftBracketingBar]", "x", "\[RightBracketingBar]"}], 
         "\[Equal]", "2"}]},
       {
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
         RowBox[{"[", 
          SubscriptBox["x", "1"], "]"}]}]},
       {
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
         RowBox[{"[", 
          SubscriptBox["x", "2"], "]"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(ProdDomain \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:172182433", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.655463166244055*^9, 3.6554632122797356`*^9}, 
   3.655463421836904*^9},
 CellTags->{
  "ID:172182433", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element]"},
 CellID->172182433],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["<<", "N"], "x"}], 
   TagBox[")",
    "AutoParentheses"]}], ":=", 
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["<<", "\[ScriptCapitalA]"], 
      RowBox[{"(", 
       SubscriptBox["x", "1"], ")"}]}], 
     TagBox[")",
      "AutoParentheses"]}], ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["<<", "\[ScriptCapitalB]"], 
      RowBox[{"(", 
       SubscriptBox["x", "2"], ")"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   "\[RightAngleBracket]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(ProdDomain parsing)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:96567293", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6554632429337893`*^9, 3.6554632679260335`*^9}},
 CellTags->{
  "ID:96567293", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain parsing"},
 CellID->96567293],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox[">>", "N"], 
    RowBox[{"[", "x", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], ":=", 
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      UnderscriptBox[">>", "\[ScriptCapitalA]"], 
      RowBox[{"[", 
       SubscriptBox["x", "1"], "]"}]}], ")"}], ",", 
    RowBox[{"(", 
     RowBox[{
      UnderscriptBox[">>", "\[ScriptCapitalB]"], 
      RowBox[{"[", 
       SubscriptBox["x", "2"], "]"}]}], ")"}]}], 
   "\[RightAngleBracket]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(ProdDomain printing)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:666017826", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.655463279142453*^9, {3.6554633094065065`*^9, 3.65546333441335*^9}, {
   3.6554634410873375`*^9, 3.6554634613761735`*^9}},
 CellTags->{
  "ID:666017826", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain printing"},
 CellID->666017826],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->154080212]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->166200272]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.6554634966946354`*^9, 3.6554634975682373`*^9}, {
  3.655464732507406*^9, 3.655464736766214*^9}},
 CellID->430264024],

Cell["", "OpenEnvironment",
 CellID->166969519],

Cell[CellGroupData[{

Cell["\<\
Lemma: Alternative Characterization of \[Element] of Product Domains\
\>", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6554635838207884`*^9, 3.6554635981104136`*^9}},
 CellID->496003494],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
  "\[ScriptCapitalA]", ",", "\[ScriptCapitalB]"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 43183279}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.655463520469077*^9, 3.6554635246498847`*^9}},
 CellTags->{
  "ID:43183279", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->43183279],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"\[ScriptCapitalD]", "=", 
   RowBox[{"ProdDomain", "[", 
    RowBox[{"\[ScriptCapitalA]", ",", "\[ScriptCapitalB]"}], 
    "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 501919234}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6554635421843157`*^9, 3.65546357310357*^9}},
 CellTags->{
  "ID:501919234", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->501919234],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"x1", ",", "x2"}]], 
  RowBox[{
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"\[LeftAngleBracket]", 
       RowBox[{"x1", ",", "x2"}], "\[RightAngleBracket]"}], "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
      RowBox[{"[", "x1", "]"}]}], "\[And]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
      RowBox[{"[", "x2", "]"}]}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(ProdDomain \[Element] alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:177079530", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6554636202936525`*^9, 3.6554636236476583`*^9}},
 CellTags->{
  "ID:177079530", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element] alternative", "IR"},
 CellID->177079530],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   UnderscriptBox["\[Exists]", 
    RowBox[{
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
      RowBox[{"[", "x1", "]"}]}], ",", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
      RowBox[{"[", "x2", "]"}]}]}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{"x", "\[Equal]", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"x1", ",", "x2"}], "\[RightAngleBracket]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(ProdDomain \[Element] alternative II)", "FrameLabel"], 
        "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:160393105", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.655463631244872*^9, 3.6554636343648777`*^9}},
 CellTags->{
  "ID:160393105", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element] alternative II"},
 CellID->160393105],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"x", "\[Equal]", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{
       SubscriptBox["x", "1"], ",", 
       SubscriptBox["x", "2"]}], "\[RightAngleBracket]"}]}], "\[And]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
     RowBox[{"[", 
      SubscriptBox["x", "1"], "]"}]}], "\[And]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
     RowBox[{"[", 
      SubscriptBox["x", "2"], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(ProdDomain \[Element] alternative III)", "FrameLabel"], 
        "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:666612949", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6554636407608886`*^9, 3.655463643771694*^9}},
 CellTags->{
  "ID:666612949", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element] alternative III"},
 CellID->666612949],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isDomain", "[", "\[ScriptCapitalA]", "]"}], "\[And]", 
    RowBox[{"isDomain", "[", "\[ScriptCapitalB]", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
  "isDomain", "[", "\[ScriptCapitalD]", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(ProdDomain isDomain)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:15990241", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.655464094175685*^9, 3.6554641190197287`*^9}},
 CellTags->{
  "ID:15990241", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain isDomain"},
 CellID->15990241],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->85772654]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->280940150],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(ProdDomain \[Element] alternative)\"\>", "FormReference",
       
       StripOnInput->False], True->
      StyleBox["\<\"(ProdDomain \[Element] alternative)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["x1", "ExpressionVariable"], ",", 
            StyleBox["x2", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"ProdDomain", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                  "]"}]], "[", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   StyleBox["x1", "ExpressionVariable"], ",", 
                   StyleBox["x2", "ExpressionVariable"]}], 
                 "\[RightAngleBracket]"}], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}], 
             ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["x1", "ExpressionVariable"], ",", 
            StyleBox["x2", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"ProdDomain", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                  "]"}]], "[", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   StyleBox["x1", "ExpressionVariable"], ",", 
                   StyleBox["x2", "ExpressionVariable"]}], 
                 "\[RightAngleBracket]"}], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}], 
             ")"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:177079530"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p177079530-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p177079530-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:177079530", "Proof|ID:177079530-1"},
 CellID->222181063],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p177079530-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->21994795]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(ProdDomain \[Element] alternative II)\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(ProdDomain \[Element] alternative II)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"ProdDomain", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Exists]", 
            GridBox[{{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}}]], 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 StyleBox["x1", "ExpressionVariable"], ",", 
                 StyleBox["x2", "ExpressionVariable"]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"ProdDomain", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Exists]", 
            GridBox[{{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}}]], 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 StyleBox["x1", "ExpressionVariable"], ",", 
                 StyleBox["x2", "ExpressionVariable"]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:160393105"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p160393105-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p160393105-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:160393105", "Proof|ID:160393105-1"},
 CellID->175723293],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p160393105-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->70824576]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(ProdDomain \[Element] alternative III)\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(ProdDomain \[Element] alternative III)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"ProdDomain", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"]}], 
               "\[RightAngleBracket]"}]}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "1"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "2"], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"ProdDomain", "[", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"]}], 
               "\[RightAngleBracket]"}]}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "1"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "2"], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:666612949"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p666612949-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p666612949-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:666612949", "Proof|ID:666612949-1"},
 CellID->159422770],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p666612949-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->684344276]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(ProdDomain isDomain)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(ProdDomain isDomain)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], "]"}]}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"ProdDomain", "[", 
               RowBox[{
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], "]"}]}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"ProdDomain", "[", 
               RowBox[{
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:15990241"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p15990241-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p15990241-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:15990241", "Proof|ID:15990241-1"},
 CellID->486730789],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p15990241-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->83158492]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lexicographic Orders (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.647744825628439*^9, 3.6477448310692787`*^9}, 
   3.64785970733322*^9, {3.6597017463242483`*^9, 3.6597017499902554`*^9}},
 CellID->583495173],

Cell[CellGroupData[{

Cell["Definitions", "Subsubsection",
 CellChangeTimes->{{3.647744835847352*^9, 3.647744837738985*^9}},
 CellID->477730874],

Cell["", "OpenEnvironment",
 CellID->949427984],

Cell[CellGroupData[{

Cell["Definition: Lexicographic Ordering", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6477448433973017`*^9, 3.647744850216319*^9}},
 CellID->2055575223],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"\[ScriptCapitalA]", ",", "\[ScriptCapitalB]", ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox[">",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[RightTriangle]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 131627256}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647744856394288*^9, 3.647744918399822*^9}, {
   3.647745202450824*^9, 3.647745207243217*^9}, 3.647765975906445*^9},
 CellTags->{
  "ID:131627256", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->131627256],

Cell[BoxData[
 RowBox[{
  RowBox[{"LexOrder", "[", 
   RowBox[{
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"\[ScriptCapitalA]", ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"\[ScriptCapitalB]", ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[RightAngleBracket]"}]}], "]"}], ":=", 
  UnderscriptBox["\[CapitalDelta]", "N"]}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1252521910}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477449252753267`*^9, 3.647744974063951*^9}, {
   3.647745208899115*^9, 3.6477452134384537`*^9}, 3.6477661411065197`*^9},
 CellTags->{
  "ID:1252521910", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1252521910],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"x1", ",", "x2", ",", "y1", ",", "y2"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 483943613}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647744979369526*^9, 3.647744992854912*^9}},
 CellTags->{
  "ID:483943613", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->483943613],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Element]", "N"], 
    RowBox[{"[", "x1", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"isTuple", "[", "x1", "]"}]},
       {
        RowBox[{
         RowBox[{"\[LeftBracketingBar]", "x1", "\[RightBracketingBar]"}], 
         "\[Equal]", "2"}]},
       {
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
         RowBox[{"[", 
          SubscriptBox["x1", "1"], "]"}]}]},
       {
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
         RowBox[{"[", 
          SubscriptBox["x1", "2"], "]"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:415499872", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64774499656129*^9, 3.647745055188252*^9}, {
  3.647745216161036*^9, 3.647745220816298*^9}},
 CellTags->{
  "ID:415499872", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element]"},
 CellID->415499872],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"x1", ",", "x2"}], "\[RightAngleBracket]"}], 
    UnderscriptBox["\[Succeeds]", "N"], 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"y1", ",", "y2"}], "\[RightAngleBracket]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Or]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{
         RowBox[{"x1", ">", "y1"}], "\[And]", 
         RowBox[{"x1", "\[NotEqual]", "y1"}]}]},
       {
        RowBox[{
         RowBox[{"x1", "\[Equal]", "y1"}], "\[And]", 
         RowBox[{"x2", "\[RightTriangle]", "y2"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder \[Succeeds])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1592061526", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647745072393915*^9, 3.64774512184912*^9}, {
   3.647753765712607*^9, 3.647753772366683*^9}, 3.647766037206089*^9, {
   3.647766095634856*^9, 3.647766111648179*^9}},
 CellTags->{
  "ID:1592061526", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Succeeds]"},
 CellID->1592061526],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x1", 
    UnderscriptBox["\[Precedes]", "N"], "y1"}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"y1", 
    UnderscriptBox["\[Succeeds]", "N"], "x1"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder \[Precedes])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:660280664", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647745150233654*^9, 3.64774517388662*^9}, 
   3.647766039231257*^9, {3.647766100748726*^9, 3.6477661031770267`*^9}},
 CellTags->{
  "ID:660280664", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Precedes]"},
 CellID->660280664],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1788854642]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->113858470],

Cell["", "OpenEnvironment",
 CellID->544818500],

Cell[CellGroupData[{

Cell["Definition: 3-ary Lexicographic Ordering", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647745309531763*^9, 3.647745321103313*^9}},
 CellID->765032411],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
  "\[ScriptCapitalA]", ",", "\[ScriptCapitalB]", ",", "\[ScriptCapitalC]", 
   ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox[">",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[RightTriangle]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[GreaterGreater]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1203319602}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.6477453330739603`*^9, {3.647745689525691*^9, 3.647745697384488*^9}, {
   3.6477457283305187`*^9, 3.647745769806366*^9}, 3.6477661370534887`*^9, {
   3.647766223392673*^9, 3.647766226005599*^9}, 3.647766268921688*^9},
 CellTags->{
  "ID:1203319602", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1203319602],

Cell[BoxData[
 RowBox[{
  RowBox[{"LexOrder3", "[", 
   RowBox[{
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"\[ScriptCapitalA]", ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"\[ScriptCapitalB]", ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"\[ScriptCapitalC]", ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[GreaterGreater]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[RightAngleBracket]"}]}], "]"}], ":=", 
  UnderscriptBox["\[CapitalDelta]", "N"]}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1155548854}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647745776328368*^9, 3.647745821245076*^9}, 
   3.6477661440871553`*^9, {3.647766228403631*^9, 3.6477662308729258`*^9}, 
   3.647766271367627*^9},
 CellTags->{
  "ID:1155548854", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1155548854],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
  "x1", ",", "x2", ",", "x3", ",", "y1", ",", "y2", ",", 
   "y3"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 268596668}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647745824566217*^9, 3.647745840064863*^9}, {
  3.64774588755238*^9, 3.647745893388158*^9}},
 CellTags->{
  "ID:268596668", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->268596668],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Element]", "N"], 
    RowBox[{"[", "x1", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"isTuple", "[", "x1", "]"}]},
       {
        RowBox[{
         RowBox[{"\[LeftBracketingBar]", "x1", "\[RightBracketingBar]"}], 
         "\[Equal]", "3"}]},
       {
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
         RowBox[{"[", 
          SubscriptBox["x1", "1"], "]"}]}]},
       {
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
         RowBox[{"[", 
          SubscriptBox["x1", "2"], "]"}]}]},
       {
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
         RowBox[{"[", 
          SubscriptBox["x1", "3"], "]"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:143611979", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477458470123987`*^9, 3.647745901337178*^9}},
 CellTags->{
  "ID:143611979", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element]"},
 CellID->143611979],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"x1", ",", "x2", ",", "x3"}], "\[RightAngleBracket]"}], 
    UnderscriptBox["\[Succeeds]", "N"], 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"y1", ",", "y2", ",", "y3"}], "\[RightAngleBracket]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Or]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{
         RowBox[{"x1", ">", "y1"}], "\[And]", 
         RowBox[{"x1", "\[NotEqual]", "y1"}]}]},
       {
        RowBox[{
         RowBox[{"x1", "\[Equal]", "y1"}], "\[And]", 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{"\[Or]", 
           RowBox[{"\[Piecewise]", GridBox[{
              {
               RowBox[{
                RowBox[{"x2", "\[RightTriangle]", "y2"}], "\[And]", 
                RowBox[{"x2", "\[NotEqual]", "y2"}]}]},
              {
               RowBox[{
                RowBox[{"x2", "\[Equal]", "y2"}], "\[And]", 
                RowBox[{"x3", "\[GreaterGreater]", "y3"}]}]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
          TagBox[")",
           "AutoParentheses"]}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[Succeeds])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1082760072", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64774588220477*^9, 3.647746091444159*^9}, {
   3.647746308343009*^9, 3.6477463766073227`*^9}, {3.647753799010132*^9, 
   3.647753808759798*^9}, 3.647766048517667*^9, 3.647766147880281*^9, {
   3.647766236564371*^9, 3.647766243665469*^9}, {3.647766274062029*^9, 
   3.647766290650854*^9}},
 CellTags->{
  "ID:1082760072", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Succeeds]"},
 CellID->1082760072],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x1", 
    UnderscriptBox["\[Precedes]", "N"], "y1"}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"y1", 
    UnderscriptBox["\[Succeeds]", "N"], "x1"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[Precedes])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2039496926", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.647746125161469*^9, 3.6477660496224337`*^9, {3.647766237853697*^9, 
   3.647766239142023*^9}, {3.647766279662384*^9, 3.6477662881445303`*^9}},
 CellTags->{
  "ID:2039496926", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Precedes]"},
 CellID->2039496926],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["ToLexOrder", "N"], "[", "x1", "]"}], ":=", 
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{
    SubscriptBox["x1", "1"], ",", 
    RowBox[{"Rest", "[", "x1", "]"}]}], 
   "\[RightAngleBracket]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 ToLexOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1528170763", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64777653908675*^9, 3.6477765591874533`*^9}},
 CellTags->{
  "ID:1528170763", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder"},
 CellID->1528170763],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1205354934]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->363305525],

Cell["", "OpenEnvironment",
 CellID->137661402],

Cell[CellGroupData[{

Cell["Definition: N-ary Lexicographic Ordering", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647833534155571*^9, 3.647833541457513*^9}},
 CellID->247405329],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "\[ScriptCapitalD]"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1177571532}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478335608211107`*^9, 3.647833617889028*^9}, {
  3.64783365724452*^9, 3.647833660416312*^9}, {3.647834408657143*^9, 
  3.647834410093886*^9}},
 CellTags->{
  "ID:1177571532", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1177571532],

Cell[BoxData[
 RowBox[{
  RowBox[{"LexOrderN", "[", "\[ScriptCapitalD]", "]"}], ":=", 
  UnderscriptBox["\[CapitalDelta]", "N"]}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1157453212}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647833608552479*^9, 3.6478336296687117`*^9}},
 CellTags->{
  "ID:1157453212", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1157453212],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"x", ",", "y"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1901627231}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647833636199156*^9, 3.6478336372488194`*^9}, {
  3.647833725950103*^9, 3.647833726208734*^9}},
 CellTags->{
  "ID:1901627231", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1901627231],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Element]", "N"], 
    RowBox[{"[", "x", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[And]", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"isTuple", "[", "x", "]"}]},
       {
        RowBox[{
         RowBox[{"\[LeftBracketingBar]", "x", "\[RightBracketingBar]"}], 
         "\[Equal]", 
         RowBox[{
         "\[LeftBracketingBar]", "\[ScriptCapitalD]", 
          "\[RightBracketingBar]"}]}]},
       {
        RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", "\[Ellipsis]", ",", 
           RowBox[{"\[LeftBracketingBar]", "x", "\[RightBracketingBar]"}]}]], 
         
         RowBox[{
          UnderscriptBox["\[Element]", 
           SubscriptBox[
            RowBox[{"(", 
             SubscriptBox["\[ScriptCapitalD]", "i"], ")"}], "1"]], 
          RowBox[{"[", 
           SubscriptBox["x", "i"], "]"}]}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:475599841", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478336408250923`*^9, 3.647833704837385*^9}},
 CellTags->{
  "ID:475599841", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN \[Element]"},
 CellID->475599841],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", 
    UnderscriptBox["\[Succeeds]", "N"], "y"}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", "\[Ellipsis]", ",", 
      RowBox[{"\[LeftBracketingBar]", "x", "\[RightBracketingBar]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"\[And]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{
           UnderscriptBox["\[ForAll]", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", "\[Ellipsis]", ",", 
             RowBox[{"i", "-", "1"}]}]], 
           RowBox[{
            SubscriptBox["x", "j"], "\[Equal]", 
            SubscriptBox["y", "j"]}]}]},
         {
          RowBox[{
           RowBox[{"(", 
            SubscriptBox[
             RowBox[{"(", 
              SubscriptBox["\[ScriptCapitalD]", "i"], ")"}], "2"], ")"}], "[", 
           RowBox[{
            SubscriptBox["x", "i"], ",", 
            SubscriptBox["y", "i"]}], "]"}]},
         {
          RowBox[{
           SubscriptBox["x", "i"], "\[NotEqual]", 
           SubscriptBox["y", "i"]}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN \[Succeeds])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1975055247", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647833721933584*^9, 3.6478339192972593`*^9}},
 CellTags->{
  "ID:1975055247", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN \[Succeeds]"},
 CellID->1975055247],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", 
    UnderscriptBox["\[Precedes]", "N"], "y"}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"y", 
    UnderscriptBox["\[Succeeds]", "N"], "x"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN \[Precedes])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:715152506", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647833956524261*^9, 3.64783398390571*^9}},
 CellTags->{
  "ID:715152506", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN \[Precedes]"},
 CellID->715152506],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["ToLexOrder", "N"], "[", "x", "]"}], ":=", 
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{
    SubscriptBox["x", "1"], ",", 
    RowBox[{"Rest", "[", "x", "]"}]}], 
   "\[RightAngleBracket]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN ToLexOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1361950489", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647834700335598*^9, 3.647834719875898*^9}},
 CellTags->{
  "ID:1361950489", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder"},
 CellID->1361950489],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1530801336]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1847880814]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas: LexOrder (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.647746574118312*^9, 3.647746581928557*^9}, {
   3.6477471737953167`*^9, 3.647747176362849*^9}, {3.647765212729713*^9, 
   3.647765217112844*^9}, 3.647841660594626*^9},
 CellID->1322241940],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"\[ScriptCapitalA]", ",", "\[ScriptCapitalB]", ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox[">",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[RightTriangle]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1394564787}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647746598113513*^9, 3.647746629123143*^9}, 
   3.6477669075605803`*^9},
 CellTags->{
  "ID:1394564787", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1394564787],

Cell["", "Text",
 CellID->710111611],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"\[ScriptCapitalL]", "=", 
   RowBox[{"LexOrder", "[", 
    RowBox[{
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalA]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox[">",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalB]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox["\[RightTriangle]",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}]}], 
    "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 56619207}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477466368952303`*^9, 3.647746648834531*^9}, 
   3.647766909260227*^9},
 CellTags->{
  "ID:56619207", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->56619207],

Cell["", "OpenEnvironment",
 CellID->2089569634],

Cell[CellGroupData[{

Cell["\<\
Lemma: Alternative Description of \[Element] of LexOrder\
\>", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6477466010546083`*^9, 3.6477466043671417`*^9}, {
  3.64774665292074*^9, 3.647746660543869*^9}, {3.647746802619884*^9, 
  3.64774680278272*^9}},
 CellID->1280486604],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"x1", ",", "x2"}]], 
  RowBox[{
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
     RowBox[{"[", 
      RowBox[{"\[LeftAngleBracket]", 
       RowBox[{"x1", ",", "x2"}], "\[RightAngleBracket]"}], "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
      RowBox[{"[", "x1", "]"}]}], "\[And]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
      RowBox[{"[", "x2", "]"}]}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder \[Element] alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:625854003", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647746702053549*^9, 3.64774672014415*^9}},
 CellTags->{
  "ID:625854003", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element] alternative"},
 CellID->625854003],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   UnderscriptBox["\[Exists]", 
    RowBox[{
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
      RowBox[{"[", "x1", "]"}]}], ",", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
      RowBox[{"[", "x2", "]"}]}]}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{"x", "\[Equal]", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"x1", ",", "x2"}], "\[RightAngleBracket]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder \[Element] alternative II)", "FrameLabel"], "  ", 
        
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1695764024", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647748475488577*^9, 3.6477485124919167`*^9}},
 CellTags->{
  "ID:1695764024", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element] alternative II"},
 CellID->1695764024],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"x", "\[Equal]", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{
       SubscriptBox["x", "1"], ",", 
       SubscriptBox["x", "2"]}], "\[RightAngleBracket]"}]}], "\[And]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
     RowBox[{"[", 
      SubscriptBox["x", "1"], "]"}]}], "\[And]", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
     RowBox[{"[", 
      SubscriptBox["x", "2"], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder \[Element] alternative III)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:998703597", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647764527202341*^9, 3.647764533993071*^9}, {
  3.647764588548527*^9, 3.647764609831255*^9}},
 CellTags->{
  "ID:998703597", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element] alternative III"},
 CellID->998703597],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1220874263]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1962097428],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder \[Element] alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder \[Element] alternative)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["x1", "ExpressionVariable"], ",", 
            StyleBox["x2", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   StyleBox["x1", "ExpressionVariable"], ",", 
                   StyleBox["x2", "ExpressionVariable"]}], 
                 "\[RightAngleBracket]"}], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}], 
             ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["x1", "ExpressionVariable"], ",", 
            StyleBox["x2", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   StyleBox["x1", "ExpressionVariable"], ",", 
                   StyleBox["x2", "ExpressionVariable"]}], 
                 "\[RightAngleBracket]"}], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}], 
             ")"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:625854003"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p625854003-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p625854003-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:625854003", "Proof|ID:625854003-1"},
 CellID->535822348],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p625854003-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->31038819]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder \[Element] alternative II)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder \[Element] alternative II)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Exists]", 
            GridBox[{{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}}]], 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 StyleBox["x1", "ExpressionVariable"], ",", 
                 StyleBox["x2", "ExpressionVariable"]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Exists]", 
            GridBox[{{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}}]], 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 StyleBox["x1", "ExpressionVariable"], ",", 
                 StyleBox["x2", "ExpressionVariable"]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1695764024"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1695764024-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1695764024-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1695764024", "Proof|ID:1695764024-1"},
 CellID->1504850255],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1695764024-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->328565073]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder \[Element] alternative III)\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder \[Element] alternative III)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"]}], 
               "\[RightAngleBracket]"}]}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "1"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "2"], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"]}], 
               "\[RightAngleBracket]"}]}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "1"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "2"], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:998703597"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p998703597-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p998703597-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:998703597", "Proof|ID:998703597-1"},
 CellID->1420174462],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p998703597-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->425113255]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->460107632],

Cell[CellGroupData[{

Cell["Theorem: LexOrder is Domain and Partial Order", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647746790126814*^9, 3.647746845334812*^9}, {
  3.647746940134688*^9, 3.647746942241981*^9}, {3.6477511604676237`*^9, 
  3.647751160653419*^9}, {3.647753331850308*^9, 3.647753332220976*^9}, {
  3.6615949803365955`*^9, 3.6615949873410077`*^9}},
 CellID->380364038],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isDomain", "[", "\[ScriptCapitalA]", "]"}], "\[And]", 
    RowBox[{"isDomain", "[", "\[ScriptCapitalB]", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
  "isDomain", "[", "\[ScriptCapitalL]", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isDomain)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:83506562", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6615950007570314`*^9, 3.661595019898265*^9}},
 CellTags->{
  "ID:83506562", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isDomain"},
 CellID->83506562],

Cell[TextData[{
 "For reflexivity of ",
 Cell[BoxData[
  FormBox[
   UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"], TraditionalForm]]],
 " it is sufficient if only ",
 Cell[BoxData[
  FormBox["\[RightTriangle]", TraditionalForm]]],
 " is reflexive."
}], "EnvironmentText",
 CellChangeTimes->{{3.6477542962403107`*^9, 3.6477543319623547`*^9}, {
  3.647755692804097*^9, 3.64775569307145*^9}},
 CellID->1205862328],

Cell[BoxData[
 RowBox[{
  RowBox[{"isReflexive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[RightTriangle]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[Implies]", 
  RowBox[{"isReflexive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isReflexive)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1564408474", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647753032625746*^9, 3.647753044213078*^9}, {
  3.647754277483838*^9, 3.647754278624449*^9}},
 CellTags->{
  "ID:1564408474", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isReflexive"},
 CellID->1564408474],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isAntisymmetric", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isAntisymmetric", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isAntisymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isAntisymmetric)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:993421296", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647753246149634*^9, 3.647753255512941*^9}, 
   3.647766929279257*^9},
 CellTags->{
  "ID:993421296", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isAntisymmetric"},
 CellID->993421296],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isAsymmetric", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isAsymmetric", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isAsymmetric", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isAsymmetric)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:762792695", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647747018489854*^9, 3.647747051522952*^9}, {
   3.647751094408004*^9, 3.647751132635378*^9}, 3.647766931969432*^9},
 CellTags->{
  "ID:762792695", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isAsymmetric"},
 CellID->762792695],

Cell[TextData[{
 "For transitivity of ",
 Cell[BoxData[
  FormBox[
   UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"], TraditionalForm]]],
 " we need antisymmetry of ",
 Cell[BoxData[
  FormBox[">", TraditionalForm]]],
 "."
}], "EnvironmentText",
 CellChangeTimes->{{3.6477542962403107`*^9, 3.6477543319623547`*^9}, {
  3.647755674995084*^9, 3.647755714879718*^9}, {3.647756171691637*^9, 
  3.647756184759511*^9}, {3.647766934749961*^9, 3.647766936101499*^9}},
 CellID->1111685493],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isAntisymmetric", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isTransitive", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isTransitive", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isTransitive", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isTransitive)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:365362652", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477470646676903`*^9, 3.647747081882319*^9}, {
  3.647751146476089*^9, 3.647751158723736*^9}, {3.647755641781966*^9, 
  3.6477556659352293`*^9}, {3.647756173606434*^9, 3.6477561771723337`*^9}, {
  3.6477669381346188`*^9, 3.647766939717848*^9}},
 CellTags->{
  "ID:365362652", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isTransitive"},
 CellID->365362652],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isPartReflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isPartReflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isPartReflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isPartReflOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:676617813", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647753289197755*^9, 3.6477532980048656`*^9}, 
   3.647766942958346*^9},
 CellTags->{
  "ID:676617813", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isPartReflOrder"},
 CellID->676617813],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isPartIrreflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isPartIrreflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isPartIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isPartIrreflOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:419051997", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.64774681448729*^9, {3.647746865634611*^9, 3.64774695449819*^9}, {
   3.647751170508648*^9, 3.647751188416621*^9}, 3.647766944508263*^9},
 CellTags->{
  "ID:419051997", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isPartIrreflOrder"},
 CellID->419051997],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1329393950]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->181543040],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isDomain)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isDomain)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], "]"}]}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"LexOrder", "[", 
               RowBox[{
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], ",", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], "]"}]}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"LexOrder", "[", 
               RowBox[{
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], ",", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:83506562"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p83506562-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p83506562-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:83506562", "Proof|ID:83506562-1"},
 CellID->19037723],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p83506562-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->547232171]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isReflexive)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isReflexive)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isReflexive", "[", 
             RowBox[{
               StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"isReflexive", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isReflexive", "[", 
             RowBox[{
               StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"isReflexive", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1564408474"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1564408474-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1564408474-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1564408474", "Proof|ID:1564408474-1"},
 CellID->957699202],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1564408474-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1999361680]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isAntisymmetric)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isAntisymmetric)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isAntisymmetric", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isAntisymmetric", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isAntisymmetric", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isAntisymmetric", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isAntisymmetric", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isAntisymmetric", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:993421296"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p993421296-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p993421296-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:993421296", "Proof|ID:993421296-1"},
 CellID->1133214309],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p993421296-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->919634829]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isAsymmetric)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isAsymmetric)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isAsymmetric", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isAsymmetric", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isAsymmetric", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:762792695"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p762792695-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p762792695-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:762792695", "Proof|ID:762792695-1"},
 CellID->650701467],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p762792695-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->740493969]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isTransitive)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isTransitive)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isAntisymmetric", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isTransitive", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isAntisymmetric", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isTransitive", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isTransitive", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:365362652"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p365362652-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p365362652-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:365362652", "Proof|ID:365362652-1"},
 CellID->2129721589],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p365362652-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->292129237]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isPartReflOrder)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isPartReflOrder)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartReflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartReflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:676617813"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p676617813-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p676617813-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:676617813", "Proof|ID:676617813-1"},
 CellID->665767943],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p676617813-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->782217123]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isPartIrreflOrder)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isPartIrreflOrder)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartIrreflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartIrreflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:419051997"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p419051997-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p419051997-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:419051997", "Proof|ID:419051997-1"},
 CellID->939925669],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p419051997-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->394715092]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->165977954],

Cell[CellGroupData[{

Cell["\<\
Theorem: \[Succeeds] in LexOrder is Noetherian\
\>", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647747192513647*^9, 3.647747199279245*^9}, {
  3.661594959728959*^9, 3.661594974439785*^9}},
 CellID->970343590],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isNoetherian", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isNoetherian", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder isNoetherian)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:318639340", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647747235592836*^9, 3.647747247954605*^9}, {
   3.647762690388832*^9, 3.647762697616705*^9}, 3.647766947362089*^9},
 CellTags->{
  "ID:318639340", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isNoetherian"},
 CellID->318639340],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1461366415]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->186632542],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder isNoetherian)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder isNoetherian)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:318639340"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p318639340-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p318639340-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:318639340", "Proof|ID:318639340-1"},
 CellID->14707961],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p318639340-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellChangeTimes->{{3.653305146955143*^9, 3.6533051502155485`*^9}},
 CellID->565402786]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas: LexOrder3 (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.647746136233478*^9, 3.6477461420254173`*^9}, 
   3.647746396786501*^9, {3.64774657638068*^9, 3.647746578193623*^9}, {
   3.6478353631144114`*^9, 3.647835366996118*^9}},
 CellID->2108979739],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
  "\[ScriptCapitalA]", ",", "\[ScriptCapitalB]", ",", "\[ScriptCapitalC]", 
   ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox[">",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[RightTriangle]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}], ",", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    TagBox["\[GreaterGreater]",
     Identity], 
    TagBox[")",
     "AutoParentheses"]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1694786048}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.6477453330739603`*^9, {3.647745689525691*^9, 3.647745697384488*^9}, {
   3.6477457283305187`*^9, 3.647745769806366*^9}, 3.647765934141877*^9, 
   3.647766302859421*^9},
 CellTags->{
  "ID:1694786048", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1694786048],

Cell["", "Text",
 CellID->242619498],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"\[ScriptCapitalL]", "=", 
   RowBox[{"LexOrder3", "[", 
    RowBox[{
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalA]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox[">",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalB]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox["\[RightTriangle]",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalC]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox["\[GreaterGreater]",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}]}], 
    "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 335763124}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477462760737257`*^9, 3.647746285228423*^9}, 
   3.647765937642646*^9, 3.647766304513926*^9},
 CellTags->{
  "ID:335763124", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->335763124],

Cell["", "OpenEnvironment",
 CellID->1897726089],

Cell[CellGroupData[{

Cell["Lemma: Properties of ToLexOrder", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{
  3.647746148900544*^9, {3.647746407489725*^9, 3.647746424550105*^9}, {
   3.647746807642128*^9, 3.6477468077543297`*^9}, {3.64783538154252*^9, 
   3.647835386308571*^9}},
 CellID->1053581462],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
   RowBox[{"[", 
    RowBox[{"x", ",", "y"}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 789393137}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477771575580397`*^9, 3.6477771648685493`*^9}},
 CellTags->{
  "ID:789393137", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->789393137],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"x1", ",", "x2", ",", "x3"}]], 
  RowBox[{
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
     RowBox[{"[", 
      RowBox[{"\[LeftAngleBracket]", 
       RowBox[{"x1", ",", "x2", ",", "x3"}], "\[RightAngleBracket]"}], 
      "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
      RowBox[{"[", "x1", "]"}]}], "\[And]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
      RowBox[{"[", "x2", "]"}]}], "\[And]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
      RowBox[{"[", "x3", "]"}]}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[Element] alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1175612329", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6477461802548313`*^9, 3.64774624785633*^9}, {
   3.647746281660406*^9, 3.647746283357684*^9}, 3.6477465164665537`*^9, {
   3.647776877962166*^9, 3.647776881084095*^9}},
 CellTags->{
  "ID:1175612329", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element] alternative"},
 CellID->1175612329],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Exists]", 
   RowBox[{
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
     RowBox[{"[", "x1", "]"}]}], ",", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
     RowBox[{"[", "x2", "]"}]}], ",", 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
     RowBox[{"[", "x3", "]"}]}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", "\[Equal]", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"x1", ",", "x2", ",", "x3"}], "\[RightAngleBracket]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[Element] alternative II)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1604133742", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647748475488577*^9, 3.6477485124919167`*^9}, {
   3.6477495173232718`*^9, 3.647749527379271*^9}, 3.647777167861071*^9},
 CellTags->{
  "ID:1604133742", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element] alternative II"},
 CellID->1604133742],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", "\[Equal]", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      SubscriptBox["x", "2"], ",", 
      SubscriptBox["x", "3"]}], "\[RightAngleBracket]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[And]", 
  RowBox[{
   UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
   RowBox[{"[", 
    SubscriptBox["x", "1"], "]"}]}], "\[And]", 
  RowBox[{
   UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
   RowBox[{"[", 
    SubscriptBox["x", "2"], "]"}]}], "\[And]", 
  RowBox[{
   UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
   RowBox[{"[", 
    SubscriptBox["x", "3"], "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[Element] alternative III)", "FrameLabel"], 
        "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1325269638", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647765258113496*^9, 3.6477653050094433`*^9}, {
  3.647777170264048*^9, 3.647777181517212*^9}},
 CellTags->{
  "ID:1325269638", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element] alternative III"},
 CellID->1325269638],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "x", "]"}], 
  "\[Equal]", 
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{
    SubscriptBox["x", "1"], ",", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SubscriptBox["x", "2"], ",", 
      SubscriptBox["x", "3"]}], "\[RightAngleBracket]"}]}], 
   "\[RightAngleBracket]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 ToLexOrder alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1305799953", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647777051418494*^9, 3.647777079419673*^9}, {
  3.6477771746522923`*^9, 3.647777184182897*^9}},
 CellTags->{
  "ID:1305799953", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder alternative", "IR"},
 CellID->1305799953],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "x", "]"}], 
    "\[Equal]", 
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "y", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", "\[Equal]", "y"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 ToLexOrder injective)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1675542119", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647776845927864*^9, 3.647776853441309*^9}, {
  3.647776901653255*^9, 3.647776921166423*^9}, {3.647776967066381*^9, 
  3.6477769722819633`*^9}, {3.647777185848299*^9, 3.647777188662468*^9}},
 CellTags->{
  "ID:1675542119", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder injective"},
 CellID->1675542119],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"\[ScriptCapitalL]2", "=", 
   RowBox[{"LexOrder", "[", 
    RowBox[{
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalB]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox["\[RightTriangle]",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalC]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox["\[GreaterGreater]",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}]}], 
    "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 659473488}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647770376842181*^9, 3.647770384897304*^9}},
 CellTags->{
  "ID:659473488", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->659473488],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", 
   RowBox[{"LexOrder", "[", 
    RowBox[{
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalA]", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox[">",
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{"\[ScriptCapitalL]2", ",", 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        TagBox[
         UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]2"],
         Identity], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[RightAngleBracket]"}]}], "]"}]], 
  RowBox[{"[", 
   RowBox[{
    UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "x", "]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 ToLexOrder \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:951534856", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647771955908167*^9, 3.647771972054159*^9}, {
  3.6477766282093983`*^9, 3.647776638497116*^9}, {3.647777196061311*^9, 
  3.647777199389632*^9}},
 CellTags->{
  "ID:951534856", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder \[Element]"},
 CellID->951534856],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "x", "]"}], 
    UnderscriptBox["\[Succeeds]", 
     RowBox[{"LexOrder", "[", 
      RowBox[{
       RowBox[{"\[LeftAngleBracket]", 
        RowBox[{"\[ScriptCapitalA]", ",", 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          TagBox[">",
           Identity], 
          TagBox[")",
           "AutoParentheses"]}]}], "\[RightAngleBracket]"}], ",", 
       RowBox[{"\[LeftAngleBracket]", 
        RowBox[{"\[ScriptCapitalL]2", ",", 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          TagBox[
           UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]2"],
           Identity], 
          TagBox[")",
           "AutoParentheses"]}]}], "\[RightAngleBracket]"}]}], "]"}]], 
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "y", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", 
    UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"], "y"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 ToLexOrder \[Succeeds])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1364381745", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647770321502861*^9, 3.647770433825979*^9}, {
  3.647776958134647*^9, 3.647776981823822*^9}, {3.647777202674934*^9, 
  3.6477772045334187`*^9}, {3.64783231519901*^9, 3.647832320222034*^9}},
 CellTags->{
  "ID:1364381745", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder \[Succeeds]"},
 CellID->1364381745],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1459892258]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->926689034],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 \[Element] alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 \[Element] alternative)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["x1", "ExpressionVariable"], ",", 
            StyleBox["x2", "ExpressionVariable"], ",", 
            StyleBox["x3", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   StyleBox["x1", "ExpressionVariable"], ",", 
                   StyleBox["x2", "ExpressionVariable"], ",", 
                   StyleBox["x3", "ExpressionVariable"]}], 
                 "\[RightAngleBracket]"}], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                 StyleBox["x3", "ExpressionVariable"], "]"}]}], 
             ")"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["x1", "ExpressionVariable"], ",", 
            StyleBox["x2", "ExpressionVariable"], ",", 
            StyleBox["x3", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   StyleBox["x1", "ExpressionVariable"], ",", 
                   StyleBox["x2", "ExpressionVariable"], ",", 
                   StyleBox["x3", "ExpressionVariable"]}], 
                 "\[RightAngleBracket]"}], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"(", 
             RowBox[{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                 StyleBox["x3", "ExpressionVariable"], "]"}]}], 
             ")"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1175612329"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1175612329-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1175612329-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1175612329", "Proof|ID:1175612329-1"},
 CellID->186855576],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1175612329-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->1804105431]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 \[Element] alternative II)\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 \[Element] alternative II)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Exists]", 
            GridBox[{{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                 StyleBox["x3", "ExpressionVariable"], "]"}]}}]], 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 StyleBox["x1", "ExpressionVariable"], ",", 
                 StyleBox["x2", "ExpressionVariable"], ",", 
                 StyleBox["x3", "ExpressionVariable"]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Exists]", 
            GridBox[{{
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                 StyleBox["x1", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                 StyleBox["x2", "ExpressionVariable"], "]"}]}, {
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                 StyleBox["x3", "ExpressionVariable"], "]"}]}}]], 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 StyleBox["x1", "ExpressionVariable"], ",", 
                 StyleBox["x2", "ExpressionVariable"], ",", 
                 StyleBox["x3", "ExpressionVariable"]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1604133742"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1604133742-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1604133742-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1604133742", "Proof|ID:1604133742-1"},
 CellID->593724936],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1604133742-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->82900886]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 \[Element] alternative III)\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 \[Element] alternative III)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "3"]}], 
               "\[RightAngleBracket]"}]}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "1"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "2"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "3"], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "3"]}], 
               "\[RightAngleBracket]"}]}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "1"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "2"], "]"}], "\[And]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
             SubscriptBox[
              StyleBox["x", "ExpressionVariable"], "3"], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1325269638"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1325269638-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1325269638-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1325269638", "Proof|ID:1325269638-1"},
 CellID->2061926766],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1325269638-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1181888230]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 ToLexOrder alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 ToLexOrder alternative)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["ToLexOrder", 
              RowBox[{"LexOrder3", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
             StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
           RowBox[{"\[LeftAngleBracket]", 
             RowBox[{
               SubscriptBox[
                StyleBox["x", "ExpressionVariable"], "1"], ",", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "2"], ",", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "3"]}], 
                 "\[RightAngleBracket]"}]}], 
             "\[RightAngleBracket]"}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["ToLexOrder", 
              RowBox[{"LexOrder3", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
             StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
           RowBox[{"\[LeftAngleBracket]", 
             RowBox[{
               SubscriptBox[
                StyleBox["x", "ExpressionVariable"], "1"], ",", 
               RowBox[{"\[LeftAngleBracket]", 
                 RowBox[{
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "2"], ",", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "3"]}], 
                 "\[RightAngleBracket]"}]}], 
             "\[RightAngleBracket]"}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1305799953"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1305799953-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1305799953-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1305799953", "Proof|ID:1305799953-1"},
 CellID->259168266],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1305799953-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->109259321]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 ToLexOrder injective)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 ToLexOrder injective)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             StyleBox[
             "y", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}], "\[Implies]", 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             StyleBox[
             "y", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1675542119"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1675542119-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1675542119-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1675542119", "Proof|ID:1675542119-1"},
 CellID->1614785598],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1675542119-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->1306217654]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 ToLexOrder \[Element])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 ToLexOrder \[Element])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Element]", 
            RowBox[{"LexOrder", "[", 
              RowBox[{
                RowBox[{"\[LeftAngleBracket]", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                  "\[RightAngleBracket]"}], ",", 
                RowBox[{"\[LeftAngleBracket]", 
                  RowBox[{
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}], ",", 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]]}], 
                  "\[RightAngleBracket]"}]}], "]"}]], "[", 
           RowBox[{
             UnderscriptBox["ToLexOrder", 
              RowBox[{"LexOrder3", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
             StyleBox["x", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Element]", 
            RowBox[{"LexOrder", "[", 
              RowBox[{
                RowBox[{"\[LeftAngleBracket]", 
                  RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                  "\[RightAngleBracket]"}], ",", 
                RowBox[{"\[LeftAngleBracket]", 
                  RowBox[{
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}], ",", 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]]}], 
                  "\[RightAngleBracket]"}]}], "]"}]], "[", 
           RowBox[{
             UnderscriptBox["ToLexOrder", 
              RowBox[{"LexOrder3", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
             StyleBox["x", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:951534856"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p951534856-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p951534856-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:951534856", "Proof|ID:951534856-1"},
 CellID->277734451],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p951534856-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->695240427]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 ToLexOrder \[Succeeds])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 ToLexOrder \[Succeeds])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], 
             UnderscriptBox["\[Succeeds]", 
              RowBox[{"LexOrder", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}], ",", 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], 
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], 
             UnderscriptBox["\[Succeeds]", 
              RowBox[{"LexOrder3", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], 
             StyleBox[
             "y", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}, {
             StyleBox[">", "ExpressionVariable"]}, {
             StyleBox["\[RightTriangle]", "ExpressionVariable"]}, {
             StyleBox["\[GreaterGreater]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], 
             UnderscriptBox["\[Succeeds]", 
              RowBox[{"LexOrder", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}], ",", 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrder", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], 
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], 
             UnderscriptBox["\[Succeeds]", 
              RowBox[{"LexOrder3", "[", 
                RowBox[{
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                  RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], 
             StyleBox[
             "y", "ExpressionVariable"]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1364381745"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1364381745-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1364381745-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1364381745", "Proof|ID:1364381745-1"},
 CellID->465277495],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1364381745-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1693369290]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->1393992124],

Cell[CellGroupData[{

Cell["Corollary: LexOrder3 is Domain and Partial Noetherian Order", \
"EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647766513353388*^9, 3.647766523989237*^9}, {
  3.6615947952266703`*^9, 3.6615947976758747`*^9}, {3.6615949374053197`*^9, 
  3.6615949493705406`*^9}},
 CellID->981198618],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isDomain", "[", "\[ScriptCapitalA]", "]"}], "\[And]", 
    RowBox[{"isDomain", "[", "\[ScriptCapitalB]", "]"}], "\[And]", 
    RowBox[{"isDomain", "[", "\[ScriptCapitalC]", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
  "isDomain", "[", "\[ScriptCapitalL]", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 isDomain)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:350830179", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6615948068486905`*^9, 3.661594826972726*^9}},
 CellTags->{
  "ID:350830179", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isDomain"},
 CellID->350830179],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isPartReflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isPartReflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[And]", 
    RowBox[{"isPartReflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], "\[GreaterGreater]", 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalC]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isPartReflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 isPartReflOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1492126708", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647766627674178*^9, 3.647766638587757*^9}},
 CellTags->{
  "ID:1492126708", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isPartReflOrder"},
 CellID->1492126708],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isPartIrreflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isPartIrreflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[And]", 
    RowBox[{"isPartIrreflOrder", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], "\[GreaterGreater]", 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalC]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isPartIrreflOrder", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 isPartIrreflOrder)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:448490662", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647766534138489*^9, 3.6477666176992683`*^9}},
 CellTags->{
  "ID:448490662", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isPartIrreflOrder"},
 CellID->448490662],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isNoetherian", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[">",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalA]"}], "]"}], "\[And]", 
    RowBox[{"isNoetherian", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox["\[RightTriangle]",
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalB]"}], "]"}], "\[And]", 
    RowBox[{"isNoetherian", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], "\[GreaterGreater]", 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalC]"}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox[
      UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 isNoetherian)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1880074166", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647766642901573*^9, 3.647766663990179*^9}},
 CellTags->{
  "ID:1880074166", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isNoetherian"},
 CellID->1880074166],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1190944264]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1107192474],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 isDomain)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 isDomain)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], "]"}]}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"LexOrder3", "[", 
               RowBox[{
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], ",", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], ",", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], "]"}], 
             "\[And]", 
             RowBox[{"isDomain", "[", 
               StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], "]"}]}], 
           "\[Implies]", 
           RowBox[{"isDomain", "[", 
             RowBox[{"LexOrder3", "[", 
               RowBox[{
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], ",", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], ",", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:350830179"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p350830179-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p350830179-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:350830179", "Proof|ID:350830179-1"},
 CellID->359925756],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p350830179-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->94159074]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 isPartReflOrder)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 isPartReflOrder)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartReflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartReflOrder", "[", 
               RowBox[{
                 StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartReflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1492126708"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1492126708-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1492126708-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1492126708", "Proof|ID:1492126708-1"},
 CellID->2037194359],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1492126708-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->150732688]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 isPartIrreflOrder)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 isPartIrreflOrder)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartIrreflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isPartIrreflOrder", "[", 
               RowBox[{
                 StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isPartIrreflOrder", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:448490662"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p448490662-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p448490662-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:448490662", "Proof|ID:448490662-1"},
 CellID->259882569],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p448490662-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->698127626]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 isNoetherian)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 isNoetherian)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox[">", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]}], "]"}],
              "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
                 StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]}], 
               "]"}]}], "\[Implies]", 
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrder3", "[", 
                  RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1880074166"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1880074166-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1880074166-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1880074166", "Proof|ID:1880074166-1"},
 CellID->1837575531],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1880074166-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->699513794]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->467060496],

Cell[CellGroupData[{

Cell["Lemma: Lexicographic Orders and Universal Quantifiers", \
"EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6483647655361834`*^9, 3.648364781092*^9}},
 CellID->2006149543],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"P", ",", "Q"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1745474933}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6483647863224983`*^9, 3.64836478715455*^9}, {
  3.648366953125702*^9, 3.64836695356736*^9}},
 CellTags->{
  "ID:1745474933", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1745474933],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
       RowBox[{"[", "x", "]"}]}]], 
     RowBox[{"Q", "[", "x", "]"}]], 
    RowBox[{"P", "[", "x", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
       RowBox[{"[", "a", "]"}]}], ",", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
       RowBox[{"[", "b", "]"}]}], ",", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
       RowBox[{"[", "c", "]"}]}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"Q", "[", 
       RowBox[{"\[LeftAngleBracket]", 
        RowBox[{"a", ",", "b", ",", "c"}], "\[RightAngleBracket]"}], "]"}], 
      "\[Implies]", 
      RowBox[{"P", "[", 
       RowBox[{"\[LeftAngleBracket]", 
        RowBox[{"a", ",", "b", ",", "c"}], "\[RightAngleBracket]"}], "]"}]}], 
     
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[ForAll])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1629835903", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.648366594473221*^9, 3.648366602376245*^9}, {
  3.648366986513776*^9, 3.64836699881734*^9}},
 CellTags->{
  "ID:1629835903", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[ForAll]", "IR"},
 CellID->1629835903],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
       RowBox[{"[", "x", "]"}]}]], 
     RowBox[{"Q", "[", 
      RowBox[{
       SubscriptBox["x", "1"], ",", 
       SubscriptBox["x", "2"], ",", 
       SubscriptBox["x", "3"]}], "]"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      SubscriptBox["x", "2"], ",", 
      SubscriptBox["x", "3"]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
       RowBox[{"[", "a", "]"}]}], ",", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
       RowBox[{"[", "b", "]"}]}], ",", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
       RowBox[{"[", "c", "]"}]}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"Q", "[", 
       RowBox[{"a", ",", "b", ",", "c"}], "]"}], "\[Implies]", 
      RowBox[{"P", "[", 
       RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 \[ForAll] II)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:555552062", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64836479230868*^9, 3.648364852788547*^9}, {
  3.6483651824888144`*^9, 3.648365193019477*^9}, {3.6483669561926613`*^9, 
  3.648366982458666*^9}},
 CellTags->{
  "ID:555552062", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[ForAll] II", "IR"},
 CellID->555552062],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isDomain", "[", "\[ScriptCapitalL]", "]"}], "\[And]", 
    RowBox[{"isNoetherian", "[", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[
        UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"],
        Identity], 
       TagBox[")",
        "AutoParentheses"]}], ",", "\[ScriptCapitalL]"}], "]"}], "\[And]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
         RowBox[{"[", "a1", "]"}]}], ",", 
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
         RowBox[{"[", "b1", "]"}]}], ",", 
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
         RowBox[{"[", "c1", "]"}]}]}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          UnderscriptBox["\[ForAll]", 
           RowBox[{
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalA]"], 
             RowBox[{"[", "a2", "]"}]}], ",", 
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalB]"], 
             RowBox[{"[", "b2", "]"}]}], ",", 
            RowBox[{
             UnderscriptBox["\[Element]", "\[ScriptCapitalC]"], 
             RowBox[{"[", "c2", "]"}]}]}]], 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           RowBox[{
            RowBox[{
             RowBox[{"\[LeftAngleBracket]", 
              RowBox[{"a1", ",", "b1", ",", "c1"}], "\[RightAngleBracket]"}], 
             
             UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"], 
             RowBox[{"\[LeftAngleBracket]", 
              RowBox[{"a2", ",", "b2", ",", "c2"}], 
              "\[RightAngleBracket]"}]}], "\[Implies]", 
            RowBox[{"P", "[", 
             RowBox[{"a2", ",", "b2", ",", "c2"}], "]"}]}], 
           TagBox[")",
            "AutoParentheses"]}]}], 
         TagBox[")",
          "AutoParentheses"]}], "\[Implies]", 
        RowBox[{"P", "[", 
         RowBox[{"a1", ",", "b1", ",", "c1"}], "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
      RowBox[{"[", "x", "]"}]}]], 
    RowBox[{"P", "[", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      SubscriptBox["x", "2"], ",", 
      SubscriptBox["x", "3"]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrder3 Noetherian induction)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:628439052", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.648364917458095*^9, 3.648365078247302*^9}, {
  3.6483651482180643`*^9, 3.6483652114894753`*^9}, {3.648365248602948*^9, 
  3.64836526874614*^9}, {3.6483656141549892`*^9, 3.648365624816482*^9}, {
  3.6567588685891104`*^9, 3.6567588763423243`*^9}, {3.656759207609906*^9, 
  3.6567592079375067`*^9}},
 CellTags->{
  "ID:628439052", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 Noetherian induction", "IR"},
 CellID->628439052],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1946547022]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1624022479],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 \[ForAll])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 \[ForAll])\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"], ",", 
            StyleBox["Q", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                RowBox[{
                  StyleBox["Q", "ExpressionVariable"], "[", 
                  StyleBox["x", "ExpressionVariable"], "]"}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                   StyleBox["a", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                   StyleBox["b", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                   StyleBox["c", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 StyleBox["Q", "ExpressionVariable"], "[", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["b", "ExpressionVariable"], ",", 
                    StyleBox["c", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], "]"}], "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["b", "ExpressionVariable"], ",", 
                    StyleBox["c", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"], ",", 
            StyleBox["Q", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                RowBox[{
                  StyleBox["Q", "ExpressionVariable"], "[", 
                  StyleBox["x", "ExpressionVariable"], "]"}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                   StyleBox["a", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                   StyleBox["b", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                   StyleBox["c", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 StyleBox["Q", "ExpressionVariable"], "[", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["b", "ExpressionVariable"], ",", 
                    StyleBox["c", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], "]"}], "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{"\[LeftAngleBracket]", 
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], ",", 
                    StyleBox["b", "ExpressionVariable"], ",", 
                    StyleBox["c", "ExpressionVariable"]}], 
                   "\[RightAngleBracket]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1629835903"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1629835903-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1629835903-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1629835903", "Proof|ID:1629835903-1"},
 CellID->1507488488],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1629835903-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1198879348]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 \[ForAll] II)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 \[ForAll] II)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"], ",", 
            StyleBox["Q", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                RowBox[{
                  StyleBox["Q", "ExpressionVariable"], "[", 
                  RowBox[{
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], ",", 
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "2"], ",", 
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "3"]}], "]"}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], ",", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "2"], ",", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "3"]}], "]"}]}], 
             ")"}], "\[DoubleLeftRightArrow]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                   StyleBox["a", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                   StyleBox["b", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                   StyleBox["c", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 StyleBox["Q", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], ",", 
                   StyleBox["b", "ExpressionVariable"], ",", 
                   StyleBox["c", "ExpressionVariable"]}], "]"}], "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], ",", 
                   StyleBox["b", "ExpressionVariable"], ",", 
                   StyleBox["c", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"], ",", 
            StyleBox["Q", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
                RowBox[{
                  StyleBox["Q", "ExpressionVariable"], "[", 
                  RowBox[{
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], ",", 
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "2"], ",", 
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "3"]}], "]"}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], ",", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "2"], ",", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "3"]}], "]"}]}], 
             ")"}], "\[DoubleLeftRightArrow]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                   StyleBox["a", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                   StyleBox["b", "ExpressionVariable"], "]"}]}, {
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                   StyleBox["c", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               RowBox[{
                 StyleBox["Q", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], ",", 
                   StyleBox["b", "ExpressionVariable"], ",", 
                   StyleBox["c", "ExpressionVariable"]}], "]"}], "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], ",", 
                   StyleBox["b", "ExpressionVariable"], ",", 
                   StyleBox["c", "ExpressionVariable"]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:555552062"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p555552062-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p555552062-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:555552062", "Proof|ID:555552062-1"},
 CellID->1496219234],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p555552062-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->603715255]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrder3 Noetherian induction)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrder3 Noetherian induction)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}], "]"}], "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 UnderscriptBox["\[Succeeds]", 
                  RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
                 RowBox[{"LexOrder3", "[", 
                   RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["a1", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                    StyleBox["b1", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                    StyleBox["c1", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["a2", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                    StyleBox["b2", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                    StyleBox["c2", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["a1", "ExpressionVariable"], ",", 
                    StyleBox["b1", "ExpressionVariable"], ",", 
                    StyleBox["c1", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["a2", "ExpressionVariable"], ",", 
                    StyleBox["b2", "ExpressionVariable"], ",", 
                    StyleBox["c2", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "\[Implies]", 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["a2", "ExpressionVariable"], ",", 
                    StyleBox["b2", "ExpressionVariable"], ",", 
                    StyleBox["c2", "ExpressionVariable"]}], "]"}]}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["a1", "ExpressionVariable"], ",", 
                    StyleBox["b1", "ExpressionVariable"], ",", 
                    StyleBox["c1", "ExpressionVariable"]}], "]"}]}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "3"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
            StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
            StyleBox[">", "ExpressionVariable"], ",", 
            StyleBox["\[RightTriangle]", "ExpressionVariable"], ",", 
            StyleBox["\[GreaterGreater]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"isDomain", "[", 
               RowBox[{"LexOrder3", "[", 
                 RowBox[{
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                   RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}], "]"}], "\[And]", 
             RowBox[{"isNoetherian", "[", 
               RowBox[{
                 UnderscriptBox["\[Succeeds]", 
                  RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], ",", 
                 RowBox[{"LexOrder3", "[", 
                   RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]}], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["a1", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                    StyleBox["b1", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                    StyleBox["c1", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"]], "[", 
                    StyleBox["a2", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"]], "[", 
                    StyleBox["b2", "ExpressionVariable"], "]"}]}, {
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"]], "[", 
                    StyleBox["c2", "ExpressionVariable"], "]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["a1", "ExpressionVariable"], ",", 
                    StyleBox["b1", "ExpressionVariable"], ",", 
                    StyleBox["c1", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["a2", "ExpressionVariable"], ",", 
                    StyleBox["b2", "ExpressionVariable"], ",", 
                    StyleBox["c2", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "\[Implies]", 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["a2", "ExpressionVariable"], ",", 
                    StyleBox["b2", "ExpressionVariable"], ",", 
                    StyleBox["c2", "ExpressionVariable"]}], "]"}]}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["a1", "ExpressionVariable"], ",", 
                    StyleBox["b1", "ExpressionVariable"], ",", 
                    StyleBox["c1", "ExpressionVariable"]}], "]"}]}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrder3", "[", 
                    RowBox[{
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalA]", "ExpressionVariable"], ",", 
                    
                    StyleBox[">", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalB]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[RightTriangle]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}], ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    StyleBox["\[ScriptCapitalC]", "ExpressionVariable"], ",", 
                    
                    StyleBox["\[GreaterGreater]", "ExpressionVariable"]}], 
                    "\[RightAngleBracket]"}]}], "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "2"], ",", 
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "3"]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:628439052"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p628439052-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p628439052-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:628439052", "Proof|ID:628439052-1"},
 CellID->16324577],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p628439052-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->10755916]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas: LexOrderN (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.647834224777319*^9, 3.64783422899656*^9}, {
  3.648364751927747*^9, 3.648364753963176*^9}, {3.65970174147264*^9, 
  3.6597017442182446`*^9}},
 CellID->1621146162],

Cell["", "OpenEnvironment",
 CellID->790435182],

Cell[CellGroupData[{

Cell[TextData[{
 "Lemma: ",
 Cell[BoxData[
  FormBox[
   RowBox[{"LexOrderN", "[", 
    RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], "]"}], 
   TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"LexOrderN", "[", 
    RowBox[{
    "\[LeftAngleBracket]", "\[ScriptCapitalD]", "\[RightAngleBracket]"}], 
    "]"}], TraditionalForm]]]
}], "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647842208674142*^9, 3.6478422211136923`*^9}, {
  3.647842677011956*^9, 3.647842688249408*^9}},
 CellID->614809765],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "x"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"LexOrderN", "[", 
        RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], "]"}]], 
      RowBox[{"[", "x", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"x", "\[Equal]", 
      RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN empty \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1750417022", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647842044422303*^9, 3.6478420712078857`*^9}},
 CellTags->{
  "ID:1750417022", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN empty \[Element]", "IR"},
 CellID->1750417022],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", 
     RowBox[{"LexOrderN", "[", 
      RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], "]"}]], 
    RowBox[{"[", 
     RowBox[{"x", ",", "y"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Not]", 
    RowBox[{"x", 
     UnderscriptBox["\[Succeeds]", 
      RowBox[{"LexOrderN", "[", 
       RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], "]"}]], 
     "y"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN empty \[Succeeds])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1743969343", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478421025014267`*^9, 3.6478421493733053`*^9}},
 CellTags->{
  "ID:1743969343", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN empty \[Succeeds]"},
 CellID->1743969343],

Cell[BoxData[
 UnderscriptBox[
  UnderscriptBox["\[ForAll]", 
   RowBox[{"isTuple", "[", "\[ScriptCapitalD]", "]"}]], 
  RowBox[{
   RowBox[{
   "\[LeftBracketingBar]", "\[ScriptCapitalD]", "\[RightBracketingBar]"}], 
   "\[Equal]", "2"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 562382244}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647842653688217*^9, 3.6478426709746323`*^9}},
 CellTags->{
  "ID:562382244", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->562382244],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "x"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"LexOrderN", "[", 
        RowBox[{
        "\[LeftAngleBracket]", "\[ScriptCapitalD]", "\[RightAngleBracket]"}], 
        "]"}]], 
      RowBox[{"[", "x", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"x", "\[Equal]", 
        RowBox[{"\[LeftAngleBracket]", 
         SubscriptBox["x", "1"], "\[RightAngleBracket]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[And]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        SubscriptBox["\[ScriptCapitalD]", "1"]], 
       RowBox[{"[", 
        SubscriptBox["x", "1"], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN singleton \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1321392049", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478426997667313`*^9, 3.6478427535745*^9}},
 CellTags->{
  "ID:1321392049", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN singleton \[Element]", "IR"},
 CellID->1321392049],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", 
     RowBox[{"LexOrderN", "[", 
      RowBox[{
      "\[LeftAngleBracket]", "\[ScriptCapitalD]", "\[RightAngleBracket]"}], 
      "]"}]], 
    RowBox[{"[", "x", "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["ToLexOrder", 
      RowBox[{"LexOrderN", "[", 
       RowBox[{
       "\[LeftAngleBracket]", "\[ScriptCapitalD]", "\[RightAngleBracket]"}], 
       "]"}]], "[", "x", "]"}], "\[Equal]", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}]}], 
     "\[RightAngleBracket]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN ToLexOrder singleton)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:533732994", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647847168337254*^9, 3.6478472021193457`*^9}, {
  3.647847668312561*^9, 3.647847678657249*^9}},
 CellTags->{
  "ID:533732994", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder singleton", "IR"},
 CellID->533732994],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    UnderscriptBox["\[Element]", 
     RowBox[{"LexOrderN", "[", 
      RowBox[{
      "\[LeftAngleBracket]", "\[ScriptCapitalD]", "\[RightAngleBracket]"}], 
      "]"}]], 
    RowBox[{"[", 
     RowBox[{"x", ",", "y"}], "]"}]}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"x", 
      UnderscriptBox["\[Succeeds]", 
       RowBox[{"LexOrderN", "[", 
        RowBox[{
        "\[LeftAngleBracket]", "\[ScriptCapitalD]", "\[RightAngleBracket]"}], 
        "]"}]], "y"}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        SubscriptBox["\[ScriptCapitalD]", "2"], ")"}], "[", 
       RowBox[{
        SubscriptBox["x", "1"], ",", 
        SubscriptBox["y", "1"]}], "]"}], "\[And]", 
      RowBox[{
       SubscriptBox["x", "1"], "\[NotEqual]", 
       SubscriptBox["y", "1"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN singleton \[Succeeds])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1826894117", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647842765177039*^9, 3.647842794855847*^9}, {
  3.647847904067493*^9, 3.647847910079578*^9}},
 CellTags->{
  "ID:1826894117", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN singleton \[Succeeds]"},
 CellID->1826894117],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->729757556]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->30441166],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrderN empty \[Element])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrderN empty \[Element])\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["x", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             
             RowBox[{"\[LeftAngleBracket]", 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["x", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             StyleBox["x", "ExpressionVariable"], "\[Equal]", 
             
             RowBox[{"\[LeftAngleBracket]", 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1750417022"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1750417022-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1750417022-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1750417022", "Proof|ID:1750417022-1"},
 CellID->1480567573],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1750417022-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1683959206]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrderN empty \[Succeeds])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrderN empty \[Succeeds])\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{"\[Not]", 
           RowBox[{
             TagBox["(", "AutoParentheses"], 
             RowBox[{
               StyleBox["x", "ExpressionVariable"], 
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], 
               StyleBox["y", "ExpressionVariable"]}], 
             TagBox[")", "AutoParentheses"]}]}]}], $CellContext`TheoremaForm],
       DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{"\[Not]", 
           RowBox[{
             TagBox["(", "AutoParentheses"], 
             RowBox[{
               StyleBox["x", "ExpressionVariable"], 
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}], 
                  "]"}]], 
               StyleBox["y", "ExpressionVariable"]}], 
             TagBox[
             ")", "AutoParentheses"]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1743969343"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1743969343-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1743969343-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1743969343", "Proof|ID:1743969343-1"},
 CellID->1693726967],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1743969343-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->2062993410]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrderN singleton \[Element])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrderN singleton \[Element])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}, {
             StyleBox["x", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"\[LeftBracketingBar]", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
               "\[RightBracketingBar]"}], "\[Equal]", "2"}], "\[Implies]", 
           RowBox[{
             RowBox[{"(", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  RowBox[{"LexOrderN", "[", 
                    RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], ")"}], 
             "\[DoubleLeftRightArrow]", 
             RowBox[{"(", 
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{"\[LeftAngleBracket]", 
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], 
                    "\[RightAngleBracket]"}]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "1"]], "[", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], "]"}]}], 
               ")"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}, {
             StyleBox["x", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"\[LeftBracketingBar]", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
               "\[RightBracketingBar]"}], "\[Equal]", "2"}], "\[Implies]", 
           RowBox[{
             RowBox[{"(", 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  RowBox[{"LexOrderN", "[", 
                    RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], ")"}], 
             "\[DoubleLeftRightArrow]", 
             RowBox[{"(", 
               RowBox[{
                 RowBox[{
                   StyleBox["x", "ExpressionVariable"], "\[Equal]", 
                   RowBox[{"\[LeftAngleBracket]", 
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], 
                    "\[RightAngleBracket]"}]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "1"]], "[", 
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], "]"}]}], 
               ")"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1321392049"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1321392049-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1321392049-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1321392049", "Proof|ID:1321392049-1"},
 CellID->539924176],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1321392049-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->497987145]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrderN ToLexOrder singleton,[IR])\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrderN ToLexOrder singleton,[IR])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"\[LeftBracketingBar]", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
               "\[RightBracketingBar]"}], "\[Equal]", "2"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"\[LeftBracketingBar]", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
               "\[RightBracketingBar]"}], "\[Equal]", "2"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["ToLexOrder", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}], "\[Equal]", 
             RowBox[{"\[LeftAngleBracket]", 
               RowBox[{
                 SubscriptBox[
                  StyleBox["x", "ExpressionVariable"], "1"], ",", 
                 RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}]}], 
               "\[RightAngleBracket]"}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:533732994"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p533732994-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p533732994-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:533732994", "Proof|ID:533732994-1"},
 CellID->814775281],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p533732994-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1352481777]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrderN singleton \[Succeeds])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrderN singleton \[Succeeds])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"\[LeftBracketingBar]", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
               "\[RightBracketingBar]"}], "\[Equal]", "2"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               StyleBox["x", "ExpressionVariable"], 
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], 
               StyleBox["y", "ExpressionVariable"]}], 
             "\[DoubleLeftRightArrow]", 
             RowBox[{"(", 
               RowBox[{
                 RowBox[{
                   SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "2"],
                    "[", 
                   RowBox[{
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], ",", 
                    SubscriptBox[
                    StyleBox["y", "ExpressionVariable"], "1"]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], "\[NotEqual]", 
                   
                   SubscriptBox[
                    StyleBox["y", "ExpressionVariable"], "1"]}]}], 
               ")"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["x", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], "[", 
               StyleBox["y", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"\[LeftBracketingBar]", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
               "\[RightBracketingBar]"}], "\[Equal]", "2"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               StyleBox["x", "ExpressionVariable"], 
               UnderscriptBox["\[Succeeds]", 
                RowBox[{"LexOrderN", "[", 
                  RowBox[{"\[LeftAngleBracket]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightAngleBracket]"}], "]"}]], 
               StyleBox["y", "ExpressionVariable"]}], 
             "\[DoubleLeftRightArrow]", 
             RowBox[{"(", 
               RowBox[{
                 RowBox[{
                   SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "2"],
                    "[", 
                   RowBox[{
                    SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], ",", 
                    SubscriptBox[
                    StyleBox["y", "ExpressionVariable"], "1"]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   SubscriptBox[
                    StyleBox["x", "ExpressionVariable"], "1"], "\[NotEqual]", 
                   
                   SubscriptBox[
                    StyleBox["y", "ExpressionVariable"], "1"]}]}], 
               ")"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1826894117"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1826894117-1-po.m\"}]"]],
   
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1826894117-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1826894117", "Proof|ID:1826894117-1"},
 CellID->1194249226],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1826894117-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->178546167]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->442664140],

Cell[CellGroupData[{

Cell["Lemma: Properties of ToLexOrder", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{
  3.6478342902577877`*^9, {3.647835389909548*^9, 3.647835395020912*^9}, {
   3.647842028575897*^9, 3.647842032902466*^9}},
 CellID->1956082993],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"isTuple", "[", "\[ScriptCapitalD]", "]"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 415166645}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478342972790937`*^9, 3.647834302829981*^9}, {
   3.647834443942223*^9, 3.647834452634717*^9}, 3.6478352259023457`*^9, {
   3.6478428454843407`*^9, 3.647842851033778*^9}, {3.6478479761067944`*^9, 
   3.6478479765119877`*^9}},
 CellTags->{
  "ID:415166645", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->415166645],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptCapitalD]", "\[NotEqual]", 
   RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}]}], 
  "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1101966307}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478479838804693`*^9, 3.647847989121008*^9}},
 CellTags->{
  "ID:1101966307", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1101966307],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{
   RowBox[{"\[ScriptCapitalL]", "=", 
    RowBox[{"LexOrderN", "[", "\[ScriptCapitalD]", "]"}]}], ",", 
   RowBox[{"\[ScriptCapitalL]0", "=", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      RowBox[{"LexOrderN", "[", 
       RowBox[{"Rest", "[", "\[ScriptCapitalD]", "]"}], "]"}], ",", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       TagBox[
        UnderscriptBox["\[Succeeds]", 
         RowBox[{"LexOrderN", "[", 
          RowBox[{"Rest", "[", "\[ScriptCapitalD]", "]"}], "]"}]],
        Identity], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     "\[RightAngleBracket]"}]}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 639341233}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647834483536346*^9, 3.647834509320644*^9}, {
  3.647834610821782*^9, 3.647834632072485*^9}, {3.6478352338096647`*^9, 
  3.647835236937398*^9}, {3.647841776991597*^9, 3.647841801992057*^9}, {
  3.647848254035569*^9, 3.64784827191013*^9}},
 CellTags->{
  "ID:639341233", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->639341233],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["\[ForAll]", 
    RowBox[{
     RowBox[{"i", "=", "1"}], ",", "\[Ellipsis]", ",", 
     RowBox[{
     "\[LeftBracketingBar]", "\[ScriptCapitalD]", 
      "\[RightBracketingBar]"}]}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{"isTuple", "[", 
      SubscriptBox["\[ScriptCapitalD]", "i"], "]"}], "\[And]", 
     RowBox[{
      RowBox[{"\[LeftBracketingBar]", 
       SubscriptBox["\[ScriptCapitalD]", "i"], "\[RightBracketingBar]"}], 
      "\[Equal]", "2"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 206422078}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647834322919441*^9, 3.647834361700562*^9}, {
  3.647835244374411*^9, 3.647835259314642*^9}, {3.647842853544636*^9, 
  3.647842858673608*^9}},
 CellTags->{
  "ID:206422078", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->206422078],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   UnderscriptBox["\[Element]", "\[ScriptCapitalL]"], 
   RowBox[{"[", 
    RowBox[{"x", ",", "y"}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Functors.nb", 1296242587}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647834554819901*^9, 3.647834562780896*^9}},
 CellTags->{
  "ID:1296242587", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1296242587],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", 
   RowBox[{"LexOrder", "[", 
    RowBox[{
     SubscriptBox["\[ScriptCapitalD]", "1"], ",", "\[ScriptCapitalL]0"}], 
    "]"}]], 
  RowBox[{"[", 
   RowBox[{
    UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "x", "]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN ToLexOrder \[Element])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:194852796", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647834590747033*^9, 3.647834643740095*^9}, {
  3.647834770132662*^9, 3.6478348059709063`*^9}, {3.647835280660495*^9, 
  3.6478352899069023`*^9}, {3.647841769473489*^9, 3.647841795652266*^9}},
 CellTags->{
  "ID:194852796", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder \[Element]"},
 CellID->194852796],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->676400811]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1779467229],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(LexOrderN ToLexOrder \[Element])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(LexOrderN ToLexOrder \[Element])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
             "\[NotEqual]", 
             RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "=", "1"}], ",", 
                    "\[Ellipsis]", ",", 
                    RowBox[{"\[LeftBracketingBar]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightBracketingBar]"}]}]}}]], 
               RowBox[{
                 RowBox[{"isTuple", "[", 
                   SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    StyleBox["i", "ExpressionVariable"]], "]"}], "\[And]", 
                 RowBox[{
                   RowBox[{"\[LeftBracketingBar]", 
                    SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    StyleBox["i", "ExpressionVariable"]], 
                    "\[RightBracketingBar]"}], "\[Equal]", "2"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrderN", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  RowBox[{"LexOrder", "[", 
                    RowBox[{
                    SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "1"],
                     ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    RowBox[{"LexOrderN", "[", 
                    RowBox[{"Rest", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}], "]"}], ",", 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrderN", "[", 
                    RowBox[{"Rest", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}], "]"}]]}], "\[RightAngleBracket]"}]}], "]"}]], "[", 
                 
                 RowBox[{
                   UnderscriptBox["ToLexOrder", 
                    RowBox[{"LexOrderN", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             RowBox[{"isTuple", "[", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
             "\[NotEqual]", 
             RowBox[{"\[LeftAngleBracket]", "\[RightAngleBracket]"}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "=", "1"}], ",", 
                    "\[Ellipsis]", ",", 
                    RowBox[{"\[LeftBracketingBar]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "\[RightBracketingBar]"}]}]}}]], 
               RowBox[{
                 RowBox[{"isTuple", "[", 
                   SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    StyleBox["i", "ExpressionVariable"]], "]"}], "\[And]", 
                 RowBox[{
                   RowBox[{"\[LeftBracketingBar]", 
                    SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    StyleBox["i", "ExpressionVariable"]], 
                    "\[RightBracketingBar]"}], "\[Equal]", "2"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"LexOrderN", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[Element]", 
                  RowBox[{"LexOrder", "[", 
                    RowBox[{
                    SubscriptBox[
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "1"],
                     ",", 
                    RowBox[{"\[LeftAngleBracket]", 
                    RowBox[{
                    RowBox[{"LexOrderN", "[", 
                    RowBox[{"Rest", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}], "]"}], ",", 
                    UnderscriptBox["\[Succeeds]", 
                    RowBox[{"LexOrderN", "[", 
                    RowBox[{"Rest", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}], "]"}]]}], "\[RightAngleBracket]"}]}], "]"}]], "[", 
                 
                 RowBox[{
                   UnderscriptBox["ToLexOrder", 
                    RowBox[{"LexOrderN", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:194852796"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p194852796-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p194852796-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:194852796", "Proof|ID:194852796-1"},
 CellID->210990893],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p194852796-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->34034514]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Missing (LexOrderN)", "Subsubsection",
 CellChangeTimes->{{3.659701830642397*^9, 3.6597018327952003`*^9}, {
  3.659701978952857*^9, 3.6597019820104628`*^9}},
 CellID->36056484],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "x", "]"}], 
    UnderscriptBox["\[Succeeds]", 
     RowBox[{"LexOrder", "[", 
      RowBox[{
       SubscriptBox["\[ScriptCapitalD]", "1"], ",", "\[ScriptCapitalL]0"}], 
      "]"}]], 
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "y", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", 
    UnderscriptBox["\[Succeeds]", "\[ScriptCapitalL]"], "y"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "Text",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN ToLexOrder \[Succeeds])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1320576944", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478348718979597`*^9, 3.6478349439355173`*^9}, {
  3.647835294879196*^9, 3.647835302952787*^9}, {3.647841806030609*^9, 
  3.647841807947213*^9}, {3.6597017804415083`*^9, 3.6597017902695255`*^9}},
 CellTags->{
  "ID:1320576944", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder \[Succeeds]"},
 CellID->1320576944],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "x", "]"}], 
    "\[Equal]", 
    RowBox[{
     UnderscriptBox["ToLexOrder", "\[ScriptCapitalL]"], "[", "y", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"x", "\[Equal]", "y"}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "Text",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(LexOrderN ToLexOrder injective)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1403292599", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647834850029152*^9, 3.6478348622310143`*^9}, 
   3.6597017849343166`*^9},
 CellTags->{
  "ID:1403292599", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder injective"},
 CellID->1403292599]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{1105, 762},
WindowMargins->{{138, Automatic}, {Automatic, 0}},
ShowSelection->True,
CounterAssignments->{{"TheoremaFormulaCounter" -> 5}},
Magnification->1.,
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Theorema"}, "TheoremaCore.nb"]]], 
   
   Cell["Modify the definitions below to change the default appearance of all \
cells in a given style. \nMake modifications to any definition using commands \
in the Format menu.", "Text"], 
   Cell[
    CellGroupData[{
      Cell["Notebook Options Settings", "Section"], 
      Cell[
      "The options defined for the style below will be used at the Notebook \
level.", "Text"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Notebook"], InputAliases -> {"and" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[And]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "or" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", "\[Or]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "not" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Not]", "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "impl" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[Implies]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[DoubleLongLeftRightArrow]", 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                "\[SelectionPlaceholder]", "\[Equal]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox[
                  
                  RowBox[{
                   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
                    "\[DoubleLongLeftRightArrow]"}], Identity, SyntaxForm -> 
                  "a:=b"], "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", ":=", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "andn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[And]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "orn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Or]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "equivn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[DoubleLeftRightArrow]", "\[Piecewise]", 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "cdist" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Piecewise]", 
                 
                 GridBox[{{
                   "\[SelectionPlaceholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}, {
                   "\[Placeholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "far" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exr" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "farc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exrc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "let" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["let", 
                  RowBox[{"\[Placeholder]", "=", "\[Placeholder]"}]], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "app" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293a", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "prep" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293b", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "join" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22c8", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "elemT" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22ff", Identity, SyntaxForm -> "a+b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "subop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "supop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SuperscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "subsupop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubsuperscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "oop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "uoop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               UnderoverscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "osop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox[
                OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
                "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "op" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               TagBox["\[SelectionPlaceholder]", Identity], 
               TagBox[")", "AutoParentheses"]}], "[]" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:e114", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:e115", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "()" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:fd3e", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:fd3f", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "<>" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27e8", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27e9", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "{}" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:e117", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:e118", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "[[]]" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27e6", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27e7", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "(())" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:2e28", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:2e29", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "<<>>" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27ea", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27eb", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "{{}}" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:2983", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:2984", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "(" -> 
            TagBox["(", "AutoParentheses"], ")" -> 
            TagBox[")", "AutoParentheses"]}, Background -> 
          RGBColor[0.957, 0.96, 0.97]], 
         Cell[
          StyleData["Notebook", "Printout"], Background -> None]}, Open]]}, 
     Open]], 
   Cell[
    CellGroupData[{
      Cell["Style Environment Names", "Section"], 
      Cell[
       StyleData[All, "Working"], DockedCells -> {
         Cell[
         "Theorema 2.0", "SBO", FontTracking -> 8, 
          CellMargins -> {{0, 0}, {0, 0}}, 
          CellFrameMargins -> {{0, 50}, {0, 0}}, FontSize -> 28, FontSlant -> 
          "Plain", FontColor -> RGBColor[0.29, 0.46, 0.6], TextAlignment -> 
          Right, Background -> RGBColor[0.36, 0.54, 0.69]]}], 
      Cell[
       StyleData[
       All, "Layout", StyleDefinitions -> StyleData[All, "Working"]], 
       MenuSortingValue -> 1200]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Styles for Title and Section Cells", "Section"], 
      Cell[
       CellGroupData[{
         Cell["Title", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{27, 27}, {10, 30}}, 
             TextAlignment -> Center, MenuSortingValue -> 1100, 
             MenuCommandKey -> "1", FontFamily -> "Bitstream Charter", 
             FontSize -> 36, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Title", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{6, 10}, {5, 30}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], CellMargins -> {{27, 27}, {20, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1150, FontFamily -> 
             "Bitstream Charter", FontSize -> 24, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{6, 10}, {5, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], CellMargins -> {{27, 27}, {8, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Author"], CellMargins -> {{27, 27}, {18, 20}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Sectioning", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], ShowGroupOpener -> True, MenuSortingValue -> 
             1250, MenuCommandKey -> "4", FontFamily -> "Bitstream Charter", 
             FontSize -> 20, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Section", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{2, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {8, 12}}, 
             MenuSortingValue -> 1300, MenuCommandKey -> "5", FontFamily -> 
             "Bitstream Charter", FontSize -> 14, FontWeight -> "Bold", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Subsection", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{9, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {2, 10}}, 
             MenuSortingValue -> 1350, MenuCommandKey -> "6", FontFamily -> 
             "Bitstream Charter", FontSize -> 12, FontWeight -> "Bold", 
             FontSlant -> "Italic", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsection", "Printout"], ShowGroupOpener -> False,
              CellMargins -> {{35, 0}, {7, 14}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsubsection"], CellDingbat -> None, 
             ShowGroupOpener -> True, 
             CellMargins -> {{27, Inherited}, {Inherited, Inherited}}, 
             FontFamily -> "Bitstream Charter", FontSize -> 11, FontWeight -> 
             "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsubsection", "Printout"], 
             CellMargins -> {{50, 0}, {7, 14}}]}, Closed]]}, Open]]}, Open]], 
   
   Cell[
    CellGroupData[{
      Cell["Styles for Publication\[Hyphen]ready Documents", "Section"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Author"], CellMargins -> {{27, 30}, {20, 5}}, 
          MenuSortingValue -> 1900, FontFamily -> "Helvetica", FontSize -> 14,
           FontSlant -> "Italic"], 
         Cell[
          StyleData["Author", "Printout"], CellMargins -> {{6, 10}, {0, 10}}, 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Abstract"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
          CellMargins -> {{27, 140}, {20, 20}}, LineSpacing -> {0.9, 0}, 
          MenuSortingValue -> 2050, FontFamily -> "Times", FontSize -> 12], 
         Cell[
          StyleData["Abstract", "Printout"], Hyphenation -> True, 
          LineSpacing -> {1, 2}, FontSize -> 10]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Text", "Section"], 
      Cell[
       StyleData["Text"], CellMargins -> {{27, 27}, {Inherited, Inherited}}, 
       TextJustification -> 1., ParagraphIndent -> 15, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["EnvironmentText"], ShowCellBracket -> Automatic, 
       CellMargins -> {{82, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextJustification -> 1., ParagraphSpacing -> {0.3, 0.}, 
       MenuSortingValue -> 1480, MenuCommandKey -> "T", FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Item"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "Item", 
          CounterAssignments -> {{"Subitem", 0}, {"Subsubitem", 0}}, 
          MenuSortingValue -> 1600, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Item", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemParagraph"], CellMargins -> {{81, 10}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          DefaultNewCellStyle -> "Item", MenuSortingValue -> 1600, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemParagraph", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "Subitem", 
          CounterAssignments -> {{"Subsubitem", 0}}, MenuSortingValue -> 1610,
           FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subitem", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemParagraph"], CellMargins -> {{105, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subitem", 
          MenuSortingValue -> 1610, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemParagraph", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subsubitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1620, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subsubitem", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemParagraph"], 
          CellMargins -> {{129, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1625, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemParagraph", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "ItemNumbered", 
          CounterAssignments -> {{"SubitemNumbered", 0}, {
            "SubsubitemNumbered", 0}}, MenuSortingValue -> 1630, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemNumbered", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "SubitemNumbered", 
          CounterAssignments -> {{"SubsubitemNumbered", 0}}, MenuSortingValue -> 
          1640, FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemNumbered", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], ".", 
              CounterBox["SubsubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> 
          "SubitemNumbered", CounterIncrements -> "SubsubitemNumbered", 
          MenuSortingValue -> 1645, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemNumbered", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Theorema", "Section"], 
      Cell[
       StyleData["GlobalDeclaration"], CellFrame -> {{0, 2}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 3}, {2, 2}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       InitializationCell -> True, CellFrameMargins -> 10, CellFrameColor -> 
       RGBColor[0.73, 0.65, 0.61], CellFrameLabelMargins -> {{33, 7}, {1, 1}},
        ShowAutoStyles -> False, MenuSortingValue -> 1441, MenuCommandKey -> 
       "G", FontSize -> 14], 
      Cell[
       StyleData["OpenEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {-4, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       StyleData["EnvironmentHeader"], 
       CellFrame -> {{False, False}, {False, False}}, 
       CellMargins -> {{76, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 6, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       ShowAutoStyles -> False, MenuSortingValue -> 1450, FontSize -> 14, 
       FontWeight -> "Bold", FontVariations -> {"CapsType" -> "SmallCaps"}, 
       Background -> RGBColor[0.89, 0.8, 0.69]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FormalTextInputFormula"], ShowCellBracket -> Automatic, 
          CellMargins -> {{96, 10}, {2, 2}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
          InitializationCell -> True, CellFrameLabelMargins -> 53, 
          ShowAutoStyles -> False, LimitsPositioningTokens -> {}, 
          MenuSortingValue -> 1470, MenuCommandKey -> "F", FontWeight -> 
          "Bold", FontColor -> RGBColor[0.25, 0.19, 0.2]], 
         Cell[
          StyleData["FormalTextInputFormula", "Layout"], Editable -> False], 
         Cell[
          StyleData["FormalTextInputFormula", "Presentation"], Editable -> 
          False]}, Open]], 
      Cell[
       StyleData["EndEnvironmentMarker"], 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextAlignment -> Right, MenuSortingValue -> 1480], 
      Cell[
       StyleData["CloseEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {False, True}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {Inherited, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Computation"], CellFrame -> {{1.5, 0}, {0, 0}}, 
          ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 7}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
          CellFrameMargins -> {{8, 8}, {3, 4}}, CellFrameColor -> 
          RGBColor[0.486, 0.33, 0.32], ShowAutoStyles -> False, 
          MenuSortingValue -> 1510, FontWeight -> "Bold", FontColor -> 
          RGBColor[0.23, 0.25, 0.34], Background -> 
          RGBColor[0.88, 0.88, 0.92]], 
         Cell[
          StyleData["Computation", "Layout"], Editable -> False], 
         Cell[
          StyleData["Computation", "Presentation"], Editable -> False]}, 
        Open]], 
      Cell[
       StyleData["ComputationResult"], CellFrame -> {{1.5, 0}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
       CellFrameMargins -> {{8, 8}, {4, 3}}, CellFrameColor -> 
       RGBColor[0.486, 0.33, 0.32], StyleMenuListing -> None, FontColor -> 
       RGBColor[0.23, 0.25, 0.34], Background -> RGBColor[0.88, 0.88, 0.92]], 
      
      Cell[
       StyleData["ComputationInfo"], ShowCellBracket -> False, 
       CellMargins -> {{120, 10}, {10, 2}}, StyleMenuListing -> None, 
       FontFamily -> $CellContext`Arial], 
      Cell[
       StyleData["ComputationInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{144, 10}, {10, 2}}, StyleMenuListing -> None], 
      Cell[
       StyleData["ProofInfo"], ShowCellBracket -> False, 
       CellMargins -> {{76, 10}, {6, 6}}, CellFrameLabelMargins -> 15, 
       StyleMenuListing -> None, FontFamily -> "Arial"], 
      Cell[
       StyleData["ProofInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{100, 10}, {0, 0}}, StyleMenuListing -> None], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FrameLabel"], LanguageCategory -> None, StyleMenuListing -> 
          None, FontFamily -> "Times New Roman", FontSize -> 10, FontWeight -> 
          "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
          RGBColor[0.55, 0.44, 0.42], Background -> None], 
         Cell[
          StyleData["FrameLabel", "Printout"]]}, Open]], 
      Cell[
       StyleData["OpenArchive"], CellFrame -> {{False, False}, {False, True}},
        ShowCellBracket -> Automatic, CellMargins -> {{70, 70}, {0, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 20}, CellFrameMargins -> 3, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], CellFrameLabelMargins -> 1, 
       DefaultFormatType -> DefaultInputFormatType, ShowAutoStyles -> False, 
       MenuSortingValue -> 1210, FontWeight -> Bold, Background -> 
       RGBColor[0.73, 0.74, 0.84]], 
      Cell[
       StyleData["ArchiveInfo"], ShowCellBracket -> Automatic, 
       CellMargins -> {{70, 70}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 5, CellFrameLabelMargins -> 3, ShowCellTags -> 
       False, ShowAutoStyles -> False, MenuSortingValue -> 1220, FontWeight -> 
       "Bold", Background -> RGBColor[0.88, 0.88, 0.92]], 
      Cell[
       StyleData["CloseArchive"], 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> 
       Automatic, CellMargins -> {{0, 0}, {5, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 25}, CellFrameMargins -> 2, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], TextAlignment -> Center, 
       MenuSortingValue -> 1230, FontFamily -> "Arial Black", FontSize -> 24, 
       FontWeight -> "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       Background -> RGBColor[0.73, 0.65, 0.61]], 
      Cell[
       StyleData["IncludeArchive"], CellFrame -> {{4, 0}, {False, False}}, 
       ShowCellBracket -> Automatic, 
       CellMargins -> {{81, 100}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameColor -> RGBColor[0.55, 0.44, 0.42], 
       CellFrameLabels -> {{"\[RightSkeleton]", None}, {None, None}}, 
       CellFrameLabelMargins -> 25, MenuSortingValue -> 1445], 
      Cell[
       StyleData["ExpressionVariable"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionABF"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionMeta"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["AutoParentheses"], Editable -> False, SpanMaxSize -> 3, 
          FontOpacity -> 0.15], 
         Cell[
          StyleData["AutoParentheses", "Layout"], FontOpacity -> 0], 
         Cell[
          StyleData["AutoParentheses", "SlideShow"], FontOpacity -> 0]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Emphasized"], MenuCommandKey -> "E", FontSlant -> 
          "Italic"], 
         Cell[
          StyleData["Emphasized", "SlideShow"], FontSlant -> "Plain", 
          FontColor -> RGBColor[0.36, 0.54, 0.69]]}, Open]], 
      Cell[
       StyleData["GenericButton"], FontFamily -> "Bitstream Charter", 
       FontWeight -> "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
       FontVariations -> {
        "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
         "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
       RGBColor[0.23, 0.25, 0.34]], 
      Cell[
       StyleData["TheoremaForm"], "TwoByteSyntaxCharacterAutoReplacement" -> 
       True, LineSpacing -> {1.25, 0, 2}, SingleLetterItalics -> True, 
       StyleMenuListing -> None, FontFamily -> "Courier"], 
      Cell[
       StyleData["ComponentActive"], FontFamily -> "Times New Roman"], 
      Cell[
       StyleData["ComponentInactive"], FontFamily -> "Times New Roman", 
       FontOpacity -> 0.4], 
      Cell[
       StyleData["ComponentEmpty"], FontFamily -> "Times New Roman", 
       FontVariations -> {"StrikeThrough" -> True}], 
      Cell[
       StyleData["TabView"], FontFamily -> "Times New Roman", FontSize -> 10], 
      Cell[
       StyleData["TabViewLabel"], FontFamily -> "Times New Roman", FontSize -> 
       10, FontWeight -> "Bold"], 
      Cell[
       StyleData["FormReference", StyleDefinitions -> StyleData["Text"]], 
       FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> "Plain",
        FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["FormReferenceHover", StyleDefinitions -> StyleData["Text"]],
        FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> 
       "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> True}, 
       FontColor -> RGBColor[0.404, 0.43, 0.545]], 
      Cell[
       StyleData["DisplayFormula"], CellMargins -> {{36, 6}, {7, 7}}, 
       ConversionRules :> {
        "HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}}, 
       CellHorizontalScrolling -> True, DefaultFormatType -> TraditionalForm, 
       InputAutoReplacements -> {}, TextAlignment -> Center, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       ButtonBoxOptions -> {Appearance -> {Automatic, None}}]}, Open]]}, 
  Visible -> False, FrontEndVersion -> 
  "9.0 for Linux x86 (64-bit) (February 7, 2013)", StyleDefinitions -> 
  "StylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ID:13590416"->{
  Cell[39318, 1108, 673, 18, 31, "GlobalDeclaration",
   CellTags->{
    "ID:13590416", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->13590416]},
 "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"->{
  Cell[39318, 1108, 673, 18, 31, "GlobalDeclaration",
   CellTags->{
    "ID:13590416", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->13590416],
  Cell[39994, 1128, 737, 19, 30, "GlobalDeclaration",
   CellTags->{
    "ID:52891026", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->52891026],
  Cell[40734, 1149, 618, 16, 30, "GlobalDeclaration",
   CellTags->{
    "ID:556284720", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->556284720],
  Cell[41355, 1167, 1916, 62, 93, "FormalTextInputFormula",
   CellTags->{
    "ID:172182433", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain \[Element]"},
   CellID->172182433],
  Cell[43274, 1231, 1426, 48, 39, "FormalTextInputFormula",
   CellTags->{
    "ID:96567293", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain parsing"},
   CellID->96567293],
  Cell[44703, 1281, 1376, 43, 39, "FormalTextInputFormula",
   CellTags->{
    "ID:666017826", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain printing"},
   CellID->666017826],
  Cell[46943, 1359, 692, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:43183279", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->43183279],
  Cell[47638, 1379, 769, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:501919234", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->501919234],
  Cell[48410, 1401, 1515, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:177079530", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative", "IR"},
   CellID->177079530],
  Cell[49928, 1448, 1422, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:160393105", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative II"},
   CellID->160393105],
  Cell[51353, 1492, 1483, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:666612949", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative III"},
   CellID->666612949],
  Cell[52839, 1538, 1043, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:15990241", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain isDomain"},
   CellID->15990241],
  Cell[74206, 2132, 1049, 32, 70, "GlobalDeclaration",
   CellTags->{
    "ID:131627256", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->131627256],
  Cell[75258, 2166, 1322, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1252521910", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1252521910],
  Cell[76583, 2206, 682, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:483943613", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->483943613],
  Cell[77268, 2225, 1937, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:415499872", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Element]"},
   CellID->415499872],
  Cell[79208, 2289, 1935, 58, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1592061526", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Succeeds]"},
   CellID->1592061526],
  Cell[81146, 2349, 1309, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:660280664", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Precedes]"},
   CellID->660280664],
  Cell[83058, 2415, 1340, 43, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1203319602", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1203319602],
  Cell[84401, 2460, 1624, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1155548854", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1155548854],
  Cell[86028, 2510, 759, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:268596668", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->268596668],
  Cell[86790, 2532, 2048, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:143611979", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Element]"},
   CellID->143611979],
  Cell[88841, 2600, 2751, 79, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1082760072", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Succeeds]"},
   CellID->1082760072],
  Cell[91595, 2681, 1342, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2039496926", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Precedes]"},
   CellID->2039496926],
  Cell[92940, 2725, 970, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1528170763", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder"},
   CellID->1528170763],
  Cell[94513, 2777, 753, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1177571532", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1177571532],
  Cell[95269, 2797, 722, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1157453212", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1157453212],
  Cell[95994, 2817, 712, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1901627231", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1901627231],
  Cell[96709, 2837, 2168, 68, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:475599841", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Element]"},
   CellID->475599841],
  Cell[98880, 2907, 2412, 76, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1975055247", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Succeeds]"},
   CellID->1975055247],
  Cell[101295, 2985, 1233, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:715152506", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Precedes]"},
   CellID->715152506],
  Cell[102531, 3027, 966, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1361950489", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder"},
   CellID->1361950489],
  Cell[103937, 3072, 1008, 32, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1394564787", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1394564787],
  Cell[104987, 3109, 1294, 39, 70, "GlobalDeclaration",
   CellTags->{
    "ID:56619207", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->56619207],
  Cell[106878, 3170, 1500, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:625854003", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Element] alternative"},
   
   CellID->625854003],
  Cell[108381, 3217, 1421, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1695764024", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder \[Element] alternative II"},
   CellID->1695764024],
  Cell[109805, 3261, 1517, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:998703597", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder \[Element] alternative III"},
   CellID->998703597],
  Cell[130805, 3809, 1039, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:83506562", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isDomain"},
   CellID->83506562],
  Cell[132266, 3855, 1311, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1564408474", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isReflexive"},
   CellID->1564408474],
  Cell[133580, 3898, 1674, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:993421296", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isAntisymmetric"},
   CellID->993421296],
  Cell[135257, 3956, 1705, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:762792695", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isAsymmetric"},
   CellID->762792695],
  Cell[137452, 4029, 2082, 67, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:365362652", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isTransitive"},
   CellID->365362652],
  Cell[139537, 4098, 1676, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:676617813", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isPartReflOrder"},
   CellID->676617813],
  Cell[141216, 4156, 1753, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:419051997", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isPartIrreflOrder"},
   CellID->419051997],
  Cell[189546, 5397, 1705, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:318639340", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isNoetherian"},
   CellID->318639340],
  Cell[198592, 5643, 1292, 43, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1694786048", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1694786048],
  Cell[199926, 5691, 1606, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:335763124", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->335763124],
  Cell[202122, 5760, 756, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:789393137", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->789393137],
  Cell[202881, 5782, 1777, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1175612329", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Element] alternative"},
   CellID->1175612329],
  Cell[204661, 5835, 1447, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1604133742", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder3 \[Element] alternative II"},
   CellID->1604133742],
  Cell[206111, 5877, 1533, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1325269638", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder3 \[Element] alternative III"},
   CellID->1325269638],
  Cell[207647, 5924, 1179, 32, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1305799953", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder alternative",
      "IR"},
   CellID->1305799953],
  Cell[208829, 5958, 1350, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1675542119", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder injective"},
   CellID->1675542119],
  Cell[210182, 5999, 1286, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:659473488", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->659473488],
  Cell[211471, 6039, 1652, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:951534856", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder \[Element]"},
   
   CellID->951534856],
  Cell[213126, 6089, 2121, 61, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1364381745", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder \[Succeeds]"},
   CellID->1364381745],
  Cell[290616, 7916, 1112, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:350830179", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isDomain"},
   CellID->350830179],
  Cell[291731, 7949, 1883, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1492126708", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isPartReflOrder"},
   CellID->1492126708],
  Cell[293617, 8013, 1894, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:448490662", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isPartIrreflOrder"},
   CellID->448490662],
  Cell[295514, 8077, 1865, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1880074166", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isNoetherian"},
   CellID->1880074166],
  Cell[330713, 8947, 710, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1745474933", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1745474933],
  Cell[331426, 8967, 2091, 65, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1629835903", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll]", "IR"},
   CellID->1629835903],
  Cell[333520, 9034, 2234, 70, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:555552062", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll] II", "IR"},
   CellID->555552062],
  Cell[335757, 9106, 3887, 114, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:628439052", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 Noetherian induction", 
     "IR"},
   CellID->628439052],
  Cell[382301, 10198, 1433, 44, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1750417022", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN empty \[Element]", "IR"},
   CellID->1750417022],
  Cell[383737, 10244, 1291, 38, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1743969343", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN empty \[Succeeds]"},
   CellID->1743969343],
  Cell[385031, 10284, 829, 22, 48, "GlobalDeclaration",
   CellTags->{
    "ID:562382244", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->562382244],
  Cell[385863, 10308, 1820, 58, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1321392049", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN singleton \[Element]", 
     "IR"},
   CellID->1321392049],
  Cell[387686, 10368, 1577, 46, 52, "FormalTextInputFormula",
   CellTags->{
    "ID:533732994", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder singleton", 
     "IR"},
   CellID->533732994],
  Cell[389266, 10416, 1958, 62, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1826894117", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN singleton \[Succeeds]"},
   
   CellID->1826894117],
  Cell[417298, 11195, 867, 20, 33, "GlobalDeclaration",
   CellTags->{
    "ID:415166645", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->415166645],
  Cell[418168, 11217, 743, 19, 23, "GlobalDeclaration",
   CellTags->{
    "ID:1101966307", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1101966307],
  Cell[418914, 11238, 1452, 38, 55, "GlobalDeclaration",
   CellTags->{
    "ID:639341233", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->639341233],
  Cell[420369, 11278, 1300, 37, 33, "GlobalDeclaration",
   CellTags->{
    "ID:206422078", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->206422078],
  Cell[421672, 11317, 755, 20, 42, "GlobalDeclaration",
   CellTags->{
    "ID:1296242587", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1296242587],
  Cell[422430, 11339, 1184, 31, 37, "FormalTextInputFormula",
   CellTags->{
    "ID:194852796", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder \[Element]"},
   
   CellID->194852796],
  Cell[432308, 11595, 1560, 44, 45, "Text",
   CellTags->{
    "ID:1320576944", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder \[Succeeds]"},
   CellID->1320576944],
  Cell[433871, 11641, 1216, 38, 39, "Text",
   CellTags->{
    "ID:1403292599", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder injective"},
   CellID->1403292599]},
 "ID:52891026"->{
  Cell[39994, 1128, 737, 19, 30, "GlobalDeclaration",
   CellTags->{
    "ID:52891026", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->52891026]},
 "ID:556284720"->{
  Cell[40734, 1149, 618, 16, 30, "GlobalDeclaration",
   CellTags->{
    "ID:556284720", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->556284720]},
 "ID:172182433"->{
  Cell[41355, 1167, 1916, 62, 93, "FormalTextInputFormula",
   CellTags->{
    "ID:172182433", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain \[Element]"},
   CellID->172182433]},
 "ProdDomain \[Element]"->{
  Cell[41355, 1167, 1916, 62, 93, "FormalTextInputFormula",
   CellTags->{
    "ID:172182433", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain \[Element]"},
   CellID->172182433]},
 "ID:96567293"->{
  Cell[43274, 1231, 1426, 48, 39, "FormalTextInputFormula",
   CellTags->{
    "ID:96567293", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain parsing"},
   CellID->96567293]},
 "ProdDomain parsing"->{
  Cell[43274, 1231, 1426, 48, 39, "FormalTextInputFormula",
   CellTags->{
    "ID:96567293", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain parsing"},
   CellID->96567293]},
 "ID:666017826"->{
  Cell[44703, 1281, 1376, 43, 39, "FormalTextInputFormula",
   CellTags->{
    "ID:666017826", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain printing"},
   CellID->666017826]},
 "ProdDomain printing"->{
  Cell[44703, 1281, 1376, 43, 39, "FormalTextInputFormula",
   CellTags->{
    "ID:666017826", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain printing"},
   CellID->666017826]},
 "ID:43183279"->{
  Cell[46943, 1359, 692, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:43183279", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->43183279]},
 "ID:501919234"->{
  Cell[47638, 1379, 769, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:501919234", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->501919234]},
 "ID:177079530"->{
  Cell[48410, 1401, 1515, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:177079530", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative", "IR"},
   CellID->177079530]},
 "ProdDomain \[Element] alternative"->{
  Cell[48410, 1401, 1515, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:177079530", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative", "IR"},
   CellID->177079530]},
 "IR"->{
  Cell[48410, 1401, 1515, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:177079530", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative", "IR"},
   CellID->177079530],
  Cell[207647, 5924, 1179, 32, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1305799953", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder alternative",
      "IR"},
   CellID->1305799953],
  Cell[331426, 8967, 2091, 65, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1629835903", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll]", "IR"},
   CellID->1629835903],
  Cell[333520, 9034, 2234, 70, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:555552062", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll] II", "IR"},
   CellID->555552062],
  Cell[335757, 9106, 3887, 114, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:628439052", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 Noetherian induction", 
     "IR"},
   CellID->628439052],
  Cell[382301, 10198, 1433, 44, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1750417022", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN empty \[Element]", "IR"},
   CellID->1750417022],
  Cell[385863, 10308, 1820, 58, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1321392049", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN singleton \[Element]", 
     "IR"},
   CellID->1321392049],
  Cell[387686, 10368, 1577, 46, 52, "FormalTextInputFormula",
   CellTags->{
    "ID:533732994", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder singleton", 
     "IR"},
   CellID->533732994]},
 "ID:160393105"->{
  Cell[49928, 1448, 1422, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:160393105", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative II"},
   CellID->160393105]},
 "ProdDomain \[Element] alternative II"->{
  Cell[49928, 1448, 1422, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:160393105", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative II"},
   CellID->160393105]},
 "ID:666612949"->{
  Cell[51353, 1492, 1483, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:666612949", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative III"},
   CellID->666612949]},
 "ProdDomain \[Element] alternative III"->{
  Cell[51353, 1492, 1483, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:666612949", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "ProdDomain \[Element] alternative III"},
   CellID->666612949]},
 "ID:15990241"->{
  Cell[52839, 1538, 1043, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:15990241", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain isDomain"},
   CellID->15990241]},
 "ProdDomain isDomain"->{
  Cell[52839, 1538, 1043, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:15990241", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "ProdDomain isDomain"},
   CellID->15990241]},
 "Proof|ID:177079530"->{
  Cell[54037, 1579, 4689, 120, 70, "ProofInfo",
   CellTags->{"Proof|ID:177079530", "Proof|ID:177079530-1"},
   CellID->222181063]},
 "Proof|ID:177079530-1"->{
  Cell[54037, 1579, 4689, 120, 70, "ProofInfo",
   CellTags->{"Proof|ID:177079530", "Proof|ID:177079530-1"},
   CellID->222181063]},
 "Proof|ID:160393105"->{
  Cell[59245, 1718, 4584, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:160393105", "Proof|ID:160393105-1"},
   CellID->175723293]},
 "Proof|ID:160393105-1"->{
  Cell[59245, 1718, 4584, 118, 70, "ProofInfo",
   CellTags->{"Proof|ID:160393105", "Proof|ID:160393105-1"},
   CellID->175723293]},
 "Proof|ID:666612949"->{
  Cell[64348, 1855, 4719, 122, 70, "ProofInfo",
   CellTags->{"Proof|ID:666612949", "Proof|ID:666612949-1"},
   CellID->159422770]},
 "Proof|ID:666612949-1"->{
  Cell[64348, 1855, 4719, 122, 70, "ProofInfo",
   CellTags->{"Proof|ID:666612949", "Proof|ID:666612949-1"},
   CellID->159422770]},
 "Proof|ID:15990241"->{
  Cell[69587, 1996, 3242, 88, 70, "ProofInfo",
   CellTags->{"Proof|ID:15990241", "Proof|ID:15990241-1"},
   CellID->486730789]},
 "Proof|ID:15990241-1"->{
  Cell[69587, 1996, 3242, 88, 70, "ProofInfo",
   CellTags->{"Proof|ID:15990241", "Proof|ID:15990241-1"},
   CellID->486730789]},
 "ID:131627256"->{
  Cell[74206, 2132, 1049, 32, 70, "GlobalDeclaration",
   CellTags->{
    "ID:131627256", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->131627256]},
 "ID:1252521910"->{
  Cell[75258, 2166, 1322, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1252521910", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1252521910]},
 "ID:483943613"->{
  Cell[76583, 2206, 682, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:483943613", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->483943613]},
 "ID:415499872"->{
  Cell[77268, 2225, 1937, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:415499872", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Element]"},
   CellID->415499872]},
 "LexOrder \[Element]"->{
  Cell[77268, 2225, 1937, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:415499872", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Element]"},
   CellID->415499872]},
 "ID:1592061526"->{
  Cell[79208, 2289, 1935, 58, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1592061526", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Succeeds]"},
   CellID->1592061526]},
 "LexOrder \[Succeeds]"->{
  Cell[79208, 2289, 1935, 58, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1592061526", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Succeeds]"},
   CellID->1592061526]},
 "ID:660280664"->{
  Cell[81146, 2349, 1309, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:660280664", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Precedes]"},
   CellID->660280664]},
 "LexOrder \[Precedes]"->{
  Cell[81146, 2349, 1309, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:660280664", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Precedes]"},
   CellID->660280664]},
 "ID:1203319602"->{
  Cell[83058, 2415, 1340, 43, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1203319602", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1203319602]},
 "ID:1155548854"->{
  Cell[84401, 2460, 1624, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1155548854", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1155548854]},
 "ID:268596668"->{
  Cell[86028, 2510, 759, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:268596668", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->268596668]},
 "ID:143611979"->{
  Cell[86790, 2532, 2048, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:143611979", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Element]"},
   CellID->143611979]},
 "LexOrder3 \[Element]"->{
  Cell[86790, 2532, 2048, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:143611979", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Element]"},
   CellID->143611979]},
 "ID:1082760072"->{
  Cell[88841, 2600, 2751, 79, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1082760072", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Succeeds]"},
   CellID->1082760072]},
 "LexOrder3 \[Succeeds]"->{
  Cell[88841, 2600, 2751, 79, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1082760072", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Succeeds]"},
   CellID->1082760072]},
 "ID:2039496926"->{
  Cell[91595, 2681, 1342, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2039496926", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Precedes]"},
   CellID->2039496926]},
 "LexOrder3 \[Precedes]"->{
  Cell[91595, 2681, 1342, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2039496926", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Precedes]"},
   CellID->2039496926]},
 "ID:1528170763"->{
  Cell[92940, 2725, 970, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1528170763", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder"},
   CellID->1528170763]},
 "LexOrder3 ToLexOrder"->{
  Cell[92940, 2725, 970, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1528170763", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder"},
   CellID->1528170763]},
 "ID:1177571532"->{
  Cell[94513, 2777, 753, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1177571532", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1177571532]},
 "ID:1157453212"->{
  Cell[95269, 2797, 722, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1157453212", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1157453212]},
 "ID:1901627231"->{
  Cell[95994, 2817, 712, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1901627231", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1901627231]},
 "ID:475599841"->{
  Cell[96709, 2837, 2168, 68, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:475599841", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Element]"},
   CellID->475599841]},
 "LexOrderN \[Element]"->{
  Cell[96709, 2837, 2168, 68, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:475599841", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Element]"},
   CellID->475599841]},
 "ID:1975055247"->{
  Cell[98880, 2907, 2412, 76, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1975055247", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Succeeds]"},
   CellID->1975055247]},
 "LexOrderN \[Succeeds]"->{
  Cell[98880, 2907, 2412, 76, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1975055247", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Succeeds]"},
   CellID->1975055247]},
 "ID:715152506"->{
  Cell[101295, 2985, 1233, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:715152506", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Precedes]"},
   CellID->715152506]},
 "LexOrderN \[Precedes]"->{
  Cell[101295, 2985, 1233, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:715152506", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN \[Precedes]"},
   CellID->715152506]},
 "ID:1361950489"->{
  Cell[102531, 3027, 966, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1361950489", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder"},
   CellID->1361950489]},
 "LexOrderN ToLexOrder"->{
  Cell[102531, 3027, 966, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1361950489", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder"},
   CellID->1361950489]},
 "ID:1394564787"->{
  Cell[103937, 3072, 1008, 32, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1394564787", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1394564787]},
 "ID:56619207"->{
  Cell[104987, 3109, 1294, 39, 70, "GlobalDeclaration",
   CellTags->{
    "ID:56619207", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->56619207]},
 "ID:625854003"->{
  Cell[106878, 3170, 1500, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:625854003", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Element] alternative"},
   
   CellID->625854003]},
 "LexOrder \[Element] alternative"->{
  Cell[106878, 3170, 1500, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:625854003", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder \[Element] alternative"},
   
   CellID->625854003]},
 "ID:1695764024"->{
  Cell[108381, 3217, 1421, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1695764024", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder \[Element] alternative II"},
   CellID->1695764024]},
 "LexOrder \[Element] alternative II"->{
  Cell[108381, 3217, 1421, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1695764024", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder \[Element] alternative II"},
   CellID->1695764024]},
 "ID:998703597"->{
  Cell[109805, 3261, 1517, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:998703597", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder \[Element] alternative III"},
   CellID->998703597]},
 "LexOrder \[Element] alternative III"->{
  Cell[109805, 3261, 1517, 44, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:998703597", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder \[Element] alternative III"},
   CellID->998703597]},
 "Proof|ID:625854003"->{
  Cell[111480, 3316, 5729, 139, 70, "ProofInfo",
   CellTags->{"Proof|ID:625854003", "Proof|ID:625854003-1"},
   CellID->535822348]},
 "Proof|ID:625854003-1"->{
  Cell[111480, 3316, 5729, 139, 70, "ProofInfo",
   CellTags->{"Proof|ID:625854003", "Proof|ID:625854003-1"},
   CellID->535822348]},
 "Proof|ID:1695764024"->{
  Cell[117728, 3474, 5626, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:1695764024", "Proof|ID:1695764024-1"},
   CellID->1504850255]},
 "Proof|ID:1695764024-1"->{
  Cell[117728, 3474, 5626, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:1695764024", "Proof|ID:1695764024-1"},
   CellID->1504850255]},
 "Proof|ID:998703597"->{
  Cell[123875, 3631, 5760, 142, 70, "ProofInfo",
   CellTags->{"Proof|ID:998703597", "Proof|ID:998703597-1"},
   CellID->1420174462]},
 "Proof|ID:998703597-1"->{
  Cell[123875, 3631, 5760, 142, 70, "ProofInfo",
   CellTags->{"Proof|ID:998703597", "Proof|ID:998703597-1"},
   CellID->1420174462]},
 "ID:83506562"->{
  Cell[130805, 3809, 1039, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:83506562", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isDomain"},
   CellID->83506562]},
 "LexOrder isDomain"->{
  Cell[130805, 3809, 1039, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:83506562", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isDomain"},
   CellID->83506562]},
 "ID:1564408474"->{
  Cell[132266, 3855, 1311, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1564408474", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isReflexive"},
   CellID->1564408474]},
 "LexOrder isReflexive"->{
  Cell[132266, 3855, 1311, 41, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1564408474", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isReflexive"},
   CellID->1564408474]},
 "ID:993421296"->{
  Cell[133580, 3898, 1674, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:993421296", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isAntisymmetric"},
   CellID->993421296]},
 "LexOrder isAntisymmetric"->{
  Cell[133580, 3898, 1674, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:993421296", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isAntisymmetric"},
   CellID->993421296]},
 "ID:762792695"->{
  Cell[135257, 3956, 1705, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:762792695", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isAsymmetric"},
   CellID->762792695]},
 "LexOrder isAsymmetric"->{
  Cell[135257, 3956, 1705, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:762792695", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isAsymmetric"},
   CellID->762792695]},
 "ID:365362652"->{
  Cell[137452, 4029, 2082, 67, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:365362652", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isTransitive"},
   CellID->365362652]},
 "LexOrder isTransitive"->{
  Cell[137452, 4029, 2082, 67, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:365362652", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isTransitive"},
   CellID->365362652]},
 "ID:676617813"->{
  Cell[139537, 4098, 1676, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:676617813", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isPartReflOrder"},
   CellID->676617813]},
 "LexOrder isPartReflOrder"->{
  Cell[139537, 4098, 1676, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:676617813", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isPartReflOrder"},
   CellID->676617813]},
 "ID:419051997"->{
  Cell[141216, 4156, 1753, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:419051997", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isPartIrreflOrder"},
   CellID->419051997]},
 "LexOrder isPartIrreflOrder"->{
  Cell[141216, 4156, 1753, 57, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:419051997", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isPartIrreflOrder"},
   CellID->419051997]},
 "Proof|ID:83506562"->{
  Cell[143126, 4224, 4361, 112, 70, "ProofInfo",
   CellTags->{"Proof|ID:83506562", "Proof|ID:83506562-1"},
   CellID->19037723]},
 "Proof|ID:83506562-1"->{
  Cell[143126, 4224, 4361, 112, 70, "ProofInfo",
   CellTags->{"Proof|ID:83506562", "Proof|ID:83506562-1"},
   CellID->19037723]},
 "Proof|ID:1564408474"->{
  Cell[148006, 4355, 5786, 141, 70, "ProofInfo",
   CellTags->{"Proof|ID:1564408474", "Proof|ID:1564408474-1"},
   CellID->957699202]},
 "Proof|ID:1564408474-1"->{
  Cell[148006, 4355, 5786, 141, 70, "ProofInfo",
   CellTags->{"Proof|ID:1564408474", "Proof|ID:1564408474-1"},
   CellID->957699202]},
 "Proof|ID:993421296"->{
  Cell[154314, 4515, 6338, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:993421296", "Proof|ID:993421296-1"},
   CellID->1133214309]},
 "Proof|ID:993421296-1"->{
  Cell[154314, 4515, 6338, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:993421296", "Proof|ID:993421296-1"},
   CellID->1133214309]},
 "Proof|ID:762792695"->{
  Cell[161172, 4686, 6313, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:762792695", "Proof|ID:762792695-1"},
   CellID->650701467]},
 "Proof|ID:762792695-1"->{
  Cell[161172, 4686, 6313, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:762792695", "Proof|ID:762792695-1"},
   CellID->650701467]},
 "Proof|ID:365362652"->{
  Cell[168005, 4857, 6782, 162, 70, "ProofInfo",
   CellTags->{"Proof|ID:365362652", "Proof|ID:365362652-1"},
   CellID->2129721589]},
 "Proof|ID:365362652-1"->{
  Cell[168005, 4857, 6782, 162, 70, "ProofInfo",
   CellTags->{"Proof|ID:365362652", "Proof|ID:365362652-1"},
   CellID->2129721589]},
 "Proof|ID:676617813"->{
  Cell[175307, 5038, 6337, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:676617813", "Proof|ID:676617813-1"},
   CellID->665767943]},
 "Proof|ID:676617813-1"->{
  Cell[175307, 5038, 6337, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:676617813", "Proof|ID:676617813-1"},
   CellID->665767943]},
 "Proof|ID:419051997"->{
  Cell[182164, 5209, 6353, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:419051997", "Proof|ID:419051997-1"},
   CellID->939925669]},
 "Proof|ID:419051997-1"->{
  Cell[182164, 5209, 6353, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:419051997", "Proof|ID:419051997-1"},
   CellID->939925669]},
 "ID:318639340"->{
  Cell[189546, 5397, 1705, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:318639340", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isNoetherian"},
   CellID->318639340]},
 "LexOrder isNoetherian"->{
  Cell[189546, 5397, 1705, 56, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:318639340", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder isNoetherian"},
   CellID->318639340]},
 "Proof|ID:318639340"->{
  Cell[191408, 5464, 6312, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:318639340", "Proof|ID:318639340-1"},
   CellID->14707961]},
 "Proof|ID:318639340-1"->{
  Cell[191408, 5464, 6312, 152, 70, "ProofInfo",
   CellTags->{"Proof|ID:318639340", "Proof|ID:318639340-1"},
   CellID->14707961]},
 "ID:1694786048"->{
  Cell[198592, 5643, 1292, 43, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1694786048", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1694786048]},
 "ID:335763124"->{
  Cell[199926, 5691, 1606, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:335763124", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->335763124]},
 "ID:789393137"->{
  Cell[202122, 5760, 756, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:789393137", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->789393137]},
 "ID:1175612329"->{
  Cell[202881, 5782, 1777, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1175612329", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Element] alternative"},
   CellID->1175612329]},
 "LexOrder3 \[Element] alternative"->{
  Cell[202881, 5782, 1777, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1175612329", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[Element] alternative"},
   CellID->1175612329]},
 "ID:1604133742"->{
  Cell[204661, 5835, 1447, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1604133742", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder3 \[Element] alternative II"},
   CellID->1604133742]},
 "LexOrder3 \[Element] alternative II"->{
  Cell[204661, 5835, 1447, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1604133742", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder3 \[Element] alternative II"},
   CellID->1604133742]},
 "ID:1325269638"->{
  Cell[206111, 5877, 1533, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1325269638", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder3 \[Element] alternative III"},
   CellID->1325269638]},
 "LexOrder3 \[Element] alternative III"->{
  Cell[206111, 5877, 1533, 45, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1325269638", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", 
     "LexOrder3 \[Element] alternative III"},
   CellID->1325269638]},
 "ID:1305799953"->{
  Cell[207647, 5924, 1179, 32, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1305799953", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder alternative",
      "IR"},
   CellID->1305799953]},
 "LexOrder3 ToLexOrder alternative"->{
  Cell[207647, 5924, 1179, 32, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1305799953", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder alternative",
      "IR"},
   CellID->1305799953]},
 "ID:1675542119"->{
  Cell[208829, 5958, 1350, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1675542119", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder injective"},
   CellID->1675542119]},
 "LexOrder3 ToLexOrder injective"->{
  Cell[208829, 5958, 1350, 39, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1675542119", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder injective"},
   CellID->1675542119]},
 "ID:659473488"->{
  Cell[210182, 5999, 1286, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:659473488", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->659473488]},
 "ID:951534856"->{
  Cell[211471, 6039, 1652, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:951534856", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder \[Element]"},
   
   CellID->951534856]},
 "LexOrder3 ToLexOrder \[Element]"->{
  Cell[211471, 6039, 1652, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:951534856", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder \[Element]"},
   
   CellID->951534856]},
 "ID:1364381745"->{
  Cell[213126, 6089, 2121, 61, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1364381745", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder \[Succeeds]"},
   CellID->1364381745]},
 "LexOrder3 ToLexOrder \[Succeeds]"->{
  Cell[213126, 6089, 2121, 61, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1364381745", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 ToLexOrder \[Succeeds]"},
   CellID->1364381745]},
 "Proof|ID:1175612329"->{
  Cell[215404, 6161, 7326, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1175612329", "Proof|ID:1175612329-1"},
   CellID->186855576]},
 "Proof|ID:1175612329-1"->{
  Cell[215404, 6161, 7326, 168, 70, "ProofInfo",
   CellTags->{"Proof|ID:1175612329", "Proof|ID:1175612329-1"},
   CellID->186855576]},
 "Proof|ID:1604133742"->{
  Cell[223252, 6348, 7081, 165, 70, "ProofInfo",
   CellTags->{"Proof|ID:1604133742", "Proof|ID:1604133742-1"},
   CellID->593724936]},
 "Proof|ID:1604133742-1"->{
  Cell[223252, 6348, 7081, 165, 70, "ProofInfo",
   CellTags->{"Proof|ID:1604133742", "Proof|ID:1604133742-1"},
   CellID->593724936]},
 "Proof|ID:1325269638"->{
  Cell[230853, 6532, 7341, 173, 70, "ProofInfo",
   CellTags->{"Proof|ID:1325269638", "Proof|ID:1325269638-1"},
   CellID->2061926766]},
 "Proof|ID:1325269638-1"->{
  Cell[230853, 6532, 7341, 173, 70, "ProofInfo",
   CellTags->{"Proof|ID:1325269638", "Proof|ID:1325269638-1"},
   CellID->2061926766]},
 "Proof|ID:1305799953"->{
  Cell[238716, 6724, 8165, 190, 70, "ProofInfo",
   CellTags->{"Proof|ID:1305799953", "Proof|ID:1305799953-1"},
   CellID->259168266]},
 "Proof|ID:1305799953-1"->{
  Cell[238716, 6724, 8165, 190, 70, "ProofInfo",
   CellTags->{"Proof|ID:1305799953", "Proof|ID:1305799953-1"},
   CellID->259168266]},
 "Proof|ID:1675542119"->{
  Cell[247402, 6933, 12000, 268, 70, "ProofInfo",
   CellTags->{"Proof|ID:1675542119", "Proof|ID:1675542119-1"},
   CellID->1614785598]},
 "Proof|ID:1675542119-1"->{
  Cell[247402, 6933, 12000, 268, 70, "ProofInfo",
   CellTags->{"Proof|ID:1675542119", "Proof|ID:1675542119-1"},
   CellID->1614785598]},
 "Proof|ID:951534856"->{
  Cell[259924, 7220, 11059, 247, 70, "ProofInfo",
   CellTags->{"Proof|ID:951534856", "Proof|ID:951534856-1"},
   CellID->277734451]},
 "Proof|ID:951534856-1"->{
  Cell[259924, 7220, 11059, 247, 70, "ProofInfo",
   CellTags->{"Proof|ID:951534856", "Proof|ID:951534856-1"},
   CellID->277734451]},
 "Proof|ID:1364381745"->{
  Cell[271503, 7486, 18017, 394, 70, "ProofInfo",
   CellTags->{"Proof|ID:1364381745", "Proof|ID:1364381745-1"},
   CellID->465277495]},
 "Proof|ID:1364381745-1"->{
  Cell[271503, 7486, 18017, 394, 70, "ProofInfo",
   CellTags->{"Proof|ID:1364381745", "Proof|ID:1364381745-1"},
   CellID->465277495]},
 "ID:350830179"->{
  Cell[290616, 7916, 1112, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:350830179", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isDomain"},
   CellID->350830179]},
 "LexOrder3 isDomain"->{
  Cell[290616, 7916, 1112, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:350830179", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isDomain"},
   CellID->350830179]},
 "ID:1492126708"->{
  Cell[291731, 7949, 1883, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1492126708", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isPartReflOrder"},
   CellID->1492126708]},
 "LexOrder3 isPartReflOrder"->{
  Cell[291731, 7949, 1883, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1492126708", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isPartReflOrder"},
   CellID->1492126708]},
 "ID:448490662"->{
  Cell[293617, 8013, 1894, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:448490662", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isPartIrreflOrder"},
   CellID->448490662]},
 "LexOrder3 isPartIrreflOrder"->{
  Cell[293617, 8013, 1894, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:448490662", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isPartIrreflOrder"},
   CellID->448490662]},
 "ID:1880074166"->{
  Cell[295514, 8077, 1865, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1880074166", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isNoetherian"},
   CellID->1880074166]},
 "LexOrder3 isNoetherian"->{
  Cell[295514, 8077, 1865, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1880074166", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 isNoetherian"},
   CellID->1880074166]},
 "Proof|ID:350830179"->{
  Cell[297537, 8150, 5541, 134, 70, "ProofInfo",
   CellTags->{"Proof|ID:350830179", "Proof|ID:350830179-1"},
   CellID->359925756]},
 "Proof|ID:350830179-1"->{
  Cell[297537, 8150, 5541, 134, 70, "ProofInfo",
   CellTags->{"Proof|ID:350830179", "Proof|ID:350830179-1"},
   CellID->359925756]},
 "Proof|ID:1492126708"->{
  Cell[303597, 8303, 8371, 191, 70, "ProofInfo",
   CellTags->{"Proof|ID:1492126708", "Proof|ID:1492126708-1"},
   CellID->2037194359]},
 "Proof|ID:1492126708-1"->{
  Cell[303597, 8303, 8371, 191, 70, "ProofInfo",
   CellTags->{"Proof|ID:1492126708", "Proof|ID:1492126708-1"},
   CellID->2037194359]},
 "Proof|ID:448490662"->{
  Cell[312489, 8513, 8381, 190, 70, "ProofInfo",
   CellTags->{"Proof|ID:448490662", "Proof|ID:448490662-1"},
   CellID->259882569]},
 "Proof|ID:448490662-1"->{
  Cell[312489, 8513, 8381, 190, 70, "ProofInfo",
   CellTags->{"Proof|ID:448490662", "Proof|ID:448490662-1"},
   CellID->259882569]},
 "Proof|ID:1880074166"->{
  Cell[321390, 8722, 8341, 191, 70, "ProofInfo",
   CellTags->{"Proof|ID:1880074166", "Proof|ID:1880074166-1"},
   CellID->1837575531]},
 "Proof|ID:1880074166-1"->{
  Cell[321390, 8722, 8341, 191, 70, "ProofInfo",
   CellTags->{"Proof|ID:1880074166", "Proof|ID:1880074166-1"},
   CellID->1837575531]},
 "ID:1745474933"->{
  Cell[330713, 8947, 710, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1745474933", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1745474933]},
 "ID:1629835903"->{
  Cell[331426, 8967, 2091, 65, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1629835903", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll]", "IR"},
   CellID->1629835903]},
 "LexOrder3 \[ForAll]"->{
  Cell[331426, 8967, 2091, 65, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1629835903", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll]", "IR"},
   CellID->1629835903]},
 "ID:555552062"->{
  Cell[333520, 9034, 2234, 70, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:555552062", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll] II", "IR"},
   CellID->555552062]},
 "LexOrder3 \[ForAll] II"->{
  Cell[333520, 9034, 2234, 70, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:555552062", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 \[ForAll] II", "IR"},
   CellID->555552062]},
 "ID:628439052"->{
  Cell[335757, 9106, 3887, 114, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:628439052", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 Noetherian induction", 
     "IR"},
   CellID->628439052]},
 "LexOrder3 Noetherian induction"->{
  Cell[335757, 9106, 3887, 114, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:628439052", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrder3 Noetherian induction", 
     "IR"},
   CellID->628439052]},
 "Proof|ID:1629835903"->{
  Cell[339802, 9231, 9347, 211, 70, "ProofInfo",
   CellTags->{"Proof|ID:1629835903", "Proof|ID:1629835903-1"},
   CellID->1507488488]},
 "Proof|ID:1629835903-1"->{
  Cell[339802, 9231, 9347, 211, 70, "ProofInfo",
   CellTags->{"Proof|ID:1629835903", "Proof|ID:1629835903-1"},
   CellID->1507488488]},
 "Proof|ID:555552062"->{
  Cell[349671, 9461, 10050, 226, 70, "ProofInfo",
   CellTags->{"Proof|ID:555552062", "Proof|ID:555552062-1"},
   CellID->1496219234]},
 "Proof|ID:555552062-1"->{
  Cell[349671, 9461, 10050, 226, 70, "ProofInfo",
   CellTags->{"Proof|ID:555552062", "Proof|ID:555552062-1"},
   CellID->1496219234]},
 "Proof|ID:628439052"->{
  Cell[360241, 9706, 20450, 435, 70, "ProofInfo",
   CellTags->{"Proof|ID:628439052", "Proof|ID:628439052-1"},
   CellID->16324577]},
 "Proof|ID:628439052-1"->{
  Cell[360241, 9706, 20450, 435, 70, "ProofInfo",
   CellTags->{"Proof|ID:628439052", "Proof|ID:628439052-1"},
   CellID->16324577]},
 "ID:1750417022"->{
  Cell[382301, 10198, 1433, 44, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1750417022", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN empty \[Element]", "IR"},
   CellID->1750417022]},
 "LexOrderN empty \[Element]"->{
  Cell[382301, 10198, 1433, 44, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1750417022", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN empty \[Element]", "IR"},
   CellID->1750417022]},
 "ID:1743969343"->{
  Cell[383737, 10244, 1291, 38, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1743969343", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN empty \[Succeeds]"},
   CellID->1743969343]},
 "LexOrderN empty \[Succeeds]"->{
  Cell[383737, 10244, 1291, 38, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1743969343", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN empty \[Succeeds]"},
   CellID->1743969343]},
 "ID:562382244"->{
  Cell[385031, 10284, 829, 22, 48, "GlobalDeclaration",
   CellTags->{
    "ID:562382244", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->562382244]},
 "ID:1321392049"->{
  Cell[385863, 10308, 1820, 58, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1321392049", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN singleton \[Element]", 
     "IR"},
   CellID->1321392049]},
 "LexOrderN singleton \[Element]"->{
  Cell[385863, 10308, 1820, 58, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1321392049", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN singleton \[Element]", 
     "IR"},
   CellID->1321392049]},
 "ID:533732994"->{
  Cell[387686, 10368, 1577, 46, 52, "FormalTextInputFormula",
   CellTags->{
    "ID:533732994", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder singleton", 
     "IR"},
   CellID->533732994]},
 "LexOrderN ToLexOrder singleton"->{
  Cell[387686, 10368, 1577, 46, 52, "FormalTextInputFormula",
   CellTags->{
    "ID:533732994", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder singleton", 
     "IR"},
   CellID->533732994]},
 "ID:1826894117"->{
  Cell[389266, 10416, 1958, 62, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1826894117", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN singleton \[Succeeds]"},
   
   CellID->1826894117]},
 "LexOrderN singleton \[Succeeds]"->{
  Cell[389266, 10416, 1958, 62, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1826894117", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN singleton \[Succeeds]"},
   
   CellID->1826894117]},
 "Proof|ID:1750417022"->{
  Cell[391379, 10489, 3018, 89, 28, "ProofInfo",
   CellTags->{"Proof|ID:1750417022", "Proof|ID:1750417022-1"},
   CellID->1480567573]},
 "Proof|ID:1750417022-1"->{
  Cell[391379, 10489, 3018, 89, 28, "ProofInfo",
   CellTags->{"Proof|ID:1750417022", "Proof|ID:1750417022-1"},
   CellID->1480567573]},
 "Proof|ID:1743969343"->{
  Cell[394919, 10597, 3878, 106, 26, "ProofInfo",
   CellTags->{"Proof|ID:1743969343", "Proof|ID:1743969343-1"},
   CellID->1693726967]},
 "Proof|ID:1743969343-1"->{
  Cell[394919, 10597, 3878, 106, 26, "ProofInfo",
   CellTags->{"Proof|ID:1743969343", "Proof|ID:1743969343-1"},
   CellID->1693726967]},
 "Proof|ID:1321392049"->{
  Cell[399319, 10722, 4932, 126, 26, "ProofInfo",
   CellTags->{"Proof|ID:1321392049", "Proof|ID:1321392049-1"},
   CellID->539924176]},
 "Proof|ID:1321392049-1"->{
  Cell[399319, 10722, 4932, 126, 26, "ProofInfo",
   CellTags->{"Proof|ID:1321392049", "Proof|ID:1321392049-1"},
   CellID->539924176]},
 "Proof|ID:533732994"->{
  Cell[404772, 10867, 4588, 116, 26, "ProofInfo",
   CellTags->{"Proof|ID:533732994", "Proof|ID:533732994-1"},
   CellID->814775281]},
 "Proof|ID:533732994-1"->{
  Cell[404772, 10867, 4588, 116, 26, "ProofInfo",
   CellTags->{"Proof|ID:533732994", "Proof|ID:533732994-1"},
   CellID->814775281]},
 "Proof|ID:1826894117"->{
  Cell[409881, 11002, 6381, 158, 26, "ProofInfo",
   CellTags->{"Proof|ID:1826894117", "Proof|ID:1826894117-1"},
   CellID->1194249226]},
 "Proof|ID:1826894117-1"->{
  Cell[409881, 11002, 6381, 158, 26, "ProofInfo",
   CellTags->{"Proof|ID:1826894117", "Proof|ID:1826894117-1"},
   CellID->1194249226]},
 "ID:415166645"->{
  Cell[417298, 11195, 867, 20, 33, "GlobalDeclaration",
   CellTags->{
    "ID:415166645", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->415166645]},
 "ID:1101966307"->{
  Cell[418168, 11217, 743, 19, 23, "GlobalDeclaration",
   CellTags->{
    "ID:1101966307", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1101966307]},
 "ID:639341233"->{
  Cell[418914, 11238, 1452, 38, 55, "GlobalDeclaration",
   CellTags->{
    "ID:639341233", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->639341233]},
 "ID:206422078"->{
  Cell[420369, 11278, 1300, 37, 33, "GlobalDeclaration",
   CellTags->{
    "ID:206422078", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->206422078]},
 "ID:1296242587"->{
  Cell[421672, 11317, 755, 20, 42, "GlobalDeclaration",
   CellTags->{
    "ID:1296242587", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb"},
   CellID->1296242587]},
 "ID:194852796"->{
  Cell[422430, 11339, 1184, 31, 37, "FormalTextInputFormula",
   CellTags->{
    "ID:194852796", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder \[Element]"},
   
   CellID->194852796]},
 "LexOrderN ToLexOrder \[Element]"->{
  Cell[422430, 11339, 1184, 31, 37, "FormalTextInputFormula",
   CellTags->{
    "ID:194852796", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder \[Element]"},
   
   CellID->194852796]},
 "Proof|ID:194852796"->{
  Cell[423771, 11381, 7821, 189, 28, "ProofInfo",
   CellTags->{"Proof|ID:194852796", "Proof|ID:194852796-1"},
   CellID->210990893]},
 "Proof|ID:194852796-1"->{
  Cell[423771, 11381, 7821, 189, 28, "ProofInfo",
   CellTags->{"Proof|ID:194852796", "Proof|ID:194852796-1"},
   CellID->210990893]},
 "ID:1320576944"->{
  Cell[432308, 11595, 1560, 44, 45, "Text",
   CellTags->{
    "ID:1320576944", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder \[Succeeds]"},
   CellID->1320576944]},
 "LexOrderN ToLexOrder \[Succeeds]"->{
  Cell[432308, 11595, 1560, 44, 45, "Text",
   CellTags->{
    "ID:1320576944", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder \[Succeeds]"},
   CellID->1320576944]},
 "ID:1403292599"->{
  Cell[433871, 11641, 1216, 38, 39, "Text",
   CellTags->{
    "ID:1403292599", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder injective"},
   CellID->1403292599]},
 "LexOrderN ToLexOrder injective"->{
  Cell[433871, 11641, 1216, 38, 39, "Text",
   CellTags->{
    "ID:1403292599", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Functors.nb", "LexOrderN ToLexOrder injective"},
   CellID->1403292599]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ID:13590416", 472753, 12449},
 {"Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", \
473026, 12456},
 {"ID:52891026", 490371, 12940},
 {"ID:556284720", 490585, 12947},
 {"ID:172182433", 490801, 12954},
 {"ProdDomain \[Element]", 491057, 12961},
 {"ID:96567293", 491303, 12968},
 {"ProdDomain parsing", 491551, 12975},
 {"ID:666017826", 491793, 12982},
 {"ProdDomain printing", 492045, 12989},
 {"ID:43183279", 492289, 12996},
 {"ID:501919234", 492503, 13003},
 {"ID:177079530", 492719, 13010},
 {"ProdDomain \[Element] alternative", 493011, 13018},
 {"IR", 493272, 13026},
 {"ID:160393105", 495259, 13080},
 {"ProdDomain \[Element] alternative II", 495551, 13088},
 {"ID:666612949", 495819, 13096},
 {"ProdDomain \[Element] alternative III", 496113, 13104},
 {"ID:15990241", 496381, 13112},
 {"ProdDomain isDomain", 496631, 13119},
 {"Proof|ID:177079530", 496880, 13126},
 {"Proof|ID:177079530-1", 497040, 13130},
 {"Proof|ID:160393105", 497198, 13134},
 {"Proof|ID:160393105-1", 497358, 13138},
 {"Proof|ID:666612949", 497516, 13142},
 {"Proof|ID:666612949-1", 497676, 13146},
 {"Proof|ID:15990241", 497833, 13150},
 {"Proof|ID:15990241-1", 497989, 13154},
 {"ID:131627256", 498138, 13158},
 {"ID:1252521910", 498356, 13165},
 {"ID:483943613", 498575, 13172},
 {"ID:415499872", 498791, 13179},
 {"LexOrder \[Element]", 499043, 13186},
 {"ID:1592061526", 499289, 13193},
 {"LexOrder \[Succeeds]", 499545, 13200},
 {"ID:660280664", 499793, 13207},
 {"LexOrder \[Precedes]", 500047, 13214},
 {"ID:1203319602", 500294, 13221},
 {"ID:1155548854", 500514, 13228},
 {"ID:268596668", 500733, 13235},
 {"ID:143611979", 500949, 13242},
 {"LexOrder3 \[Element]", 501203, 13249},
 {"ID:1082760072", 501450, 13256},
 {"LexOrder3 \[Succeeds]", 501708, 13263},
 {"ID:2039496926", 501958, 13270},
 {"LexOrder3 \[Precedes]", 502216, 13277},
 {"ID:1528170763", 502466, 13284},
 {"LexOrder3 ToLexOrder", 502721, 13291},
 {"ID:1177571532", 502969, 13298},
 {"ID:1157453212", 503188, 13305},
 {"ID:1901627231", 503407, 13312},
 {"ID:475599841", 503625, 13319},
 {"LexOrderN \[Element]", 503879, 13326},
 {"ID:1975055247", 504126, 13333},
 {"LexOrderN \[Succeeds]", 504384, 13340},
 {"ID:715152506", 504633, 13347},
 {"LexOrderN \[Precedes]", 504890, 13354},
 {"ID:1361950489", 505139, 13361},
 {"LexOrderN ToLexOrder", 505395, 13368},
 {"ID:1394564787", 505644, 13375},
 {"ID:56619207", 505863, 13382},
 {"ID:625854003", 506079, 13389},
 {"LexOrder \[Element] alternative", 506360, 13397},
 {"ID:1695764024", 506623, 13405},
 {"LexOrder \[Element] alternative II", 506914, 13413},
 {"ID:998703597", 507183, 13421},
 {"LexOrder \[Element] alternative III", 507474, 13429},
 {"Proof|ID:625854003", 507748, 13437},
 {"Proof|ID:625854003-1", 507909, 13441},
 {"Proof|ID:1695764024", 508069, 13445},
 {"Proof|ID:1695764024-1", 508234, 13449},
 {"Proof|ID:998703597", 508396, 13453},
 {"Proof|ID:998703597-1", 508558, 13457},
 {"ID:83506562", 508711, 13461},
 {"LexOrder isDomain", 508958, 13468},
 {"ID:1564408474", 509201, 13475},
 {"LexOrder isReflexive", 509458, 13482},
 {"ID:993421296", 509707, 13489},
 {"LexOrder isAntisymmetric", 509970, 13496},
 {"ID:762792695", 510221, 13503},
 {"LexOrder isAsymmetric", 510478, 13510},
 {"ID:365362652", 510726, 13517},
 {"LexOrder isTransitive", 510983, 13524},
 {"ID:676617813", 511231, 13531},
 {"LexOrder isPartReflOrder", 511494, 13538},
 {"ID:419051997", 511745, 13545},
 {"LexOrder isPartIrreflOrder", 512012, 13552},
 {"Proof|ID:83506562", 512270, 13559},
 {"Proof|ID:83506562-1", 512427, 13563},
 {"Proof|ID:1564408474", 512584, 13567},
 {"Proof|ID:1564408474-1", 512748, 13571},
 {"Proof|ID:993421296", 512909, 13575},
 {"Proof|ID:993421296-1", 513071, 13579},
 {"Proof|ID:762792695", 513231, 13583},
 {"Proof|ID:762792695-1", 513392, 13587},
 {"Proof|ID:365362652", 513551, 13591},
 {"Proof|ID:365362652-1", 513713, 13595},
 {"Proof|ID:676617813", 513873, 13599},
 {"Proof|ID:676617813-1", 514034, 13603},
 {"Proof|ID:419051997", 514193, 13607},
 {"Proof|ID:419051997-1", 514354, 13611},
 {"ID:318639340", 514507, 13615},
 {"LexOrder isNoetherian", 514764, 13622},
 {"Proof|ID:318639340", 515018, 13629},
 {"Proof|ID:318639340-1", 515178, 13633},
 {"ID:1694786048", 515331, 13637},
 {"ID:335763124", 515551, 13644},
 {"ID:789393137", 515769, 13651},
 {"ID:1175612329", 515987, 13658},
 {"LexOrder3 \[Element] alternative", 516268, 13665},
 {"ID:1604133742", 516530, 13672},
 {"LexOrder3 \[Element] alternative II", 516823, 13680},
 {"ID:1325269638", 517094, 13688},
 {"LexOrder3 \[Element] alternative III", 517389, 13696},
 {"ID:1305799953", 517661, 13704},
 {"LexOrder3 ToLexOrder alternative", 517954, 13712},
 {"ID:1675542119", 518228, 13720},
 {"LexOrder3 ToLexOrder injective", 518505, 13727},
 {"ID:659473488", 518764, 13734},
 {"ID:951534856", 518982, 13741},
 {"LexOrder3 ToLexOrder \[Element]", 519263, 13749},
 {"ID:1364381745", 519526, 13757},
 {"LexOrder3 ToLexOrder \[Succeeds]", 519807, 13764},
 {"Proof|ID:1175612329", 520075, 13771},
 {"Proof|ID:1175612329-1", 520239, 13775},
 {"Proof|ID:1604133742", 520401, 13779},
 {"Proof|ID:1604133742-1", 520565, 13783},
 {"Proof|ID:1325269638", 520727, 13787},
 {"Proof|ID:1325269638-1", 520892, 13791},
 {"Proof|ID:1305799953", 521055, 13795},
 {"Proof|ID:1305799953-1", 521219, 13799},
 {"Proof|ID:1675542119", 521381, 13803},
 {"Proof|ID:1675542119-1", 521547, 13807},
 {"Proof|ID:951534856", 521710, 13811},
 {"Proof|ID:951534856-1", 521872, 13815},
 {"Proof|ID:1364381745", 522033, 13819},
 {"Proof|ID:1364381745-1", 522198, 13823},
 {"ID:350830179", 522354, 13827},
 {"LexOrder3 isDomain", 522605, 13834},
 {"ID:1492126708", 522851, 13841},
 {"LexOrder3 isPartReflOrder", 523118, 13848},
 {"ID:448490662", 523372, 13855},
 {"LexOrder3 isPartIrreflOrder", 523641, 13862},
 {"ID:1880074166", 523896, 13869},
 {"LexOrder3 isNoetherian", 524157, 13876},
 {"Proof|ID:350830179", 524414, 13883},
 {"Proof|ID:350830179-1", 524575, 13887},
 {"Proof|ID:1492126708", 524735, 13891},
 {"Proof|ID:1492126708-1", 524900, 13895},
 {"Proof|ID:448490662", 525062, 13899},
 {"Proof|ID:448490662-1", 525223, 13903},
 {"Proof|ID:1880074166", 525383, 13907},
 {"Proof|ID:1880074166-1", 525548, 13911},
 {"ID:1745474933", 525705, 13915},
 {"ID:1629835903", 525925, 13922},
 {"LexOrder3 \[ForAll]", 526186, 13929},
 {"ID:555552062", 526440, 13936},
 {"LexOrder3 \[ForAll] II", 526705, 13943},
 {"ID:628439052", 526960, 13950},
 {"LexOrder3 Noetherian induction", 527248, 13958},
 {"Proof|ID:1629835903", 527525, 13966},
 {"Proof|ID:1629835903-1", 527690, 13970},
 {"Proof|ID:555552062", 527852, 13974},
 {"Proof|ID:555552062-1", 528015, 13978},
 {"Proof|ID:628439052", 528176, 13982},
 {"Proof|ID:628439052-1", 528337, 13986},
 {"ID:1750417022", 528491, 13990},
 {"LexOrderN empty \[Element]", 528767, 13997},
 {"ID:1743969343", 529030, 14004},
 {"LexOrderN empty \[Succeeds]", 529302, 14011},
 {"ID:562382244", 529559, 14018},
 {"ID:1321392049", 529778, 14025},
 {"LexOrderN singleton \[Element]", 530068, 14033},
 {"ID:533732994", 530340, 14041},
 {"LexOrderN ToLexOrder singleton", 530628, 14049},
 {"ID:1826894117", 530899, 14057},
 {"LexOrderN singleton \[Succeeds]", 531183, 14065},
 {"Proof|ID:1750417022", 531455, 14073},
 {"Proof|ID:1750417022-1", 531620, 14077},
 {"Proof|ID:1743969343", 531783, 14081},
 {"Proof|ID:1743969343-1", 531949, 14085},
 {"Proof|ID:1321392049", 532113, 14089},
 {"Proof|ID:1321392049-1", 532278, 14093},
 {"Proof|ID:533732994", 532440, 14097},
 {"Proof|ID:533732994-1", 532602, 14101},
 {"Proof|ID:1826894117", 532763, 14105},
 {"Proof|ID:1826894117-1", 532929, 14109},
 {"ID:415166645", 533086, 14113},
 {"ID:1101966307", 533305, 14120},
 {"ID:639341233", 533525, 14127},
 {"ID:206422078", 533744, 14134},
 {"ID:1296242587", 533964, 14141},
 {"ID:194852796", 534184, 14148},
 {"LexOrderN ToLexOrder \[Element]", 534466, 14156},
 {"Proof|ID:194852796", 534735, 14164},
 {"Proof|ID:194852796-1", 534897, 14168},
 {"ID:1320576944", 535052, 14172},
 {"LexOrderN ToLexOrder \[Succeeds]", 535316, 14179},
 {"ID:1403292599", 535561, 14186},
 {"LexOrderN ToLexOrder injective", 535821, 14193}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 166, 3, 84, "Title",
 CellID->1472320091],
Cell[CellGroupData[{
Cell[770, 29, 116, 2, 73, "Section",
 CellID->909929215],
Cell[CellGroupData[{
Cell[911, 35, 125, 2, 38, "Subsection",
 CellID->304735566],
Cell[1039, 39, 153, 3, 70, "Input",
 CellID->848912120],
Cell[1195, 44, 344, 8, 70, "Input",
 CellID->254769439],
Cell[1542, 54, 386, 9, 70, "Input",
 CellID->34967564],
Cell[1931, 65, 305, 8, 70, "Input",
 CellID->242592210],
Cell[2239, 75, 353, 8, 70, "Input",
 CellID->268120864],
Cell[2595, 85, 155, 3, 70, "Input",
 CellID->307882976],
Cell[2753, 90, 157, 3, 70, "Input",
 CellID->634255394]
}, Closed]],
Cell[CellGroupData[{
Cell[2947, 98, 124, 2, 30, "Subsection",
 CellID->1386333768],
Cell[CellGroupData[{
Cell[3096, 104, 584, 17, 70, "Input",
 CellID->239327779],
Cell[CellGroupData[{
Cell[3705, 125, 614, 13, 70, "Print",
 CellID->231074188],
Cell[4322, 140, 318, 7, 70, "Print",
 CellID->235399543],
Cell[4643, 149, 609, 13, 70, "Print",
 CellID->74228564],
Cell[5255, 164, 581, 12, 70, "Print",
 CellID->52740732],
Cell[5839, 178, 316, 7, 70, "Print",
 CellID->174797361],
Cell[6158, 187, 588, 12, 70, "Print",
 CellID->189035512],
Cell[6749, 201, 318, 7, 70, "Print",
 CellID->173771855],
Cell[7070, 210, 598, 12, 70, "Print",
 CellID->319542108],
Cell[7671, 224, 318, 7, 70, "Print",
 CellID->303606234],
Cell[7992, 233, 321, 7, 70, "Print",
 CellID->57640752],
Cell[8316, 242, 324, 7, 70, "Print",
 CellID->134635643],
Cell[8643, 251, 324, 7, 70, "Print",
 CellID->406213841],
Cell[8970, 260, 589, 12, 70, "Print",
 CellID->69157529],
Cell[9562, 274, 318, 7, 70, "Print",
 CellID->492543894],
Cell[9883, 283, 318, 7, 70, "Print",
 CellID->473149805],
Cell[10204, 292, 582, 12, 70, "Print",
 CellID->253932889],
Cell[10789, 306, 318, 7, 70, "Print",
 CellID->117224106],
Cell[11110, 315, 322, 7, 70, "Print",
 CellID->107200411],
Cell[11435, 324, 324, 7, 70, "Print",
 CellID->241953319],
Cell[11762, 333, 592, 12, 70, "Print",
 CellID->122444630],
Cell[12357, 347, 320, 7, 70, "Print",
 CellID->806172405],
Cell[12680, 356, 322, 7, 70, "Print",
 CellID->356623074],
Cell[13005, 365, 320, 7, 70, "Print",
 CellID->1502692],
Cell[13328, 374, 321, 7, 70, "Print",
 CellID->46282536],
Cell[13652, 383, 322, 7, 70, "Print",
 CellID->171440827],
Cell[13977, 392, 323, 7, 70, "Print",
 CellID->62930444],
Cell[14303, 401, 321, 7, 70, "Print",
 CellID->92091199],
Cell[14627, 410, 603, 13, 70, "Print",
 CellID->140574753],
Cell[15233, 425, 320, 7, 70, "Print",
 CellID->112619049],
Cell[15556, 434, 321, 7, 70, "Print",
 CellID->21818011],
Cell[15880, 443, 322, 7, 70, "Print",
 CellID->434096050],
Cell[16205, 452, 322, 7, 70, "Print",
 CellID->156161373],
Cell[16530, 461, 322, 7, 70, "Print",
 CellID->267176890],
Cell[16855, 470, 589, 12, 70, "Print",
 CellID->64091394],
Cell[17447, 484, 314, 7, 70, "Print",
 CellID->5691558],
Cell[17764, 493, 584, 12, 70, "Print",
 CellID->186593265],
Cell[18351, 507, 317, 7, 70, "Print",
 CellID->34313527],
Cell[18671, 516, 317, 7, 70, "Print",
 CellID->118518],
Cell[18991, 525, 322, 7, 70, "Print",
 CellID->319115275],
Cell[19316, 534, 322, 7, 70, "Print",
 CellID->693325999],
Cell[19641, 543, 118, 2, 70, "Print",
 CellID->106341091],
Cell[19762, 547, 108, 2, 70, "Print",
 CellID->103393720],
Cell[19873, 551, 312, 7, 70, "Print",
 CellID->324871125],
Cell[20188, 560, 311, 7, 70, "Print",
 CellID->61897625],
Cell[20502, 569, 314, 7, 70, "Print",
 CellID->230972936],
Cell[20819, 578, 314, 7, 70, "Print",
 CellID->157118787],
Cell[21136, 587, 314, 7, 70, "Print",
 CellID->435797633],
Cell[21453, 596, 314, 7, 70, "Print",
 CellID->174803739],
Cell[21770, 605, 314, 7, 70, "Print",
 CellID->370066886],
Cell[22087, 614, 313, 7, 70, "Print",
 CellID->25912622],
Cell[22403, 623, 314, 7, 70, "Print",
 CellID->180366616],
Cell[22720, 632, 314, 7, 70, "Print",
 CellID->534735304],
Cell[23037, 641, 314, 7, 70, "Print",
 CellID->230748884],
Cell[23354, 650, 316, 7, 70, "Print",
 CellID->124731382],
Cell[23673, 659, 316, 7, 70, "Print",
 CellID->756925856],
Cell[23992, 668, 316, 7, 70, "Print",
 CellID->593677906],
Cell[24311, 677, 316, 7, 70, "Print",
 CellID->164174786],
Cell[24630, 686, 316, 7, 70, "Print",
 CellID->478359904],
Cell[24949, 695, 313, 7, 70, "Print",
 CellID->82331956],
Cell[25265, 704, 313, 7, 70, "Print",
 CellID->34366134],
Cell[25581, 713, 313, 7, 70, "Print",
 CellID->56164485],
Cell[25897, 722, 313, 7, 70, "Print",
 CellID->683135210],
Cell[26213, 731, 313, 7, 70, "Print",
 CellID->127805],
Cell[26529, 740, 315, 7, 70, "Print",
 CellID->51646120],
Cell[26847, 749, 318, 7, 70, "Print",
 CellID->165867777],
Cell[27168, 758, 316, 7, 70, "Print",
 CellID->266526958],
Cell[27487, 767, 315, 7, 70, "Print",
 CellID->407414415],
Cell[27805, 776, 316, 7, 70, "Print",
 CellID->308206403],
Cell[28124, 785, 316, 7, 70, "Print",
 CellID->135952013],
Cell[28443, 794, 316, 7, 70, "Print",
 CellID->315920781],
Cell[28762, 803, 318, 7, 70, "Print",
 CellID->151317848],
Cell[29083, 812, 318, 7, 70, "Print",
 CellID->500119495],
Cell[29404, 821, 318, 7, 70, "Print",
 CellID->458982690],
Cell[29725, 830, 318, 7, 70, "Print",
 CellID->359534940],
Cell[30046, 839, 318, 7, 70, "Print",
 CellID->120613399],
Cell[30367, 848, 318, 7, 70, "Print",
 CellID->114102864],
Cell[30688, 857, 315, 7, 70, "Print",
 CellID->149819274],
Cell[31006, 866, 318, 7, 70, "Print",
 CellID->304159966],
Cell[31327, 875, 317, 7, 70, "Print",
 CellID->87983146],
Cell[31647, 884, 318, 7, 70, "Print",
 CellID->674154617],
Cell[31968, 893, 318, 7, 70, "Print",
 CellID->138442590],
Cell[32289, 902, 315, 7, 70, "Print",
 CellID->42611772],
Cell[32607, 911, 316, 7, 70, "Print",
 CellID->242925013],
Cell[32926, 920, 121, 2, 70, "Print",
 CellID->174649905],
Cell[33050, 924, 100, 2, 70, "Print",
 CellID->334581406]
}, Open  ]]
}, Closed]],
Cell[33177, 930, 178, 4, 70, "Input",
 CellID->2077551358],
Cell[CellGroupData[{
Cell[33380, 938, 541, 12, 70, "Input",
 CellID->1909803754],
Cell[33924, 952, 894, 16, 70, "Output",
 CellID->1365249879]
}, Open  ]],
Cell[34833, 971, 589, 16, 70, "Input",
 CellID->1780799392],
Cell[CellGroupData[{
Cell[35447, 991, 498, 12, 70, "Input",
 CellID->63220416],
Cell[35948, 1005, 112, 2, 70, "Output",
 CellID->13465628]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[36109, 1013, 128, 2, 30, "Subsection",
 CellID->1454182661],
Cell[36240, 1017, 983, 25, 70, "Input",
 CellID->2074904605],
Cell[37226, 1044, 416, 9, 70, "Input",
 CellID->1980565193],
Cell[37645, 1055, 169, 3, 70, "Input",
 CellID->444074165],
Cell[37817, 1060, 333, 6, 70, "Input",
 CellID->584704106]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[38199, 1072, 238, 4, 43, "Section",
 CellID->284088374],
Cell[CellGroupData[{
Cell[38462, 1080, 191, 3, 38, "Subsection",
 CellID->107685530],
Cell[CellGroupData[{
Cell[38678, 1087, 126, 2, 28, "Subsubsection",
 CellID->515936865],
Cell[38807, 1091, 47, 1, 12, "OpenEnvironment",
 CellID->400670803],
Cell[CellGroupData[{
Cell[38879, 1096, 436, 10, 43, "EnvironmentHeader",
 CellID->403870778],
Cell[39318, 1108, 673, 18, 31, "GlobalDeclaration",
 CellTags->{
  "ID:13590416", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->13590416],
Cell[39994, 1128, 737, 19, 30, "GlobalDeclaration",
 CellTags->{
  "ID:52891026", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->52891026],
Cell[40734, 1149, 618, 16, 30, "GlobalDeclaration",
 CellTags->{
  "ID:556284720", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->556284720],
Cell[41355, 1167, 1916, 62, 93, "FormalTextInputFormula",
 CellTags->{
  "ID:172182433", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element]"},
 CellID->172182433],
Cell[43274, 1231, 1426, 48, 39, "FormalTextInputFormula",
 CellTags->{
  "ID:96567293", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain parsing"},
 CellID->96567293],
Cell[44703, 1281, 1376, 43, 39, "FormalTextInputFormula",
 CellTags->{
  "ID:666017826", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain printing"},
 CellID->666017826],
Cell[46082, 1326, 65, 1, 26, "EndEnvironmentMarker",
 CellID->154080212]
}, Open  ]],
Cell[46162, 1330, 48, 1, 16, "CloseEnvironment",
 CellID->166200272]
}, Closed]],
Cell[CellGroupData[{
Cell[46247, 1336, 185, 3, 22, "Subsubsection",
 CellID->430264024],
Cell[46435, 1341, 47, 1, 70, "OpenEnvironment",
 CellID->166969519],
Cell[CellGroupData[{
Cell[46507, 1346, 433, 11, 70, "EnvironmentHeader",
 CellID->496003494],
Cell[46943, 1359, 692, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:43183279", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->43183279],
Cell[47638, 1379, 769, 20, 70, "GlobalDeclaration",
 CellTags->{
  "ID:501919234", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->501919234],
Cell[48410, 1401, 1515, 45, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:177079530", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element] alternative", "IR"},
 CellID->177079530],
Cell[49928, 1448, 1422, 42, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:160393105", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element] alternative II"},
 CellID->160393105],
Cell[51353, 1492, 1483, 44, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:666612949", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain \[Element] alternative III"},
 CellID->666612949],
Cell[52839, 1538, 1043, 30, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:15990241", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "ProdDomain isDomain"},
 CellID->15990241],
Cell[53885, 1570, 64, 1, 70, "EndEnvironmentMarker",
 CellID->85772654]
}, Open  ]],
Cell[53964, 1574, 48, 1, 70, "CloseEnvironment",
 CellID->280940150],
Cell[CellGroupData[{
Cell[54037, 1579, 4689, 120, 70, "ProofInfo",
 CellTags->{"Proof|ID:177079530", "Proof|ID:177079530-1"},
 CellID->222181063],
Cell[58729, 1701, 479, 12, 70, "ProofInfoBody",
 CellID->21994795]
}, Closed]],
Cell[CellGroupData[{
Cell[59245, 1718, 4584, 118, 70, "ProofInfo",
 CellTags->{"Proof|ID:160393105", "Proof|ID:160393105-1"},
 CellID->175723293],
Cell[63832, 1838, 479, 12, 70, "ProofInfoBody",
 CellID->70824576]
}, Closed]],
Cell[CellGroupData[{
Cell[64348, 1855, 4719, 122, 70, "ProofInfo",
 CellTags->{"Proof|ID:666612949", "Proof|ID:666612949-1"},
 CellID->159422770],
Cell[69070, 1979, 480, 12, 70, "ProofInfoBody",
 CellID->684344276]
}, Closed]],
Cell[CellGroupData[{
Cell[69587, 1996, 3242, 88, 70, "ProofInfo",
 CellTags->{"Proof|ID:15990241", "Proof|ID:15990241-1"},
 CellID->486730789],
Cell[72832, 2086, 478, 12, 70, "ProofInfoBody",
 CellID->83158492]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[73371, 2105, 220, 3, 30, "Subsection",
 CellID->583495173],
Cell[CellGroupData[{
Cell[73616, 2112, 122, 2, 28, "Subsubsection",
 CellID->477730874],
Cell[73741, 2116, 47, 1, 70, "OpenEnvironment",
 CellID->949427984],
Cell[CellGroupData[{
Cell[73813, 2121, 390, 9, 70, "EnvironmentHeader",
 CellID->2055575223],
Cell[74206, 2132, 1049, 32, 70, "GlobalDeclaration",
 CellTags->{
  "ID:131627256", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->131627256],
Cell[75258, 2166, 1322, 38, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1252521910", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1252521910],
Cell[76583, 2206, 682, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:483943613", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->483943613],
Cell[77268, 2225, 1937, 62, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:415499872", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element]"},
 CellID->415499872],
Cell[79208, 2289, 1935, 58, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1592061526", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Succeeds]"},
 CellID->1592061526],
Cell[81146, 2349, 1309, 41, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:660280664", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Precedes]"},
 CellID->660280664],
Cell[82458, 2392, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1788854642]
}, Open  ]],
Cell[82539, 2396, 48, 1, 70, "CloseEnvironment",
 CellID->113858470],
Cell[82590, 2399, 47, 1, 70, "OpenEnvironment",
 CellID->544818500],
Cell[CellGroupData[{
Cell[82662, 2404, 393, 9, 70, "EnvironmentHeader",
 CellID->765032411],
Cell[83058, 2415, 1340, 43, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1203319602", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1203319602],
Cell[84401, 2460, 1624, 48, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1155548854", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1155548854],
Cell[86028, 2510, 759, 20, 70, "GlobalDeclaration",
 CellTags->{
  "ID:268596668", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->268596668],
Cell[86790, 2532, 2048, 66, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:143611979", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element]"},
 CellID->143611979],
Cell[88841, 2600, 2751, 79, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1082760072", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Succeeds]"},
 CellID->1082760072],
Cell[91595, 2681, 1342, 42, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:2039496926", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Precedes]"},
 CellID->2039496926],
Cell[92940, 2725, 970, 27, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1528170763", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder"},
 CellID->1528170763],
Cell[93913, 2754, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1205354934]
}, Open  ]],
Cell[93994, 2758, 48, 1, 70, "CloseEnvironment",
 CellID->363305525],
Cell[94045, 2761, 47, 1, 70, "OpenEnvironment",
 CellID->137661402],
Cell[CellGroupData[{
Cell[94117, 2766, 393, 9, 70, "EnvironmentHeader",
 CellID->247405329],
Cell[94513, 2777, 753, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1177571532", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1177571532],
Cell[95269, 2797, 722, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1157453212", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1157453212],
Cell[95994, 2817, 712, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1901627231", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1901627231],
Cell[96709, 2837, 2168, 68, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:475599841", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN \[Element]"},
 CellID->475599841],
Cell[98880, 2907, 2412, 76, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1975055247", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN \[Succeeds]"},
 CellID->1975055247],
Cell[101295, 2985, 1233, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:715152506", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN \[Precedes]"},
 CellID->715152506],
Cell[102531, 3027, 966, 27, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1361950489", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder"},
 CellID->1361950489],
Cell[103500, 3056, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1530801336]
}, Open  ]],
Cell[103581, 3060, 49, 1, 70, "CloseEnvironment",
 CellID->1847880814]
}, Closed]],
Cell[CellGroupData[{
Cell[103667, 3066, 267, 4, 22, "Subsubsection",
 CellID->1322241940],
Cell[103937, 3072, 1008, 32, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1394564787", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1394564787],
Cell[104948, 3106, 36, 1, 70, "Text",
 CellID->710111611],
Cell[104987, 3109, 1294, 39, 70, "GlobalDeclaration",
 CellTags->{
  "ID:56619207", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->56619207],
Cell[106284, 3150, 48, 1, 70, "OpenEnvironment",
 CellID->2089569634],
Cell[CellGroupData[{
Cell[106357, 3155, 518, 13, 70, "EnvironmentHeader",
 CellID->1280486604],
Cell[106878, 3170, 1500, 45, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:625854003", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element] alternative"},
 CellID->625854003],
Cell[108381, 3217, 1421, 42, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1695764024", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element] alternative II"},
 CellID->1695764024],
Cell[109805, 3261, 1517, 44, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:998703597", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder \[Element] alternative III"},
 CellID->998703597],
Cell[111325, 3307, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1220874263]
}, Open  ]],
Cell[111406, 3311, 49, 1, 70, "CloseEnvironment",
 CellID->1962097428],
Cell[CellGroupData[{
Cell[111480, 3316, 5729, 139, 70, "ProofInfo",
 CellTags->{"Proof|ID:625854003", "Proof|ID:625854003-1"},
 CellID->535822348],
Cell[117212, 3457, 479, 12, 70, "ProofInfoBody",
 CellID->31038819]
}, Closed]],
Cell[CellGroupData[{
Cell[117728, 3474, 5626, 138, 70, "ProofInfo",
 CellTags->{"Proof|ID:1695764024", "Proof|ID:1695764024-1"},
 CellID->1504850255],
Cell[123357, 3614, 481, 12, 70, "ProofInfoBody",
 CellID->328565073]
}, Closed]],
Cell[CellGroupData[{
Cell[123875, 3631, 5760, 142, 70, "ProofInfo",
 CellTags->{"Proof|ID:998703597", "Proof|ID:998703597-1"},
 CellID->1420174462],
Cell[129638, 3775, 480, 12, 70, "ProofInfoBody",
 CellID->425113255]
}, Closed]],
Cell[130133, 3790, 47, 1, 70, "OpenEnvironment",
 CellID->460107632],
Cell[CellGroupData[{
Cell[130205, 3795, 597, 12, 70, "EnvironmentHeader",
 CellID->380364038],
Cell[130805, 3809, 1039, 30, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:83506562", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isDomain"},
 CellID->83506562],
Cell[131847, 3841, 416, 12, 70, "EnvironmentText",
 CellID->1205862328],
Cell[132266, 3855, 1311, 41, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1564408474", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isReflexive"},
 CellID->1564408474],
Cell[133580, 3898, 1674, 56, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:993421296", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isAntisymmetric"},
 CellID->993421296],
Cell[135257, 3956, 1705, 56, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:762792695", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isAsymmetric"},
 CellID->762792695],
Cell[136965, 4014, 484, 13, 70, "EnvironmentText",
 CellID->1111685493],
Cell[137452, 4029, 2082, 67, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:365362652", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isTransitive"},
 CellID->365362652],
Cell[139537, 4098, 1676, 56, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:676617813", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isPartReflOrder"},
 CellID->676617813],
Cell[141216, 4156, 1753, 57, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:419051997", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isPartIrreflOrder"},
 CellID->419051997],
Cell[142972, 4215, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1329393950]
}, Open  ]],
Cell[143053, 4219, 48, 1, 70, "CloseEnvironment",
 CellID->181543040],
Cell[CellGroupData[{
Cell[143126, 4224, 4361, 112, 70, "ProofInfo",
 CellTags->{"Proof|ID:83506562", "Proof|ID:83506562-1"},
 CellID->19037723],
Cell[147490, 4338, 479, 12, 70, "ProofInfoBody",
 CellID->547232171]
}, Closed]],
Cell[CellGroupData[{
Cell[148006, 4355, 5786, 141, 70, "ProofInfo",
 CellTags->{"Proof|ID:1564408474", "Proof|ID:1564408474-1"},
 CellID->957699202],
Cell[153795, 4498, 482, 12, 70, "ProofInfoBody",
 CellID->1999361680]
}, Closed]],
Cell[CellGroupData[{
Cell[154314, 4515, 6338, 152, 70, "ProofInfo",
 CellTags->{"Proof|ID:993421296", "Proof|ID:993421296-1"},
 CellID->1133214309],
Cell[160655, 4669, 480, 12, 70, "ProofInfoBody",
 CellID->919634829]
}, Closed]],
Cell[CellGroupData[{
Cell[161172, 4686, 6313, 152, 70, "ProofInfo",
 CellTags->{"Proof|ID:762792695", "Proof|ID:762792695-1"},
 CellID->650701467],
Cell[167488, 4840, 480, 12, 70, "ProofInfoBody",
 CellID->740493969]
}, Closed]],
Cell[CellGroupData[{
Cell[168005, 4857, 6782, 162, 70, "ProofInfo",
 CellTags->{"Proof|ID:365362652", "Proof|ID:365362652-1"},
 CellID->2129721589],
Cell[174790, 5021, 480, 12, 70, "ProofInfoBody",
 CellID->292129237]
}, Closed]],
Cell[CellGroupData[{
Cell[175307, 5038, 6337, 152, 70, "ProofInfo",
 CellTags->{"Proof|ID:676617813", "Proof|ID:676617813-1"},
 CellID->665767943],
Cell[181647, 5192, 480, 12, 70, "ProofInfoBody",
 CellID->782217123]
}, Closed]],
Cell[CellGroupData[{
Cell[182164, 5209, 6353, 152, 70, "ProofInfo",
 CellTags->{"Proof|ID:419051997", "Proof|ID:419051997-1"},
 CellID->939925669],
Cell[188520, 5363, 480, 12, 70, "ProofInfoBody",
 CellID->394715092]
}, Closed]],
Cell[189015, 5378, 47, 1, 70, "OpenEnvironment",
 CellID->165977954],
Cell[CellGroupData[{
Cell[189087, 5383, 456, 12, 70, "EnvironmentHeader",
 CellID->970343590],
Cell[189546, 5397, 1705, 56, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:318639340", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder isNoetherian"},
 CellID->318639340],
Cell[191254, 5455, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1461366415]
}, Open  ]],
Cell[191335, 5459, 48, 1, 70, "CloseEnvironment",
 CellID->186632542],
Cell[CellGroupData[{
Cell[191408, 5464, 6312, 152, 70, "ProofInfo",
 CellTags->{"Proof|ID:318639340", "Proof|ID:318639340-1"},
 CellID->14707961],
Cell[197723, 5618, 548, 13, 70, "ProofInfoBody",
 CellID->565402786]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[198320, 5637, 269, 4, 22, "Subsubsection",
 CellID->2108979739],
Cell[198592, 5643, 1292, 43, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1694786048", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1694786048],
Cell[199887, 5688, 36, 1, 70, "Text",
 CellID->242619498],
Cell[199926, 5691, 1606, 48, 70, "GlobalDeclaration",
 CellTags->{
  "ID:335763124", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->335763124],
Cell[201535, 5741, 48, 1, 70, "OpenEnvironment",
 CellID->1897726089],
Cell[CellGroupData[{
Cell[201608, 5746, 511, 12, 70, "EnvironmentHeader",
 CellID->1053581462],
Cell[202122, 5760, 756, 20, 70, "GlobalDeclaration",
 CellTags->{
  "ID:789393137", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->789393137],
Cell[202881, 5782, 1777, 51, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1175612329", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element] alternative"},
 CellID->1175612329],
Cell[204661, 5835, 1447, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1604133742", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element] alternative II"},
 CellID->1604133742],
Cell[206111, 5877, 1533, 45, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1325269638", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[Element] alternative III"},
 CellID->1325269638],
Cell[207647, 5924, 1179, 32, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1305799953", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder alternative", "IR"},
 CellID->1305799953],
Cell[208829, 5958, 1350, 39, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1675542119", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder injective"},
 CellID->1675542119],
Cell[210182, 5999, 1286, 38, 70, "GlobalDeclaration",
 CellTags->{
  "ID:659473488", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->659473488],
Cell[211471, 6039, 1652, 48, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:951534856", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder \[Element]"},
 CellID->951534856],
Cell[213126, 6089, 2121, 61, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1364381745", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 ToLexOrder \[Succeeds]"},
 CellID->1364381745],
Cell[215250, 6152, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1459892258]
}, Open  ]],
Cell[215331, 6156, 48, 1, 70, "CloseEnvironment",
 CellID->926689034],
Cell[CellGroupData[{
Cell[215404, 6161, 7326, 168, 70, "ProofInfo",
 CellTags->{"Proof|ID:1175612329", "Proof|ID:1175612329-1"},
 CellID->186855576],
Cell[222733, 6331, 482, 12, 70, "ProofInfoBody",
 CellID->1804105431]
}, Closed]],
Cell[CellGroupData[{
Cell[223252, 6348, 7081, 165, 70, "ProofInfo",
 CellTags->{"Proof|ID:1604133742", "Proof|ID:1604133742-1"},
 CellID->593724936],
Cell[230336, 6515, 480, 12, 70, "ProofInfoBody",
 CellID->82900886]
}, Closed]],
Cell[CellGroupData[{
Cell[230853, 6532, 7341, 173, 70, "ProofInfo",
 CellTags->{"Proof|ID:1325269638", "Proof|ID:1325269638-1"},
 CellID->2061926766],
Cell[238197, 6707, 482, 12, 70, "ProofInfoBody",
 CellID->1181888230]
}, Closed]],
Cell[CellGroupData[{
Cell[238716, 6724, 8165, 190, 70, "ProofInfo",
 CellTags->{"Proof|ID:1305799953", "Proof|ID:1305799953-1"},
 CellID->259168266],
Cell[246884, 6916, 481, 12, 70, "ProofInfoBody",
 CellID->109259321]
}, Closed]],
Cell[CellGroupData[{
Cell[247402, 6933, 12000, 268, 70, "ProofInfo",
 CellTags->{"Proof|ID:1675542119", "Proof|ID:1675542119-1"},
 CellID->1614785598],
Cell[259405, 7203, 482, 12, 70, "ProofInfoBody",
 CellID->1306217654]
}, Closed]],
Cell[CellGroupData[{
Cell[259924, 7220, 11059, 247, 70, "ProofInfo",
 CellTags->{"Proof|ID:951534856", "Proof|ID:951534856-1"},
 CellID->277734451],
Cell[270986, 7469, 480, 12, 70, "ProofInfoBody",
 CellID->695240427]
}, Closed]],
Cell[CellGroupData[{
Cell[271503, 7486, 18017, 394, 70, "ProofInfo",
 CellTags->{"Proof|ID:1364381745", "Proof|ID:1364381745-1"},
 CellID->465277495],
Cell[289523, 7882, 482, 12, 70, "ProofInfoBody",
 CellID->1693369290]
}, Closed]],
Cell[290020, 7897, 48, 1, 70, "OpenEnvironment",
 CellID->1393992124],
Cell[CellGroupData[{
Cell[290093, 7902, 520, 12, 70, "EnvironmentHeader",
 CellID->981198618],
Cell[290616, 7916, 1112, 31, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:350830179", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isDomain"},
 CellID->350830179],
Cell[291731, 7949, 1883, 62, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1492126708", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isPartReflOrder"},
 CellID->1492126708],
Cell[293617, 8013, 1894, 62, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:448490662", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isPartIrreflOrder"},
 CellID->448490662],
Cell[295514, 8077, 1865, 62, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1880074166", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 isNoetherian"},
 CellID->1880074166],
Cell[297382, 8141, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1190944264]
}, Open  ]],
Cell[297463, 8145, 49, 1, 70, "CloseEnvironment",
 CellID->1107192474],
Cell[CellGroupData[{
Cell[297537, 8150, 5541, 134, 70, "ProofInfo",
 CellTags->{"Proof|ID:350830179", "Proof|ID:350830179-1"},
 CellID->359925756],
Cell[303081, 8286, 479, 12, 70, "ProofInfoBody",
 CellID->94159074]
}, Closed]],
Cell[CellGroupData[{
Cell[303597, 8303, 8371, 191, 70, "ProofInfo",
 CellTags->{"Proof|ID:1492126708", "Proof|ID:1492126708-1"},
 CellID->2037194359],
Cell[311971, 8496, 481, 12, 70, "ProofInfoBody",
 CellID->150732688]
}, Closed]],
Cell[CellGroupData[{
Cell[312489, 8513, 8381, 190, 70, "ProofInfo",
 CellTags->{"Proof|ID:448490662", "Proof|ID:448490662-1"},
 CellID->259882569],
Cell[320873, 8705, 480, 12, 70, "ProofInfoBody",
 CellID->698127626]
}, Closed]],
Cell[CellGroupData[{
Cell[321390, 8722, 8341, 191, 70, "ProofInfo",
 CellTags->{"Proof|ID:1880074166", "Proof|ID:1880074166-1"},
 CellID->1837575531],
Cell[329734, 8915, 481, 12, 70, "ProofInfoBody",
 CellID->699513794]
}, Closed]],
Cell[330230, 8930, 47, 1, 70, "OpenEnvironment",
 CellID->467060496],
Cell[CellGroupData[{
Cell[330302, 8935, 408, 10, 70, "EnvironmentHeader",
 CellID->2006149543],
Cell[330713, 8947, 710, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1745474933", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1745474933],
Cell[331426, 8967, 2091, 65, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1629835903", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[ForAll]", "IR"},
 CellID->1629835903],
Cell[333520, 9034, 2234, 70, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:555552062", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 \[ForAll] II", "IR"},
 CellID->555552062],
Cell[335757, 9106, 3887, 114, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:628439052", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrder3 Noetherian induction", "IR"},
 CellID->628439052],
Cell[339647, 9222, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1946547022]
}, Open  ]],
Cell[339728, 9226, 49, 1, 70, "CloseEnvironment",
 CellID->1624022479],
Cell[CellGroupData[{
Cell[339802, 9231, 9347, 211, 70, "ProofInfo",
 CellTags->{"Proof|ID:1629835903", "Proof|ID:1629835903-1"},
 CellID->1507488488],
Cell[349152, 9444, 482, 12, 70, "ProofInfoBody",
 CellID->1198879348]
}, Closed]],
Cell[CellGroupData[{
Cell[349671, 9461, 10050, 226, 70, "ProofInfo",
 CellTags->{"Proof|ID:555552062", "Proof|ID:555552062-1"},
 CellID->1496219234],
Cell[359724, 9689, 480, 12, 70, "ProofInfoBody",
 CellID->603715255]
}, Closed]],
Cell[CellGroupData[{
Cell[360241, 9706, 20450, 435, 70, "ProofInfo",
 CellTags->{"Proof|ID:628439052", "Proof|ID:628439052-1"},
 CellID->16324577],
Cell[380694, 10143, 479, 12, 70, "ProofInfoBody",
 CellID->10755916]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[381222, 10161, 242, 4, 22, "Subsubsection",
 CellID->1621146162],
Cell[381467, 10167, 47, 1, 12, "OpenEnvironment",
 CellID->790435182],
Cell[CellGroupData[{
Cell[381539, 10172, 759, 24, 43, "EnvironmentHeader",
 CellID->614809765],
Cell[382301, 10198, 1433, 44, 41, "FormalTextInputFormula",
 CellTags->{
  "ID:1750417022", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN empty \[Element]", "IR"},
 CellID->1750417022],
Cell[383737, 10244, 1291, 38, 53, "FormalTextInputFormula",
 CellTags->{
  "ID:1743969343", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN empty \[Succeeds]"},
 CellID->1743969343],
Cell[385031, 10284, 829, 22, 48, "GlobalDeclaration",
 CellTags->{
  "ID:562382244", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->562382244],
Cell[385863, 10308, 1820, 58, 41, "FormalTextInputFormula",
 CellTags->{
  "ID:1321392049", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN singleton \[Element]", "IR"},
 CellID->1321392049],
Cell[387686, 10368, 1577, 46, 52, "FormalTextInputFormula",
 CellTags->{
  "ID:533732994", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder singleton", "IR"},
 CellID->533732994],
Cell[389266, 10416, 1958, 62, 53, "FormalTextInputFormula",
 CellTags->{
  "ID:1826894117", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN singleton \[Succeeds]"},
 CellID->1826894117],
Cell[391227, 10480, 65, 1, 26, "EndEnvironmentMarker",
 CellID->729757556]
}, Open  ]],
Cell[391307, 10484, 47, 1, 16, "CloseEnvironment",
 CellID->30441166],
Cell[CellGroupData[{
Cell[391379, 10489, 3018, 89, 28, "ProofInfo",
 CellTags->{"Proof|ID:1750417022", "Proof|ID:1750417022-1"},
 CellID->1480567573],
Cell[394400, 10580, 482, 12, 70, "ProofInfoBody",
 CellID->1683959206]
}, Closed]],
Cell[CellGroupData[{
Cell[394919, 10597, 3878, 106, 26, "ProofInfo",
 CellTags->{"Proof|ID:1743969343", "Proof|ID:1743969343-1"},
 CellID->1693726967],
Cell[398800, 10705, 482, 12, 70, "ProofInfoBody",
 CellID->2062993410]
}, Closed]],
Cell[CellGroupData[{
Cell[399319, 10722, 4932, 126, 26, "ProofInfo",
 CellTags->{"Proof|ID:1321392049", "Proof|ID:1321392049-1"},
 CellID->539924176],
Cell[404254, 10850, 481, 12, 70, "ProofInfoBody",
 CellID->497987145]
}, Closed]],
Cell[CellGroupData[{
Cell[404772, 10867, 4588, 116, 26, "ProofInfo",
 CellTags->{"Proof|ID:533732994", "Proof|ID:533732994-1"},
 CellID->814775281],
Cell[409363, 10985, 481, 12, 70, "ProofInfoBody",
 CellID->1352481777]
}, Closed]],
Cell[CellGroupData[{
Cell[409881, 11002, 6381, 158, 26, "ProofInfo",
 CellTags->{"Proof|ID:1826894117", "Proof|ID:1826894117-1"},
 CellID->1194249226],
Cell[416265, 11162, 481, 12, 70, "ProofInfoBody",
 CellID->178546167]
}, Closed]],
Cell[416761, 11177, 47, 1, 12, "OpenEnvironment",
 CellID->442664140],
Cell[CellGroupData[{
Cell[416833, 11182, 462, 11, 43, "EnvironmentHeader",
 CellID->1956082993],
Cell[417298, 11195, 867, 20, 33, "GlobalDeclaration",
 CellTags->{
  "ID:415166645", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->415166645],
Cell[418168, 11217, 743, 19, 23, "GlobalDeclaration",
 CellTags->{
  "ID:1101966307", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1101966307],
Cell[418914, 11238, 1452, 38, 55, "GlobalDeclaration",
 CellTags->{
  "ID:639341233", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->639341233],
Cell[420369, 11278, 1300, 37, 33, "GlobalDeclaration",
 CellTags->{
  "ID:206422078", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->206422078],
Cell[421672, 11317, 755, 20, 42, "GlobalDeclaration",
 CellTags->{
  "ID:1296242587", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb"},
 
 CellID->1296242587],
Cell[422430, 11339, 1184, 31, 37, "FormalTextInputFormula",
 CellTags->{
  "ID:194852796", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder \[Element]"},
 CellID->194852796],
Cell[423617, 11372, 65, 1, 26, "EndEnvironmentMarker",
 CellID->676400811]
}, Open  ]],
Cell[423697, 11376, 49, 1, 16, "CloseEnvironment",
 CellID->1779467229],
Cell[CellGroupData[{
Cell[423771, 11381, 7821, 189, 28, "ProofInfo",
 CellTags->{"Proof|ID:194852796", "Proof|ID:194852796-1"},
 CellID->210990893],
Cell[431595, 11572, 479, 12, 70, "ProofInfoBody",
 CellID->34034514]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[432123, 11590, 182, 3, 22, "Subsubsection",
 CellID->36056484],
Cell[432308, 11595, 1560, 44, 45, "Text",
 CellTags->{
  "ID:1320576944", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder \[Succeeds]"},
 CellID->1320576944],
Cell[433871, 11641, 1216, 38, 39, "Text",
 CellTags->{
  "ID:1403292599", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Functors.nb", 
   "LexOrderN ToLexOrder injective"},
 CellID->1403292599]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
