(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    672269,      18151]
NotebookOptionsPosition[    500939,      13645]
NotebookOutlinePosition[    626189,      16783]
CellTagsIndexPosition[    616594,      16533]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Infinite Sequences", "Title",
 CellChangeTimes->{{3.655448324260866*^9, 3.655448327505672*^9}},
 CellID->312331020],

Cell[CellGroupData[{

Cell["Preliminaries", "Section",
 CellChangeTimes->{{3.6443084245106*^9, 3.644308427083333*^9}},
 CellID->909929215],

Cell[CellGroupData[{

Cell["Theory Packages", "Subsection",
 CellChangeTimes->{{3.6564866805403986`*^9, 3.656486682974003*^9}},
 CellID->332720151],

Cell[BoxData[
 RowBox[{"$PackageDirectory", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
    "$RootDirectory", ",", "\"\<scratch\>\"", ",", "\"\<amaletzk\>\"", ",", 
     "\"\<Theorema Environment Data\>\""}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.666438783233775*^9, 3.666438821083324*^9}},
 CellID->498486718],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{"$PackageDirectory", ",", "\"\<LogicSets.m\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.656675573019778*^9, 3.6566755911314096`*^9}, 
   3.666439454184341*^9},
 CellID->92407312],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{"$PackageDirectory", ",", "\"\<NatInt.m\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.656675573019778*^9, 3.6566755911314096`*^9}, {
   3.658641645717029*^9, 3.658641646809031*^9}, 3.6664394554862757`*^9},
 CellID->65743246],

Cell[BoxData[
 RowBox[{"LoadTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.65648668712361*^9, 3.6564866934416213`*^9}},
 CellID->5767244],

Cell[BoxData[
 RowBox[{"MakeTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6554581496366425`*^9, 3.655458153349449*^9}},
 CellID->67977463],

Cell[BoxData[
 RowBox[{"UpdateTheoryPackage", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6554581496366425`*^9, 3.655458153349449*^9}, {
  3.6566757544636965`*^9, 3.6566757553528976`*^9}},
 CellID->262499848]
}, Closed]],

Cell[CellGroupData[{

Cell["Theory Analysis", "Subsection",
 CellChangeTimes->{{3.640668830437483*^9, 3.640668834318727*^9}},
 CellID->1386333768],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AnalyzeProofs", "[", "\"\<Theory\>\"", "]"}], "//", 
  "Timing"}]], "Input",
 CellChangeTimes->{{3.653223166066796*^9, 3.653223174615611*^9}, {
  3.65648706840588*^9, 3.6564870700282826`*^9}},
 CellID->239327779],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\AlgebraicStructures\\\" (\"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\AlgebraicStructures\" (", 1, " of ", "13", 
   "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564208690605`*^9},
 CellID->158090628],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"22\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "22"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564208846607`*^9},
 CellID->223865565],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\ConsistencyChecker\\\" (\"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\ConsistencyChecker\" (", 2, " of ", "13", 
   "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564223666635`*^9},
 CellID->320567056],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Fields\\\" (\"\>", "\[InvisibleSpace]", 
   "3", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Fields\" (", 3, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564223666635`*^9},
 CellID->149694710],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"36\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "36"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564223666635`*^9},
 CellID->388967025],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Functors\\\" (\"\>", 
   "\[InvisibleSpace]", "4", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Functors\" (", 4, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956426672271*^9},
 CellID->417317509],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"34\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "34"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956426672271*^9},
 CellID->105057068],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\GroebnerRings\\\" (\"\>", 
   "\[InvisibleSpace]", "5", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\GroebnerRings\" (", 5, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564304786777`*^9},
 CellID->170344358],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564305098777`*^9},
 CellID->59878091],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956436890289*^9},
 CellID->270263721],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564431459*^9},
 CellID->95964398],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"165\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "165"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956449261111*^9},
 CellID->182630151],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Integers\\\" (\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Integers\" (", 6, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956451101914*^9},
 CellID->256884688],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"61\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "61"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956451101914*^9},
 CellID->493680956],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"61\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "61"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564554699216`*^9},
 CellID->237443615],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\LogicSets\\\" (\"\>", 
   "\[InvisibleSpace]", "7", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\LogicSets\" (", 7, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564565151234`*^9},
 CellID->76067169],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"146\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "146"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956456546324*^9},
 CellID->443696001],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"146\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "146"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956460961131*^9},
 CellID->78171029],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"146\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "146"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564657659397`*^9},
 CellID->202960436],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\NatInt\\\" (\"\>", "\[InvisibleSpace]", 
   "8", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\NatInt\" (", 8, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564702899475`*^9},
 CellID->17723120],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"260\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "260"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564703055477`*^9},
 CellID->326250159],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"260\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "260"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564748139553`*^9},
 CellID->179483095],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"260\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "260"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956479587564*^9},
 CellID->105179698],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"260\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "260"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956485031974*^9},
 CellID->306116921],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"260\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "260"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956490101982*^9},
 CellID->475858624],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"260\"\>"}],
  SequenceForm["Reading proof ", 251, " of ", "260"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564948287907`*^9},
 CellID->296224080],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Polynomials\\\" (\"\>", 
   "\[InvisibleSpace]", "9", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Polynomials\" (", 9, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564957179923`*^9},
 CellID->723645],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956495749192*^9},
 CellID->74452417],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564973091955`*^9},
 CellID->425908128],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579564984635973`*^9},
 CellID->37595789],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956499664799*^9},
 CellID->524478834],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956501068802*^9},
 CellID->16316289],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 251, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565026600046`*^9},
 CellID->106640037],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"343\"\>"}],
  SequenceForm["Reading proof ", 301, " of ", "343"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956504001607*^9},
 CellID->494472817],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\PolyTuples\\\" (\"\>", 
   "\[InvisibleSpace]", "10", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\PolyTuples\" (", 10, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956505109209*^9},
 CellID->367043018],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956505109209*^9},
 CellID->227672584],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565090560155`*^9},
 CellID->157656635],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565129872227`*^9},
 CellID->995408888],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"161\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "161"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.65795651702763*^9},
 CellID->262024770],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\ReductionRings\\\" (\"\>", 
   "\[InvisibleSpace]", "11", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\ReductionRings\" (", 11, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565179792314`*^9},
 CellID->260527909],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"249\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "249"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565180104313`*^9},
 CellID->206165272],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"249\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "249"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565230648403`*^9},
 CellID->11435295],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"249\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "249"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956528010049*^9},
 CellID->263137527],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"249\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "249"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565333296585`*^9},
 CellID->9928849],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"249\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "249"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956538633668*^9},
 CellID->291474409],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Sequences\\\" (\"\>", 
   "\[InvisibleSpace]", "12", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Sequences\" (", 12, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956544202877*^9},
 CellID->375037910],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"48\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "48"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565442184772`*^9},
 CellID->781061712],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading directory \
\\\"C:\\\\Users\\\\Alex\\\\Documents\\\\Doktorat\\\\Theorema \
Notebooks\\\\Reduction Ring Theory\\\\Tuples\\\" (\"\>", "\[InvisibleSpace]", 
   "13", "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", "\<\"13\"\>", "\[InvisibleSpace]", "\<\"):\"\>"}],
  SequenceForm[
  "Reading directory \"C:\\Users\\Alex\\Documents\\Doktorat\\Theorema \
Notebooks\\Reduction Ring Theory\\Tuples\" (", 13, " of ", "13", "):"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565480404844`*^9},
 CellID->145606035],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"218\"\>"}],
  SequenceForm["Reading proof ", 1, " of ", "218"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956548071684*^9},
 CellID->248456276],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"218\"\>"}],
  SequenceForm["Reading proof ", 51, " of ", "218"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565506144886`*^9},
 CellID->552988536],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"218\"\>"}],
  SequenceForm["Reading proof ", 101, " of ", "218"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956553110493*^9},
 CellID->153771248],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"218\"\>"}],
  SequenceForm["Reading proof ", 151, " of ", "218"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565560432982`*^9},
 CellID->10414559],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Reading proof \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "\<\"218\"\>"}],
  SequenceForm["Reading proof ", 201, " of ", "218"],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565588825035`*^9},
 CellID->466233970],

Cell[BoxData["\<\"Creating forward rules:\"\>"], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956559880905*^9},
 CellID->449905919],

Cell[BoxData["\<\"Preparing ...\"\>"], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565599745054`*^9},
 CellID->733914214],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565604737062`*^9},
 CellID->8563035],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 51, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565618777084`*^9},
 CellID->20227579],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 101, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956563297311*^9},
 CellID->83033835],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 151, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565647013135`*^9},
 CellID->225949661],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 201, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956566120916*^9},
 CellID->277792142],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 251, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565675249186`*^9},
 CellID->11979445],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 301, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956568897721*^9},
 CellID->10605067],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 351, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565702861233`*^9},
 CellID->367067033],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 401, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565716745253`*^9},
 CellID->308164228],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 451, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956573078528*^9},
 CellID->243433680],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 501, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565744669304`*^9},
 CellID->24298702],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 551, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565758553333`*^9},
 CellID->30997595],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 601, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565772437353`*^9},
 CellID->46705460],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 651, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956578647738*^9},
 CellID->212524022],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 701, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565800673404`*^9},
 CellID->276917745],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 751, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956581486943*^9},
 CellID->130401517],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 801, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565829065456`*^9},
 CellID->64754584],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 851, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956584310548*^9},
 CellID->218944533],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "901", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 901, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565857145505`*^9},
 CellID->12631768],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "951", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 951, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956587102953*^9},
 CellID->366898097],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1001", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1001, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956588491355*^9},
 CellID->379282732],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1051", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1051, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956589879758*^9},
 CellID->298961362],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1101, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.65795659128376*^9},
 CellID->129431472],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1151, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565927189627`*^9},
 CellID->817000596],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1201, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956594138565*^9},
 CellID->633081491],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1251, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565955581675`*^9},
 CellID->29050669],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1301, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565969621696`*^9},
 CellID->28300500],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1351, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565983817725`*^9},
 CellID->80021108],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1401, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579565998013754`*^9},
 CellID->488103918],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1451, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956601220978*^9},
 CellID->54242838],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1501, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.65795660262498*^9},
 CellID->156839950],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1551, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566039977827`*^9},
 CellID->453347964],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1601, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566053861847`*^9},
 CellID->16622128],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1651, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956606774587*^9},
 CellID->104567740],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1701, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.65795660819419*^9},
 CellID->178526472],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1751, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566095669923`*^9},
 CellID->503909769],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1801, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566109397945`*^9},
 CellID->442999571],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1851, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566123281975`*^9},
 CellID->530543999],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1901", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1901, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566137009993`*^9},
 CellID->366879544],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "1951", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 1951, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956615073802*^9},
 CellID->362480173],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2001", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2001, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566164622045`*^9},
 CellID->12794165],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2051", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2051, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956617850607*^9},
 CellID->403658380],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2101", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2101, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956619223409*^9},
 CellID->642787780],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2151", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2151, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566206118116`*^9},
 CellID->354788248],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2201", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2201, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956622000214*^9},
 CellID->340157019],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2251", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2251, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566234042163`*^9},
 CellID->681856349],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2301", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2301, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566247926188`*^9},
 CellID->95638345],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2351", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2351, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566261810217`*^9},
 CellID->2966214],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2401", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2401, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566275538235`*^9},
 CellID->153090462],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2451", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2451, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566289422264`*^9},
 CellID->75768980],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2501", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2501, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956630330629*^9},
 CellID->297684573],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2551", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2551, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566317190313`*^9},
 CellID->103101471],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2601", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2601, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566331074333`*^9},
 CellID->101383971],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2651", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2651, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566344958363`*^9},
 CellID->44029095],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2701", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2701, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566358842382`*^9},
 CellID->58616362],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2751", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2751, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956637288241*^9},
 CellID->383656149],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2801", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2801, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566387234435`*^9},
 CellID->895472934],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating rule \"\>", "\[InvisibleSpace]", "2851", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "2898"}],
  SequenceForm["Creating rule ", 2851, " of ", 2898],
  Editable->False]], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.657956640127446*^9},
 CellID->10637410],

Cell[BoxData["\<\"Creating thinned data ...\"\>"], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566414690485`*^9},
 CellID->335404350],

Cell[BoxData["\<\"Done\"\>"], "Print",
 CellChangeTimes->{3.656487121539573*^9, 3.6579566415626483`*^9},
 CellID->250608729]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "130.94723940000000084182829596102237701416`8.13769626043962", ",", 
   "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.656487072867488*^9, 3.656487218743344*^9, 
  3.6579566415626483`*^9},
 CellID->199348246]
}, Closed]],

Cell[BoxData[
 RowBox[{"AnalyzeProofs", "[", 
  RowBox[{"{", 
   RowBox[{"FileNameJoin", "[", 
    RowBox[{"{", 
     RowBox[{
     "$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
      "\"\<Sequences\>\""}], "}"}], "]"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.64655328989894*^9, 3.646553296127252*^9}, {
  3.6554483585205264`*^9, 3.655448360142929*^9}},
 CellID->1859739660],

Cell[BoxData[
 RowBox[{
  RowBox[{"AnalyzeProofs", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
       "$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
        "\"\<Sequences\>\""}], "}"}], "]"}], ",", 
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
       "$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
        "\"\<Reduction Ring Theory\>\"", ",", "\"\<ReductionRings\>\""}], 
       "}"}], "]"}], ",", 
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
       "$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
        "\"\<Reduction Ring Theory\>\"", ",", "\"\<Polynomials\>\""}], "}"}], 
      "]"}], ",", 
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
       "$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
        "\"\<Reduction Ring Theory\>\"", ",", "\"\<GroebnerRings\>\""}], 
       "}"}], "]"}]}], "}"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6406688560104437`*^9, 3.640668867513785*^9}, 
   3.64067664060292*^9, 3.644222019629964*^9, 3.6443084442789383`*^9, {
   3.644637309909933*^9, 3.644637395211917*^9}, 3.6446374289086847`*^9, {
   3.649665456506633*^9, 3.64966546130441*^9}, {3.6554483629509344`*^9, 
   3.6554483652597384`*^9}},
 CellID->1039312110],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComputeFormulaPositions", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.644649344001361*^9, 3.6446493476777363`*^9}},
 CellID->2077551358],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckIntegrity", "[", 
  RowBox[{"\"\<CheckPositions\>\"", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"CurrentValue", "[", "\"\<NotebookDirectory\>\"", "]"}], ",", 
       RowBox[{"CurrentValue", "[", "\"\<NotebookFileName\>\"", "]"}]}], 
      "}"}], "]"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64067003109768*^9, 3.6406700374311132`*^9}, {
   3.6406797903560762`*^9, 3.640679792950843*^9}, 3.6442220291527653`*^9},
 CellID->1909803754],

Cell[BoxData[
 RowBox[{"CheckIntegrity", "[", 
  RowBox[{"\<\"CheckPositions\"\>", "\[Rule]", 
   RowBox[{
   "{", "\<\"/home/amaletzk/Theorema Notebooks/ElementaryTheories.nb\"\>", 
    "}"}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.640670040858255*^9, 3.640670099679185*^9, 3.640670397721546*^9, 
   3.640679793300535*^9, 3.6406798406436234`*^9, 3.640679891162312*^9, 
   3.640679971009297*^9, 3.64068009182163*^9, 3.640680173340745*^9, 
   3.641037395456129*^9, 3.641116403388618*^9, 3.641286881014108*^9, 
   3.642225466578094*^9, 3.642234672070362*^9, 3.642240151894621*^9, 
   3.6423063269273643`*^9, {3.642308832539488*^9, 3.642308857563932*^9}, 
   3.642321396697977*^9, 3.6423285030212173`*^9, 3.642493582768566*^9, 
   3.642763270724422*^9, 3.642834604308413*^9, 3.643428832901271*^9, 
   3.6434441292624083`*^9, 3.643532851309215*^9, 3.6507065133125153`*^9},
 CellID->1365249879]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ps", "=", 
   RowBox[{"GetProofSize", "[", "All", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ps0", "=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Most", "[", 
       RowBox[{"Last", "[", "#", "]"}], "]"}], "]"}], "&"}], ",", "ps"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.647156479700988*^9, 3.647156479817154*^9}, {
   3.647156560839411*^9, 3.6471566309015427`*^9}, 3.6471570742150927`*^9, 
   3.6471571422253036`*^9, {3.647157728211722*^9, 3.647157728406296*^9}},
 CellID->1780799392],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Count", "[", 
  RowBox[{
   RowBox[{"NotebookGet", "[", "]"}], ",", 
   RowBox[{"Cell", "[", 
    RowBox[{"_", ",", "\"\<FormalTextInputFormula\>\"", ",", "___"}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "Infinity"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6550382930110416`*^9, 3.655038363616766*^9}, {
   3.655442032762142*^9, 3.6554420535101786`*^9}, 3.655448370173747*^9, {
   3.6554489741452227`*^9, 3.655448986406844*^9}},
 CellID->63220416],

Cell[BoxData["55"], "Output",
 CellChangeTimes->{3.655448988200847*^9},
 CellID->36314688]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Auxiliary Functions", "Subsection",
 CellChangeTimes->{{3.640668579267561*^9, 3.640668583347287*^9}},
 CellID->1454182661],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "LoadPackage", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadPackage", "[", "name_String", "]"}], ":=", 
   RowBox[{"LoadPackage", "[", 
    RowBox[{"{", "name", "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadPackage", "[", 
    RowBox[{"l", ":", 
     RowBox[{"{", "___String", "}"}]}], "]"}], ":=", 
   RowBox[{"Scan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Get", "[", 
       RowBox[{"FileNameJoin", "[", 
        RowBox[{"{", 
         RowBox[{"$HomeDirectory", ",", "\"\<Theorema Notebooks\>\"", ",", 
          RowBox[{"#", "<>", "\"\<.m\>\""}]}], "}"}], "]"}], "]"}], "&"}], 
     ",", "l"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.640668603629292*^9, 3.640668727460284*^9}, 
   3.641286816086794*^9, 3.6434459961973133`*^9, {3.653223148703965*^9, 
   3.653223155365177*^9}, {3.666439460801259*^9, 3.6664394671292458`*^9}},
 CellID->2074904605],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "FindFormula", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FindFormula", "[", "label_String", "]"}], ":=", 
   RowBox[{"NotebookLocate", "[", "label", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.640677756847624*^9, 3.6406777896243896`*^9}, 
   3.640677822869519*^9, {3.640677854902379*^9, 3.6406778579321823`*^9}},
 CellID->1980565193],

Cell[BoxData[
 RowBox[{"LoadPackage", "[", "\"\<ProofPalette\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.640668742006607*^9, 3.640668751417616*^9}},
 CellID->444074165],

Cell[BoxData[
 RowBox[{"LoadPackage", "[", "\"\<TheoryTools/TheoryTools\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.640668759133181*^9, 3.640668768089197*^9}, {
   3.6551873799276342`*^9, 3.655187380848036*^9}, {3.6585764624314137`*^9, 
   3.6585764652238183`*^9}, 3.666439469717782*^9},
 CellID->584704106]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Infinite Sequences (\[Checkmark])", "Section",
 CellChangeTimes->{{3.6463642817913637`*^9, 3.646364285313697*^9}, {
  3.64639422349069*^9, 3.646394227310183*^9}, {3.646474773621366*^9, 
  3.646474774542362*^9}, {3.6466394114773808`*^9, 3.6466394155225897`*^9}},
 CellID->857285562],

Cell[CellGroupData[{

Cell["Definitions", "Subsection",
 CellChangeTimes->{{3.646364873162013*^9, 3.646364875317564*^9}},
 CellID->1461916963],

Cell["", "OpenEnvironment",
 CellID->1686339578],

Cell[CellGroupData[{

Cell["Definition: DomainSequences", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6463650852237577`*^9, 3.646365088519288*^9}},
 CellID->787375658],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "\[ScriptCapitalD]"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb", 
          695794617}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646368089088747*^9, 3.646368091375039*^9}},
 CellTags->{
  "ID:695794617", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->695794617],

Cell[BoxData[
 RowBox[{
  RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}], ":=", 
  UnderscriptBox["\[CapitalDelta]", "N"]}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb", 
          925721429}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465532243246117`*^9, 3.6465532405641623`*^9}},
 CellTags->{
  "ID:925721429", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->925721429],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "f"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb", 
          243637066}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465532449574757`*^9, 3.6465532458134813`*^9}},
 CellTags->{
  "ID:243637066", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->243637066],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Element]", "N"], 
    RowBox[{"[", "f", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], 
  TagBox[
   RowBox[{
   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
    "\[DoubleLongLeftRightArrow]"}],
   Identity,
   SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", 
      RowBox[{"f", "[", "i", "]"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences decision predicate)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:458427713", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646365099141027*^9, 3.646365123015705*^9}, {
   3.6463651839572763`*^9, 3.646365189678549*^9}, 3.646365297176303*^9, {
   3.646553248070228*^9, 3.6465532542442293`*^9}},
 CellTags->{
  "ID:458427713", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences decision predicate"},
 CellID->458427713],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1414427201]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1338140004],

Cell[TextData[{
 "Please note that ",
 Cell[BoxData[
  FormBox["g", TraditionalForm]]],
 " in the following definition does not need to be strictly increasing, \
meaning that ",
 Cell[BoxData[
  FormBox[
   RowBox[{"subSeq", "[", 
    RowBox[{"f", ",", "g"}], "]"}], TraditionalForm]]],
 " does not have to be a subsequence of ",
 Cell[BoxData[
  FormBox["f", TraditionalForm]]],
 " in the usual sense. Apparently, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"subSeq", "[", 
     RowBox[{"f", ",", "g"}], "]"}], "=", 
    RowBox[{"f", "\[SmallCircle]", "g"}]}], TraditionalForm]]],
 ", but we avoid using the notation with \[SmallCircle] since function \
composition can be defined much more generally than only for sequences."
}], "Text",
 CellChangeTimes->{{3.646365314640244*^9, 3.646365464536131*^9}},
 CellID->923897726],

Cell["", "OpenEnvironment",
 CellID->1026547334],

Cell[CellGroupData[{

Cell["\<\
Definition: Subsequences, Images of Sequences, Tuple/Set Sequences\
\>", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.646364881027952*^9, 3.646364884562035*^9}, {
  3.646365609155263*^9, 3.646365616388667*^9}, {3.646366048743018*^9, 
  3.646366056413136*^9}, {3.6463713800060263`*^9, 3.646371382231291*^9}},
 CellID->563288901],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "f"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1289924462}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646365620092393*^9, 3.64636562084934*^9}, {
   3.646366152443873*^9, 3.646366152592011*^9}, 3.646369460709934*^9},
 CellTags->{
  "ID:1289924462", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1289924462],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"isNatMapping", "[", "g", "]"}]], 
  RowBox[{
   UnderscriptBox["\[ForAll]", 
    RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      RowBox[{"subSeq", "[", 
       RowBox[{"f", ",", "g"}], "]"}], "[", "i", "]"}], ":=", 
     RowBox[{"f", "[", 
      RowBox[{"g", "[", "i", "]"}], "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:230504716", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646364923247087*^9, 3.646364980203182*^9}, {
   3.6463652132533407`*^9, 3.646365219837037*^9}, {3.6463652759359083`*^9, 
   3.646365276765709*^9}, {3.6463653961915293`*^9, 3.646365399374704*^9}, 
   3.646365622254117*^9, {3.646366171826336*^9, 3.64636618183173*^9}, {
   3.646369450572835*^9, 3.646369457610647*^9}},
 CellTags->{
  "ID:230504716", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq"},
 CellID->230504716],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "h"], 
  RowBox[{
   UnderscriptBox["\[ForAll]", 
    RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      RowBox[{"imgSeq", "[", 
       RowBox[{"f", ",", "h"}], "]"}], "[", "i", "]"}], ":=", 
     RowBox[{"h", "[", 
      RowBox[{"f", "[", "i", "]"}], "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(imgSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:809351385", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646365690263275*^9, 3.64636571276066*^9}, 
   3.646366167180201*^9, {3.646369464211213*^9, 3.646369468984098*^9}},
 CellTags->{
  "ID:809351385", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "imgSeq"},
 CellID->809351385],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     RowBox[{"tupSeq", "[", "f", "]"}], "[", "i", "]"}], ":=", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      RowBox[{"f", "[", "j", "]"}], 
      UnderscriptBox["|", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", "\[Ellipsis]", ",", "i"}]]}], 
     "\[RightAngleBracket]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(tupSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1865902758", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463660769455137`*^9, 3.646366121771611*^9}, 
   3.646366168139929*^9, {3.646368885396675*^9, 3.646368893378283*^9}, {
   3.646371385932447*^9, 3.646371386282065*^9}},
 CellTags->{
  "ID:1865902758", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "tupSeq"},
 CellID->1865902758],

Cell[BoxData[
 RowBox[{
  RowBox[{"setSeq", "[", "f", "]"}], ":=", 
  RowBox[{"imgSeq", "[", 
   RowBox[{
    RowBox[{"tupSeq", "[", "f", "]"}], ",", "TupleToSet"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:238284462", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646368802247546*^9, 3.6463688290799437`*^9}, {
  3.646368920184311*^9, 3.646368925141646*^9}, {3.6463713903586082`*^9, 
  3.646371390692721*^9}},
 CellTags->{
  "ID:238284462", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq"},
 CellID->238284462],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->992250107]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->548294931],

Cell["", "OpenEnvironment",
 CellID->124141796],

Cell[CellGroupData[{

Cell["\<\
Definition: Subsequence Relation (\[LeftTriangleBar])\
\>", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6465560018610353`*^9, 3.646556009081554*^9}, {
  3.646556688204277*^9, 3.6465567028701*^9}, {3.647922205646844*^9, 
  3.647922210476789*^9}},
 CellID->216609509],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"f1", ",", "f2"}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"f1", "\[LeftTriangleBar]", "f2"}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox[
     RowBox[{
     ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
      "\[DoubleLongLeftRightArrow]"}],
     Identity,
     SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Exists]", 
       RowBox[{"isIncrMapping", "[", "g", "]"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"f1", "\[Equal]", 
        RowBox[{"subSeq", "[", 
         RowBox[{"f2", ",", "g"}], "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[LeftTriangleBar])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1986096562", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465560143530188`*^9, 3.646556046623135*^9}, {
  3.646556586445253*^9, 3.646556615076316*^9}, {3.646556664811295*^9, 
  3.646556664993531*^9}, {3.646636865453101*^9, 3.6466368706126347`*^9}},
 CellTags->{
  "ID:1986096562", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[LeftTriangleBar]"},
 CellID->1986096562],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1105920236]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->986220819]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemmas (\[Checkmark])", "Subsection",
 CellChangeTimes->{{3.646371207911502*^9, 3.646371208733548*^9}, {
  3.6463942083299513`*^9, 3.646394212381308*^9}, {3.646474778715404*^9, 
  3.646474779574094*^9}, {3.646639401178627*^9, 3.646639407014968*^9}},
 CellID->1098258350],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "\[ScriptCapitalD]"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 489544091}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465542206773567`*^9, 3.646554222715768*^9}},
 CellTags->{
  "ID:489544091", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->489544091],

Cell[CellGroupData[{

Cell["Subsequences (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.6463654934738617`*^9, 3.646365494368926*^9}, {
   3.646366246606319*^9, 3.646366250252967*^9}, 3.646371211057068*^9, {
   3.64637859573643*^9, 3.646378600001687*^9}, {3.646474781790987*^9, 
   3.6464747826810427`*^9}, {3.646558192626705*^9, 3.6465581953216257`*^9}},
 CellID->1909794438],

Cell["", "OpenEnvironment",
 CellID->799034423],

Cell[CellGroupData[{

Cell["Lemma: Simple Properties of subSeq for Domain Sequences", \
"EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.646366292148796*^9, 3.646366311956856*^9}, {
  3.6465574607689457`*^9, 3.6465574617015953`*^9}, {3.64699883859164*^9, 
  3.646998843608136*^9}},
 CellID->481158387],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "f"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1306945267}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646392328861652*^9, 3.6463923336546288`*^9}, 
   3.646999037657329*^9},
 CellTags->{
  "ID:1306945267", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1306945267],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "g"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 638827787}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646366333727543*^9, 3.646366335469863*^9}, {
  3.646392304914215*^9, 3.646392305063163*^9}, {3.646392348357802*^9, 
  3.646392353042452*^9}, {3.6465574281556673`*^9, 3.6465574434943323`*^9}},
 CellTags->{
  "ID:638827787", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->638827787],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"h", "=", 
   RowBox[{"subSeq", "[", 
    RowBox[{"f", ",", "g"}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 29525805}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646367037414598*^9, 3.6463670439571037`*^9}},
 CellTags->{
  "ID:29525805", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->29525805],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["\[Element]", 
      RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
     RowBox[{"[", "f", "]"}]}], "\[And]", 
    RowBox[{"isNatMapping", "[", "g", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   UnderscriptBox["\[Element]", 
    RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
   RowBox[{"[", "h", "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences subSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1744060660", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463663466808147`*^9, 3.646366370945673*^9}, 
   3.64636704691192*^9, {3.6463922835491123`*^9, 3.6463922893793*^9}, {
   3.646392337236171*^9, 3.646392339747109*^9}, {3.646999027123948*^9, 
   3.6469990583585453`*^9}},
 CellTags->{
  "ID:1744060660", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences subSeq", "IR"},
 CellID->1744060660],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "P"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1383543831}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463717692131767`*^9, 3.6463717706553698`*^9}},
 CellTags->{
  "ID:1383543831", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1383543831],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox[
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", ",", "j", ",", 
      RowBox[{"k", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
    RowBox[{
     RowBox[{"k", ">", "j"}], "\[And]", 
     RowBox[{"j", ">", "i"}]}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"f", "[", "i", "]"}], ",", 
         RowBox[{"f", "[", "j", "]"}]}], "]"}], "\[And]", 
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"f", "[", "j", "]"}], ",", 
         RowBox[{"f", "[", "k", "]"}]}], "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}], "\[Implies]", 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{"f", "[", "i", "]"}], ",", 
       RowBox[{"f", "[", "k", "]"}]}], "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1895094895}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646371773289049*^9, 3.646371784788211*^9}, 
   3.646999005086627*^9},
 CellTags->{
  "ID:1895094895", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1895094895],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{"f", "[", "i", "]"}], ",", 
      RowBox[{"f", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"k", ",", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{"f", "[", "i", "]"}], ",", 
      RowBox[{"f", "[", 
       RowBox[{"i", "+", "k"}], "]"}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(sequence transitive P I)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1841507065", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646371837855047*^9, 3.646371867706905*^9}},
 CellTags->{
  "ID:1841507065", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "sequence transitive P I"},
 CellID->1841507065],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{"f", "[", "i", "]"}], ",", 
      RowBox[{"f", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", 
      RowBox[{"i", ",", 
       RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
     RowBox[{"j", ">", "i"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{"f", "[", "i", "]"}], ",", 
      RowBox[{"f", "[", "j", "]"}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(sequence transitive P II)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1455385635", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64638344840746*^9, 3.646383462191351*^9}},
 CellTags->{
  "ID:1455385635", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "sequence transitive P II"},
 CellID->1455385635],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"isIncrMapping", "[", "g", "]"}], "\[And]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{"h", "[", "i", "]"}], ",", 
      RowBox[{"h", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq P binary)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:796771086", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646366921822729*^9, 3.646367074600545*^9}, {
  3.64637178051204*^9, 3.646371828196287*^9}},
 CellTags->{
  "ID:796771086", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq P binary"},
 CellID->796771086],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->2143432809]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->708131044],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSequences subSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSequences subSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}, {
             StyleBox["g", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{"isNatMapping", "[", 
             StyleBox["g", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             RowBox[{"subSeq", "[", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}, {
             StyleBox["g", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{"isNatMapping", "[", 
             StyleBox["g", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             RowBox[{"subSeq", "[", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1744060660"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1744060660-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1744060660-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1744060660", "Proof|ID:1744060660-1"},
 CellID->121410062],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1744060660-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1535132699]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(sequence transitive P I)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(sequence transitive P I)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                RowBox[{
                  StyleBox["k", "ExpressionVariable"], ">", 
                  StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
               "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", 
                    StyleBox["k", "ExpressionVariable"]}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                RowBox[{
                  StyleBox["k", "ExpressionVariable"], ">", 
                  StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
               "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", 
                    StyleBox["k", "ExpressionVariable"]}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1841507065"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1841507065-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1841507065-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1841507065", "Proof|ID:1841507065-1"},
 CellID->398706065],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1841507065-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->488597049]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(sequence transitive P II)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(sequence transitive P II)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                RowBox[{
                  StyleBox["k", "ExpressionVariable"], ">", 
                  StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
               "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                RowBox[{
                  StyleBox["k", "ExpressionVariable"], ">", 
                  StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
               "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1455385635"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1455385635-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1455385635-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1455385635", "Proof|ID:1455385635-1"},
 CellID->1613181412],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1455385635-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->872923449]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq P binary)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq P binary)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["g", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                RowBox[{
                  StyleBox["k", "ExpressionVariable"], ">", 
                  StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
               "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"isIncrMapping", "[", 
                 StyleBox["g", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                   "]"}]}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["g", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                RowBox[{
                  StyleBox["k", "ExpressionVariable"], ">", 
                  StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]}]], 
             RowBox[{
               RowBox[{
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                 "\[And]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
               "\[Implies]", 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"isIncrMapping", "[", 
                 StyleBox["g", "ExpressionVariable"], "]"}], "\[And]", 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                   "]"}]}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:796771086"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p796771086-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p796771086-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:796771086", "Proof|ID:796771086-1"},
 CellID->567440294],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p796771086-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->1432707641]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->1992449838],

Cell["Lemma: Simple Properties of Subsequences", "EnvironmentHeader",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.646557451421014*^9, 3.6465574688746758`*^9}, 
   3.646558045431497*^9, {3.6469756599877663`*^9, 3.646975660729494*^9}, 
   3.653302785378994*^9, {3.656671689243556*^9, 3.6566717081507893`*^9}},
 CellID->764351212],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "f"]], "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 113922190}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64655747415602*^9, 3.6465574866294537`*^9}, 
   3.646558045432033*^9, 3.64699909145958*^9, 3.653302785378994*^9, {
   3.656671689243556*^9, 3.6566717081507893`*^9}},
 CellTags->{
  "ID:113922190", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->113922190],

Cell[BoxData[
 UnderscriptBox[
  UnderscriptBox["\[ForAll]", "h"], 
  RowBox[{"h", "\[LeftTriangleBar]", "f"}]]], "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 936476105}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646557490499214*^9, 3.646557501148394*^9}, 
   3.646558045432292*^9, {3.646636912391644*^9, 3.646636917444098*^9}, 
   3.653302785378994*^9, {3.6566716892591558`*^9, 3.6566717081507893`*^9}},
 CellTags->{
  "ID:936476105", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->936476105],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["\[Element]", 
    RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
   RowBox[{"[", "f", "]"}]}], "\[Implies]", 
  RowBox[{
   UnderscriptBox["\[Element]", 
    RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
   RowBox[{"[", "h", "]"}]}]}]], "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences \[LeftTriangleBar])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1324913148", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.646557509267954*^9, 3.6465580454326973`*^9, {3.646999080449964*^9, 
   3.646999089499943*^9}, 3.653302785378994*^9, {3.6566716892591558`*^9, 
   3.6566717081507893`*^9}},
 CellTags->{
  "ID:1324913148", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences \[LeftTriangleBar]", "IR"},
 CellID->1324913148],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "P"]], "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1481705576}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463717692131767`*^9, 3.6463717706553698`*^9}, 
   3.646558045432953*^9, 3.653302785378994*^9, {3.6566716892591558`*^9, 
   3.6566717081507893`*^9}},
 CellTags->{
  "ID:1481705576", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1481705576],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox[
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", ",", "j", ",", 
      RowBox[{"k", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
    RowBox[{
     RowBox[{"k", ">", "j"}], "\[And]", 
     RowBox[{"j", ">", "i"}]}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"f", "[", "i", "]"}], ",", 
         RowBox[{"f", "[", "j", "]"}]}], "]"}], "\[And]", 
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"f", "[", "j", "]"}], ",", 
         RowBox[{"f", "[", "k", "]"}]}], "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}], "\[Implies]", 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{"f", "[", "i", "]"}], ",", 
       RowBox[{"f", "[", "k", "]"}]}], "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}], "\[Implies]"}]], "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 794304435}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646371773289049*^9, 3.646371784788211*^9}, {
   3.646558018218643*^9, 3.646558045433214*^9}, 3.646999099235015*^9, 
   3.653302785378994*^9, {3.6566716892591558`*^9, 3.6566717081507893`*^9}},
 CellTags->{
  "ID:794304435", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->794304435],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{"f", "[", "i", "]"}], ",", 
      RowBox[{"f", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{"h", "[", "i", "]"}], ",", 
      RowBox[{"h", "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[LeftTriangleBar] P binary)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1003845896", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646557549876554*^9, 3.6465575573757677`*^9}, 
   3.646558045433474*^9, 3.653302785378994*^9, {3.6566716892591558`*^9, 
   3.6566717081507893`*^9}},
 CellTags->{
  "ID:1003845896", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[LeftTriangleBar] P binary"},
 CellID->1003845896],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.6465580454336357`*^9, 3.653302785378994*^9, 
  3.6566717081507893`*^9},
 CellID->2075582208],

Cell["", "CloseEnvironment",
 CellID->1623627242],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSequences \[LeftTriangleBar])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSequences \[LeftTriangleBar])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}, {
             StyleBox["f", "ExpressionVariable"]}, {
             StyleBox["h", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["h", "ExpressionVariable"], "\[LeftTriangleEqual]", 
             StyleBox["f", "ExpressionVariable"]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["h", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}, {
             StyleBox["f", "ExpressionVariable"]}, {
             StyleBox["h", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["h", "ExpressionVariable"], "\[LeftTriangleEqual]", 
             StyleBox["f", "ExpressionVariable"]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["h", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1324913148"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1324913148-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1324913148-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1324913148", "Proof|ID:1324913148-1"},
 CellID->897924672],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1324913148-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1373935419]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[LeftTriangleBar] P binary)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[LeftTriangleBar] P binary)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["h", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               StyleBox["h", "ExpressionVariable"], "\[LeftTriangleBar]", 
               StyleBox["f", "ExpressionVariable"]}], "\[And]", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], ">", 
                    StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                   "\[And]", 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["h", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               StyleBox["h", "ExpressionVariable"], "\[LeftTriangleBar]", 
               StyleBox["f", "ExpressionVariable"]}], "\[And]", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["k", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  RowBox[{
                    StyleBox["k", "ExpressionVariable"], ">", 
                    StyleBox["j", "ExpressionVariable"]}], "\[And]", 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                   "\[And]", 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}], 
                 "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["k", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1003845896"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1003845896-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1003845896-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1003845896", "Proof|ID:1003845896-1"},
 CellID->1168681859],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1003845896-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1102065031]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->1198945339],

Cell[CellGroupData[{

Cell["Lemma: Existence of Certain Subsequences", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.646470892578822*^9, 3.646470900096537*^9}},
 CellID->723824580],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"f", ",", "P"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 51050760}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646470913902339*^9, 3.646470917552682*^9}},
 CellTags->{
  "ID:51050760", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->51050760],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[Exists]", 
       RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"j", "\[GreaterEqual]", "i"}]], 
     RowBox[{"P", "[", 
      RowBox[{"f", "[", "j", "]"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"isIncrMapping", "[", "g", "]"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{"subSeq", "[", 
        RowBox[{"f", ",", "g"}], "]"}], "[", "i", "]"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1171839467", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64647092246157*^9, 3.6464710239952*^9}, {
  3.646471098177652*^9, 3.646471098811346*^9}, {3.646475955809698*^9, 
  3.646475962723838*^9}, {3.646973762419038*^9, 3.6469737669454613`*^9}, {
  3.6469741645873947`*^9, 3.64697420024606*^9}},
 CellTags->{
  "ID:1171839467", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 1"},
 CellID->1171839467],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[ForAll]", 
       RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"j", "\[GreaterEqual]", "i"}]], 
     RowBox[{"P", "[", 
      RowBox[{"f", "[", "j", "]"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"isIncrMapping", "[", "g", "]"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{"subSeq", "[", 
        RowBox[{"f", ",", "g"}], "]"}], "[", "i", "]"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq 2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:756173591", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646471038497594*^9, 3.646471043473987*^9}, {
  3.646471101132235*^9, 3.646471101755562*^9}},
 CellTags->{
  "ID:756173591", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 2"},
 CellID->756173591],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[Exists]", 
       RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"j", ">", "i"}]], 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{"f", "[", "i", "]"}], ",", 
       RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"isIncrMapping", "[", "g", "]"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"subSeq", "[", 
         RowBox[{"f", ",", "g"}], "]"}], "[", "i", "]"}], ",", 
       RowBox[{
        RowBox[{"subSeq", "[", 
         RowBox[{"f", ",", "g"}], "]"}], "[", 
        RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq 3)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1593038128", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465544893231564`*^9, 3.646554512683653*^9}, 
   3.646554698664625*^9},
 CellTags->{
  "ID:1593038128", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 3"},
 CellID->1593038128],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"a", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"i", "\[GreaterEqual]", "a"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[Exists]", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"j", ">", "i"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"isIncrMapping", "[", "g", "]"}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"subSeq", "[", 
         RowBox[{"f", ",", "g"}], "]"}], "[", "i", "]"}], ",", 
       RowBox[{
        RowBox[{"subSeq", "[", 
         RowBox[{"f", ",", "g"}], "]"}], "[", 
        RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq 4)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:377390901", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646554683533955*^9, 3.6465547009537163`*^9}},
 CellTags->{
  "ID:377390901", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 4"},
 CellID->377390901],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"a", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[Exists]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"i", "\[GreaterEqual]", "a"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[ForAll]", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"j", ">", "i"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"isIncrMapping", "[", "g", "]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", ",", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
      RowBox[{"j", ">", "i"}]], 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"subSeq", "[", 
         RowBox[{"f", ",", "g"}], "]"}], "[", "i", "]"}], ",", 
       RowBox[{
        RowBox[{"subSeq", "[", 
         RowBox[{"f", ",", "g"}], "]"}], "[", "j", "]"}]}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq 5)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1934441835", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6469733722591887`*^9, 3.646973403988875*^9}, {
  3.646973538595331*^9, 3.646973547168082*^9}, {3.646974316186517*^9, 
  3.646974329959879*^9}},
 CellTags->{
  "ID:1934441835", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 5"},
 CellID->1934441835],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->387946042]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->482332764],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1171839467"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1171839467-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1171839467-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1171839467", "Proof|ID:1171839467-1"},
 CellID->1009035181],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1171839467-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1623584862]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq 2)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq 2)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:756173591"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p756173591-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p756173591-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:756173591", "Proof|ID:756173591-1"},
 CellID->1704654642],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p756173591-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1864994181]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq 3)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq 3)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1593038128"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1593038128-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1593038128-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1593038128", "Proof|ID:1593038128-1"},
 CellID->1107323890],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1593038128-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->2085669265]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq 4)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq 4)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:377390901"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p377390901-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p377390901-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:377390901", "Proof|ID:377390901-1"},
 CellID->383299987],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p377390901-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1006913240]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq 5)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq 5)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["a", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                  StyleBox["a", "ExpressionVariable"]}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{"isIncrMapping", "[", 
                   StyleBox["g", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1934441835"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1934441835-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1934441835-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1934441835", "Proof|ID:1934441835-1"},
 CellID->519218944],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1934441835-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->922881673]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Domain Sequences (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.658639685554986*^9, 3.658639696865006*^9}, {
  3.6586421502747154`*^9, 3.658642155032724*^9}},
 CellID->233591146],

Cell["", "OpenEnvironment",
 CellID->21484693],

Cell[CellGroupData[{

Cell["Lemma: Subsequences of Domain Sequences", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6586399146413884`*^9, 3.658639928634613*^9}},
 CellID->625353928],

Cell[BoxData[
 RowBox[{
  RowBox[{"isFinDomain", "[", "\[ScriptCapitalD]", "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "f", "]"}]}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[Exists]", 
       RowBox[{"i", ",", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
      RowBox[{"j", ">", "i"}]], 
     RowBox[{
      RowBox[{"f", "[", "i", "]"}], "\[Equal]", 
      RowBox[{"f", "[", "j", "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences finite domain)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:144670545", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6586398208696237`*^9, 3.6586398742685175`*^9}, {
  3.658640001361941*^9, 3.658640013607962*^9}},
 CellTags->{
  "ID:144670545", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences finite domain"},
 CellID->144670545],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   RowBox[{
    UnderscriptBox["\[Element]", 
     RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
    RowBox[{"[", "f", "]"}]}], ",", "P"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 72630978}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6586399329870205`*^9, 3.658639951332653*^9}},
 CellTags->{
  "ID:72630978", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->72630978],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[Exists]", 
       RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"j", "\[GreaterEqual]", "i"}]], 
     RowBox[{"P", "[", 
      RowBox[{"f", "[", "j", "]"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "h", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"h", "\[LeftTriangleBar]", "f"}], "\[And]", 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"P", "[", 
        RowBox[{"h", "[", "i", "]"}], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq DomainSequences 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1747499940", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6464710767240677`*^9, 3.646471095811389*^9}, {
  3.6465567341643877`*^9, 3.646556753183476*^9}, {3.646637259230399*^9, 
  3.646637263828334*^9}},
 CellTags->{
  "ID:1747499940", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 1"},
 CellID->1747499940],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[ForAll]", 
       RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"j", "\[GreaterEqual]", "i"}]], 
     RowBox[{"P", "[", 
      RowBox[{"f", "[", "j", "]"}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "h", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"h", "\[LeftTriangleBar]", "f"}], "\[And]", 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"P", "[", 
        RowBox[{"h", "[", "i", "]"}], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq DomainSequences 2)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:31395941", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646471109095731*^9, 3.6464711139795427`*^9}, {
   3.6465567671544447`*^9, 3.646556772047114*^9}, 3.6466372669958878`*^9},
 CellTags->{
  "ID:31395941", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 2"},
 CellID->31395941],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[Exists]", 
       RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"j", ">", "i"}]], 
     RowBox[{"P", "[", 
      RowBox[{
       RowBox[{"f", "[", "i", "]"}], ",", 
       RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "h", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"h", "\[LeftTriangleBar]", "f"}], "\[And]", 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"h", "[", "i", "]"}], ",", 
         RowBox[{"h", "[", 
          RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq DomainSequences 3)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:228528973", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646556785562495*^9, 3.646556798046029*^9}, 
   3.646637268360839*^9},
 CellTags->{
  "ID:228528973", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 3"},
 CellID->228528973],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{"a", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"i", "\[GreaterEqual]", "a"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[Exists]", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"j", ">", "i"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "h", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"h", "\[LeftTriangleBar]", "f"}], "\[And]", 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"h", "[", "i", "]"}], ",", 
         RowBox[{"h", "[", 
          RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq DomainSequences 4)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:854524374", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465568066721992`*^9, 3.646556817741026*^9}, 
   3.646637269359568*^9},
 CellTags->{
  "ID:854524374", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 4"},
 CellID->854524374],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"a", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{
     UnderscriptBox[
      UnderscriptBox["\[Exists]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"i", "\[GreaterEqual]", "a"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[ForAll]", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"j", ">", "i"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[Exists]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "h", "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{"h", "\[LeftTriangleBar]", "f"}], "\[And]", 
      RowBox[{
       UnderscriptBox[
        UnderscriptBox["\[ForAll]", 
         RowBox[{"i", ",", 
          RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
        RowBox[{"j", ">", "i"}]], 
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"h", "[", "i", "]"}], ",", 
         RowBox[{"h", "[", "j", "]"}]}], "]"}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq DomainSequences 5)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:527068444", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646975323238505*^9, 3.646975363514027*^9}},
 CellTags->{
  "ID:527068444", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 5"},
 CellID->527068444],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->637511678]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->51901917],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSequences finite domain)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSequences finite domain)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isFinDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], "\[Equal]", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["j", "ExpressionVariable"], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isFinDomain", "[", 
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[Exists]", 
                 GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                RowBox[{
                  StyleBox["j", "ExpressionVariable"], ">", 
                  StyleBox["i", "ExpressionVariable"]}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], "\[Equal]", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], "[", 
                   StyleBox["j", "ExpressionVariable"], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:144670545"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p144670545-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p144670545-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:144670545", "Proof|ID:144670545-1"},
 CellID->431495423],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p144670545-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->175865792]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq DomainSequences 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq DomainSequences 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1747499940"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1747499940-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1747499940-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1747499940", "Proof|ID:1747499940-1"},
 CellID->1369905409],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1747499940-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1124392772]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq DomainSequences 2)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq DomainSequences 2)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], "]"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:31395941"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p31395941-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p31395941-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:31395941", "Proof|ID:31395941-1"},
 CellID->1498389165],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p31395941-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->65832091]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq DomainSequences 3)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq DomainSequences 3)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}], 
             "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:228528973"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p228528973-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p228528973-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:228528973", "Proof|ID:228528973-1"},
 CellID->670198542],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p228528973-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1200865808]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq DomainSequences 4)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq DomainSequences 4)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["a", "ExpressionVariable"]}]], 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[Exists]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["a", "ExpressionVariable"]}]], 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[Exists]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], 
                   "\[LeftTriangleEqual]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:854524374"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p854524374-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p854524374-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:854524374", "Proof|ID:854524374-1"},
 CellID->295533552],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p854524374-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellChangeTimes->{{3.646975485871813*^9, 3.646975487799601*^9}},
 CellID->233940929]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq DomainSequences 5)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq DomainSequences 5)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["a", "ExpressionVariable"]}]], 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "\[LeftTriangleBar]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["a", "ExpressionVariable"]}]], 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
              "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "\[LeftTriangleBar]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:527068444"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p527068444-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p527068444-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:527068444", "Proof|ID:527068444-1"},
 CellID->1572634243],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p527068444-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1975995889]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->108625658],

Cell[CellGroupData[{

Cell["Lemma: More Facts about Domain Sequences", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6566726342474155`*^9, 3.6566726411270275`*^9}, {
  3.6566753685346184`*^9, 3.656675371077423*^9}, {3.658639702559016*^9, 
  3.658639705398221*^9}, {3.65864002388838*^9, 3.658640024793182*^9}},
 CellID->638654754],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "P"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 21904240}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.656672644683834*^9, 3.6566726454482355`*^9}},
 CellTags->{
  "ID:21904240", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->21904240],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "f", "]"}]}]], 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[ForAll]", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"j", ">", "i"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "f", "]"}]}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{"a", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[Exists]", 
        RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"i", "\[GreaterEqual]", "a"}]], 
      RowBox[{
       UnderscriptBox[
        UnderscriptBox["\[ForAll]", 
         RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
        RowBox[{"j", ">", "i"}]], 
       RowBox[{"P", "[", 
        RowBox[{
         RowBox[{"f", "[", "i", "]"}], ",", 
         RowBox[{"f", "[", "j", "]"}]}], "]"}]}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq DomainSequences 6)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:315841131", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6566721181361094`*^9, 3.656672204560261*^9}, {
  3.6566722834184*^9, 3.65667231235645*^9}, {3.6566723607789354`*^9, 
  3.656672364990943*^9}, {3.6566724564851036`*^9, 3.6566724942683697`*^9}, {
  3.656672654387051*^9, 3.656672661812664*^9}},
 CellTags->{
  "ID:315841131", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 6"},
 CellID->315841131],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->674170319]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->103869578],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq DomainSequences 6)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq DomainSequences 6)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["a", "ExpressionVariable"]}]], 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["a", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["a", "ExpressionVariable"]}]], 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], 
                    "]"}]}]}]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:315841131"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p315841131-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p315841131-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:315841131", "Proof|ID:315841131-1"},
 CellID->135253581],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p315841131-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {46., 52.}}]], "ProofInfoBody",
 CellID->151978007]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->965034304],

Cell["Corollary: Non-Existence of Domain Sequences", "EnvironmentHeader",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.64663839912744*^9, 3.646638409778167*^9}, 
   3.6566757327484584`*^9, {3.6586397085806265`*^9, 3.6586397096258287`*^9}},
 CellID->744455432],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "P"]], "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 432936581}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6466384174601088`*^9, 3.646638426055097*^9}, 
   3.6566757327484584`*^9},
 CellTags->{
  "ID:432936581", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->432936581],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Not]", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "f", "]"}]}]], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"P", "[", 
       RowBox[{"f", "[", "i", "]"}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "f", "]"}]}]], 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[ForAll]", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"j", "\[GreaterEqual]", "i"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"\[Not]", 
        RowBox[{"P", "[", 
         RowBox[{"f", "[", "j", "]"}], "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(non-existence seq P)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:557118158", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646638430476428*^9, 3.646638492780747*^9}, 
   3.6566757327484584`*^9},
 CellTags->{
  "ID:557118158", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "non-existence seq P"},
 CellID->557118158],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Not]", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "f", "]"}]}]], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "f", "]"}]}]], 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[ForAll]", 
        RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
       RowBox[{"j", ">", "i"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"\[Not]", 
        RowBox[{"P", "[", 
         RowBox[{
          RowBox[{"f", "[", "i", "]"}], ",", 
          RowBox[{"f", "[", "j", "]"}]}], "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(non-existence seq P binary)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:283188144", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646638530052897*^9, 3.6466385571937532`*^9}, {
   3.6466391116778*^9, 3.646639151970272*^9}, {3.646639235626849*^9, 
   3.6466392471035643`*^9}, 3.6566757327484584`*^9},
 CellTags->{
  "ID:283188144", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "non-existence seq P binary"},
 CellID->283188144],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Not]", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "f", "]"}]}]], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], ",", 
        RowBox[{"f", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", "f", "]"}]}]], 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "h", "]"}]}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{"\[And]", 
       RowBox[{"\[Piecewise]", GridBox[{
          {
           RowBox[{"h", "\[LeftTriangleBar]", "f"}]},
          {
           RowBox[{
            UnderscriptBox[
             UnderscriptBox["\[ForAll]", 
              RowBox[{"i", ",", 
               RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
             RowBox[{"j", ">", "i"}]], 
            RowBox[{
             TagBox["(",
              "AutoParentheses"], 
             RowBox[{"\[Not]", 
              RowBox[{"P", "[", 
               RowBox[{
                RowBox[{"h", "[", "i", "]"}], ",", 
                RowBox[{"h", "[", "j", "]"}]}], "]"}]}], 
             TagBox[")",
              "AutoParentheses"]}]}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}]}]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(non-existence seq P binary subSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:44762641", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6566702499050274`*^9, 3.6566703260955615`*^9}, 
   3.6566757327484584`*^9},
 CellTags->{
  "ID:44762641", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "non-existence seq P binary subSeq"},
 CellID->44762641],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.6566757327484584`*^9},
 CellID->2016708524],

Cell["", "CloseEnvironment",
 CellID->1830041516],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(non-existence seq P)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(non-existence seq P)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "]"}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], "]"}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "]"}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}], "]"}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:557118158"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p557118158-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p557118158-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:557118158", "Proof|ID:557118158-1"},
 CellID->608671989],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p557118158-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->204472239]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(non-existence seq P binary)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(non-existence seq P binary)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", 
                   GridBox[{{
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                 RowBox[{"\[Not]", 
                   RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:283188144"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p283188144-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p283188144-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:283188144", "Proof|ID:283188144-1"},
 CellID->1859154459],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p283188144-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->1994023359]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(non-existence seq P binary subSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(non-existence seq P binary subSeq)\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "\[LeftTriangleBar]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{"\[Not]", 
                    RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                    "]"}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Exists]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["h", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   StyleBox["h", "ExpressionVariable"], "\[LeftTriangleBar]", 
                   StyleBox["f", "ExpressionVariable"]}], "\[And]", 
                 RowBox[{
                   UnderscriptBox[
                    UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                    RowBox[{
                    StyleBox["j", "ExpressionVariable"], ">", 
                    StyleBox["i", "ExpressionVariable"]}]], 
                   RowBox[{"\[Not]", 
                    RowBox[{
                    TagBox["(", "AutoParentheses"], 
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    StyleBox["h", "ExpressionVariable"], "[", 
                    StyleBox["j", "ExpressionVariable"], "]"}]}], "]"}], 
                    TagBox[
                    ")", "AutoParentheses"]}]}]}]}]}]}]}]}], \
$CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:44762641"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p44762641-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p44762641-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:44762641", "Proof|ID:44762641-1"},
 CellID->46003965],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p44762641-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->90370019]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Images of Sequences under Functions (\[Checkmark])\
\>", "Subsubsection",
 CellChangeTimes->{{3.64636782025709*^9, 3.646367833116569*^9}, 
   3.6463712153156767`*^9, {3.6463811054846363`*^9, 3.6463811097910624`*^9}},
 CellID->39838153],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "f"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1357006098}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646368111448225*^9, 3.646368125779097*^9}, 
   3.646638055721727*^9},
 CellTags->{
  "ID:1357006098", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1357006098],

Cell["", "OpenEnvironment",
 CellID->1621518880],

Cell[CellGroupData[{

Cell["Lemma: Simple Properties of Images of Sequences", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6463681366173553`*^9, 3.646368142234693*^9}},
 CellID->1970240712],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "g"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 341801516}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646368149031649*^9, 3.646368150015753*^9}},
 CellTags->{
  "ID:341801516", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->341801516],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"h", "=", 
   RowBox[{"imgSeq", "[", 
    RowBox[{"f", ",", "g"}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 627432657}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463681520616617`*^9, 3.6463681572513237`*^9}},
 CellTags->{
  "ID:627432657", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->627432657],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["\[Element]", 
    RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
   RowBox[{"[", "f", "]"}]}], "\[Implies]", 
  RowBox[{
   UnderscriptBox["\[ForAll]", "\[ScriptCapitalD]1"], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
         RowBox[{"[", "x", "]"}]}]], 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalD]1"], 
        RowBox[{"[", 
         RowBox[{"g", "[", "x", "]"}], "]"}]}]}], 
      TagBox[")",
       "AutoParentheses"]}], "\[Implies]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]1", "]"}]], 
      RowBox[{"[", "h", "]"}]}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences imgSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:814769285", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463681650630217`*^9, 3.646368215553*^9}, {
  3.646638043710369*^9, 3.6466380520410147`*^9}},
 CellTags->{
  "ID:814769285", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences imgSeq", "IR"},
 CellID->814769285],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"isNatMapping", "[", "m", "]"}]], 
  RowBox[{
   UnderscriptBox["\[ForAll]", 
    RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     RowBox[{
      RowBox[{"subSeq", "[", 
       RowBox[{"h", ",", "m"}], "]"}], "[", "i", "]"}], "\[Equal]", 
     RowBox[{
      RowBox[{"imgSeq", "[", 
       RowBox[{
        RowBox[{"subSeq", "[", 
         RowBox[{"f", ",", "m"}], "]"}], ",", "g"}], "]"}], "[", "i", "]"}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(subSeq imgSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:527722954", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6466380727374277`*^9, 3.646638122854497*^9}, {
  3.646638170284404*^9, 3.6466381798921337`*^9}},
 CellTags->{
  "ID:527722954", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq imgSeq", "IR"},
 CellID->527722954],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->562890915]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1299180967],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSequences imgSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSequences imgSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}, {
             StyleBox["g", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalD]1", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]1", "ExpressionVariable"]], "[", 
               RowBox[{
                 StyleBox["g", "ExpressionVariable"], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]1", "ExpressionVariable"], "]"}]], 
             "[", 
             RowBox[{"imgSeq", "[", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}, {
             StyleBox["g", "ExpressionVariable"]}, {
             StyleBox["\[ScriptCapitalD]1", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   StyleBox["x", "ExpressionVariable"], "]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]1", "ExpressionVariable"]], "[", 
               RowBox[{
                 StyleBox["g", "ExpressionVariable"], "[", 
                 StyleBox["x", "ExpressionVariable"], "]"}], "]"}]}], 
           "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]1", "ExpressionVariable"], "]"}]], 
             "[", 
             RowBox[{"imgSeq", "[", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:814769285"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p814769285-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p814769285-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:814769285", "Proof|ID:814769285-1"},
 CellID->1610479839],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p814769285-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->174940712]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(subSeq imgSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(subSeq imgSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             StyleBox["g", "ExpressionVariable"]}, {
             RowBox[{"isNatMapping", "[", 
               StyleBox["m", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"subSeq", "[", 
               RowBox[{
                 RowBox[{"imgSeq", "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], ",", 
                 StyleBox["m", "ExpressionVariable"]}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[Equal]", 
           RowBox[{
             RowBox[{"imgSeq", "[", 
               RowBox[{
                 RowBox[{"subSeq", "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["m", "ExpressionVariable"]}], "]"}], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             StyleBox["g", "ExpressionVariable"]}, {
             RowBox[{"isNatMapping", "[", 
               StyleBox["m", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"subSeq", "[", 
               RowBox[{
                 RowBox[{"imgSeq", "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], ",", 
                 StyleBox["m", "ExpressionVariable"]}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[Equal]", 
           RowBox[{
             RowBox[{"imgSeq", "[", 
               RowBox[{
                 RowBox[{"subSeq", "[", 
                   RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["m", "ExpressionVariable"]}], "]"}], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:527722954"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p527722954-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p527722954-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:527722954", "Proof|ID:527722954-1"},
 CellID->503452461],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p527722954-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->332933660]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tuple- and Set Sequences (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.64636856474986*^9, 3.646368572442829*^9}, 
   3.64637121763934*^9, {3.646371414007544*^9, 3.646371417298915*^9}, {
   3.64639419876262*^9, 3.646394202788759*^9}, {3.646554316144621*^9, 
   3.6465543170021973`*^9}, {3.646554415097938*^9, 3.6465544249856663`*^9}, 
   3.646560718862105*^9, {3.646637991777959*^9, 3.646637994520927*^9}},
 CellID->599814689],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "f"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 148582272}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646368579340106*^9, 3.646368590626412*^9}, 
   3.6463923995945997`*^9},
 CellTags->{
  "ID:148582272", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->148582272],

Cell["", "OpenEnvironment",
 CellID->111632028],

Cell[CellGroupData[{

Cell["Lemma: Simple Properties of Cumulative Tuple Sequences", \
"EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.646368595528544*^9, 3.646368606911564*^9}, {
  3.646371448966734*^9, 3.646371449657799*^9}, {3.646391736044417*^9, 
  3.646391738216016*^9}},
 CellID->1413443761],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"h", "=", 
   RowBox[{"tupSeq", "[", "f", "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1254928956}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646558233370289*^9, 3.646558241426538*^9}},
 CellTags->{
  "ID:1254928956", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1254928956],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
  "i", "\[Element]", "\[DoubleStruckCapitalN]"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 462368090}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646558255878042*^9, 3.6465582678276987`*^9}},
 CellTags->{
  "ID:462368090", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->462368090],

Cell[BoxData[
 RowBox[{"isTuple", "[", 
  RowBox[{"h", "[", "i", "]"}], "]"}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isTuple tupSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1139194187", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646560628274284*^9, 3.6465606314674597`*^9}},
 CellTags->{
  "ID:1139194187", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isTuple tupSeq", "IR"},
 CellID->1139194187],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", "1", "]"}], "\[Equal]", 
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{"f", "[", "1", "]"}], 
   "\[RightAngleBracket]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(tupSeq 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:794519991", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465585678013363`*^9, 3.646558575608474*^9}},
 CellTags->{
  "ID:794519991", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "tupSeq 1", "IR"},
 CellID->794519991],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", 
   RowBox[{"i", "+", "1"}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"h", "[", "i", "]"}], 
   TagBox["\:293a",
    Identity,
    SyntaxForm->"a*b"], 
   RowBox[{"f", "[", 
    RowBox[{"i", "+", "1"}], "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(tupSeq +1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1371530240", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6465582909261417`*^9, 3.646558304119152*^9}},
 CellTags->{
  "ID:1371530240", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "tupSeq +1", "IR"},
 CellID->1371530240],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["\[Element]", 
    RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
   RowBox[{"[", "f", "]"}]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1979298560}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646393526413624*^9, 3.6463935316231623`*^9}},
 CellTags->{
  "ID:1979298560", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1979298560],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", 
   RowBox[{"DomainTuples", "[", "\[ScriptCapitalD]", "]"}]], 
  RowBox[{"[", 
   RowBox[{"h", "[", "i", "]"}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainTuples tupSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1953194276", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646393538977406*^9, 3.64639356495439*^9}, 
   3.6465582457995358`*^9, 3.6465606626459303`*^9},
 CellTags->{
  "ID:1953194276", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainTuples tupSeq", "IR"},
 CellID->1953194276],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", 
   RowBox[{"DomainSequences", "[", 
    RowBox[{"DomainTuples", "[", "\[ScriptCapitalD]", "]"}], "]"}]], 
  RowBox[{"[", "h", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences tupSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1662300990", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646368637360642*^9, 3.646368695953979*^9}, {
   3.6463689646001253`*^9, 3.646368980653646*^9}, 3.646381786237009*^9, {
   3.646392388663074*^9, 3.646392396605812*^9}, {3.646393529286097*^9, 
   3.646393529850922*^9}, 3.646558247416093*^9},
 CellTags->{
  "ID:1662300990", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences tupSeq", "IR"},
 CellID->1662300990],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->2021563103]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1824927207],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isTuple tupSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isTuple tupSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{"isTuple", "[", 
           RowBox[{
             RowBox[{"tupSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{"isTuple", "[", 
           RowBox[{
             RowBox[{"tupSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1139194187"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1139194187-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1139194187-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1139194187", "Proof|ID:1139194187-1"},
 CellID->943422580],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1139194187-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1204429517]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(tupSeq 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(tupSeq 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"tupSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", "1", "]"}], 
           "\[Equal]", 
           RowBox[{"\[LeftAngleBracket]", 
             RowBox[{
               StyleBox["f", "ExpressionVariable"], "[", "1", "]"}], 
             "\[RightAngleBracket]"}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"tupSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", "1", "]"}], 
           "\[Equal]", 
           RowBox[{"\[LeftAngleBracket]", 
             RowBox[{
               StyleBox["f", "ExpressionVariable"], "[", "1", "]"}], 
             "\[RightAngleBracket]"}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:794519991"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p794519991-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p794519991-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:794519991", "Proof|ID:794519991-1"},
 CellID->1464040180],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p794519991-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1313144744]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(tupSeq +1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(tupSeq +1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"tupSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}], 
           "\[Equal]", 
           RowBox[{
             RowBox[{
               RowBox[{"tupSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["i", "ExpressionVariable"], "]"}], "\:293a", 
             RowBox[{
               StyleBox["f", "ExpressionVariable"], "[", 
               RowBox[{
                 StyleBox["i", "ExpressionVariable"], "+", "1"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"tupSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}], 
           "\[Equal]", 
           RowBox[{
             RowBox[{
               RowBox[{"tupSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["i", "ExpressionVariable"], "]"}], "\:293a", 
             RowBox[{
               StyleBox["f", "ExpressionVariable"], "[", 
               RowBox[{
                 StyleBox["i", "ExpressionVariable"], "+", "1"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1371530240"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1371530240-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1371530240-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1371530240", "Proof|ID:1371530240-1"},
 CellID->215916439],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1371530240-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1464403863]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainTuples tupSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainTuples tupSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainTuples", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               RowBox[{
                 RowBox[{"tupSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                 StyleBox["i", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainTuples", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               RowBox[{
                 RowBox[{"tupSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                 StyleBox["i", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1953194276"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1953194276-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1953194276-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1953194276", "Proof|ID:1953194276-1"},
 CellID->709826783],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1953194276-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellChangeTimes->{{3.6466375231073837`*^9, 3.6466375250991297`*^9}},
 CellID->1762868189]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSequences tupSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSequences tupSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Element]", 
            RowBox[{"DomainSequences", "[", 
              RowBox[{"DomainTuples", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
              "]"}]], "[", 
           RowBox[{"tupSeq", "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
         RowBox[{
           UnderscriptBox["\[Element]", 
            RowBox[{"DomainSequences", "[", 
              RowBox[{"DomainTuples", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
              "]"}]], "[", 
           RowBox[{"tupSeq", "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1662300990"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1662300990-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1662300990-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1662300990", "Proof|ID:1662300990-1"},
 CellID->103093795],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1662300990-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellChangeTimes->{3.6463938843479443`*^9},
 CellID->1183821222]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->1002113064],

Cell[CellGroupData[{

Cell["Lemma: Simple Properties of Cumulative Set Sequences", \
"EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.646368753672763*^9, 3.646368767949253*^9}, {
  3.646369166359935*^9, 3.646369171430962*^9}, {3.6463714364234333`*^9, 
  3.646371451881617*^9}, {3.6463917411302567`*^9, 3.6463917435677757`*^9}},
 CellID->731916267],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"h", "=", 
   RowBox[{"setSeq", "[", "f", "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 791300552}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646368774434794*^9, 3.646368782464175*^9}, {
  3.646369004875333*^9, 3.646369007092998*^9}},
 CellTags->{
  "ID:791300552", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->791300552],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
  "i", "\[Element]", "\[DoubleStruckCapitalN]"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1677316354}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463690732588453`*^9, 3.6463690767800207`*^9}},
 CellTags->{
  "ID:1677316354", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1677316354],

Cell[BoxData[
 RowBox[{"isSet", "[", 
  RowBox[{"h", "[", "i", "]"}], "]"}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isSet setSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1304989559", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646560677518963*^9, 3.6465606846296253`*^9}},
 CellTags->{
  "ID:1304989559", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isSet setSeq"},
 CellID->1304989559],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", "i", "]"}], "\[Equal]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"f", "[", "j", "]"}], 
    UnderscriptBox["|", 
     RowBox[{"j", "\[Element]", 
      SubscriptBox["\[DoubleStruckCapitalN]", 
       RowBox[{"1", ",", "\[Ellipsis]", ",", "i"}]]}]]}], 
   "}"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:600858398", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646369018621984*^9, 3.646369041323764*^9}, {
   3.646369078769702*^9, 3.64636908283652*^9}, 3.646369217288989*^9, {
   3.6463831772965384`*^9, 3.646383184737842*^9}},
 CellTags->{
  "ID:600858398", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq alternative", "IR"},
 CellID->600858398],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", "1", "]"}], "\[Equal]", 
  RowBox[{"{", 
   RowBox[{"f", "[", "1", "]"}], "}"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq 1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1813366458", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64655867769772*^9, 3.646558680763879*^9}, 
   3.646558719680732*^9},
 CellTags->{
  "ID:1813366458", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq 1", "IR"},
 CellID->1813366458],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", 
   RowBox[{"i", "+", "1"}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"h", "[", "i", "]"}], "\[Union]", 
   RowBox[{"{", 
    RowBox[{"f", "[", 
     RowBox[{"i", "+", "1"}], "]"}], "}"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq +1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:282957248", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646554337178384*^9, 3.646554348807514*^9}},
 CellTags->{
  "ID:282957248", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq +1", "IR"},
 CellID->282957248],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", "x"], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{"x", "\[Element]", 
      RowBox[{"h", "[", "i", "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], "\[DoubleLongLeftRightArrow]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[Exists]", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", "\[Ellipsis]", ",", "i"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"x", "\[Equal]", 
        RowBox[{"f", "[", "j", "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[Element] setSeq I)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1456913783", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646369089220797*^9, 3.646369135174171*^9}, 
   3.646369218693622*^9},
 CellTags->{
  "ID:1456913783", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[Element] setSeq I", "IR"},
 CellID->1456913783],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{
    RowBox[{"j", "=", "1"}], ",", "\[Ellipsis]", ",", "i"}]], 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{"f", "[", "j", "]"}], "\[Element]", 
    RowBox[{"h", "[", "i", "]"}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[Element] setSeq II)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2074355943", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463691838355827`*^9, 3.6463692199088*^9}},
 CellTags->{
  "ID:2074355943", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[Element] setSeq II", "IR"},
 CellID->2074355943],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", "i", "]"}], "\[SubsetEqual]", 
  RowBox[{"h", "[", 
   RowBox[{"i", "+", "1"}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[SubsetEqual] setSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:2028876528", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646384567111747*^9, 3.6463845888386*^9}, 
   3.646384645527029*^9},
 CellTags->{
  "ID:2028876528", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[SubsetEqual] setSeq", "IR"},
 CellID->2028876528],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"k", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
  RowBox[{
   RowBox[{"h", "[", "k", "]"}], "\[SubsetEqual]", 
   RowBox[{"h", "[", 
    RowBox[{"k", "+", "i"}], "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[SubsetEqual] setSeq ind)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:919542923", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646991310277811*^9, 3.646991333176893*^9}},
 CellTags->{
  "ID:919542923", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[SubsetEqual] setSeq ind"},
 CellID->919542923],

Cell[BoxData[
 RowBox[{
  UnderscriptBox[
   UnderscriptBox["\[ForAll]", 
    RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
   RowBox[{"j", "\[GreaterEqual]", "i"}]], 
  RowBox[{
   RowBox[{"h", "[", "i", "]"}], "\[SubsetEqual]", 
   RowBox[{"h", "[", "j", "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(\[SubsetEqual] setSeq II)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1620668672", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646991340912648*^9, 3.646991353293606*^9}},
 CellTags->{
  "ID:1620668672", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[SubsetEqual] setSeq II"},
 CellID->1620668672],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["\[Element]", 
    RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
   RowBox[{"[", "f", "]"}]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1306894362}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646393991306635*^9, 3.646393996473768*^9}},
 CellTags->{
  "ID:1306894362", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1306894362],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", 
   RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
  RowBox[{"[", 
   RowBox[{"h", "[", "i", "]"}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSets setSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1977563124", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646394005845407*^9, 3.6463940229586363`*^9}, 
   3.646560743957699*^9},
 CellTags->{
  "ID:1977563124", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSets setSeq", "IR"},
 CellID->1977563124],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Element]", 
   RowBox[{"DomainSequences", "[", 
    RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}], "]"}]], 
  RowBox[{"[", "h", "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences setSeq)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1963351311", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6463692245940113`*^9, 3.646369229986319*^9}, {
  3.64639242474545*^9, 3.6463924315105677`*^9}, {3.646393994082478*^9, 
  3.646393994977682*^9}},
 CellTags->{
  "ID:1963351311", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences setSeq", "IR"},
 CellID->1963351311],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1378714125]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->403992653],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isSet setSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isSet setSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{"isSet", "[", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{"isSet", "[", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], 
           "]"}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1304989559"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1304989559-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1304989559-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1304989559", "Proof|ID:1304989559-1"},
 CellID->1710781526],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1304989559-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->2031883802]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq alternative)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[Equal]", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], "[", 
                 StyleBox["j", "ExpressionVariable"], "]"}], 
               UnderscriptBox["|", 
                GridBox[{{
                   RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    SubscriptBox["\[DoubleStruckCapitalN]", 
                    RowBox[{"1", ",", "\[Ellipsis]", ",", 
                    StyleBox["i", "ExpressionVariable"]}]]}]}}]]}], 
             "}"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[Equal]", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], "[", 
                 StyleBox["j", "ExpressionVariable"], "]"}], 
               UnderscriptBox["|", 
                GridBox[{{
                   RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    SubscriptBox["\[DoubleStruckCapitalN]", 
                    RowBox[{"1", ",", "\[Ellipsis]", ",", 
                    StyleBox["i", "ExpressionVariable"]}]]}]}}]]}], 
             "}"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:600858398"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p600858398-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p600858398-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:600858398", "Proof|ID:600858398-1"},
 CellID->1970211136],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p600858398-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->1307335873]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq 1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq 1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", "1", "]"}], 
           "\[Equal]", 
           RowBox[{"{", 
             RowBox[{
               StyleBox["f", "ExpressionVariable"], "[", "1", "]"}], 
             "}"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", "1", "]"}], 
           "\[Equal]", 
           RowBox[{"{", 
             RowBox[{
               StyleBox["f", "ExpressionVariable"], "[", "1", "]"}], 
             "}"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1813366458"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1813366458-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1813366458-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1813366458", "Proof|ID:1813366458-1"},
 CellID->1785703456],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1813366458-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->940005247]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq +1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq +1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}], 
           "\[Equal]", 
           RowBox[{
             RowBox[{
               RowBox[{"setSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["i", "ExpressionVariable"], "]"}], "\[Union]", 
             RowBox[{"{", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}], 
               "}"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}], 
           "\[Equal]", 
           RowBox[{
             RowBox[{
               RowBox[{"setSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["i", "ExpressionVariable"], "]"}], "\[Union]", 
             RowBox[{"{", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], "[", 
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}], 
               "}"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:282957248"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p282957248-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p282957248-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:282957248", "Proof|ID:282957248-1"},
 CellID->257579260],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p282957248-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1452926057]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[Element] setSeq I)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[Element] setSeq I)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             StyleBox["x", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               StyleBox["x", "ExpressionVariable"], "\[Element]", 
               RowBox[{
                 RowBox[{"setSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                 StyleBox["i", "ExpressionVariable"], "]"}]}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{
                   RowBox[{
                    StyleBox["j", "ExpressionVariable"], "=", "1"}], ",", 
                   "\[Ellipsis]", ",", 
                   StyleBox["i", "ExpressionVariable"]}]}}]], 
             RowBox[{
               StyleBox["x", "ExpressionVariable"], "\[Equal]", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], "[", 
                 StyleBox["j", "ExpressionVariable"], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             StyleBox["x", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{"(", 
             RowBox[{
               StyleBox["x", "ExpressionVariable"], "\[Element]", 
               RowBox[{
                 RowBox[{"setSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                 StyleBox["i", "ExpressionVariable"], "]"}]}], ")"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{
             UnderscriptBox["\[Exists]", 
              GridBox[{{
                 RowBox[{
                   RowBox[{
                    StyleBox["j", "ExpressionVariable"], "=", "1"}], ",", 
                   "\[Ellipsis]", ",", 
                   StyleBox["i", "ExpressionVariable"]}]}}]], 
             RowBox[{
               StyleBox["x", "ExpressionVariable"], "\[Equal]", 
               RowBox[{
                 StyleBox["f", "ExpressionVariable"], "[", 
                 StyleBox["j", "ExpressionVariable"], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1456913783"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1456913783-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1456913783-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1456913783", "Proof|ID:1456913783-1"},
 CellID->660915054],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1456913783-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->122844036]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[Element] setSeq II)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[Element] setSeq II)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             RowBox[{
               RowBox[{
                 StyleBox["j", "ExpressionVariable"], "=", "1"}], ",", 
               "\[Ellipsis]", ",", 
               StyleBox["i", "ExpressionVariable"]}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["f", "ExpressionVariable"], "[", 
             StyleBox["j", "ExpressionVariable"], "]"}], "\[Element]", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             RowBox[{
               RowBox[{
                 StyleBox["j", "ExpressionVariable"], "=", "1"}], ",", 
               "\[Ellipsis]", ",", 
               StyleBox["i", "ExpressionVariable"]}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["f", "ExpressionVariable"], "[", 
             StyleBox["j", "ExpressionVariable"], "]"}], "\[Element]", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:2074355943"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p2074355943-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p2074355943-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:2074355943", "Proof|ID:2074355943-1"},
 CellID->1118991764],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p2074355943-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {25., 31.}}]], "ProofInfoBody",
 CellID->760690908]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[SubsetEqual] setSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[SubsetEqual] setSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "+", "1"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "+", "1"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:2028876528"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p2028876528-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p2028876528-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:2028876528", "Proof|ID:2028876528-1"},
 CellID->594436158],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p2028876528-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->303866791]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[SubsetEqual] setSeq ind)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[SubsetEqual] setSeq ind)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             RowBox[{
               StyleBox["k", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["k", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["k", "ExpressionVariable"], "+", 
               StyleBox["i", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             RowBox[{
               StyleBox["k", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             StyleBox["k", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
           RowBox[{
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "[", 
             RowBox[{
               StyleBox["k", "ExpressionVariable"], "+", 
               StyleBox["i", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:919542923"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p919542923-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p919542923-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:919542923", "Proof|ID:919542923-1"},
 CellID->1947715984],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p919542923-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->299306856]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(\[SubsetEqual] setSeq II)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(\[SubsetEqual] setSeq II)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             RowBox[{
               StyleBox["j", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
             StyleBox["i", "ExpressionVariable"]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"setSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["i", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
             RowBox[{
               RowBox[{"setSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["j", "ExpressionVariable"], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}, {
             RowBox[{
               StyleBox["j", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             StyleBox["j", "ExpressionVariable"], "\[GreaterEqual]", 
             StyleBox["i", "ExpressionVariable"]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               RowBox[{"setSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["i", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
             RowBox[{
               RowBox[{"setSeq", "[", 
                 StyleBox["f", "ExpressionVariable"], "]"}], "[", 
               StyleBox["j", "ExpressionVariable"], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1620668672"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1620668672-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1620668672-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1620668672", "Proof|ID:1620668672-1"},
 CellID->1297375468],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1620668672-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->958645388]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSets setSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSets setSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               RowBox[{
                 RowBox[{"setSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                 StyleBox["i", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               RowBox[{
                 RowBox[{"setSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                 StyleBox["i", "ExpressionVariable"], "]"}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1977563124"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1977563124-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1977563124-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1977563124", "Proof|ID:1977563124-1"},
 CellID->1381526050],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1977563124-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1576193163]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSequences setSeq)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSequences setSeq)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
                "]"}]], "[", 
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             StyleBox["f", "ExpressionVariable"], "]"}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                RowBox[{"DomainSets", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}], 
                "]"}]], "[", 
             RowBox[{"setSeq", "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1963351311"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1963351311-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1963351311-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1963351311", "Proof|ID:1963351311-1"},
 CellID->410175681],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1963351311-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->283292552]
}, Closed]],

Cell["", "OpenEnvironment",
 CellID->997501851],

Cell[CellGroupData[{

Cell["Lemma: setSeq and subSeq", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6469780694957857`*^9, 3.64697807409251*^9}},
 CellID->1684644361],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"isIncrMapping", "[", "g", "]"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1148013153}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64697808858381*^9, 3.64697809303328*^9}, {
   3.64697840927964*^9, 3.646978430131452*^9}, 3.646978668638154*^9, 
   3.6469787738863087`*^9, {3.646978848946315*^9, 3.646978853304825*^9}, 
   3.646982007598302*^9, {3.646995991905706*^9, 3.646995992123782*^9}},
 CellTags->{
  "ID:1148013153", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1148013153],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"h", "=", 
   RowBox[{"setSeq", "[", "f", "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1542915564}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646978100389146*^9, 3.646978104857544*^9}},
 CellTags->{
  "ID:1542915564", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1542915564],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"s", "=", 
   RowBox[{"setSeq", "[", 
    RowBox[{"subSeq", "[", 
     RowBox[{"f", ",", "g"}], "]"}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 304038122}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646978109268517*^9, 3.646978129447441*^9}},
 CellTags->{
  "ID:304038122", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->304038122],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
  RowBox[{
   RowBox[{"s", "[", "i", "]"}], "\[SubsetEqual]", 
   RowBox[{
    RowBox[{"subSeq", "[", 
     RowBox[{"h", ",", "g"}], "]"}], "[", "i", 
    "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq subSeq \[SubsetEqual])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:57707614", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646978148874907*^9, 3.64697815986926*^9}, {
   3.646978777232229*^9, 3.646978785639379*^9}, 3.646978856297433*^9, {
   3.6469825734543133`*^9, 3.646982602018297*^9}},
 CellTags->{
  "ID:57707614", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq subSeq \[SubsetEqual]"},
 CellID->57707614],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", "P"]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1967681402}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646978664521283*^9, 3.646978665493367*^9}},
 CellTags->{
  "ID:1967681402", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1967681402],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["\[Element]", 
      RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
     RowBox[{"[", "f", "]"}]}], "\[And]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{"P", "[", 
       RowBox[{
        RowBox[{"h", "[", "i", "]"}], ",", 
        RowBox[{"h", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1555261236}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646991381861669*^9, 3.646991394082602*^9}},
 CellTags->{
  "ID:1555261236", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1555261236],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", 
       RowBox[{"A", ",", "B"}], "]"}]}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
       RowBox[{"[", "b", "]"}]}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"A", ",", 
           RowBox[{"A", "\[Union]", 
            RowBox[{"{", "b", "}"}]}]}], "]"}], "\[And]", 
         RowBox[{"B", "\[SubsetEqual]", "A"}]}], 
        TagBox[")",
         "AutoParentheses"]}], "\[Implies]", 
       RowBox[{"P", "[", 
        RowBox[{"B", ",", 
         RowBox[{"B", "\[Union]", 
          RowBox[{"{", "b", "}"}]}]}], "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   UnderscriptBox["\[ForAll]", 
    RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
   RowBox[{"P", "[", 
    RowBox[{
     RowBox[{"s", "[", "i", "]"}], ",", 
     RowBox[{"s", "[", 
      RowBox[{"i", "+", "1"}], "]"}]}], "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq subSeq P binary)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:710393364", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6469891984389763`*^9, 3.646989274580303*^9}},
 CellTags->{
  "ID:710393364", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq subSeq P binary"},
 CellID->710393364],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", 
       RowBox[{"A", ",", "B"}], "]"}]}]], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{
       UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
       RowBox[{"[", "b", "]"}]}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"A", ",", 
           RowBox[{"A", "\[Union]", 
            RowBox[{"{", "b", "}"}]}]}], "]"}], "\[And]", 
         RowBox[{"B", "\[SubsetEqual]", "A"}]}], 
        TagBox[")",
         "AutoParentheses"]}], "\[Implies]", 
       RowBox[{"P", "[", 
        RowBox[{"B", ",", 
         RowBox[{"B", "\[Union]", 
          RowBox[{"{", "b", "}"}]}]}], "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   UnderscriptBox[
    UnderscriptBox["\[ForAll]", "s0"], 
    RowBox[{"s0", "\[LeftTriangleBar]", "f"}]], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
    RowBox[{"P", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"setSeq", "[", "s0", "]"}], "[", "i", "]"}], ",", 
      RowBox[{
       RowBox[{"setSeq", "[", "s0", "]"}], "[", 
       RowBox[{"i", "+", "1"}], "]"}]}], 
     "]"}]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq subsequence P binary)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:622465561", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6469958775423098`*^9, 3.6469959373850822`*^9}},
 CellTags->{
  "ID:622465561", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq subsequence P binary"},
 CellID->622465561],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    UnderscriptBox["\[ForAll]", 
     RowBox[{
      UnderscriptBox["\[Element]", 
       RowBox[{"DomainSets", "[", "\[ScriptCapitalD]", "]"}]], 
      RowBox[{"[", 
       RowBox[{"A", ",", "B", ",", "C"}], "]"}]}]], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"P", "[", 
         RowBox[{"A", ",", "B"}], "]"}], "\[And]", 
        RowBox[{"B", "\[SubsetEqual]", "C"}]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[Implies]", 
      RowBox[{"P", "[", 
       RowBox[{"A", ",", "C"}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]"}]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 2032932287}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6469786757616987`*^9, 3.6469786838034573`*^9}, {
  3.646978805466152*^9, 3.646978819987414*^9}, {3.646981983058219*^9, 
  3.646982004989171*^9}, {3.646991385511704*^9, 3.646991396901856*^9}},
 CellTags->{
  "ID:2032932287", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->2032932287],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"k", ",", 
    RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
  RowBox[{"P", "[", 
   RowBox[{
    RowBox[{"h", "[", "i", "]"}], ",", 
    RowBox[{"h", "[", 
     RowBox[{"i", "+", "k"}], "]"}]}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq transitive P I)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:525775183", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.646978713859708*^9, 3.646978727252117*^9}, {
  3.646978830048843*^9, 3.6469788331171303`*^9}},
 CellTags->{
  "ID:525775183", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq transitive P I"},
 CellID->525775183],

Cell[BoxData[
 RowBox[{
  UnderscriptBox[
   UnderscriptBox["\[ForAll]", 
    RowBox[{"i", ",", 
     RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
   RowBox[{"j", ">", "i"}]], 
  RowBox[{"P", "[", 
   RowBox[{
    RowBox[{"h", "[", "i", "]"}], ",", 
    RowBox[{"h", "[", "j", "]"}]}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(setSeq transitive P II)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:397952331", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{
  3.646978742402586*^9, {3.646978834523432*^9, 3.64697883592876*^9}, {
   3.646978882644836*^9, 3.64697889101092*^9}},
 CellTags->{
  "ID:397952331", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq transitive P II"},
 CellID->397952331],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->216509956]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1092859258],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq subSeq \[SubsetEqual])\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq subSeq \[SubsetEqual])\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{"isIncrMapping", "[", 
               StyleBox["g", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               RowBox[{"subSeq", "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], ",", 
                   StyleBox["g", "ExpressionVariable"]}], "]"}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
           RowBox[{
             RowBox[{"subSeq", "[", 
               RowBox[{
                 RowBox[{"setSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{"isIncrMapping", "[", 
               StyleBox["g", "ExpressionVariable"], "]"}]}, {
             RowBox[{
               StyleBox["i", "ExpressionVariable"], "\[Element]", 
               "\[DoubleStruckCapitalN]"}]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{"setSeq", "[", 
               RowBox[{"subSeq", "[", 
                 RowBox[{
                   StyleBox["f", "ExpressionVariable"], ",", 
                   StyleBox["g", "ExpressionVariable"]}], "]"}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], "]"}], "\[SubsetEqual]", 
           RowBox[{
             RowBox[{"subSeq", "[", 
               RowBox[{
                 RowBox[{"setSeq", "[", 
                   StyleBox["f", "ExpressionVariable"], "]"}], ",", 
                 StyleBox["g", "ExpressionVariable"]}], "]"}], "[", 
             StyleBox["i", "ExpressionVariable"], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:57707614"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p57707614-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p57707614-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:57707614", "Proof|ID:57707614-1"},
 CellID->240880461],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p57707614-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->61395463]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq subSeq P binary)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq subSeq P binary)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{"isIncrMapping", "[", 
               StyleBox["g", "ExpressionVariable"], "]"}]}, {
             StyleBox["P", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["b", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   RowBox[{
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], "]"}], 
                    "\[And]", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["A", "ExpressionVariable"]}]}], "\[Implies]", 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], 
                    "]"}]}]}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          GridBox[{{
             StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}, {
             StyleBox["f", "ExpressionVariable"]}, {
             RowBox[{"isIncrMapping", "[", 
               StyleBox["g", "ExpressionVariable"], "]"}]}, {
             StyleBox["P", "ExpressionVariable"]}}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["b", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   RowBox[{
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], "]"}], 
                    "\[And]", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["A", "ExpressionVariable"]}]}], "\[Implies]", 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], 
                    "]"}]}]}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    RowBox[{"subSeq", "[", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], ",", 
                    StyleBox["g", "ExpressionVariable"]}], "]"}], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:710393364"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p710393364-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p710393364-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:710393364", "Proof|ID:710393364-1"},
 CellID->127172224],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p710393364-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {46., 52.}}]], "ProofInfoBody",
 CellID->1754240357]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq subsequence P binary)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq subsequence P binary)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["b", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   RowBox[{
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], "]"}], 
                    "\[And]", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["A", "ExpressionVariable"]}]}], "\[Implies]", 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], 
                    "]"}]}]}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 RowBox[{
                   StyleBox["s0", "ExpressionVariable"]}]], 
                RowBox[{
                  StyleBox["s0", "ExpressionVariable"], "\[LeftTriangleBar]", 
                  StyleBox["f", "ExpressionVariable"]}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["s0", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["s0", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["b", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   RowBox[{
                    RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], "]"}], 
                    "\[And]", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["A", "ExpressionVariable"]}]}], "\[Implies]", 
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], ",", 
                    RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[Union]", 
                    RowBox[{"{", 
                    StyleBox["b", "ExpressionVariable"], "}"}]}]}], 
                    "]"}]}]}]}], "\[Implies]", 
             RowBox[{
               UnderscriptBox[
                UnderscriptBox["\[ForAll]", 
                 RowBox[{
                   StyleBox["s0", "ExpressionVariable"]}]], 
                RowBox[{
                  StyleBox["s0", "ExpressionVariable"], "\[LeftTriangleBar]", 
                  StyleBox["f", "ExpressionVariable"]}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["s0", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                    RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["s0", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                   "]"}]}]}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:622465561"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p622465561-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p622465561-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:622465561", "Proof|ID:622465561-1"},
 CellID->1443092268],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p622465561-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1086243377]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq transitive P I)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq transitive P I)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["C", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["B", "ExpressionVariable"]}], "]"}], "\[And]", 
                   RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["C", "ExpressionVariable"]}]}], "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["C", "ExpressionVariable"]}], "]"}]}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["k", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}, {
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", 
                    StyleBox["k", "ExpressionVariable"]}], "]"}]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["C", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["B", "ExpressionVariable"]}], "]"}], "\[And]", 
                   RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["C", "ExpressionVariable"]}]}], "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["C", "ExpressionVariable"]}], "]"}]}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[ForAll]", 
              GridBox[{{
                 RowBox[{
                   StyleBox["k", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}, {
                 RowBox[{
                   StyleBox["i", "ExpressionVariable"], "\[Element]", 
                   "\[DoubleStruckCapitalN]"}]}}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", 
                    StyleBox["k", "ExpressionVariable"]}], "]"}]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:525775183"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p525775183-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p525775183-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:525775183", "Proof|ID:525775183-1"},
 CellID->143657730],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p525775183-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {31., 37.}}]], "ProofInfoBody",
 CellID->103241608]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(setSeq transitive P II)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(setSeq transitive P II)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["C", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["B", "ExpressionVariable"]}], "]"}], "\[And]", 
                   RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["C", "ExpressionVariable"]}]}], "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["C", "ExpressionVariable"]}], "]"}]}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                StyleBox["j", "ExpressionVariable"], ">", 
                StyleBox["i", "ExpressionVariable"]}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   StyleBox["j", "ExpressionVariable"], "]"}]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["f", "ExpressionVariable"], ",", 
            StyleBox["P", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                RowBox[{"DomainSequences", "[", 
                  StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]],
                "[", 
               StyleBox["f", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["A", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["B", "ExpressionVariable"], "]"}]}, {
                   RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSets", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["C", "ExpressionVariable"], "]"}]}}]], 
               RowBox[{
                 RowBox[{
                   RowBox[{
                    StyleBox["P", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["B", "ExpressionVariable"]}], "]"}], "\[And]", 
                   RowBox[{
                    StyleBox["B", "ExpressionVariable"], "\[SubsetEqual]", 
                    StyleBox["C", "ExpressionVariable"]}]}], "\[Implies]", 
                 RowBox[{
                   StyleBox["P", "ExpressionVariable"], "[", 
                   RowBox[{
                    StyleBox["A", "ExpressionVariable"], ",", 
                    StyleBox["C", "ExpressionVariable"]}], "]"}]}]}], 
             "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 StyleBox["P", "ExpressionVariable"], "[", 
                 RowBox[{
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                   RowBox[{
                    RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], "]"}]}], 
                 "]"}]}]}], "\[Implies]", 
           RowBox[{
             UnderscriptBox[
              UnderscriptBox["\[ForAll]", 
               GridBox[{{
                  RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}, {
                  RowBox[{
                    StyleBox["j", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
              RowBox[{
                StyleBox["j", "ExpressionVariable"], ">", 
                StyleBox["i", "ExpressionVariable"]}]], 
             RowBox[{
               StyleBox["P", "ExpressionVariable"], "[", 
               RowBox[{
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   StyleBox["i", "ExpressionVariable"], "]"}], ",", 
                 RowBox[{
                   RowBox[{"setSeq", "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}], "[", 
                   StyleBox["j", "ExpressionVariable"], "]"}]}], 
               "]"}]}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:397952331"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p397952331-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p397952331-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:397952331", "Proof|ID:397952331-1"},
 CellID->825469030],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p397952331-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1841738698]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Natural Recursion (\[Checkmark])", "Subsubsection",
 CellChangeTimes->{{3.647856346267066*^9, 3.647856350021545*^9}, {
  3.647856917538316*^9, 3.64785692136664*^9}, {3.657958238419675*^9, 
  3.6579582394336767`*^9}},
 CellID->979798864],

Cell["", "OpenEnvironment",
 CellID->875877332],

Cell[CellGroupData[{

Cell["Lemma: Natural Recursion and Domain Sequences", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647856358165469*^9, 3.6478563658102922`*^9}, {
  3.6597624944028206`*^9, 3.659762511937251*^9}},
 CellID->1290937647],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{"b", ",", "C", ",", "P"}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1448839763}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647857588691709*^9, 3.6478576040017443`*^9}},
 CellTags->{
  "ID:1448839763", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1448839763],

Cell[BoxData[
 UnderscriptBox["let", 
  RowBox[{"f", "=", 
   RowBox[{"natRec1", "[", 
    RowBox[{"b", ",", "C"}], "]"}]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 1803197151}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647857629920052*^9, 3.6478576402482433`*^9}, {
   3.657958244815686*^9, 3.6579582451276865`*^9}, 3.6597639823888392`*^9},
 CellTags->{
  "ID:1803197151", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1803197151],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{
    RowBox[{
     UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
     RowBox[{"[", "b", "]"}]}], "\[And]", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{
         UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
         RowBox[{"[", "a", "]"}]}]], 
       RowBox[{
        UnderscriptBox["\[Element]", "\[ScriptCapitalD]"], 
        RowBox[{"[", 
         RowBox[{"C", "[", 
          RowBox[{"i", ",", "a"}], "]"}], "]"}]}]}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{
   UnderscriptBox["\[Element]", 
    RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
   RowBox[{"[", "f", "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(DomainSequences natRec1)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:571239857", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.6478564910180197`*^9, 3.6478565813515387`*^9}, 
   3.6478566365509377`*^9, {3.647857593524103*^9, 3.647857597551633*^9}, 
   3.647857642987327*^9},
 CellTags->{
  "ID:571239857", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences natRec1", "IR"},
 CellID->571239857],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1264693290]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->851206410],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(DomainSequences natRec1)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(DomainSequences natRec1)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["b", "ExpressionVariable"], ",", 
            StyleBox["C", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["b", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   RowBox[{
                    StyleBox["C", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], ",", 
                    StyleBox["a", "ExpressionVariable"]}], "]"}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             RowBox[{"primRec", "[", 
               RowBox[{
                 StyleBox["b", "ExpressionVariable"], ",", 
                 StyleBox["C", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["b", "ExpressionVariable"], ",", 
            StyleBox["C", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{
             RowBox[{
               UnderscriptBox["\[Element]", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
               StyleBox["b", "ExpressionVariable"], "]"}], "\[And]", 
             RowBox[{
               UnderscriptBox["\[ForAll]", 
                GridBox[{{
                   RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                    StyleBox["a", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[Element]", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]], "[", 
                   RowBox[{
                    StyleBox["C", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], ",", 
                    StyleBox["a", "ExpressionVariable"]}], "]"}], "]"}]}]}]}],
            "\[Implies]", 
           RowBox[{
             UnderscriptBox["\[Element]", 
              RowBox[{"DomainSequences", "[", 
                StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], "]"}]], 
             "[", 
             RowBox[{"primRec", "[", 
               RowBox[{
                 StyleBox["b", "ExpressionVariable"], ",", 
                 StyleBox["C", "ExpressionVariable"]}], "]"}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:571239857"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p571239857-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p571239857-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:571239857", "Proof|ID:571239857-1"},
 CellID->1151616933],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p571239857-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1250697138]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Alternative Description of Noetherianity (\[Checkmark])\
\>", "Subsubsection",
 CellChangeTimes->{{3.647853120630661*^9, 3.647853124154614*^9}, {
  3.6478596211925573`*^9, 3.64785963453366*^9}},
 CellID->1533920470],

Cell[BoxData[
 UnderscriptBox["\[ForAll]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   TagBox["\[Succeeds]",
    Identity], 
   TagBox[")",
    "AutoParentheses"]}]]], "GlobalDeclaration",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Language`Session`Private`removeGlobal[{
         "C:\\Users\\Alex\\Documents\\Doktorat\\Theorema Notebooks\\Reduction \
Ring Theory\\Sequences.nb", 646368107}]]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647853177328388*^9, 3.6478531869453707`*^9}, 
   3.65976416940877*^9},
 CellTags->{
  "ID:646368107", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->646368107],

Cell["", "OpenEnvironment",
 CellID->1976234692],

Cell[CellGroupData[{

Cell["Lemma: Alternative Description of Noetherianity", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.6478531621928787`*^9, 3.647853170871249*^9}, {
  3.647859641130584*^9, 3.6478596417660933`*^9}},
 CellID->144716839],

Cell[BoxData[
 RowBox[{
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], "\[Implies]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Not]", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "f", "]"}]}]], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], "\[Succeeds]", 
        RowBox[{"f", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox[
        "(isNoetherian alternative \[DoubleRightArrow])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1140411407", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647853204157074*^9, 3.647853272409425*^9}},
 CellTags->{
  "ID:1140411407", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isNoetherian alternative \[DoubleRightArrow]"},
 CellID->1140411407],

Cell[BoxData[
 RowBox[{
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Not]", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "f", "]"}]}]], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], "\[Succeeds]", 
        RowBox[{"f", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}], "\[Implies]", 
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], 
   "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox[
        "(isNoetherian alternative \[DoubleLeftArrow])", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:199914937", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.64785591041029*^9, 3.6478559195561543`*^9}},
 CellTags->{
  "ID:199914937", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isNoetherian alternative \[DoubleLeftArrow]"},
 CellID->199914937],

Cell[BoxData[
 RowBox[{
  RowBox[{"isNoetherian", "[", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[Succeeds]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}], ",", "\[ScriptCapitalD]"}], "]"}], 
  "\[DoubleLongLeftRightArrow]", 
  RowBox[{
   TagBox["(",
    "AutoParentheses"], 
   RowBox[{"\[Not]", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "f", "]"}]}]], 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"i", "\[Element]", "\[DoubleStruckCapitalN]"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"f", "[", "i", "]"}], "\[Succeeds]", 
        RowBox[{"f", "[", 
         RowBox[{"i", "+", "1"}], "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}]}], 
   TagBox[")",
    "AutoParentheses"]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(isNoetherian alternative)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:1370074896", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647859390223503*^9, 3.6478593996260767`*^9}},
 CellTags->{
  "ID:1370074896", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isNoetherian alternative", "IR"},
 CellID->1370074896],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1985690430]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->266751900],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isNoetherian alternative \[DoubleRightArrow])\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isNoetherian alternative \[DoubleRightArrow])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "\[Succeeds]", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], 
                    "]"}]}]}]}], 
               TagBox[
               ")", "AutoParentheses"]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[Implies]", 
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "\[Succeeds]", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], 
                    "]"}]}]}]}], 
               TagBox[
               ")", "AutoParentheses"]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1140411407"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1140411407-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1140411407-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1140411407", "Proof|ID:1140411407-1"},
 CellID->1132196675],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1140411407-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->426882134]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isNoetherian alternative \[DoubleLeftArrow])\"\>", 
       "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isNoetherian alternative \[DoubleLeftArrow])\"\>", 
       "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "\[Succeeds]", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], 
                    "]"}]}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm], DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "\[Succeeds]", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], 
                    "]"}]}]}]}], 
               TagBox[")", "AutoParentheses"]}]}], "\[Implies]", 
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], 
             "]"}]}]}], $CellContext`TheoremaForm]], "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:199914937"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p199914937-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p199914937-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:199914937", "Proof|ID:199914937-1"},
 CellID->1848022108],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p199914937-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {38., 45.}}]], "ProofInfoBody",
 CellID->747427303]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox["\<\"\[CheckmarkedBox]\"\>",
   StripOnInput->False,
   ShowStringCharacters->False]]],
 " Proof of ",
 Cell[BoxData[
  ButtonBox[
   TagBox[
    TooltipBox[
     PaneSelectorBox[{False->
      StyleBox["\<\"(isNoetherian alternative)\"\>", "FormReference",
       StripOnInput->False], True->
      StyleBox["\<\"(isNoetherian alternative)\"\>", "FormReferenceHover",
       StripOnInput->False]}, Dynamic[
       CurrentValue["MouseOver"]],
      FrameMargins->0,
      ImageSize->Automatic],
     TagBox[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "\[Succeeds]", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], 
                    "]"}]}]}]}], 
               TagBox[
               ")", "AutoParentheses"]}]}]}]}], $CellContext`TheoremaForm], 
      DisplayForm]],
    Annotation[#, 
     DisplayForm[
      FormBox[
       RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
            StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], ",", 
            StyleBox["\[Succeeds]", "ExpressionVariable"]}]], 
         RowBox[{
           RowBox[{"isNoetherian", "[", 
             RowBox[{
               StyleBox["\[Succeeds]", "ExpressionVariable"], ",", 
               StyleBox["\[ScriptCapitalD]", "ExpressionVariable"]}], "]"}], 
           "\[DoubleLeftRightArrow]", 
           RowBox[{"\[Not]", 
             RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", 
                  GridBox[{{
                    RowBox[{
                    UnderscriptBox["\[Element]", 
                    RowBox[{"DomainSequences", "[", 
                    StyleBox["\[ScriptCapitalD]", "ExpressionVariable"], 
                    "]"}]], "[", 
                    StyleBox["f", "ExpressionVariable"], "]"}]}}]], 
                 RowBox[{
                   UnderscriptBox["\[ForAll]", 
                    GridBox[{{
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "\[Element]", 
                    "\[DoubleStruckCapitalN]"}]}}]], 
                   RowBox[{
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    StyleBox["i", "ExpressionVariable"], "]"}], "\[Succeeds]", 
                    RowBox[{
                    StyleBox["f", "ExpressionVariable"], "[", 
                    RowBox[{
                    StyleBox["i", "ExpressionVariable"], "+", "1"}], 
                    "]"}]}]}]}], 
               TagBox[
               ")", "AutoParentheses"]}]}]}]}], $CellContext`TheoremaForm]], 
     "Tooltip"]& ],
   Appearance->None,
   ButtonFunction:>NotebookLocate["ID:1370074896"],
   Evaluator->Automatic,
   Method->"Preemptive"]]],
 " #1:   ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["\<\"Show proof\"\>",
    StripOnInput->False,
    FontVariations->{"Underline"->True}],
   Appearance->None,
   ButtonFunction:>Theorema`Common`displayProof[
     ToExpression[
     "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \"p1370074896-1-po.m\"}]"]],
   Evaluator->Automatic,
   ImageSize->Automatic,
   Method->"Queued"]]]
}], "ProofInfo",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Interface`GUI`Private`removeGroup[
         ButtonNotebook[], "p1370074896-1"]]]]}, {None, None}},
 CellTags->{"Proof|ID:1370074896", "Proof|ID:1370074896-1"},
 CellID->2015968322],

Cell[BoxData[
 DynamicBox[ToBoxes[
   Refresh[
    ReplaceAll[
     Get[
      ToExpression[
      "FileNameJoin[{CurrentValue[\"NotebookDirectory\"], \
FileBaseName[CurrentValue[\"NotebookFileName\"]], \
\"p1370074896-1-display.m\"}]"]], Theorema`Interface`GUI`Private`FORM -> 
     Theorema`Interface`GUI`Private`displayFormulaFromKey], 
    TrackedSymbols :> {Theorema`Common`$tmaEnv}], StandardForm],
  ImageSizeCache->{516., {24., 30.}}]], "ProofInfoBody",
 CellID->1932073843]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Dickson Domains (\[Checkmark])", "Section",
 CellChangeTimes->{{3.6470808410624104`*^9, 3.6470808443618507`*^9}, {
  3.647853142870945*^9, 3.6478531454681892`*^9}, {3.655449015001694*^9, 
  3.6554490480269527`*^9}},
 CellID->1470860699],

Cell[CellGroupData[{

Cell["Informal Explanation", "Subsection",
 CellChangeTimes->{{3.647080855843582*^9, 3.647080859418686*^9}},
 CellID->638816316],

Cell[TextData[{
 "A domain ",
 Cell[BoxData[
  FormBox["D", TraditionalForm]]],
 " belongs to category \[OpenCurlyDoubleQuote]DicksonDomain\
\[CloseCurlyDoubleQuote] iff it is endowed with a binary relation \
\[PrecedesEqual] such that there does not exist an infinite sequence ",
 Cell[BoxData[
  FormBox["S", TraditionalForm]]],
 " with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "i"], "\[NotPrecedesEqual]", 
    SubscriptBox["S", "j"]}], TraditionalForm]]],
 " for all ",
 Cell[BoxData[
  FormBox[
   RowBox[{"j", ">", "i"}], TraditionalForm]]],
 ". The most famous class of examples of such a domain is most probably the \
class of domains ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalN]", "n"], TraditionalForm]]],
 " with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "\[PrecedesEqual]", 
    RowBox[{"y", ":", 
     RowBox[{"\[DoubleLeftRightArrow]", 
      RowBox[{
       UnderscriptBox["\[ForAll]", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", "\[Ellipsis]", ",", "n"}]], 
       RowBox[{
        SubscriptBox["x", "i"], "\[LessEqual]", 
        SubscriptBox["y", "i"]}]}]}]}]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.647080821332724*^9, 3.64708082977032*^9}, {
  3.647080863621956*^9, 3.6470810830794287`*^9}},
 CellID->1469052720]
}, Closed]],

Cell[CellGroupData[{

Cell["Definition", "Subsection",
 CellChangeTimes->{{3.647081109433404*^9, 3.647081111081395*^9}},
 CellID->562649382],

Cell["", "OpenEnvironment",
 CellID->1973229411],

Cell[CellGroupData[{

Cell["Definition: Dickson Domain", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.647081116525856*^9, 3.647081120275054*^9}},
 CellID->1054407908],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[ForAll]", 
   RowBox[{"\[ScriptCapitalD]", ",", 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     TagBox["\[PrecedesEqual]",
      Identity], 
     TagBox[")",
      "AutoParentheses"]}]}]], 
  RowBox[{
   RowBox[{"isDicksonDomain", "[", 
    RowBox[{"\[ScriptCapitalD]", ",", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox["\[PrecedesEqual]",
       Identity], 
      TagBox[")",
       "AutoParentheses"]}]}], "]"}], 
   TagBox[
    RowBox[{
    ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
     "\[DoubleLongLeftRightArrow]"}],
    Identity,
    SyntaxForm->"a\[DoubleLongLeftRightArrow]b"], 
   RowBox[{
    TagBox["(",
     "AutoParentheses"], 
    RowBox[{
     UnderscriptBox["\[ForAll]", 
      RowBox[{
       UnderscriptBox["\[Element]", 
        RowBox[{"DomainSequences", "[", "\[ScriptCapitalD]", "]"}]], 
       RowBox[{"[", "S", "]"}]}]], 
     RowBox[{
      UnderscriptBox[
       UnderscriptBox["\[Exists]", 
        RowBox[{"i", ",", 
         RowBox[{"j", "\[Element]", "\[DoubleStruckCapitalN]"}]}]], 
       RowBox[{"j", ">", "i"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{"S", "[", "i", "]"}], "\[PrecedesEqual]", 
        RowBox[{"S", "[", "j", "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}], 
    TagBox[")",
     "AutoParentheses"]}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        StyleBox["(Dickson domain)", "FrameLabel"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[{
           "ID:610667129", 
            "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"}]]}]]]}, {None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.647081125456695*^9, 3.647081269236171*^9}, {
  3.647081335008719*^9, 3.647081341502048*^9}},
 CellTags->{
  "ID:610667129", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "Dickson domain"},
 CellID->610667129],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1499268482]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->833346990]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{1105, 761},
WindowMargins->{{2, Automatic}, {0, Automatic}},
ShowSelection->True,
CounterAssignments->{{"TheoremaFormulaCounter" -> 1}},
Magnification->1.,
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Theorema"}, "TheoremaCore.nb"]]], 
   Cell["Modify the definitions below to change the default appearance of all \
cells in a given style. \nMake modifications to any definition using commands \
in the Format menu.", "Text"], 
   Cell[
    CellGroupData[{
      Cell["Notebook Options Settings", "Section"], 
      Cell[
      "The options defined for the style below will be used at the Notebook \
level.", "Text"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Notebook"], InputAliases -> {"and" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[And]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "or" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", "\[Or]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "not" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Not]", "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "impl" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[Implies]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[DoubleLongLeftRightArrow]", 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[Equal]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox[
                  
                  RowBox[{
                   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
                    "\[DoubleLongLeftRightArrow]"}], Identity, SyntaxForm -> 
                  "a:=b"], "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", ":=", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "andn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[And]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "orn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Or]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "equivn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[DoubleLeftRightArrow]", "\[Piecewise]", 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "cdist" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Piecewise]", 
                 
                 GridBox[{{
                   "\[SelectionPlaceholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}, {
                   "\[Placeholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "far" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exr" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "farc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exrc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "let" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["let", 
                  RowBox[{"\[Placeholder]", "=", "\[Placeholder]"}]], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "app" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293a", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "prep" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293b", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "join" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22c8", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "elemT" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22ff", Identity, SyntaxForm -> "a+b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "subop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "supop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SuperscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "subsupop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubsuperscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "oop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "uoop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               UnderoverscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "osop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox[
                OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
                "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "op" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               TagBox["\[SelectionPlaceholder]", Identity], 
               TagBox[")", "AutoParentheses"]}], "[]" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:e114", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:e115", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "()" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:fd3e", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:fd3f", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "<>" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27e8", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27e9", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "{}" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:e117", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:e118", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "[[]]" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27e6", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27e7", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "(())" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:2e28", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:2e29", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "<<>>" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:27ea", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:27eb", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "{{}}" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 TagBox["\:2983", Identity, SyntaxForm -> "("], 
                 "\[SelectionPlaceholder]", 
                 TagBox["\:2984", Identity, SyntaxForm -> ")"]}], 
               TagBox[")", "AutoParentheses"]}], "(" -> 
            TagBox["(", "AutoParentheses"], ")" -> 
            TagBox[")", "AutoParentheses"]}, Background -> 
          RGBColor[0.957, 0.96, 0.97]], 
         Cell[
          StyleData["Notebook", "Printout"], Background -> None]}, Open]]}, 
     Open]], 
   Cell[
    CellGroupData[{
      Cell["Style Environment Names", "Section"], 
      Cell[
       StyleData[All, "Working"], DockedCells -> {
         Cell[
         "Theorema 2.0", "SBO", FontTracking -> 8, 
          CellMargins -> {{0, 0}, {0, 0}}, 
          CellFrameMargins -> {{0, 50}, {0, 0}}, FontSize -> 28, FontSlant -> 
          "Plain", FontColor -> RGBColor[0.29, 0.46, 0.6], TextAlignment -> 
          Right, Background -> RGBColor[0.36, 0.54, 0.69]]}], 
      Cell[
       StyleData[
       All, "Layout", StyleDefinitions -> StyleData[All, "Working"]], 
       MenuSortingValue -> 1200]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Styles for Title and Section Cells", "Section"], 
      Cell[
       CellGroupData[{
         Cell["Title", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{27, 27}, {10, 30}}, 
             TextAlignment -> Center, MenuSortingValue -> 1100, 
             MenuCommandKey -> "1", FontFamily -> "Bitstream Charter", 
             FontSize -> 36, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Title", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{6, 10}, {5, 30}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], CellMargins -> {{27, 27}, {20, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1150, FontFamily -> 
             "Bitstream Charter", FontSize -> 24, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{6, 10}, {5, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], CellMargins -> {{27, 27}, {8, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Author"], CellMargins -> {{27, 27}, {18, 20}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Sectioning", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], ShowGroupOpener -> True, MenuSortingValue -> 
             1250, MenuCommandKey -> "4", FontFamily -> "Bitstream Charter", 
             FontSize -> 20, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Section", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{2, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {8, 12}}, 
             MenuSortingValue -> 1300, MenuCommandKey -> "5", FontFamily -> 
             "Bitstream Charter", FontSize -> 14, FontWeight -> "Bold", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Subsection", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{9, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {2, 10}}, 
             MenuSortingValue -> 1350, MenuCommandKey -> "6", FontFamily -> 
             "Bitstream Charter", FontSize -> 12, FontWeight -> "Bold", 
             FontSlant -> "Italic", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsection", "Printout"], ShowGroupOpener -> False,
              CellMargins -> {{35, 0}, {7, 14}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsubsection"], CellDingbat -> None, 
             ShowGroupOpener -> True, 
             CellMargins -> {{27, Inherited}, {Inherited, Inherited}}, 
             FontFamily -> "Bitstream Charter", FontSize -> 11, FontWeight -> 
             "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsubsection", "Printout"], 
             CellMargins -> {{50, 0}, {7, 14}}]}, Closed]]}, Open]]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Styles for Publication\[Hyphen]ready Documents", "Section"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Author"], CellMargins -> {{27, 30}, {20, 5}}, 
          MenuSortingValue -> 1900, FontFamily -> "Helvetica", FontSize -> 14,
           FontSlant -> "Italic"], 
         Cell[
          StyleData["Author", "Printout"], CellMargins -> {{6, 10}, {0, 10}}, 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Abstract"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
          CellMargins -> {{27, 140}, {20, 20}}, LineSpacing -> {0.9, 0}, 
          MenuSortingValue -> 2050, FontFamily -> "Times", FontSize -> 12], 
         Cell[
          StyleData["Abstract", "Printout"], Hyphenation -> True, 
          LineSpacing -> {1, 2}, FontSize -> 10]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Text", "Section"], 
      Cell[
       StyleData["Text"], CellMargins -> {{27, 27}, {Inherited, Inherited}}, 
       TextJustification -> 1., ParagraphIndent -> 15, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["EnvironmentText"], ShowCellBracket -> Automatic, 
       CellMargins -> {{82, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextJustification -> 1., ParagraphSpacing -> {0.3, 0.}, 
       MenuSortingValue -> 1480, MenuCommandKey -> "T", FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Item"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "Item", 
          CounterAssignments -> {{"Subitem", 0}, {"Subsubitem", 0}}, 
          MenuSortingValue -> 1600, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Item", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemParagraph"], CellMargins -> {{81, 10}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          DefaultNewCellStyle -> "Item", MenuSortingValue -> 1600, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemParagraph", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "Subitem", 
          CounterAssignments -> {{"Subsubitem", 0}}, MenuSortingValue -> 1610,
           FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subitem", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemParagraph"], CellMargins -> {{105, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subitem", 
          MenuSortingValue -> 1610, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemParagraph", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subsubitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1620, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subsubitem", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemParagraph"], 
          CellMargins -> {{129, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1625, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemParagraph", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "ItemNumbered", 
          CounterAssignments -> {{"SubitemNumbered", 0}, {
            "SubsubitemNumbered", 0}}, MenuSortingValue -> 1630, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemNumbered", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "SubitemNumbered", 
          CounterAssignments -> {{"SubsubitemNumbered", 0}}, MenuSortingValue -> 
          1640, FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemNumbered", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], ".", 
              CounterBox["SubsubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> 
          "SubitemNumbered", CounterIncrements -> "SubsubitemNumbered", 
          MenuSortingValue -> 1645, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemNumbered", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Theorema", "Section"], 
      Cell[
       StyleData["GlobalDeclaration"], CellFrame -> {{0, 2}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 3}, {2, 2}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       InitializationCell -> True, CellFrameMargins -> 10, CellFrameColor -> 
       RGBColor[0.73, 0.65, 0.61], CellFrameLabelMargins -> {{33, 7}, {1, 1}},
        ShowAutoStyles -> False, MenuSortingValue -> 1441, MenuCommandKey -> 
       "G", FontSize -> 14], 
      Cell[
       StyleData["OpenEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {-4, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       StyleData["EnvironmentHeader"], 
       CellFrame -> {{False, False}, {False, False}}, 
       CellMargins -> {{76, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 6, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       ShowAutoStyles -> False, MenuSortingValue -> 1450, FontSize -> 14, 
       FontWeight -> "Bold", FontVariations -> {"CapsType" -> "SmallCaps"}, 
       Background -> RGBColor[0.89, 0.8, 0.69]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FormalTextInputFormula"], ShowCellBracket -> Automatic, 
          CellMargins -> {{96, 10}, {2, 2}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
          InitializationCell -> True, CellFrameLabelMargins -> 53, 
          ShowAutoStyles -> False, LimitsPositioningTokens -> {}, 
          MenuSortingValue -> 1470, MenuCommandKey -> "F", FontWeight -> 
          "Bold", FontColor -> RGBColor[0.25, 0.19, 0.2]], 
         Cell[
          StyleData["FormalTextInputFormula", "Layout"], Editable -> False], 
         Cell[
          StyleData["FormalTextInputFormula", "Presentation"], Editable -> 
          False]}, Open]], 
      Cell[
       StyleData["EndEnvironmentMarker"], 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextAlignment -> Right, MenuSortingValue -> 1480], 
      Cell[
       StyleData["CloseEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {False, True}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {Inherited, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Computation"], CellFrame -> {{1.5, 0}, {0, 0}}, 
          ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 7}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
          CellFrameMargins -> {{8, 8}, {3, 4}}, CellFrameColor -> 
          RGBColor[0.486, 0.33, 0.32], ShowAutoStyles -> False, 
          MenuSortingValue -> 1510, FontWeight -> "Bold", FontColor -> 
          RGBColor[0.23, 0.25, 0.34], Background -> 
          RGBColor[0.88, 0.88, 0.92]], 
         Cell[
          StyleData["Computation", "Layout"], Editable -> False], 
         Cell[
          StyleData["Computation", "Presentation"], Editable -> False]}, 
        Open]], 
      Cell[
       StyleData["ComputationResult"], CellFrame -> {{1.5, 0}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
       CellFrameMargins -> {{8, 8}, {4, 3}}, CellFrameColor -> 
       RGBColor[0.486, 0.33, 0.32], StyleMenuListing -> None, FontColor -> 
       RGBColor[0.23, 0.25, 0.34], Background -> RGBColor[0.88, 0.88, 0.92]], 
      Cell[
       StyleData["ComputationInfo"], ShowCellBracket -> False, 
       CellMargins -> {{120, 10}, {10, 2}}, StyleMenuListing -> None, 
       FontFamily -> $CellContext`Arial], 
      Cell[
       StyleData["ComputationInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{144, 10}, {10, 2}}, StyleMenuListing -> None], 
      Cell[
       StyleData["ProofInfo"], ShowCellBracket -> False, 
       CellMargins -> {{76, 10}, {6, 6}}, CellFrameLabelMargins -> 15, 
       StyleMenuListing -> None, FontFamily -> "Arial"], 
      Cell[
       StyleData["ProofInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{100, 10}, {0, 0}}, StyleMenuListing -> None], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FrameLabel"], LanguageCategory -> None, StyleMenuListing -> 
          None, FontFamily -> "Times New Roman", FontSize -> 10, FontWeight -> 
          "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
          RGBColor[0.55, 0.44, 0.42], Background -> None], 
         Cell[
          StyleData["FrameLabel", "Printout"]]}, Open]], 
      Cell[
       StyleData["OpenArchive"], CellFrame -> {{False, False}, {False, True}},
        ShowCellBracket -> Automatic, CellMargins -> {{70, 70}, {0, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 20}, CellFrameMargins -> 3, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], CellFrameLabelMargins -> 1, 
       DefaultFormatType -> DefaultInputFormatType, ShowAutoStyles -> False, 
       MenuSortingValue -> 1210, FontWeight -> Bold, Background -> 
       RGBColor[0.73, 0.74, 0.84]], 
      Cell[
       StyleData["ArchiveInfo"], ShowCellBracket -> Automatic, 
       CellMargins -> {{70, 70}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 5, CellFrameLabelMargins -> 3, ShowCellTags -> 
       False, ShowAutoStyles -> False, MenuSortingValue -> 1220, FontWeight -> 
       "Bold", Background -> RGBColor[0.88, 0.88, 0.92]], 
      Cell[
       StyleData["CloseArchive"], 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> 
       Automatic, CellMargins -> {{0, 0}, {5, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 25}, CellFrameMargins -> 2, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], TextAlignment -> Center, 
       MenuSortingValue -> 1230, FontFamily -> "Arial Black", FontSize -> 24, 
       FontWeight -> "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       Background -> RGBColor[0.73, 0.65, 0.61]], 
      Cell[
       StyleData["IncludeArchive"], CellFrame -> {{4, 0}, {False, False}}, 
       ShowCellBracket -> Automatic, 
       CellMargins -> {{81, 100}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameColor -> RGBColor[0.55, 0.44, 0.42], 
       CellFrameLabels -> {{"\[RightSkeleton]", None}, {None, None}}, 
       CellFrameLabelMargins -> 25, MenuSortingValue -> 1445], 
      Cell[
       StyleData["ExpressionVariable"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionABF"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionMeta"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["AutoParentheses"], Editable -> False, SpanMaxSize -> 3, 
          FontOpacity -> 0.15], 
         Cell[
          StyleData["AutoParentheses", "Layout"], FontOpacity -> 0], 
         Cell[
          StyleData["AutoParentheses", "SlideShow"], FontOpacity -> 0]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Emphasized"], MenuCommandKey -> "E", FontSlant -> 
          "Italic"], 
         Cell[
          StyleData["Emphasized", "SlideShow"], FontSlant -> "Plain", 
          FontColor -> RGBColor[0.36, 0.54, 0.69]]}, Open]], 
      Cell[
       StyleData["GenericButton"], FontFamily -> "Bitstream Charter", 
       FontWeight -> "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
       FontVariations -> {
        "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
         "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
       RGBColor[0.23, 0.25, 0.34]], 
      Cell[
       StyleData["TheoremaForm"], "TwoByteSyntaxCharacterAutoReplacement" -> 
       True, LineSpacing -> {1.25, 0, 2}, SingleLetterItalics -> True, 
       StyleMenuListing -> None, FontFamily -> "Courier"], 
      Cell[
       StyleData["ComponentActive"], FontFamily -> "Times New Roman"], 
      Cell[
       StyleData["ComponentInactive"], FontFamily -> "Times New Roman", 
       FontOpacity -> 0.4], 
      Cell[
       StyleData["ComponentEmpty"], FontFamily -> "Times New Roman", 
       FontVariations -> {"StrikeThrough" -> True}], 
      Cell[
       StyleData["TabView"], FontFamily -> "Times New Roman", FontSize -> 10], 
      Cell[
       StyleData["TabViewLabel"], FontFamily -> "Times New Roman", FontSize -> 
       10, FontWeight -> "Bold"], 
      Cell[
       StyleData["FormReference", StyleDefinitions -> StyleData["Text"]], 
       FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> "Plain",
        FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["FormReferenceHover", StyleDefinitions -> StyleData["Text"]],
        FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> 
       "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> True}, 
       FontColor -> RGBColor[0.404, 0.43, 0.545]], 
      Cell[
       StyleData["DisplayFormula"], CellMargins -> {{36, 6}, {7, 7}}, 
       ConversionRules :> {
        "HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}}, 
       CellHorizontalScrolling -> True, DefaultFormatType -> TraditionalForm, 
       InputAutoReplacements -> {}, TextAlignment -> Center, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       ButtonBoxOptions -> {Appearance -> {Automatic, None}}]}, Open]]}, 
  Visible -> False, FrontEndVersion -> 
  "9.0 for Linux x86 (64-bit) (February 7, 2013)", StyleDefinitions -> 
  "StylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ID:695794617"->{
  Cell[53078, 1412, 632, 15, 31, "GlobalDeclaration",
   CellTags->{
    "ID:695794617", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->695794617]},
 "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"->{
  Cell[53078, 1412, 632, 15, 31, "GlobalDeclaration",
   CellTags->{
    "ID:695794617", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->695794617],
  Cell[53713, 1429, 708, 17, 30, "GlobalDeclaration",
   CellTags->{
    "ID:925721429", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->925721429],
  Cell[54424, 1448, 620, 15, 30, "GlobalDeclaration",
   CellTags->{
    "ID:243637066", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->243637066],
  Cell[55047, 1465, 1587, 48, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:458427713", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "DomainSequences decision predicate"},
   CellID->458427713],
  Cell[58256, 1568, 709, 16, 30, "GlobalDeclaration",
   CellTags->{
    "ID:1289924462", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1289924462],
  Cell[58968, 1586, 1459, 40, 33, "FormalTextInputFormula",
   CellTags->{
    "ID:230504716", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq"},
   CellID->230504716],
  Cell[60430, 1628, 1217, 36, 31, "FormalTextInputFormula",
   CellTags->{
    "ID:809351385", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "imgSeq"},
   CellID->809351385],
  Cell[61650, 1666, 1348, 39, 47, "FormalTextInputFormula",
   CellTags->{
    "ID:1865902758", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq"},
   CellID->1865902758],
  Cell[63001, 1707, 970, 27, 21, "FormalTextInputFormula",
   CellTags->{
    "ID:238284462", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq"},
   CellID->238284462],
  Cell[64692, 1763, 1829, 58, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1986096562", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[LeftTriangleBar]"},
   CellID->1986096562],
  Cell[66969, 1839, 653, 15, 31, "GlobalDeclaration",
   CellTags->{
    "ID:489544091", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->489544091],
  Cell[68598, 1884, 666, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1306945267", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1306945267],
  Cell[69267, 1902, 783, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:638827787", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->638827787],
  Cell[70053, 1921, 710, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:29525805", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->29525805],
  Cell[70766, 1941, 1397, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1744060660", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences subSeq", "IR"},
   CellID->1744060660],
  Cell[72166, 1981, 642, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1383543831", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1383543831],
  Cell[72811, 1998, 1572, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1895094895", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1895094895],
  Cell[74386, 2048, 1504, 47, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1841507065", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "sequence transitive P I"},
   CellID->1841507065],
  Cell[75893, 2097, 1532, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1455385635", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "sequence transitive P II"},
   CellID->1455385635],
  Cell[77428, 2147, 1696, 54, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:796771086", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq P binary"},
   CellID->796771086],
  Cell[117055, 3149, 823, 18, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:113922190", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->113922190],
  Cell[117881, 3169, 913, 20, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:936476105", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->936476105],
  Cell[118797, 3191, 1270, 32, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1324913148", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "DomainSequences \[LeftTriangleBar]", "IR"},
   CellID->1324913148],
  Cell[120070, 3225, 810, 18, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1481705576", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1481705576],
  Cell[120883, 3245, 1757, 50, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:794304435", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->794304435],
  Cell[122643, 3297, 1655, 49, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1003845896", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[LeftTriangleBar] P binary"},
   CellID->1003845896],
  Cell[140027, 3752, 655, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:51050760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->51050760],
  Cell[140685, 3770, 1819, 53, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1171839467", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 1"},
   CellID->1171839467],
  Cell[142507, 3825, 1672, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:756173591", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 2"},
   CellID->756173591],
  Cell[144182, 3878, 1862, 58, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1593038128", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 3"},
   CellID->1593038128],
  Cell[146047, 3938, 2025, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:377390901", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 4"},
   CellID->377390901],
  Cell[148075, 4002, 2182, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1934441835", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 5"},
   CellID->1934441835],
  Cell[187595, 5050, 1480, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:144670545", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences finite domain"},
   CellID->144670545],
  Cell[189078, 5094, 797, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:72630978", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->72630978],
  Cell[189878, 5116, 1986, 60, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1747499940", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 1"},
   CellID->1747499940],
  Cell[191867, 5178, 1956, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:31395941", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 2"},
   CellID->31395941],
  Cell[193826, 5239, 2050, 64, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:228528973", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 3"},
   CellID->228528973],
  Cell[195879, 5305, 2244, 69, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:854524374", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 4"},
   CellID->854524374],
  Cell[198126, 5376, 2276, 70, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:527068444", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 5"},
   CellID->527068444],
  Cell[249580, 6698, 634, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:21904240", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->21904240],
  Cell[250217, 6715, 2587, 74, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:315841131", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 6"},
   CellID->315841131],
  Cell[263271, 7057, 731, 17, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:432936581", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->432936581],
  Cell[264005, 7076, 2168, 66, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:557118158", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "non-existence seq P"},
   CellID->557118158],
  Cell[266176, 7144, 2426, 72, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:283188144", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "non-existence seq P binary"},
   CellID->283188144],
  Cell[268605, 7218, 2976, 89, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:44762641", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "non-existence seq P binary subSeq"},
   CellID->44762641],
  Cell[298498, 7991, 664, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1357006098", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1357006098],
  Cell[299644, 8025, 635, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:341801516", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->341801516],
  Cell[300282, 8042, 715, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:627432657", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->627432657],
  Cell[301000, 8062, 1731, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:814769285", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences imgSeq", "IR"},
   CellID->814769285],
  Cell[302734, 8115, 1367, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:527722954", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq imgSeq", "IR"},
   CellID->527722954],
  Cell[314809, 8447, 663, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:148582272", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->148582272],
  Cell[316058, 8484, 689, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1254928956", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1254928956],
  Cell[316750, 8503, 694, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:462368090", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->462368090],
  Cell[317447, 8522, 795, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1139194187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isTuple tupSeq", "IR"},
   CellID->1139194187],
  Cell[318245, 8545, 869, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:794519991", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq 1", "IR"},
   CellID->794519991],
  Cell[319117, 8571, 965, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1371530240", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq +1", "IR"},
   CellID->1371530240],
  Cell[320085, 8602, 771, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1979298560", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1979298560],
  Cell[320859, 8623, 951, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1953194276", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainTuples tupSeq", "IR"},
   CellID->1953194276],
  Cell[321813, 8650, 1117, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1662300990", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences tupSeq", "IR"},
   CellID->1662300990],
  Cell[342257, 9248, 735, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:791300552", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->791300552],
  Cell[342995, 9268, 699, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1677316354", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1677316354],
  Cell[343697, 9287, 783, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1304989559", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isSet setSeq"},
   CellID->1304989559],
  Cell[344483, 9310, 1150, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:600858398", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq alternative", "IR"},
   CellID->600858398],
  Cell[345636, 9343, 854, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1813366458", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq 1", "IR"},
   CellID->1813366458],
  Cell[346493, 9369, 939, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:282957248", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq +1", "IR"},
   CellID->282957248],
  Cell[347435, 9398, 1549, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1456913783", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq I", "IR"},
   CellID->1456913783],
  Cell[348987, 9451, 1048, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2074355943", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq II", "IR"},
   CellID->2074355943],
  Cell[350038, 9484, 885, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2028876528", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq", "IR"},
   CellID->2028876528],
  Cell[350926, 9510, 968, 26, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:919542923", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq ind"},
   CellID->919542923],
  Cell[351897, 9538, 1008, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1620668672", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq II"},
   CellID->1620668672],
  Cell[352908, 9567, 769, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1306894362", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1306894362],
  Cell[353680, 9588, 922, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1977563124", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSets setSeq", "IR"},
   CellID->1977563124],
  Cell[354605, 9615, 1020, 26, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1963351311", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences setSeq", "IR"},
   CellID->1963351311],
  Cell[399260, 10907, 893, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1148013153", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1148013153],
  Cell[400156, 10928, 689, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1542915564", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1542915564],
  Cell[400848, 10947, 747, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:304038122", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->304038122],
  Cell[401598, 10968, 1135, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:57707614", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subSeq \[SubsetEqual]"},
   CellID->57707614],
  Cell[402736, 11000, 638, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1967681402", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1967681402],
  Cell[403377, 11017, 1276, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1555261236", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1555261236],
  Cell[404656, 11057, 2105, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:710393364", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subSeq P binary"},
   CellID->710393364],
  Cell[406764, 11125, 2330, 73, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:622465561", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subsequence P binary"},
   CellID->622465561],
  Cell[409097, 11200, 1558, 46, 70, "GlobalDeclaration",
   CellTags->{
    "ID:2032932287", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->2032932287],
  Cell[410658, 11248, 1055, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:525775183", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq transitive P I"},
   CellID->525775183],
  Cell[411716, 11279, 1104, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:397952331", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq transitive P II"},
   CellID->397952331],
  Cell[462917, 12540, 673, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1448839763", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1448839763],
  Cell[463593, 12558, 793, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1803197151", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1803197151],
  Cell[464389, 12579, 1799, 53, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:571239857", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences natRec1", "IR"},
   CellID->571239857],
  Cell[472608, 12808, 791, 23, 33, "GlobalDeclaration",
   CellTags->{
    "ID:646368107", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->646368107],
  Cell[473931, 12850, 1737, 54, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1140411407", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "isNoetherian alternative \[DoubleRightArrow]"},
   CellID->1140411407],
  Cell[475671, 12906, 1737, 55, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:199914937", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "isNoetherian alternative \[DoubleLeftArrow]"},
   CellID->199914937],
  Cell[477411, 12963, 1716, 54, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1370074896", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isNoetherian alternative", "IR"},
   CellID->1370074896],
  Cell[498586, 13562, 2181, 71, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:610667129", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "Dickson domain"},
   CellID->610667129]},
 "ID:925721429"->{
  Cell[53713, 1429, 708, 17, 30, "GlobalDeclaration",
   CellTags->{
    "ID:925721429", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->925721429]},
 "ID:243637066"->{
  Cell[54424, 1448, 620, 15, 30, "GlobalDeclaration",
   CellTags->{
    "ID:243637066", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->243637066]},
 "ID:458427713"->{
  Cell[55047, 1465, 1587, 48, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:458427713", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "DomainSequences decision predicate"},
   CellID->458427713]},
 "DomainSequences decision predicate"->{
  Cell[55047, 1465, 1587, 48, 38, "FormalTextInputFormula",
   CellTags->{
    "ID:458427713", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "DomainSequences decision predicate"},
   CellID->458427713]},
 "ID:1289924462"->{
  Cell[58256, 1568, 709, 16, 30, "GlobalDeclaration",
   CellTags->{
    "ID:1289924462", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1289924462]},
 "ID:230504716"->{
  Cell[58968, 1586, 1459, 40, 33, "FormalTextInputFormula",
   CellTags->{
    "ID:230504716", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq"},
   CellID->230504716]},
 "subSeq"->{
  Cell[58968, 1586, 1459, 40, 33, "FormalTextInputFormula",
   CellTags->{
    "ID:230504716", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq"},
   CellID->230504716]},
 "ID:809351385"->{
  Cell[60430, 1628, 1217, 36, 31, "FormalTextInputFormula",
   CellTags->{
    "ID:809351385", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "imgSeq"},
   CellID->809351385]},
 "imgSeq"->{
  Cell[60430, 1628, 1217, 36, 31, "FormalTextInputFormula",
   CellTags->{
    "ID:809351385", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "imgSeq"},
   CellID->809351385]},
 "ID:1865902758"->{
  Cell[61650, 1666, 1348, 39, 47, "FormalTextInputFormula",
   CellTags->{
    "ID:1865902758", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq"},
   CellID->1865902758]},
 "tupSeq"->{
  Cell[61650, 1666, 1348, 39, 47, "FormalTextInputFormula",
   CellTags->{
    "ID:1865902758", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq"},
   CellID->1865902758]},
 "ID:238284462"->{
  Cell[63001, 1707, 970, 27, 21, "FormalTextInputFormula",
   CellTags->{
    "ID:238284462", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq"},
   CellID->238284462]},
 "setSeq"->{
  Cell[63001, 1707, 970, 27, 21, "FormalTextInputFormula",
   CellTags->{
    "ID:238284462", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq"},
   CellID->238284462]},
 "ID:1986096562"->{
  Cell[64692, 1763, 1829, 58, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1986096562", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[LeftTriangleBar]"},
   CellID->1986096562]},
 "\[LeftTriangleBar]"->{
  Cell[64692, 1763, 1829, 58, 41, "FormalTextInputFormula",
   CellTags->{
    "ID:1986096562", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[LeftTriangleBar]"},
   CellID->1986096562]},
 "ID:489544091"->{
  Cell[66969, 1839, 653, 15, 31, "GlobalDeclaration",
   CellTags->{
    "ID:489544091", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->489544091]},
 "ID:1306945267"->{
  Cell[68598, 1884, 666, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1306945267", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1306945267]},
 "ID:638827787"->{
  Cell[69267, 1902, 783, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:638827787", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->638827787]},
 "ID:29525805"->{
  Cell[70053, 1921, 710, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:29525805", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->29525805]},
 "ID:1744060660"->{
  Cell[70766, 1941, 1397, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1744060660", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences subSeq", "IR"},
   CellID->1744060660]},
 "DomainSequences subSeq"->{
  Cell[70766, 1941, 1397, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1744060660", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences subSeq", "IR"},
   CellID->1744060660]},
 "IR"->{
  Cell[70766, 1941, 1397, 38, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1744060660", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences subSeq", "IR"},
   CellID->1744060660],
  Cell[118797, 3191, 1270, 32, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1324913148", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "DomainSequences \[LeftTriangleBar]", "IR"},
   CellID->1324913148],
  Cell[301000, 8062, 1731, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:814769285", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences imgSeq", "IR"},
   CellID->814769285],
  Cell[302734, 8115, 1367, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:527722954", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq imgSeq", "IR"},
   CellID->527722954],
  Cell[317447, 8522, 795, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1139194187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isTuple tupSeq", "IR"},
   CellID->1139194187],
  Cell[318245, 8545, 869, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:794519991", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq 1", "IR"},
   CellID->794519991],
  Cell[319117, 8571, 965, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1371530240", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq +1", "IR"},
   CellID->1371530240],
  Cell[320859, 8623, 951, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1953194276", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainTuples tupSeq", "IR"},
   CellID->1953194276],
  Cell[321813, 8650, 1117, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1662300990", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences tupSeq", "IR"},
   CellID->1662300990],
  Cell[344483, 9310, 1150, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:600858398", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq alternative", "IR"},
   CellID->600858398],
  Cell[345636, 9343, 854, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1813366458", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq 1", "IR"},
   CellID->1813366458],
  Cell[346493, 9369, 939, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:282957248", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq +1", "IR"},
   CellID->282957248],
  Cell[347435, 9398, 1549, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1456913783", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq I", "IR"},
   CellID->1456913783],
  Cell[348987, 9451, 1048, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2074355943", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq II", "IR"},
   CellID->2074355943],
  Cell[350038, 9484, 885, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2028876528", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq", "IR"},
   CellID->2028876528],
  Cell[353680, 9588, 922, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1977563124", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSets setSeq", "IR"},
   CellID->1977563124],
  Cell[354605, 9615, 1020, 26, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1963351311", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences setSeq", "IR"},
   CellID->1963351311],
  Cell[464389, 12579, 1799, 53, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:571239857", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences natRec1", "IR"},
   CellID->571239857],
  Cell[477411, 12963, 1716, 54, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1370074896", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isNoetherian alternative", "IR"},
   CellID->1370074896]},
 "ID:1383543831"->{
  Cell[72166, 1981, 642, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1383543831", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1383543831]},
 "ID:1895094895"->{
  Cell[72811, 1998, 1572, 48, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1895094895", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1895094895]},
 "ID:1841507065"->{
  Cell[74386, 2048, 1504, 47, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1841507065", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "sequence transitive P I"},
   CellID->1841507065]},
 "sequence transitive P I"->{
  Cell[74386, 2048, 1504, 47, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1841507065", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "sequence transitive P I"},
   CellID->1841507065]},
 "ID:1455385635"->{
  Cell[75893, 2097, 1532, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1455385635", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "sequence transitive P II"},
   CellID->1455385635]},
 "sequence transitive P II"->{
  Cell[75893, 2097, 1532, 48, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1455385635", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "sequence transitive P II"},
   CellID->1455385635]},
 "ID:796771086"->{
  Cell[77428, 2147, 1696, 54, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:796771086", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq P binary"},
   CellID->796771086]},
 "subSeq P binary"->{
  Cell[77428, 2147, 1696, 54, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:796771086", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq P binary"},
   CellID->796771086]},
 "Proof|ID:1744060660"->{
  Cell[79281, 2212, 3678, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1744060660", "Proof|ID:1744060660-1"},
   CellID->121410062]},
 "Proof|ID:1744060660-1"->{
  Cell[79281, 2212, 3678, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1744060660", "Proof|ID:1744060660-1"},
   CellID->121410062]},
 "Proof|ID:1841507065"->{
  Cell[83481, 2329, 10206, 244, 70, "ProofInfo",
   CellTags->{"Proof|ID:1841507065", "Proof|ID:1841507065-1"},
   CellID->398706065]},
 "Proof|ID:1841507065-1"->{
  Cell[83481, 2329, 10206, 244, 70, "ProofInfo",
   CellTags->{"Proof|ID:1841507065", "Proof|ID:1841507065-1"},
   CellID->398706065]},
 "Proof|ID:1455385635"->{
  Cell[94208, 2592, 10381, 248, 70, "ProofInfo",
   CellTags->{"Proof|ID:1455385635", "Proof|ID:1455385635-1"},
   CellID->1613181412]},
 "Proof|ID:1455385635-1"->{
  Cell[94208, 2592, 10381, 248, 70, "ProofInfo",
   CellTags->{"Proof|ID:1455385635", "Proof|ID:1455385635-1"},
   CellID->1613181412]},
 "Proof|ID:796771086"->{
  Cell[105110, 2859, 10783, 256, 70, "ProofInfo",
   CellTags->{"Proof|ID:796771086", "Proof|ID:796771086-1"},
   CellID->567440294]},
 "Proof|ID:796771086-1"->{
  Cell[105110, 2859, 10783, 256, 70, "ProofInfo",
   CellTags->{"Proof|ID:796771086", "Proof|ID:796771086-1"},
   CellID->567440294]},
 "ID:113922190"->{
  Cell[117055, 3149, 823, 18, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:113922190", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->113922190]},
 "ID:936476105"->{
  Cell[117881, 3169, 913, 20, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:936476105", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->936476105]},
 "ID:1324913148"->{
  Cell[118797, 3191, 1270, 32, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1324913148", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "DomainSequences \[LeftTriangleBar]", "IR"},
   CellID->1324913148]},
 "DomainSequences \[LeftTriangleBar]"->{
  Cell[118797, 3191, 1270, 32, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1324913148", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "DomainSequences \[LeftTriangleBar]", "IR"},
   CellID->1324913148]},
 "ID:1481705576"->{
  Cell[120070, 3225, 810, 18, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1481705576", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1481705576]},
 "ID:794304435"->{
  Cell[120883, 3245, 1757, 50, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:794304435", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->794304435]},
 "ID:1003845896"->{
  Cell[122643, 3297, 1655, 49, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1003845896", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[LeftTriangleBar] P binary"},
   CellID->1003845896]},
 "\[LeftTriangleBar] P binary"->{
  Cell[122643, 3297, 1655, 49, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:1003845896", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[LeftTriangleBar] P binary"},
   CellID->1003845896]},
 "Proof|ID:1324913148"->{
  Cell[124603, 3359, 3646, 97, 70, "ProofInfo",
   CellTags->{"Proof|ID:1324913148", "Proof|ID:1324913148-1"},
   CellID->897924672]},
 "Proof|ID:1324913148-1"->{
  Cell[124603, 3359, 3646, 97, 70, "ProofInfo",
   CellTags->{"Proof|ID:1324913148", "Proof|ID:1324913148-1"},
   CellID->897924672]},
 "Proof|ID:1003845896"->{
  Cell[128771, 3475, 10287, 244, 70, "ProofInfo",
   CellTags->{"Proof|ID:1003845896", "Proof|ID:1003845896-1"},
   CellID->1168681859]},
 "Proof|ID:1003845896-1"->{
  Cell[128771, 3475, 10287, 244, 70, "ProofInfo",
   CellTags->{"Proof|ID:1003845896", "Proof|ID:1003845896-1"},
   CellID->1168681859]},
 "ID:51050760"->{
  Cell[140027, 3752, 655, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:51050760", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->51050760]},
 "ID:1171839467"->{
  Cell[140685, 3770, 1819, 53, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1171839467", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 1"},
   CellID->1171839467]},
 "subSeq 1"->{
  Cell[140685, 3770, 1819, 53, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1171839467", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 1"},
   CellID->1171839467]},
 "ID:756173591"->{
  Cell[142507, 3825, 1672, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:756173591", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 2"},
   CellID->756173591]},
 "subSeq 2"->{
  Cell[142507, 3825, 1672, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:756173591", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 2"},
   CellID->756173591]},
 "ID:1593038128"->{
  Cell[144182, 3878, 1862, 58, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1593038128", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 3"},
   CellID->1593038128]},
 "subSeq 3"->{
  Cell[144182, 3878, 1862, 58, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1593038128", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 3"},
   CellID->1593038128]},
 "ID:377390901"->{
  Cell[146047, 3938, 2025, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:377390901", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 4"},
   CellID->377390901]},
 "subSeq 4"->{
  Cell[146047, 3938, 2025, 62, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:377390901", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 4"},
   CellID->377390901]},
 "ID:1934441835"->{
  Cell[148075, 4002, 2182, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1934441835", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 5"},
   CellID->1934441835]},
 "subSeq 5"->{
  Cell[148075, 4002, 2182, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1934441835", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq 5"},
   CellID->1934441835]},
 "Proof|ID:1171839467"->{
  Cell[150413, 4079, 5625, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:1171839467", "Proof|ID:1171839467-1"},
   CellID->1009035181]},
 "Proof|ID:1171839467-1"->{
  Cell[150413, 4079, 5625, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:1171839467", "Proof|ID:1171839467-1"},
   CellID->1009035181]},
 "Proof|ID:756173591"->{
  Cell[156560, 4244, 5620, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:756173591", "Proof|ID:756173591-1"},
   CellID->1704654642]},
 "Proof|ID:756173591-1"->{
  Cell[156560, 4244, 5620, 146, 70, "ProofInfo",
   CellTags->{"Proof|ID:756173591", "Proof|ID:756173591-1"},
   CellID->1704654642]},
 "Proof|ID:1593038128"->{
  Cell[162701, 4409, 6741, 170, 70, "ProofInfo",
   CellTags->{"Proof|ID:1593038128", "Proof|ID:1593038128-1"},
   CellID->1107323890]},
 "Proof|ID:1593038128-1"->{
  Cell[162701, 4409, 6741, 170, 70, "ProofInfo",
   CellTags->{"Proof|ID:1593038128", "Proof|ID:1593038128-1"},
   CellID->1107323890]},
 "Proof|ID:377390901"->{
  Cell[169964, 4598, 7663, 190, 70, "ProofInfo",
   CellTags->{"Proof|ID:377390901", "Proof|ID:377390901-1"},
   CellID->383299987]},
 "Proof|ID:377390901-1"->{
  Cell[169964, 4598, 7663, 190, 70, "ProofInfo",
   CellTags->{"Proof|ID:377390901", "Proof|ID:377390901-1"},
   CellID->383299987]},
 "Proof|ID:1934441835"->{
  Cell[178148, 4807, 8250, 202, 70, "ProofInfo",
   CellTags->{"Proof|ID:1934441835", "Proof|ID:1934441835-1"},
   CellID->519218944]},
 "Proof|ID:1934441835-1"->{
  Cell[178148, 4807, 8250, 202, 70, "ProofInfo",
   CellTags->{"Proof|ID:1934441835", "Proof|ID:1934441835-1"},
   CellID->519218944]},
 "ID:144670545"->{
  Cell[187595, 5050, 1480, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:144670545", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences finite domain"},
   CellID->144670545]},
 "DomainSequences finite domain"->{
  Cell[187595, 5050, 1480, 42, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:144670545", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences finite domain"},
   CellID->144670545]},
 "ID:72630978"->{
  Cell[189078, 5094, 797, 20, 70, "GlobalDeclaration",
   CellTags->{
    "ID:72630978", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->72630978]},
 "ID:1747499940"->{
  Cell[189878, 5116, 1986, 60, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1747499940", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 1"},
   CellID->1747499940]},
 "subSeq DomainSequences 1"->{
  Cell[189878, 5116, 1986, 60, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1747499940", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 1"},
   CellID->1747499940]},
 "ID:31395941"->{
  Cell[191867, 5178, 1956, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:31395941", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 2"},
   CellID->31395941]},
 "subSeq DomainSequences 2"->{
  Cell[191867, 5178, 1956, 59, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:31395941", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 2"},
   CellID->31395941]},
 "ID:228528973"->{
  Cell[193826, 5239, 2050, 64, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:228528973", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 3"},
   CellID->228528973]},
 "subSeq DomainSequences 3"->{
  Cell[193826, 5239, 2050, 64, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:228528973", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 3"},
   CellID->228528973]},
 "ID:854524374"->{
  Cell[195879, 5305, 2244, 69, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:854524374", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 4"},
   CellID->854524374]},
 "subSeq DomainSequences 4"->{
  Cell[195879, 5305, 2244, 69, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:854524374", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 4"},
   CellID->854524374]},
 "ID:527068444"->{
  Cell[198126, 5376, 2276, 70, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:527068444", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 5"},
   CellID->527068444]},
 "subSeq DomainSequences 5"->{
  Cell[198126, 5376, 2276, 70, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:527068444", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 5"},
   CellID->527068444]},
 "Proof|ID:144670545"->{
  Cell[200557, 5457, 4915, 126, 70, "ProofInfo",
   CellTags->{"Proof|ID:144670545", "Proof|ID:144670545-1"},
   CellID->431495423]},
 "Proof|ID:144670545-1"->{
  Cell[200557, 5457, 4915, 126, 70, "ProofInfo",
   CellTags->{"Proof|ID:144670545", "Proof|ID:144670545-1"},
   CellID->431495423]},
 "Proof|ID:1747499940"->{
  Cell[205992, 5602, 7088, 176, 70, "ProofInfo",
   CellTags->{"Proof|ID:1747499940", "Proof|ID:1747499940-1"},
   CellID->1369905409]},
 "Proof|ID:1747499940-1"->{
  Cell[205992, 5602, 7088, 176, 70, "ProofInfo",
   CellTags->{"Proof|ID:1747499940", "Proof|ID:1747499940-1"},
   CellID->1369905409]},
 "Proof|ID:31395941"->{
  Cell[213602, 5797, 7078, 176, 70, "ProofInfo",
   CellTags->{"Proof|ID:31395941", "Proof|ID:31395941-1"},
   CellID->1498389165]},
 "Proof|ID:31395941-1"->{
  Cell[213602, 5797, 7078, 176, 70, "ProofInfo",
   CellTags->{"Proof|ID:31395941", "Proof|ID:31395941-1"},
   CellID->1498389165]},
 "Proof|ID:228528973"->{
  Cell[221198, 5992, 7908, 194, 70, "ProofInfo",
   CellTags->{"Proof|ID:228528973", "Proof|ID:228528973-1"},
   CellID->670198542]},
 "Proof|ID:228528973-1"->{
  Cell[221198, 5992, 7908, 194, 70, "ProofInfo",
   CellTags->{"Proof|ID:228528973", "Proof|ID:228528973-1"},
   CellID->670198542]},
 "Proof|ID:854524374"->{
  Cell[229627, 6205, 8846, 214, 70, "ProofInfo",
   CellTags->{"Proof|ID:854524374", "Proof|ID:854524374-1"},
   CellID->295533552]},
 "Proof|ID:854524374-1"->{
  Cell[229627, 6205, 8846, 214, 70, "ProofInfo",
   CellTags->{"Proof|ID:854524374", "Proof|ID:854524374-1"},
   CellID->295533552]},
 "Proof|ID:527068444"->{
  Cell[239059, 6439, 9405, 224, 70, "ProofInfo",
   CellTags->{"Proof|ID:527068444", "Proof|ID:527068444-1"},
   CellID->1572634243]},
 "Proof|ID:527068444-1"->{
  Cell[239059, 6439, 9405, 224, 70, "ProofInfo",
   CellTags->{"Proof|ID:527068444", "Proof|ID:527068444-1"},
   CellID->1572634243]},
 "ID:21904240"->{
  Cell[249580, 6698, 634, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:21904240", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->21904240]},
 "ID:315841131"->{
  Cell[250217, 6715, 2587, 74, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:315841131", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 6"},
   CellID->315841131]},
 "subSeq DomainSequences 6"->{
  Cell[250217, 6715, 2587, 74, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:315841131", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq DomainSequences 6"},
   CellID->315841131]},
 "Proof|ID:315841131"->{
  Cell[252960, 6800, 9220, 224, 70, "ProofInfo",
   CellTags->{"Proof|ID:315841131", "Proof|ID:315841131-1"},
   CellID->135253581]},
 "Proof|ID:315841131-1"->{
  Cell[252960, 6800, 9220, 224, 70, "ProofInfo",
   CellTags->{"Proof|ID:315841131", "Proof|ID:315841131-1"},
   CellID->135253581]},
 "ID:432936581"->{
  Cell[263271, 7057, 731, 17, 70, "GlobalDeclaration",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:432936581", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->432936581]},
 "ID:557118158"->{
  Cell[264005, 7076, 2168, 66, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:557118158", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "non-existence seq P"},
   CellID->557118158]},
 "non-existence seq P"->{
  Cell[264005, 7076, 2168, 66, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:557118158", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "non-existence seq P"},
   CellID->557118158]},
 "ID:283188144"->{
  Cell[266176, 7144, 2426, 72, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:283188144", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "non-existence seq P binary"},
   CellID->283188144]},
 "non-existence seq P binary"->{
  Cell[266176, 7144, 2426, 72, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:283188144", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "non-existence seq P binary"},
   CellID->283188144]},
 "ID:44762641"->{
  Cell[268605, 7218, 2976, 89, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:44762641", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "non-existence seq P binary subSeq"},
   CellID->44762641]},
 "non-existence seq P binary subSeq"->{
  Cell[268605, 7218, 2976, 89, 70, "FormalTextInputFormula",
   CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
   CellTags->{
    "ID:44762641", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "non-existence seq P binary subSeq"},
   CellID->44762641]},
 "Proof|ID:557118158"->{
  Cell[271837, 7319, 7341, 182, 70, "ProofInfo",
   CellTags->{"Proof|ID:557118158", "Proof|ID:557118158-1"},
   CellID->608671989]},
 "Proof|ID:557118158-1"->{
  Cell[271837, 7319, 7341, 182, 70, "ProofInfo",
   CellTags->{"Proof|ID:557118158", "Proof|ID:557118158-1"},
   CellID->608671989]},
 "Proof|ID:283188144"->{
  Cell[279698, 7520, 8224, 202, 70, "ProofInfo",
   CellTags->{"Proof|ID:283188144", "Proof|ID:283188144-1"},
   CellID->1859154459]},
 "Proof|ID:283188144-1"->{
  Cell[279698, 7520, 8224, 202, 70, "ProofInfo",
   CellTags->{"Proof|ID:283188144", "Proof|ID:283188144-1"},
   CellID->1859154459]},
 "Proof|ID:44762641"->{
  Cell[288443, 7741, 9277, 223, 70, "ProofInfo",
   CellTags->{"Proof|ID:44762641", "Proof|ID:44762641-1"},
   CellID->46003965]},
 "Proof|ID:44762641-1"->{
  Cell[288443, 7741, 9277, 223, 70, "ProofInfo",
   CellTags->{"Proof|ID:44762641", "Proof|ID:44762641-1"},
   CellID->46003965]},
 "ID:1357006098"->{
  Cell[298498, 7991, 664, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1357006098", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1357006098]},
 "ID:341801516"->{
  Cell[299644, 8025, 635, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:341801516", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->341801516]},
 "ID:627432657"->{
  Cell[300282, 8042, 715, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:627432657", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->627432657]},
 "ID:814769285"->{
  Cell[301000, 8062, 1731, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:814769285", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences imgSeq", "IR"},
   CellID->814769285]},
 "DomainSequences imgSeq"->{
  Cell[301000, 8062, 1731, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:814769285", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences imgSeq", "IR"},
   CellID->814769285]},
 "ID:527722954"->{
  Cell[302734, 8115, 1367, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:527722954", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq imgSeq", "IR"},
   CellID->527722954]},
 "subSeq imgSeq"->{
  Cell[302734, 8115, 1367, 40, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:527722954", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "subSeq imgSeq", "IR"},
   CellID->527722954]},
 "Proof|ID:814769285"->{
  Cell[304258, 8166, 4860, 124, 70, "ProofInfo",
   CellTags->{"Proof|ID:814769285", "Proof|ID:814769285-1"},
   CellID->1610479839]},
 "Proof|ID:814769285-1"->{
  Cell[304258, 8166, 4860, 124, 70, "ProofInfo",
   CellTags->{"Proof|ID:814769285", "Proof|ID:814769285-1"},
   CellID->1610479839]},
 "Proof|ID:527722954"->{
  Cell[309638, 8309, 4195, 110, 70, "ProofInfo",
   CellTags->{"Proof|ID:527722954", "Proof|ID:527722954-1"},
   CellID->503452461]},
 "Proof|ID:527722954-1"->{
  Cell[309638, 8309, 4195, 110, 70, "ProofInfo",
   CellTags->{"Proof|ID:527722954", "Proof|ID:527722954-1"},
   CellID->503452461]},
 "ID:148582272"->{
  Cell[314809, 8447, 663, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:148582272", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->148582272]},
 "ID:1254928956"->{
  Cell[316058, 8484, 689, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1254928956", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1254928956]},
 "ID:462368090"->{
  Cell[316750, 8503, 694, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:462368090", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->462368090]},
 "ID:1139194187"->{
  Cell[317447, 8522, 795, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1139194187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isTuple tupSeq", "IR"},
   CellID->1139194187]},
 "isTuple tupSeq"->{
  Cell[317447, 8522, 795, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1139194187", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isTuple tupSeq", "IR"},
   CellID->1139194187]},
 "ID:794519991"->{
  Cell[318245, 8545, 869, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:794519991", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq 1", "IR"},
   CellID->794519991]},
 "tupSeq 1"->{
  Cell[318245, 8545, 869, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:794519991", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq 1", "IR"},
   CellID->794519991]},
 "ID:1371530240"->{
  Cell[319117, 8571, 965, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1371530240", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq +1", "IR"},
   CellID->1371530240]},
 "tupSeq +1"->{
  Cell[319117, 8571, 965, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1371530240", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "tupSeq +1", "IR"},
   CellID->1371530240]},
 "ID:1979298560"->{
  Cell[320085, 8602, 771, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1979298560", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1979298560]},
 "ID:1953194276"->{
  Cell[320859, 8623, 951, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1953194276", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainTuples tupSeq", "IR"},
   CellID->1953194276]},
 "DomainTuples tupSeq"->{
  Cell[320859, 8623, 951, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1953194276", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainTuples tupSeq", "IR"},
   CellID->1953194276]},
 "ID:1662300990"->{
  Cell[321813, 8650, 1117, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1662300990", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences tupSeq", "IR"},
   CellID->1662300990]},
 "DomainSequences tupSeq"->{
  Cell[321813, 8650, 1117, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1662300990", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences tupSeq", "IR"},
   CellID->1662300990]},
 "Proof|ID:1139194187"->{
  Cell[323088, 8688, 2612, 76, 70, "ProofInfo",
   CellTags->{"Proof|ID:1139194187", "Proof|ID:1139194187-1"},
   CellID->943422580]},
 "Proof|ID:1139194187-1"->{
  Cell[323088, 8688, 2612, 76, 70, "ProofInfo",
   CellTags->{"Proof|ID:1139194187", "Proof|ID:1139194187-1"},
   CellID->943422580]},
 "Proof|ID:794519991"->{
  Cell[326222, 8783, 2569, 78, 70, "ProofInfo",
   CellTags->{"Proof|ID:794519991", "Proof|ID:794519991-1"},
   CellID->1464040180]},
 "Proof|ID:794519991-1"->{
  Cell[326222, 8783, 2569, 78, 70, "ProofInfo",
   CellTags->{"Proof|ID:794519991", "Proof|ID:794519991-1"},
   CellID->1464040180]},
 "Proof|ID:1371530240"->{
  Cell[329312, 8880, 3484, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1371530240", "Proof|ID:1371530240-1"},
   CellID->215916439]},
 "Proof|ID:1371530240-1"->{
  Cell[329312, 8880, 3484, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1371530240", "Proof|ID:1371530240-1"},
   CellID->215916439]},
 "Proof|ID:1953194276"->{
  Cell[333318, 8997, 3960, 106, 70, "ProofInfo",
   CellTags->{"Proof|ID:1953194276", "Proof|ID:1953194276-1"},
   CellID->709826783]},
 "Proof|ID:1953194276-1"->{
  Cell[333318, 8997, 3960, 106, 70, "ProofInfo",
   CellTags->{"Proof|ID:1953194276", "Proof|ID:1953194276-1"},
   CellID->709826783]},
 "Proof|ID:1662300990"->{
  Cell[337870, 9123, 3210, 88, 70, "ProofInfo",
   CellTags->{"Proof|ID:1662300990", "Proof|ID:1662300990-1"},
   CellID->103093795]},
 "Proof|ID:1662300990-1"->{
  Cell[337870, 9123, 3210, 88, 70, "ProofInfo",
   CellTags->{"Proof|ID:1662300990", "Proof|ID:1662300990-1"},
   CellID->103093795]},
 "ID:791300552"->{
  Cell[342257, 9248, 735, 18, 70, "GlobalDeclaration",
   CellTags->{
    "ID:791300552", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->791300552]},
 "ID:1677316354"->{
  Cell[342995, 9268, 699, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1677316354", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1677316354]},
 "ID:1304989559"->{
  Cell[343697, 9287, 783, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1304989559", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isSet setSeq"},
   CellID->1304989559]},
 "isSet setSeq"->{
  Cell[343697, 9287, 783, 21, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1304989559", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isSet setSeq"},
   CellID->1304989559]},
 "ID:600858398"->{
  Cell[344483, 9310, 1150, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:600858398", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq alternative", "IR"},
   CellID->600858398]},
 "setSeq alternative"->{
  Cell[344483, 9310, 1150, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:600858398", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq alternative", "IR"},
   CellID->600858398]},
 "ID:1813366458"->{
  Cell[345636, 9343, 854, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1813366458", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq 1", "IR"},
   CellID->1813366458]},
 "setSeq 1"->{
  Cell[345636, 9343, 854, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1813366458", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq 1", "IR"},
   CellID->1813366458]},
 "ID:282957248"->{
  Cell[346493, 9369, 939, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:282957248", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq +1", "IR"},
   CellID->282957248]},
 "setSeq +1"->{
  Cell[346493, 9369, 939, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:282957248", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq +1", "IR"},
   CellID->282957248]},
 "ID:1456913783"->{
  Cell[347435, 9398, 1549, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1456913783", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq I", "IR"},
   CellID->1456913783]},
 "\[Element] setSeq I"->{
  Cell[347435, 9398, 1549, 51, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1456913783", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq I", "IR"},
   CellID->1456913783]},
 "ID:2074355943"->{
  Cell[348987, 9451, 1048, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2074355943", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq II", "IR"},
   CellID->2074355943]},
 "\[Element] setSeq II"->{
  Cell[348987, 9451, 1048, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2074355943", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[Element] setSeq II", "IR"},
   CellID->2074355943]},
 "ID:2028876528"->{
  Cell[350038, 9484, 885, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2028876528", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq", "IR"},
   CellID->2028876528]},
 "\[SubsetEqual] setSeq"->{
  Cell[350038, 9484, 885, 24, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:2028876528", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq", "IR"},
   CellID->2028876528]},
 "ID:919542923"->{
  Cell[350926, 9510, 968, 26, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:919542923", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq ind"},
   CellID->919542923]},
 "\[SubsetEqual] setSeq ind"->{
  Cell[350926, 9510, 968, 26, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:919542923", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq ind"},
   CellID->919542923]},
 "ID:1620668672"->{
  Cell[351897, 9538, 1008, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1620668672", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq II"},
   CellID->1620668672]},
 "\[SubsetEqual] setSeq II"->{
  Cell[351897, 9538, 1008, 27, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1620668672", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "\[SubsetEqual] setSeq II"},
   CellID->1620668672]},
 "ID:1306894362"->{
  Cell[352908, 9567, 769, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1306894362", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1306894362]},
 "ID:1977563124"->{
  Cell[353680, 9588, 922, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1977563124", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSets setSeq", "IR"},
   CellID->1977563124]},
 "DomainSets setSeq"->{
  Cell[353680, 9588, 922, 25, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1977563124", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSets setSeq", "IR"},
   CellID->1977563124]},
 "ID:1963351311"->{
  Cell[354605, 9615, 1020, 26, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1963351311", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences setSeq", "IR"},
   CellID->1963351311]},
 "DomainSequences setSeq"->{
  Cell[354605, 9615, 1020, 26, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:1963351311", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences setSeq", "IR"},
   CellID->1963351311]},
 "Proof|ID:1304989559"->{
  Cell[355782, 9652, 2605, 76, 70, "ProofInfo",
   CellTags->{"Proof|ID:1304989559", "Proof|ID:1304989559-1"},
   CellID->1710781526]},
 "Proof|ID:1304989559-1"->{
  Cell[355782, 9652, 2605, 76, 70, "ProofInfo",
   CellTags->{"Proof|ID:1304989559", "Proof|ID:1304989559-1"},
   CellID->1710781526]},
 "Proof|ID:600858398"->{
  Cell[358909, 9747, 3706, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:600858398", "Proof|ID:600858398-1"},
   CellID->1970211136]},
 "Proof|ID:600858398-1"->{
  Cell[358909, 9747, 3706, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:600858398", "Proof|ID:600858398-1"},
   CellID->1970211136]},
 "Proof|ID:1813366458"->{
  Cell[363136, 9866, 2487, 76, 70, "ProofInfo",
   CellTags->{"Proof|ID:1813366458", "Proof|ID:1813366458-1"},
   CellID->1785703456]},
 "Proof|ID:1813366458-1"->{
  Cell[363136, 9866, 2487, 76, 70, "ProofInfo",
   CellTags->{"Proof|ID:1813366458", "Proof|ID:1813366458-1"},
   CellID->1785703456]},
 "Proof|ID:282957248"->{
  Cell[366144, 9961, 3567, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:282957248", "Proof|ID:282957248-1"},
   CellID->257579260]},
 "Proof|ID:282957248-1"->{
  Cell[366144, 9961, 3567, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:282957248", "Proof|ID:282957248-1"},
   CellID->257579260]},
 "Proof|ID:1456913783"->{
  Cell[370232, 10080, 4166, 112, 70, "ProofInfo",
   CellTags->{"Proof|ID:1456913783", "Proof|ID:1456913783-1"},
   CellID->660915054]},
 "Proof|ID:1456913783-1"->{
  Cell[370232, 10080, 4166, 112, 70, "ProofInfo",
   CellTags->{"Proof|ID:1456913783", "Proof|ID:1456913783-1"},
   CellID->660915054]},
 "Proof|ID:2074355943"->{
  Cell[374919, 10211, 3305, 92, 70, "ProofInfo",
   CellTags->{"Proof|ID:2074355943", "Proof|ID:2074355943-1"},
   CellID->1118991764]},
 "Proof|ID:2074355943-1"->{
  Cell[374919, 10211, 3305, 92, 70, "ProofInfo",
   CellTags->{"Proof|ID:2074355943", "Proof|ID:2074355943-1"},
   CellID->1118991764]},
 "Proof|ID:2028876528"->{
  Cell[378745, 10322, 3056, 86, 70, "ProofInfo",
   CellTags->{"Proof|ID:2028876528", "Proof|ID:2028876528-1"},
   CellID->594436158]},
 "Proof|ID:2028876528-1"->{
  Cell[378745, 10322, 3056, 86, 70, "ProofInfo",
   CellTags->{"Proof|ID:2028876528", "Proof|ID:2028876528-1"},
   CellID->594436158]},
 "Proof|ID:919542923"->{
  Cell[382322, 10427, 3428, 94, 70, "ProofInfo",
   CellTags->{"Proof|ID:919542923", "Proof|ID:919542923-1"},
   CellID->1947715984]},
 "Proof|ID:919542923-1"->{
  Cell[382322, 10427, 3428, 94, 70, "ProofInfo",
   CellTags->{"Proof|ID:919542923", "Proof|ID:919542923-1"},
   CellID->1947715984]},
 "Proof|ID:1620668672"->{
  Cell[386270, 10540, 3657, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1620668672", "Proof|ID:1620668672-1"},
   CellID->1297375468]},
 "Proof|ID:1620668672-1"->{
  Cell[386270, 10540, 3657, 98, 70, "ProofInfo",
   CellTags->{"Proof|ID:1620668672", "Proof|ID:1620668672-1"},
   CellID->1297375468]},
 "Proof|ID:1977563124"->{
  Cell[390448, 10657, 3953, 106, 70, "ProofInfo",
   CellTags->{"Proof|ID:1977563124", "Proof|ID:1977563124-1"},
   CellID->1381526050]},
 "Proof|ID:1977563124-1"->{
  Cell[390448, 10657, 3953, 106, 70, "ProofInfo",
   CellTags->{"Proof|ID:1977563124", "Proof|ID:1977563124-1"},
   CellID->1381526050]},
 "Proof|ID:1963351311"->{
  Cell[394923, 10782, 3384, 92, 70, "ProofInfo",
   CellTags->{"Proof|ID:1963351311", "Proof|ID:1963351311-1"},
   CellID->410175681]},
 "Proof|ID:1963351311-1"->{
  Cell[394923, 10782, 3384, 92, 70, "ProofInfo",
   CellTags->{"Proof|ID:1963351311", "Proof|ID:1963351311-1"},
   CellID->410175681]},
 "ID:1148013153"->{
  Cell[399260, 10907, 893, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1148013153", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1148013153]},
 "ID:1542915564"->{
  Cell[400156, 10928, 689, 17, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1542915564", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1542915564]},
 "ID:304038122"->{
  Cell[400848, 10947, 747, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:304038122", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->304038122]},
 "ID:57707614"->{
  Cell[401598, 10968, 1135, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:57707614", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subSeq \[SubsetEqual]"},
   CellID->57707614]},
 "setSeq subSeq \[SubsetEqual]"->{
  Cell[401598, 10968, 1135, 30, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:57707614", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subSeq \[SubsetEqual]"},
   CellID->57707614]},
 "ID:1967681402"->{
  Cell[402736, 11000, 638, 15, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1967681402", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1967681402]},
 "ID:1555261236"->{
  Cell[403377, 11017, 1276, 38, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1555261236", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1555261236]},
 "ID:710393364"->{
  Cell[404656, 11057, 2105, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:710393364", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subSeq P binary"},
   CellID->710393364]},
 "setSeq subSeq P binary"->{
  Cell[404656, 11057, 2105, 66, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:710393364", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subSeq P binary"},
   CellID->710393364]},
 "ID:622465561"->{
  Cell[406764, 11125, 2330, 73, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:622465561", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subsequence P binary"},
   CellID->622465561]},
 "setSeq subsequence P binary"->{
  Cell[406764, 11125, 2330, 73, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:622465561", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq subsequence P binary"},
   CellID->622465561]},
 "ID:2032932287"->{
  Cell[409097, 11200, 1558, 46, 70, "GlobalDeclaration",
   CellTags->{
    "ID:2032932287", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->2032932287]},
 "ID:525775183"->{
  Cell[410658, 11248, 1055, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:525775183", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq transitive P I"},
   CellID->525775183]},
 "setSeq transitive P I"->{
  Cell[410658, 11248, 1055, 29, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:525775183", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq transitive P I"},
   CellID->525775183]},
 "ID:397952331"->{
  Cell[411716, 11279, 1104, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:397952331", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq transitive P II"},
   CellID->397952331]},
 "setSeq transitive P II"->{
  Cell[411716, 11279, 1104, 31, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:397952331", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "setSeq transitive P II"},
   CellID->397952331]},
 "Proof|ID:57707614"->{
  Cell[412977, 11321, 3756, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:57707614", "Proof|ID:57707614-1"},
   CellID->240880461]},
 "Proof|ID:57707614-1"->{
  Cell[412977, 11321, 3756, 100, 70, "ProofInfo",
   CellTags->{"Proof|ID:57707614", "Proof|ID:57707614-1"},
   CellID->240880461]},
 "Proof|ID:710393364"->{
  Cell[417251, 11440, 11267, 262, 70, "ProofInfo",
   CellTags->{"Proof|ID:710393364", "Proof|ID:710393364-1"},
   CellID->127172224]},
 "Proof|ID:710393364-1"->{
  Cell[417251, 11440, 11267, 262, 70, "ProofInfo",
   CellTags->{"Proof|ID:710393364", "Proof|ID:710393364-1"},
   CellID->127172224]},
 "Proof|ID:622465561"->{
  Cell[429039, 11721, 11224, 262, 70, "ProofInfo",
   CellTags->{"Proof|ID:622465561", "Proof|ID:622465561-1"},
   CellID->1443092268]},
 "Proof|ID:622465561-1"->{
  Cell[429039, 11721, 11224, 262, 70, "ProofInfo",
   CellTags->{"Proof|ID:622465561", "Proof|ID:622465561-1"},
   CellID->1443092268]},
 "Proof|ID:525775183"->{
  Cell[440784, 12002, 10071, 236, 70, "ProofInfo",
   CellTags->{"Proof|ID:525775183", "Proof|ID:525775183-1"},
   CellID->143657730]},
 "Proof|ID:525775183-1"->{
  Cell[440784, 12002, 10071, 236, 70, "ProofInfo",
   CellTags->{"Proof|ID:525775183", "Proof|ID:525775183-1"},
   CellID->143657730]},
 "Proof|ID:397952331"->{
  Cell[451375, 12257, 10237, 240, 70, "ProofInfo",
   CellTags->{"Proof|ID:397952331", "Proof|ID:397952331-1"},
   CellID->825469030]},
 "Proof|ID:397952331-1"->{
  Cell[451375, 12257, 10237, 240, 70, "ProofInfo",
   CellTags->{"Proof|ID:397952331", "Proof|ID:397952331-1"},
   CellID->825469030]},
 "ID:1448839763"->{
  Cell[462917, 12540, 673, 16, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1448839763", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1448839763]},
 "ID:1803197151"->{
  Cell[463593, 12558, 793, 19, 70, "GlobalDeclaration",
   CellTags->{
    "ID:1803197151", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->1803197151]},
 "ID:571239857"->{
  Cell[464389, 12579, 1799, 53, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:571239857", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences natRec1", "IR"},
   CellID->571239857]},
 "DomainSequences natRec1"->{
  Cell[464389, 12579, 1799, 53, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:571239857", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "DomainSequences natRec1", "IR"},
   CellID->571239857]},
 "Proof|ID:571239857"->{
  Cell[466345, 12643, 5502, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:571239857", "Proof|ID:571239857-1"},
   CellID->1151616933]},
 "Proof|ID:571239857-1"->{
  Cell[466345, 12643, 5502, 138, 70, "ProofInfo",
   CellTags->{"Proof|ID:571239857", "Proof|ID:571239857-1"},
   CellID->1151616933]},
 "ID:646368107"->{
  Cell[472608, 12808, 791, 23, 33, "GlobalDeclaration",
   CellTags->{
    "ID:646368107", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb"},
   CellID->646368107]},
 "ID:1140411407"->{
  Cell[473931, 12850, 1737, 54, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1140411407", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "isNoetherian alternative \[DoubleRightArrow]"},
   CellID->1140411407]},
 "isNoetherian alternative \[DoubleRightArrow]"->{
  Cell[473931, 12850, 1737, 54, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1140411407", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "isNoetherian alternative \[DoubleRightArrow]"},
   CellID->1140411407]},
 "ID:199914937"->{
  Cell[475671, 12906, 1737, 55, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:199914937", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "isNoetherian alternative \[DoubleLeftArrow]"},
   CellID->199914937]},
 "isNoetherian alternative \[DoubleLeftArrow]"->{
  Cell[475671, 12906, 1737, 55, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:199914937", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", 
     "isNoetherian alternative \[DoubleLeftArrow]"},
   CellID->199914937]},
 "ID:1370074896"->{
  Cell[477411, 12963, 1716, 54, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1370074896", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isNoetherian alternative", "IR"},
   CellID->1370074896]},
 "isNoetherian alternative"->{
  Cell[477411, 12963, 1716, 54, 53, "FormalTextInputFormula",
   CellTags->{
    "ID:1370074896", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "isNoetherian alternative", "IR"},
   CellID->1370074896]},
 "Proof|ID:1140411407"->{
  Cell[479284, 13028, 5150, 134, 28, "ProofInfo",
   CellTags->{"Proof|ID:1140411407", "Proof|ID:1140411407-1"},
   CellID->1132196675]},
 "Proof|ID:1140411407-1"->{
  Cell[479284, 13028, 5150, 134, 28, "ProofInfo",
   CellTags->{"Proof|ID:1140411407", "Proof|ID:1140411407-1"},
   CellID->1132196675]},
 "Proof|ID:199914937"->{
  Cell[484955, 13181, 5102, 130, 26, "ProofInfo",
   CellTags->{"Proof|ID:199914937", "Proof|ID:199914937-1"},
   CellID->1848022108]},
 "Proof|ID:199914937-1"->{
  Cell[484955, 13181, 5102, 130, 26, "ProofInfo",
   CellTags->{"Proof|ID:199914937", "Proof|ID:199914937-1"},
   CellID->1848022108]},
 "Proof|ID:1370074896"->{
  Cell[490577, 13330, 5120, 132, 26, "ProofInfo",
   CellTags->{"Proof|ID:1370074896", "Proof|ID:1370074896-1"},
   CellID->2015968322]},
 "Proof|ID:1370074896-1"->{
  Cell[490577, 13330, 5120, 132, 26, "ProofInfo",
   CellTags->{"Proof|ID:1370074896", "Proof|ID:1370074896-1"},
   CellID->2015968322]},
 "ID:610667129"->{
  Cell[498586, 13562, 2181, 71, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:610667129", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "Dickson domain"},
   CellID->610667129]},
 "Dickson domain"->{
  Cell[498586, 13562, 2181, 71, 70, "FormalTextInputFormula",
   CellTags->{
    "ID:610667129", 
     "Source:/home/amaletzk/Theorema \
Notebooks/ElementaryTheories/Sequences.nb", "Dickson domain"},
   CellID->610667129]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ID:695794617", 538553, 14407},
 {"Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb", \
538830, 14414},
 {"ID:925721429", 559584, 14982},
 {"ID:243637066", 559801, 14989},
 {"ID:458427713", 560018, 14996},
 {"DomainSequences decision predicate", 560307, 15004},
 {"ID:1289924462", 560575, 15012},
 {"ID:230504716", 560794, 15019},
 {"subSeq", 561021, 15026},
 {"ID:809351385", 561254, 15033},
 {"imgSeq", 561481, 15040},
 {"ID:1865902758", 561715, 15047},
 {"tupSeq", 561944, 15054},
 {"ID:238284462", 562179, 15061},
 {"setSeq", 562405, 15068},
 {"ID:1986096562", 562638, 15075},
 {"\[LeftTriangleBar]", 562891, 15082},
 {"ID:489544091", 563138, 15089},
 {"ID:1306945267", 563356, 15096},
 {"ID:638827787", 563575, 15103},
 {"ID:29525805", 563791, 15110},
 {"ID:1744060660", 564007, 15117},
 {"DomainSequences subSeq", 564274, 15124},
 {"IR", 564521, 15131},
 {"ID:1383543831", 569045, 15248},
 {"ID:1895094895", 569265, 15255},
 {"ID:1841507065", 569486, 15262},
 {"sequence transitive P I", 569749, 15269},
 {"ID:1455385635", 570002, 15276},
 {"sequence transitive P II", 570267, 15283},
 {"ID:796771086", 570520, 15290},
 {"subSeq P binary", 570765, 15297},
 {"Proof|ID:1744060660", 571014, 15304},
 {"Proof|ID:1744060660-1", 571176, 15308},
 {"Proof|ID:1841507065", 571336, 15312},
 {"Proof|ID:1841507065-1", 571500, 15316},
 {"Proof|ID:1455385635", 571662, 15320},
 {"Proof|ID:1455385635-1", 571827, 15324},
 {"Proof|ID:796771086", 571989, 15328},
 {"Proof|ID:796771086-1", 572151, 15332},
 {"ID:113922190", 572305, 15336},
 {"ID:936476105", 572591, 15344},
 {"ID:1324913148", 572878, 15352},
 {"DomainSequences \[LeftTriangleBar]", 573244, 15361},
 {"ID:1481705576", 573589, 15370},
 {"ID:794304435", 573877, 15378},
 {"ID:1003845896", 574165, 15386},
 {"\[LeftTriangleBar] P binary", 574505, 15394},
 {"Proof|ID:1324913148", 574837, 15402},
 {"Proof|ID:1324913148-1", 575000, 15406},
 {"Proof|ID:1003845896", 575161, 15410},
 {"Proof|ID:1003845896-1", 575327, 15414},
 {"ID:51050760", 575483, 15418},
 {"ID:1171839467", 575700, 15425},
 {"subSeq 1", 575934, 15432},
 {"ID:756173591", 576172, 15439},
 {"subSeq 2", 576404, 15446},
 {"ID:1593038128", 576641, 15453},
 {"subSeq 3", 576875, 15460},
 {"ID:377390901", 577113, 15467},
 {"subSeq 4", 577345, 15474},
 {"ID:1934441835", 577582, 15481},
 {"subSeq 5", 577816, 15488},
 {"Proof|ID:1171839467", 578061, 15495},
 {"Proof|ID:1171839467-1", 578226, 15499},
 {"Proof|ID:756173591", 578388, 15503},
 {"Proof|ID:756173591-1", 578550, 15507},
 {"Proof|ID:1593038128", 578711, 15511},
 {"Proof|ID:1593038128-1", 578876, 15515},
 {"Proof|ID:377390901", 579038, 15519},
 {"Proof|ID:377390901-1", 579199, 15523},
 {"Proof|ID:1934441835", 579359, 15527},
 {"Proof|ID:1934441835-1", 579523, 15531},
 {"ID:144670545", 579678, 15535},
 {"DomainSequences finite domain", 579952, 15542},
 {"ID:72630978", 580208, 15549},
 {"ID:1747499940", 580425, 15556},
 {"subSeq DomainSequences 1", 580691, 15563},
 {"ID:31395941", 580944, 15570},
 {"subSeq DomainSequences 2", 581206, 15577},
 {"ID:228528973", 581456, 15584},
 {"subSeq DomainSequences 3", 581720, 15591},
 {"ID:854524374", 581972, 15598},
 {"subSeq DomainSequences 4", 582236, 15605},
 {"ID:527068444", 582488, 15612},
 {"subSeq DomainSequences 5", 582752, 15619},
 {"Proof|ID:144670545", 583010, 15626},
 {"Proof|ID:144670545-1", 583171, 15630},
 {"Proof|ID:1747499940", 583331, 15634},
 {"Proof|ID:1747499940-1", 583496, 15638},
 {"Proof|ID:31395941", 583657, 15642},
 {"Proof|ID:31395941-1", 583816, 15646},
 {"Proof|ID:228528973", 583974, 15650},
 {"Proof|ID:228528973-1", 584135, 15654},
 {"Proof|ID:854524374", 584294, 15658},
 {"Proof|ID:854524374-1", 584455, 15662},
 {"Proof|ID:527068444", 584614, 15666},
 {"Proof|ID:527068444-1", 584776, 15670},
 {"ID:21904240", 584929, 15674},
 {"ID:315841131", 585145, 15681},
 {"subSeq DomainSequences 6", 585409, 15688},
 {"Proof|ID:315841131", 585667, 15695},
 {"Proof|ID:315841131-1", 585828, 15699},
 {"ID:432936581", 585981, 15703},
 {"ID:557118158", 586267, 15711},
 {"non-existence seq P", 586589, 15719},
 {"ID:283188144", 586904, 15727},
 {"non-existence seq P binary", 587240, 15735},
 {"ID:44762641", 587561, 15743},
 {"non-existence seq P binary subSeq", 587915, 15752},
 {"Proof|ID:557118158", 588254, 15761},
 {"Proof|ID:557118158-1", 588415, 15765},
 {"Proof|ID:283188144", 588574, 15769},
 {"Proof|ID:283188144-1", 588736, 15773},
 {"Proof|ID:44762641", 588895, 15777},
 {"Proof|ID:44762641-1", 589052, 15781},
 {"ID:1357006098", 589203, 15785},
 {"ID:341801516", 589423, 15792},
 {"ID:627432657", 589641, 15799},
 {"ID:814769285", 589859, 15806},
 {"DomainSequences imgSeq", 590125, 15813},
 {"ID:527722954", 590381, 15820},
 {"subSeq imgSeq", 590629, 15827},
 {"Proof|ID:814769285", 590882, 15834},
 {"Proof|ID:814769285-1", 591044, 15838},
 {"Proof|ID:527722954", 591204, 15842},
 {"Proof|ID:527722954-1", 591365, 15846},
 {"ID:148582272", 591518, 15850},
 {"ID:1254928956", 591737, 15857},
 {"ID:462368090", 591957, 15864},
 {"ID:1139194187", 592176, 15871},
 {"isTuple tupSeq", 592427, 15878},
 {"ID:794519991", 592676, 15885},
 {"tupSeq 1", 592913, 15892},
 {"ID:1371530240", 593155, 15899},
 {"tupSeq +1", 593396, 15906},
 {"ID:1979298560", 593641, 15913},
 {"ID:1953194276", 593862, 15920},
 {"DomainTuples tupSeq", 594123, 15927},
 {"ID:1662300990", 594378, 15934},
 {"DomainSequences tupSeq", 594646, 15941},
 {"Proof|ID:1139194187", 594911, 15948},
 {"Proof|ID:1139194187-1", 595074, 15952},
 {"Proof|ID:794519991", 595234, 15956},
 {"Proof|ID:794519991-1", 595395, 15960},
 {"Proof|ID:1371530240", 595555, 15964},
 {"Proof|ID:1371530240-1", 595718, 15968},
 {"Proof|ID:1953194276", 595879, 15972},
 {"Proof|ID:1953194276-1", 596043, 15976},
 {"Proof|ID:1662300990", 596205, 15980},
 {"Proof|ID:1662300990-1", 596368, 15984},
 {"ID:791300552", 596522, 15988},
 {"ID:1677316354", 596741, 15995},
 {"ID:1304989559", 596962, 16002},
 {"isSet setSeq", 597203, 16009},
 {"ID:600858398", 597444, 16016},
 {"setSeq alternative", 597702, 16023},
 {"ID:1813366458", 597955, 16030},
 {"setSeq 1", 598194, 16037},
 {"ID:282957248", 598437, 16044},
 {"setSeq +1", 598676, 16051},
 {"ID:1456913783", 598919, 16058},
 {"\[Element] setSeq I", 599181, 16065},
 {"ID:2074355943", 599437, 16072},
 {"\[Element] setSeq II", 599701, 16079},
 {"ID:2028876528", 599958, 16086},
 {"\[SubsetEqual] setSeq", 600223, 16093},
 {"ID:919542923", 600479, 16100},
 {"\[SubsetEqual] setSeq ind", 600744, 16107},
 {"ID:1620668672", 600997, 16114},
 {"\[SubsetEqual] setSeq II", 601263, 16121},
 {"ID:1306894362", 601518, 16128},
 {"ID:1977563124", 601739, 16135},
 {"DomainSets setSeq", 601996, 16142},
 {"ID:1963351311", 602249, 16149},
 {"DomainSequences setSeq", 602517, 16156},
 {"Proof|ID:1304989559", 602782, 16163},
 {"Proof|ID:1304989559-1", 602946, 16167},
 {"Proof|ID:600858398", 603107, 16171},
 {"Proof|ID:600858398-1", 603269, 16175},
 {"Proof|ID:1813366458", 603430, 16179},
 {"Proof|ID:1813366458-1", 603594, 16183},
 {"Proof|ID:282957248", 603755, 16187},
 {"Proof|ID:282957248-1", 603916, 16191},
 {"Proof|ID:1456913783", 604076, 16195},
 {"Proof|ID:1456913783-1", 604241, 16199},
 {"Proof|ID:2074355943", 604404, 16203},
 {"Proof|ID:2074355943-1", 604569, 16207},
 {"Proof|ID:2028876528", 604732, 16211},
 {"Proof|ID:2028876528-1", 604896, 16215},
 {"Proof|ID:919542923", 605057, 16219},
 {"Proof|ID:919542923-1", 605219, 16223},
 {"Proof|ID:1620668672", 605380, 16227},
 {"Proof|ID:1620668672-1", 605545, 16231},
 {"Proof|ID:1977563124", 605708, 16235},
 {"Proof|ID:1977563124-1", 605874, 16239},
 {"Proof|ID:1963351311", 606038, 16243},
 {"Proof|ID:1963351311-1", 606202, 16247},
 {"ID:1148013153", 606358, 16251},
 {"ID:1542915564", 606580, 16258},
 {"ID:304038122", 606801, 16265},
 {"ID:57707614", 607019, 16272},
 {"setSeq subSeq \[SubsetEqual]", 607290, 16279},
 {"ID:1967681402", 607546, 16286},
 {"ID:1555261236", 607768, 16293},
 {"ID:710393364", 607990, 16300},
 {"setSeq subSeq P binary", 608251, 16307},
 {"ID:622465561", 608502, 16314},
 {"setSeq subsequence P binary", 608773, 16321},
 {"ID:2032932287", 609030, 16328},
 {"ID:525775183", 609252, 16335},
 {"setSeq transitive P I", 609511, 16342},
 {"ID:397952331", 609761, 16349},
 {"setSeq transitive P II", 610022, 16356},
 {"Proof|ID:57707614", 610278, 16363},
 {"Proof|ID:57707614-1", 610437, 16367},
 {"Proof|ID:710393364", 610595, 16371},
 {"Proof|ID:710393364-1", 610758, 16375},
 {"Proof|ID:622465561", 610919, 16379},
 {"Proof|ID:622465561-1", 611083, 16383},
 {"Proof|ID:525775183", 611245, 16387},
 {"Proof|ID:525775183-1", 611408, 16391},
 {"Proof|ID:397952331", 611569, 16395},
 {"Proof|ID:397952331-1", 611732, 16399},
 {"ID:1448839763", 611888, 16403},
 {"ID:1803197151", 612110, 16410},
 {"ID:571239857", 612331, 16417},
 {"DomainSequences natRec1", 612600, 16424},
 {"Proof|ID:571239857", 612864, 16431},
 {"Proof|ID:571239857-1", 613027, 16435},
 {"ID:646368107", 613182, 16439},
 {"ID:1140411407", 613402, 16446},
 {"isNoetherian alternative \[DoubleRightArrow]", 613715, 16454},
 {"ID:199914937", 613996, 16462},
 {"isNoetherian alternative \[DoubleLeftArrow]", 614305, 16470},
 {"ID:1370074896", 614584, 16478},
 {"isNoetherian alternative", 614857, 16485},
 {"Proof|ID:1140411407", 615125, 16492},
 {"Proof|ID:1140411407-1", 615291, 16496},
 {"Proof|ID:199914937", 615454, 16500},
 {"Proof|ID:199914937-1", 615617, 16504},
 {"Proof|ID:1370074896", 615779, 16508},
 {"Proof|ID:1370074896-1", 615945, 16512},
 {"ID:610667129", 616102, 16516},
 {"Dickson domain", 616347, 16523}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 121, 2, 84, "Title",
 CellID->312331020],
Cell[CellGroupData[{
Cell[725, 28, 116, 2, 73, "Section",
 CellID->909929215],
Cell[CellGroupData[{
Cell[866, 34, 125, 2, 70, "Subsection",
 CellID->332720151],
Cell[994, 38, 344, 8, 70, "Input",
 CellID->498486718],
Cell[1341, 48, 308, 8, 70, "Input",
 CellID->92407312],
Cell[1652, 58, 353, 8, 70, "Input",
 CellID->65743246],
Cell[2008, 68, 150, 3, 70, "Input",
 CellID->5767244],
Cell[2161, 73, 152, 3, 70, "Input",
 CellID->67977463],
Cell[2316, 78, 208, 4, 70, "Input",
 CellID->262499848]
}, Closed]],
Cell[CellGroupData[{
Cell[2561, 87, 124, 2, 70, "Subsection",
 CellID->1386333768],
Cell[CellGroupData[{
Cell[2710, 93, 247, 6, 70, "Input",
 CellID->239327779],
Cell[CellGroupData[{
Cell[2982, 103, 636, 13, 70, "Print",
 CellID->158090628],
Cell[3621, 118, 340, 7, 70, "Print",
 CellID->223865565],
Cell[3964, 127, 634, 13, 70, "Print",
 CellID->320567056],
Cell[4601, 142, 606, 12, 70, "Print",
 CellID->149694710],
Cell[5210, 156, 340, 7, 70, "Print",
 CellID->388967025],
Cell[5553, 165, 608, 12, 70, "Print",
 CellID->417317509],
Cell[6164, 179, 338, 7, 70, "Print",
 CellID->105057068],
Cell[6505, 188, 620, 12, 70, "Print",
 CellID->170344358],
Cell[7128, 202, 341, 7, 70, "Print",
 CellID->59878091],
Cell[7472, 211, 342, 7, 70, "Print",
 CellID->270263721],
Cell[7817, 220, 341, 7, 70, "Print",
 CellID->95964398],
Cell[8161, 229, 344, 7, 70, "Print",
 CellID->182630151],
Cell[8508, 238, 608, 12, 70, "Print",
 CellID->256884688],
Cell[9119, 252, 338, 7, 70, "Print",
 CellID->493680956],
Cell[9460, 261, 342, 7, 70, "Print",
 CellID->237443615],
Cell[9805, 270, 611, 12, 70, "Print",
 CellID->76067169],
Cell[10419, 284, 340, 7, 70, "Print",
 CellID->443696001],
Cell[10762, 293, 341, 7, 70, "Print",
 CellID->78171029],
Cell[11106, 302, 346, 7, 70, "Print",
 CellID->202960436],
Cell[11455, 311, 605, 12, 70, "Print",
 CellID->17723120],
Cell[12063, 325, 342, 7, 70, "Print",
 CellID->326250159],
Cell[12408, 334, 344, 7, 70, "Print",
 CellID->179483095],
Cell[12755, 343, 344, 7, 70, "Print",
 CellID->105179698],
Cell[13102, 352, 344, 7, 70, "Print",
 CellID->306116921],
Cell[13449, 361, 344, 7, 70, "Print",
 CellID->475858624],
Cell[13796, 370, 346, 7, 70, "Print",
 CellID->296224080],
Cell[14145, 379, 613, 12, 70, "Print",
 CellID->723645],
Cell[14761, 393, 339, 7, 70, "Print",
 CellID->74452417],
Cell[15103, 402, 344, 7, 70, "Print",
 CellID->425908128],
Cell[15450, 411, 345, 7, 70, "Print",
 CellID->37595789],
Cell[15798, 420, 344, 7, 70, "Print",
 CellID->524478834],
Cell[16145, 429, 343, 7, 70, "Print",
 CellID->16316289],
Cell[16491, 438, 346, 7, 70, "Print",
 CellID->106640037],
Cell[16840, 447, 344, 7, 70, "Print",
 CellID->494472817],
Cell[17187, 456, 614, 12, 70, "Print",
 CellID->367043018],
Cell[17804, 470, 340, 7, 70, "Print",
 CellID->227672584],
Cell[18147, 479, 344, 7, 70, "Print",
 CellID->157656635],
Cell[18494, 488, 346, 7, 70, "Print",
 CellID->995408888],
Cell[18843, 497, 343, 7, 70, "Print",
 CellID->262024770],
Cell[19189, 506, 624, 12, 70, "Print",
 CellID->260527909],
Cell[19816, 520, 342, 7, 70, "Print",
 CellID->206165272],
Cell[20161, 529, 343, 7, 70, "Print",
 CellID->11435295],
Cell[20507, 538, 344, 7, 70, "Print",
 CellID->263137527],
Cell[20854, 547, 344, 7, 70, "Print",
 CellID->9928849],
Cell[21201, 556, 344, 7, 70, "Print",
 CellID->291474409],
Cell[21548, 565, 612, 12, 70, "Print",
 CellID->375037910],
Cell[22163, 579, 340, 7, 70, "Print",
 CellID->781061712],
Cell[22506, 588, 608, 12, 70, "Print",
 CellID->145606035],
Cell[23117, 602, 340, 7, 70, "Print",
 CellID->248456276],
Cell[23460, 611, 344, 7, 70, "Print",
 CellID->552988536],
Cell[23807, 620, 344, 7, 70, "Print",
 CellID->153771248],
Cell[24154, 629, 345, 7, 70, "Print",
 CellID->10414559],
Cell[24502, 638, 346, 7, 70, "Print",
 CellID->466233970],
Cell[24851, 647, 141, 2, 70, "Print",
 CellID->449905919],
Cell[24995, 651, 133, 2, 70, "Print",
 CellID->733914214],
Cell[25131, 655, 332, 7, 70, "Print",
 CellID->8563035],
Cell[25466, 664, 335, 7, 70, "Print",
 CellID->20227579],
Cell[25804, 673, 335, 7, 70, "Print",
 CellID->83033835],
Cell[26142, 682, 338, 7, 70, "Print",
 CellID->225949661],
Cell[26483, 691, 336, 7, 70, "Print",
 CellID->277792142],
Cell[26822, 700, 337, 7, 70, "Print",
 CellID->11979445],
Cell[27162, 709, 335, 7, 70, "Print",
 CellID->10605067],
Cell[27500, 718, 338, 7, 70, "Print",
 CellID->367067033],
Cell[27841, 727, 338, 7, 70, "Print",
 CellID->308164228],
Cell[28182, 736, 336, 7, 70, "Print",
 CellID->243433680],
Cell[28521, 745, 337, 7, 70, "Print",
 CellID->24298702],
Cell[28861, 754, 337, 7, 70, "Print",
 CellID->30997595],
Cell[29201, 763, 337, 7, 70, "Print",
 CellID->46705460],
Cell[29541, 772, 336, 7, 70, "Print",
 CellID->212524022],
Cell[29880, 781, 338, 7, 70, "Print",
 CellID->276917745],
Cell[30221, 790, 336, 7, 70, "Print",
 CellID->130401517],
Cell[30560, 799, 337, 7, 70, "Print",
 CellID->64754584],
Cell[30900, 808, 336, 7, 70, "Print",
 CellID->218944533],
Cell[31239, 817, 337, 7, 70, "Print",
 CellID->12631768],
Cell[31579, 826, 336, 7, 70, "Print",
 CellID->366898097],
Cell[31918, 835, 338, 7, 70, "Print",
 CellID->379282732],
Cell[32259, 844, 338, 7, 70, "Print",
 CellID->298961362],
Cell[32600, 853, 337, 7, 70, "Print",
 CellID->129431472],
Cell[32940, 862, 340, 7, 70, "Print",
 CellID->817000596],
Cell[33283, 871, 338, 7, 70, "Print",
 CellID->633081491],
Cell[33624, 880, 339, 7, 70, "Print",
 CellID->29050669],
Cell[33966, 889, 339, 7, 70, "Print",
 CellID->28300500],
Cell[34308, 898, 339, 7, 70, "Print",
 CellID->80021108],
Cell[34650, 907, 340, 7, 70, "Print",
 CellID->488103918],
Cell[34993, 916, 337, 7, 70, "Print",
 CellID->54242838],
Cell[35333, 925, 337, 7, 70, "Print",
 CellID->156839950],
Cell[35673, 934, 340, 7, 70, "Print",
 CellID->453347964],
Cell[36016, 943, 339, 7, 70, "Print",
 CellID->16622128],
Cell[36358, 952, 338, 7, 70, "Print",
 CellID->104567740],
Cell[36699, 961, 337, 7, 70, "Print",
 CellID->178526472],
Cell[37039, 970, 340, 7, 70, "Print",
 CellID->503909769],
Cell[37382, 979, 340, 7, 70, "Print",
 CellID->442999571],
Cell[37725, 988, 340, 7, 70, "Print",
 CellID->530543999],
Cell[38068, 997, 340, 7, 70, "Print",
 CellID->366879544],
Cell[38411, 1006, 338, 7, 70, "Print",
 CellID->362480173],
Cell[38752, 1015, 339, 7, 70, "Print",
 CellID->12794165],
Cell[39094, 1024, 338, 7, 70, "Print",
 CellID->403658380],
Cell[39435, 1033, 338, 7, 70, "Print",
 CellID->642787780],
Cell[39776, 1042, 340, 7, 70, "Print",
 CellID->354788248],
Cell[40119, 1051, 338, 7, 70, "Print",
 CellID->340157019],
Cell[40460, 1060, 340, 7, 70, "Print",
 CellID->681856349],
Cell[40803, 1069, 339, 7, 70, "Print",
 CellID->95638345],
Cell[41145, 1078, 338, 7, 70, "Print",
 CellID->2966214],
Cell[41486, 1087, 340, 7, 70, "Print",
 CellID->153090462],
Cell[41829, 1096, 339, 7, 70, "Print",
 CellID->75768980],
Cell[42171, 1105, 338, 7, 70, "Print",
 CellID->297684573],
Cell[42512, 1114, 340, 7, 70, "Print",
 CellID->103101471],
Cell[42855, 1123, 340, 7, 70, "Print",
 CellID->101383971],
Cell[43198, 1132, 339, 7, 70, "Print",
 CellID->44029095],
Cell[43540, 1141, 339, 7, 70, "Print",
 CellID->58616362],
Cell[43882, 1150, 338, 7, 70, "Print",
 CellID->383656149],
Cell[44223, 1159, 340, 7, 70, "Print",
 CellID->895472934],
Cell[44566, 1168, 337, 7, 70, "Print",
 CellID->10637410],
Cell[44906, 1177, 145, 2, 70, "Print",
 CellID->335404350],
Cell[45054, 1181, 124, 2, 70, "Print",
 CellID->250608729]
}, Open  ]],
Cell[45193, 1186, 252, 7, 70, "Output",
 CellID->199348246]
}, Closed]],
Cell[45460, 1196, 394, 10, 70, "Input",
 CellID->1859739660],
Cell[45857, 1208, 1350, 33, 70, "Input",
 CellID->1039312110],
Cell[47210, 1243, 178, 4, 70, "Input",
 CellID->2077551358],
Cell[CellGroupData[{
Cell[47413, 1251, 541, 12, 70, "Input",
 CellID->1909803754],
Cell[47957, 1265, 894, 16, 70, "Output",
 CellID->1365249879]
}, Open  ]],
Cell[48866, 1284, 586, 15, 70, "Input",
 CellID->1780799392],
Cell[CellGroupData[{
Cell[49477, 1303, 496, 12, 70, "Input",
 CellID->63220416],
Cell[49976, 1317, 90, 2, 70, "Output",
 CellID->36314688]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[50115, 1325, 128, 2, 70, "Subsection",
 CellID->1454182661],
Cell[50246, 1329, 985, 25, 70, "Input",
 CellID->2074904605],
Cell[51234, 1356, 416, 9, 70, "Input",
 CellID->1980565193],
Cell[51653, 1367, 169, 3, 70, "Input",
 CellID->444074165],
Cell[51825, 1372, 311, 6, 70, "Input",
 CellID->584704106]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[52185, 1384, 287, 4, 43, "Section",
 CellID->857285562],
Cell[CellGroupData[{
Cell[52497, 1392, 120, 2, 38, "Subsection",
 CellID->1461916963],
Cell[52620, 1396, 48, 1, 12, "OpenEnvironment",
 CellID->1686339578],
Cell[CellGroupData[{
Cell[52693, 1401, 382, 9, 43, "EnvironmentHeader",
 CellID->787375658],
Cell[53078, 1412, 632, 15, 31, "GlobalDeclaration",
 CellTags->{
  "ID:695794617", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->695794617],
Cell[53713, 1429, 708, 17, 30, "GlobalDeclaration",
 CellTags->{
  "ID:925721429", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->925721429],
Cell[54424, 1448, 620, 15, 30, "GlobalDeclaration",
 CellTags->{
  "ID:243637066", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->243637066],
Cell[55047, 1465, 1587, 48, 38, "FormalTextInputFormula",
 CellTags->{
  "ID:458427713", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences decision predicate"},
 CellID->458427713],
Cell[56637, 1515, 66, 1, 26, "EndEnvironmentMarker",
 CellID->1414427201]
}, Open  ]],
Cell[56718, 1519, 49, 1, 16, "CloseEnvironment",
 CellID->1338140004],
Cell[56770, 1522, 834, 24, 63, "Text",
 CellID->923897726],
Cell[57607, 1548, 48, 1, 12, "OpenEnvironment",
 CellID->1026547334],
Cell[CellGroupData[{
Cell[57680, 1553, 573, 13, 43, "EnvironmentHeader",
 CellID->563288901],
Cell[58256, 1568, 709, 16, 30, "GlobalDeclaration",
 CellTags->{
  "ID:1289924462", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1289924462],
Cell[58968, 1586, 1459, 40, 33, "FormalTextInputFormula",
 CellTags->{
  "ID:230504716", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq"},
 CellID->230504716],
Cell[60430, 1628, 1217, 36, 31, "FormalTextInputFormula",
 CellTags->{
  "ID:809351385", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "imgSeq"},
 CellID->809351385],
Cell[61650, 1666, 1348, 39, 47, "FormalTextInputFormula",
 CellTags->{
  "ID:1865902758", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "tupSeq"},
 CellID->1865902758],
Cell[63001, 1707, 970, 27, 21, "FormalTextInputFormula",
 CellTags->{
  "ID:238284462", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq"},
 CellID->238284462],
Cell[63974, 1736, 65, 1, 26, "EndEnvironmentMarker",
 CellID->992250107]
}, Open  ]],
Cell[64054, 1740, 48, 1, 16, "CloseEnvironment",
 CellID->548294931],
Cell[64105, 1743, 47, 1, 12, "OpenEnvironment",
 CellID->124141796],
Cell[CellGroupData[{
Cell[64177, 1748, 512, 13, 43, "EnvironmentHeader",
 CellID->216609509],
Cell[64692, 1763, 1829, 58, 41, "FormalTextInputFormula",
 CellTags->{
  "ID:1986096562", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[LeftTriangleBar]"},
 CellID->1986096562],
Cell[66524, 1823, 66, 1, 26, "EndEnvironmentMarker",
 CellID->1105920236]
}, Open  ]],
Cell[66605, 1827, 48, 1, 16, "CloseEnvironment",
 CellID->986220819]
}, Closed]],
Cell[CellGroupData[{
Cell[66690, 1833, 276, 4, 30, "Subsection",
 CellID->1098258350],
Cell[66969, 1839, 653, 15, 31, "GlobalDeclaration",
 CellTags->{
  "ID:489544091", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->489544091],
Cell[CellGroupData[{
Cell[67647, 1858, 362, 5, 28, "Subsubsection",
 CellID->1909794438],
Cell[68012, 1865, 47, 1, 70, "OpenEnvironment",
 CellID->799034423],
Cell[CellGroupData[{
Cell[68084, 1870, 511, 12, 70, "EnvironmentHeader",
 CellID->481158387],
Cell[68598, 1884, 666, 16, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1306945267", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1306945267],
Cell[69267, 1902, 783, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:638827787", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->638827787],
Cell[70053, 1921, 710, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:29525805", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->29525805],
Cell[70766, 1941, 1397, 38, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1744060660", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences subSeq", "IR"},
 CellID->1744060660],
Cell[72166, 1981, 642, 15, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1383543831", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1383543831],
Cell[72811, 1998, 1572, 48, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1895094895", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1895094895],
Cell[74386, 2048, 1504, 47, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1841507065", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "sequence transitive P I"},
 CellID->1841507065],
Cell[75893, 2097, 1532, 48, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1455385635", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "sequence transitive P II"},
 CellID->1455385635],
Cell[77428, 2147, 1696, 54, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:796771086", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq P binary"},
 CellID->796771086],
Cell[79127, 2203, 66, 1, 70, "EndEnvironmentMarker",
 CellID->2143432809]
}, Open  ]],
Cell[79208, 2207, 48, 1, 70, "CloseEnvironment",
 CellID->708131044],
Cell[CellGroupData[{
Cell[79281, 2212, 3678, 98, 70, "ProofInfo",
 CellTags->{"Proof|ID:1744060660", "Proof|ID:1744060660-1"},
 CellID->121410062],
Cell[82962, 2312, 482, 12, 70, "ProofInfoBody",
 CellID->1535132699]
}, Closed]],
Cell[CellGroupData[{
Cell[83481, 2329, 10206, 244, 70, "ProofInfo",
 CellTags->{"Proof|ID:1841507065", "Proof|ID:1841507065-1"},
 CellID->398706065],
Cell[93690, 2575, 481, 12, 70, "ProofInfoBody",
 CellID->488597049]
}, Closed]],
Cell[CellGroupData[{
Cell[94208, 2592, 10381, 248, 70, "ProofInfo",
 CellTags->{"Proof|ID:1455385635", "Proof|ID:1455385635-1"},
 CellID->1613181412],
Cell[104592, 2842, 481, 12, 70, "ProofInfoBody",
 CellID->872923449]
}, Closed]],
Cell[CellGroupData[{
Cell[105110, 2859, 10783, 256, 70, "ProofInfo",
 CellTags->{"Proof|ID:796771086", "Proof|ID:796771086-1"},
 CellID->567440294],
Cell[115896, 3117, 481, 12, 70, "ProofInfoBody",
 CellID->1432707641]
}, Closed]],
Cell[116392, 3132, 48, 1, 70, "OpenEnvironment",
 CellID->1992449838],
Cell[116443, 3135, 609, 12, 70, "EnvironmentHeader",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->764351212],
Cell[117055, 3149, 823, 18, 70, "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:113922190", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->113922190],
Cell[117881, 3169, 913, 20, 70, "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:936476105", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->936476105],
Cell[118797, 3191, 1270, 32, 70, "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:1324913148", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences \[LeftTriangleBar]", "IR"},
 CellID->1324913148],
Cell[120070, 3225, 810, 18, 70, "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:1481705576", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1481705576],
Cell[120883, 3245, 1757, 50, 70, "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:794304435", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->794304435],
Cell[122643, 3297, 1655, 49, 70, "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:1003845896", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[LeftTriangleBar] P binary"},
 CellID->1003845896],
Cell[124301, 3348, 225, 4, 70, "EndEnvironmentMarker",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->2075582208],
Cell[124529, 3354, 49, 1, 70, "CloseEnvironment",
 CellID->1623627242],
Cell[CellGroupData[{
Cell[124603, 3359, 3646, 97, 70, "ProofInfo",
 CellTags->{"Proof|ID:1324913148", "Proof|ID:1324913148-1"},
 CellID->897924672],
Cell[128252, 3458, 482, 12, 70, "ProofInfoBody",
 CellID->1373935419]
}, Closed]],
Cell[CellGroupData[{
Cell[128771, 3475, 10287, 244, 70, "ProofInfo",
 CellTags->{"Proof|ID:1003845896", "Proof|ID:1003845896-1"},
 CellID->1168681859],
Cell[139061, 3721, 482, 12, 70, "ProofInfoBody",
 CellID->1102065031]
}, Closed]],
Cell[139558, 3736, 48, 1, 70, "OpenEnvironment",
 CellID->1198945339],
Cell[CellGroupData[{
Cell[139631, 3741, 393, 9, 70, "EnvironmentHeader",
 CellID->723824580],
Cell[140027, 3752, 655, 16, 70, "GlobalDeclaration",
 CellTags->{
  "ID:51050760", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->51050760],
Cell[140685, 3770, 1819, 53, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1171839467", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 1"},
 CellID->1171839467],
Cell[142507, 3825, 1672, 51, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:756173591", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 2"},
 CellID->756173591],
Cell[144182, 3878, 1862, 58, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1593038128", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 3"},
 CellID->1593038128],
Cell[146047, 3938, 2025, 62, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:377390901", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 4"},
 CellID->377390901],
Cell[148075, 4002, 2182, 66, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1934441835", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq 5"},
 CellID->1934441835],
Cell[150260, 4070, 65, 1, 70, "EndEnvironmentMarker",
 CellID->387946042]
}, Open  ]],
Cell[150340, 4074, 48, 1, 70, "CloseEnvironment",
 CellID->482332764],
Cell[CellGroupData[{
Cell[150413, 4079, 5625, 146, 70, "ProofInfo",
 CellTags->{"Proof|ID:1171839467", "Proof|ID:1171839467-1"},
 CellID->1009035181],
Cell[156041, 4227, 482, 12, 70, "ProofInfoBody",
 CellID->1623584862]
}, Closed]],
Cell[CellGroupData[{
Cell[156560, 4244, 5620, 146, 70, "ProofInfo",
 CellTags->{"Proof|ID:756173591", "Proof|ID:756173591-1"},
 CellID->1704654642],
Cell[162183, 4392, 481, 12, 70, "ProofInfoBody",
 CellID->1864994181]
}, Closed]],
Cell[CellGroupData[{
Cell[162701, 4409, 6741, 170, 70, "ProofInfo",
 CellTags->{"Proof|ID:1593038128", "Proof|ID:1593038128-1"},
 CellID->1107323890],
Cell[169445, 4581, 482, 12, 70, "ProofInfoBody",
 CellID->2085669265]
}, Closed]],
Cell[CellGroupData[{
Cell[169964, 4598, 7663, 190, 70, "ProofInfo",
 CellTags->{"Proof|ID:377390901", "Proof|ID:377390901-1"},
 CellID->383299987],
Cell[177630, 4790, 481, 12, 70, "ProofInfoBody",
 CellID->1006913240]
}, Closed]],
Cell[CellGroupData[{
Cell[178148, 4807, 8250, 202, 70, "ProofInfo",
 CellTags->{"Proof|ID:1934441835", "Proof|ID:1934441835-1"},
 CellID->519218944],
Cell[186401, 5011, 481, 12, 70, "ProofInfoBody",
 CellID->922881673]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[186931, 5029, 193, 3, 22, "Subsubsection",
 CellID->233591146],
Cell[187127, 5034, 46, 1, 70, "OpenEnvironment",
 CellID->21484693],
Cell[CellGroupData[{
Cell[187198, 5039, 394, 9, 70, "EnvironmentHeader",
 CellID->625353928],
Cell[187595, 5050, 1480, 42, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:144670545", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences finite domain"},
 CellID->144670545],
Cell[189078, 5094, 797, 20, 70, "GlobalDeclaration",
 CellTags->{
  "ID:72630978", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->72630978],
Cell[189878, 5116, 1986, 60, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1747499940", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 1"},
 CellID->1747499940],
Cell[191867, 5178, 1956, 59, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:31395941", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 2"},
 CellID->31395941],
Cell[193826, 5239, 2050, 64, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:228528973", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 3"},
 CellID->228528973],
Cell[195879, 5305, 2244, 69, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:854524374", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 4"},
 CellID->854524374],
Cell[198126, 5376, 2276, 70, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:527068444", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 5"},
 CellID->527068444],
Cell[200405, 5448, 65, 1, 70, "EndEnvironmentMarker",
 CellID->637511678]
}, Open  ]],
Cell[200485, 5452, 47, 1, 70, "CloseEnvironment",
 CellID->51901917],
Cell[CellGroupData[{
Cell[200557, 5457, 4915, 126, 70, "ProofInfo",
 CellTags->{"Proof|ID:144670545", "Proof|ID:144670545-1"},
 CellID->431495423],
Cell[205475, 5585, 480, 12, 70, "ProofInfoBody",
 CellID->175865792]
}, Closed]],
Cell[CellGroupData[{
Cell[205992, 5602, 7088, 176, 70, "ProofInfo",
 CellTags->{"Proof|ID:1747499940", "Proof|ID:1747499940-1"},
 CellID->1369905409],
Cell[213083, 5780, 482, 12, 70, "ProofInfoBody",
 CellID->1124392772]
}, Closed]],
Cell[CellGroupData[{
Cell[213602, 5797, 7078, 176, 70, "ProofInfo",
 CellTags->{"Proof|ID:31395941", "Proof|ID:31395941-1"},
 CellID->1498389165],
Cell[220683, 5975, 478, 12, 70, "ProofInfoBody",
 CellID->65832091]
}, Closed]],
Cell[CellGroupData[{
Cell[221198, 5992, 7908, 194, 70, "ProofInfo",
 CellTags->{"Proof|ID:228528973", "Proof|ID:228528973-1"},
 CellID->670198542],
Cell[229109, 6188, 481, 12, 70, "ProofInfoBody",
 CellID->1200865808]
}, Closed]],
Cell[CellGroupData[{
Cell[229627, 6205, 8846, 214, 70, "ProofInfo",
 CellTags->{"Proof|ID:854524374", "Proof|ID:854524374-1"},
 CellID->295533552],
Cell[238476, 6421, 546, 13, 70, "ProofInfoBody",
 CellID->233940929]
}, Closed]],
Cell[CellGroupData[{
Cell[239059, 6439, 9405, 224, 70, "ProofInfo",
 CellTags->{"Proof|ID:527068444", "Proof|ID:527068444-1"},
 CellID->1572634243],
Cell[248467, 6665, 481, 12, 70, "ProofInfoBody",
 CellID->1975995889]
}, Closed]],
Cell[248963, 6680, 47, 1, 70, "OpenEnvironment",
 CellID->108625658],
Cell[CellGroupData[{
Cell[249035, 6685, 542, 11, 70, "EnvironmentHeader",
 CellID->638654754],
Cell[249580, 6698, 634, 15, 70, "GlobalDeclaration",
 CellTags->{
  "ID:21904240", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->21904240],
Cell[250217, 6715, 2587, 74, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:315841131", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq DomainSequences 6"},
 CellID->315841131],
Cell[252807, 6791, 65, 1, 70, "EndEnvironmentMarker",
 CellID->674170319]
}, Open  ]],
Cell[252887, 6795, 48, 1, 70, "CloseEnvironment",
 CellID->103869578],
Cell[CellGroupData[{
Cell[252960, 6800, 9220, 224, 70, "ProofInfo",
 CellTags->{"Proof|ID:315841131", "Proof|ID:315841131-1"},
 CellID->135253581],
Cell[262183, 7026, 480, 12, 70, "ProofInfoBody",
 CellID->151978007]
}, Closed]],
Cell[262678, 7041, 47, 1, 70, "OpenEnvironment",
 CellID->965034304],
Cell[262728, 7044, 540, 11, 70, "EnvironmentHeader",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->744455432],
Cell[263271, 7057, 731, 17, 70, "GlobalDeclaration",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:432936581", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->432936581],
Cell[264005, 7076, 2168, 66, 70, "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:557118158", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "non-existence seq P"},
 CellID->557118158],
Cell[266176, 7144, 2426, 72, 70, "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:283188144", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "non-existence seq P binary"},
 CellID->283188144],
Cell[268605, 7218, 2976, 89, 70, "FormalTextInputFormula",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellTags->{
  "ID:44762641", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "non-existence seq P binary subSeq"},
 CellID->44762641],
Cell[271584, 7309, 176, 3, 70, "EndEnvironmentMarker",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->2016708524],
Cell[271763, 7314, 49, 1, 70, "CloseEnvironment",
 CellID->1830041516],
Cell[CellGroupData[{
Cell[271837, 7319, 7341, 182, 70, "ProofInfo",
 CellTags->{"Proof|ID:557118158", "Proof|ID:557118158-1"},
 CellID->608671989],
Cell[279181, 7503, 480, 12, 70, "ProofInfoBody",
 CellID->204472239]
}, Closed]],
Cell[CellGroupData[{
Cell[279698, 7520, 8224, 202, 70, "ProofInfo",
 CellTags->{"Proof|ID:283188144", "Proof|ID:283188144-1"},
 CellID->1859154459],
Cell[287925, 7724, 481, 12, 70, "ProofInfoBody",
 CellID->1994023359]
}, Closed]],
Cell[CellGroupData[{
Cell[288443, 7741, 9277, 223, 70, "ProofInfo",
 CellTags->{"Proof|ID:44762641", "Proof|ID:44762641-1"},
 CellID->46003965],
Cell[297723, 7966, 478, 12, 70, "ProofInfoBody",
 CellID->90370019]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[298250, 7984, 245, 5, 22, "Subsubsection",
 CellID->39838153],
Cell[298498, 7991, 664, 16, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1357006098", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1357006098],
Cell[299165, 8009, 48, 1, 70, "OpenEnvironment",
 CellID->1621518880],
Cell[CellGroupData[{
Cell[299238, 8014, 403, 9, 70, "EnvironmentHeader",
 CellID->1970240712],
Cell[299644, 8025, 635, 15, 70, "GlobalDeclaration",
 CellTags->{
  "ID:341801516", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->341801516],
Cell[300282, 8042, 715, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:627432657", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->627432657],
Cell[301000, 8062, 1731, 51, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:814769285", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences imgSeq", "IR"},
 CellID->814769285],
Cell[302734, 8115, 1367, 40, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:527722954", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "subSeq imgSeq", "IR"},
 CellID->527722954],
Cell[304104, 8157, 65, 1, 70, "EndEnvironmentMarker",
 CellID->562890915]
}, Open  ]],
Cell[304184, 8161, 49, 1, 70, "CloseEnvironment",
 CellID->1299180967],
Cell[CellGroupData[{
Cell[304258, 8166, 4860, 124, 70, "ProofInfo",
 CellTags->{"Proof|ID:814769285", "Proof|ID:814769285-1"},
 CellID->1610479839],
Cell[309121, 8292, 480, 12, 70, "ProofInfoBody",
 CellID->174940712]
}, Closed]],
Cell[CellGroupData[{
Cell[309638, 8309, 4195, 110, 70, "ProofInfo",
 CellTags->{"Proof|ID:527722954", "Proof|ID:527722954-1"},
 CellID->503452461],
Cell[313836, 8421, 480, 12, 70, "ProofInfoBody",
 CellID->332933660]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[314365, 8439, 441, 6, 22, "Subsubsection",
 CellID->599814689],
Cell[314809, 8447, 663, 16, 70, "GlobalDeclaration",
 CellTags->{
  "ID:148582272", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->148582272],
Cell[315475, 8465, 47, 1, 70, "OpenEnvironment",
 CellID->111632028],
Cell[CellGroupData[{
Cell[315547, 8470, 508, 12, 70, "EnvironmentHeader",
 CellID->1413443761],
Cell[316058, 8484, 689, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1254928956", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1254928956],
Cell[316750, 8503, 694, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:462368090", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->462368090],
Cell[317447, 8522, 795, 21, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1139194187", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isTuple tupSeq", "IR"},
 CellID->1139194187],
Cell[318245, 8545, 869, 24, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:794519991", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "tupSeq 1", "IR"},
 CellID->794519991],
Cell[319117, 8571, 965, 29, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1371530240", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "tupSeq +1", "IR"},
 CellID->1371530240],
Cell[320085, 8602, 771, 19, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1979298560", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1979298560],
Cell[320859, 8623, 951, 25, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1953194276", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainTuples tupSeq", "IR"},
 CellID->1953194276],
Cell[321813, 8650, 1117, 27, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1662300990", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences tupSeq", "IR"},
 CellID->1662300990],
Cell[322933, 8679, 66, 1, 70, "EndEnvironmentMarker",
 CellID->2021563103]
}, Open  ]],
Cell[323014, 8683, 49, 1, 70, "CloseEnvironment",
 CellID->1824927207],
Cell[CellGroupData[{
Cell[323088, 8688, 2612, 76, 70, "ProofInfo",
 CellTags->{"Proof|ID:1139194187", "Proof|ID:1139194187-1"},
 CellID->943422580],
Cell[325703, 8766, 482, 12, 70, "ProofInfoBody",
 CellID->1204429517]
}, Closed]],
Cell[CellGroupData[{
Cell[326222, 8783, 2569, 78, 70, "ProofInfo",
 CellTags->{"Proof|ID:794519991", "Proof|ID:794519991-1"},
 CellID->1464040180],
Cell[328794, 8863, 481, 12, 70, "ProofInfoBody",
 CellID->1313144744]
}, Closed]],
Cell[CellGroupData[{
Cell[329312, 8880, 3484, 98, 70, "ProofInfo",
 CellTags->{"Proof|ID:1371530240", "Proof|ID:1371530240-1"},
 CellID->215916439],
Cell[332799, 8980, 482, 12, 70, "ProofInfoBody",
 CellID->1464403863]
}, Closed]],
Cell[CellGroupData[{
Cell[333318, 8997, 3960, 106, 70, "ProofInfo",
 CellTags->{"Proof|ID:1953194276", "Proof|ID:1953194276-1"},
 CellID->709826783],
Cell[337281, 9105, 552, 13, 70, "ProofInfoBody",
 CellID->1762868189]
}, Closed]],
Cell[CellGroupData[{
Cell[337870, 9123, 3210, 88, 70, "ProofInfo",
 CellTags->{"Proof|ID:1662300990", "Proof|ID:1662300990-1"},
 CellID->103093795],
Cell[341083, 9213, 526, 13, 70, "ProofInfoBody",
 CellID->1183821222]
}, Closed]],
Cell[341624, 9229, 48, 1, 70, "OpenEnvironment",
 CellID->1002113064],
Cell[CellGroupData[{
Cell[341697, 9234, 557, 12, 70, "EnvironmentHeader",
 CellID->731916267],
Cell[342257, 9248, 735, 18, 70, "GlobalDeclaration",
 CellTags->{
  "ID:791300552", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->791300552],
Cell[342995, 9268, 699, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1677316354", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1677316354],
Cell[343697, 9287, 783, 21, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1304989559", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isSet setSeq"},
 CellID->1304989559],
Cell[344483, 9310, 1150, 31, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:600858398", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq alternative", "IR"},
 CellID->600858398],
Cell[345636, 9343, 854, 24, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1813366458", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq 1", "IR"},
 CellID->1813366458],
Cell[346493, 9369, 939, 27, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:282957248", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq +1", "IR"},
 CellID->282957248],
Cell[347435, 9398, 1549, 51, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1456913783", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[Element] setSeq I", "IR"},
 CellID->1456913783],
Cell[348987, 9451, 1048, 31, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:2074355943", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[Element] setSeq II", "IR"},
 CellID->2074355943],
Cell[350038, 9484, 885, 24, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:2028876528", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[SubsetEqual] setSeq", "IR"},
 CellID->2028876528],
Cell[350926, 9510, 968, 26, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:919542923", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[SubsetEqual] setSeq ind"},
 CellID->919542923],
Cell[351897, 9538, 1008, 27, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1620668672", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "\[SubsetEqual] setSeq II"},
 CellID->1620668672],
Cell[352908, 9567, 769, 19, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1306894362", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1306894362],
Cell[353680, 9588, 922, 25, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1977563124", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSets setSeq", "IR"},
 CellID->1977563124],
Cell[354605, 9615, 1020, 26, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:1963351311", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences setSeq", "IR"},
 CellID->1963351311],
Cell[355628, 9643, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1378714125]
}, Open  ]],
Cell[355709, 9647, 48, 1, 70, "CloseEnvironment",
 CellID->403992653],
Cell[CellGroupData[{
Cell[355782, 9652, 2605, 76, 70, "ProofInfo",
 CellTags->{"Proof|ID:1304989559", "Proof|ID:1304989559-1"},
 CellID->1710781526],
Cell[358390, 9730, 482, 12, 70, "ProofInfoBody",
 CellID->2031883802]
}, Closed]],
Cell[CellGroupData[{
Cell[358909, 9747, 3706, 100, 70, "ProofInfo",
 CellTags->{"Proof|ID:600858398", "Proof|ID:600858398-1"},
 CellID->1970211136],
Cell[362618, 9849, 481, 12, 70, "ProofInfoBody",
 CellID->1307335873]
}, Closed]],
Cell[CellGroupData[{
Cell[363136, 9866, 2487, 76, 70, "ProofInfo",
 CellTags->{"Proof|ID:1813366458", "Proof|ID:1813366458-1"},
 CellID->1785703456],
Cell[365626, 9944, 481, 12, 70, "ProofInfoBody",
 CellID->940005247]
}, Closed]],
Cell[CellGroupData[{
Cell[366144, 9961, 3567, 100, 70, "ProofInfo",
 CellTags->{"Proof|ID:282957248", "Proof|ID:282957248-1"},
 CellID->257579260],
Cell[369714, 10063, 481, 12, 70, "ProofInfoBody",
 CellID->1452926057]
}, Closed]],
Cell[CellGroupData[{
Cell[370232, 10080, 4166, 112, 70, "ProofInfo",
 CellTags->{"Proof|ID:1456913783", "Proof|ID:1456913783-1"},
 CellID->660915054],
Cell[374401, 10194, 481, 12, 70, "ProofInfoBody",
 CellID->122844036]
}, Closed]],
Cell[CellGroupData[{
Cell[374919, 10211, 3305, 92, 70, "ProofInfo",
 CellTags->{"Proof|ID:2074355943", "Proof|ID:2074355943-1"},
 CellID->1118991764],
Cell[378227, 10305, 481, 12, 70, "ProofInfoBody",
 CellID->760690908]
}, Closed]],
Cell[CellGroupData[{
Cell[378745, 10322, 3056, 86, 70, "ProofInfo",
 CellTags->{"Proof|ID:2028876528", "Proof|ID:2028876528-1"},
 CellID->594436158],
Cell[381804, 10410, 481, 12, 70, "ProofInfoBody",
 CellID->303866791]
}, Closed]],
Cell[CellGroupData[{
Cell[382322, 10427, 3428, 94, 70, "ProofInfo",
 CellTags->{"Proof|ID:919542923", "Proof|ID:919542923-1"},
 CellID->1947715984],
Cell[385753, 10523, 480, 12, 70, "ProofInfoBody",
 CellID->299306856]
}, Closed]],
Cell[CellGroupData[{
Cell[386270, 10540, 3657, 98, 70, "ProofInfo",
 CellTags->{"Proof|ID:1620668672", "Proof|ID:1620668672-1"},
 CellID->1297375468],
Cell[389930, 10640, 481, 12, 70, "ProofInfoBody",
 CellID->958645388]
}, Closed]],
Cell[CellGroupData[{
Cell[390448, 10657, 3953, 106, 70, "ProofInfo",
 CellTags->{"Proof|ID:1977563124", "Proof|ID:1977563124-1"},
 CellID->1381526050],
Cell[394404, 10765, 482, 12, 70, "ProofInfoBody",
 CellID->1576193163]
}, Closed]],
Cell[CellGroupData[{
Cell[394923, 10782, 3384, 92, 70, "ProofInfo",
 CellTags->{"Proof|ID:1963351311", "Proof|ID:1963351311-1"},
 CellID->410175681],
Cell[398310, 10876, 481, 12, 70, "ProofInfoBody",
 CellID->283292552]
}, Closed]],
Cell[398806, 10891, 47, 1, 70, "OpenEnvironment",
 CellID->997501851],
Cell[CellGroupData[{
Cell[398878, 10896, 379, 9, 70, "EnvironmentHeader",
 CellID->1684644361],
Cell[399260, 10907, 893, 19, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1148013153", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1148013153],
Cell[400156, 10928, 689, 17, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1542915564", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1542915564],
Cell[400848, 10947, 747, 19, 70, "GlobalDeclaration",
 CellTags->{
  "ID:304038122", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->304038122],
Cell[401598, 10968, 1135, 30, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:57707614", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq subSeq \[SubsetEqual]"},
 CellID->57707614],
Cell[402736, 11000, 638, 15, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1967681402", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1967681402],
Cell[403377, 11017, 1276, 38, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1555261236", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1555261236],
Cell[404656, 11057, 2105, 66, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:710393364", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq subSeq P binary"},
 CellID->710393364],
Cell[406764, 11125, 2330, 73, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:622465561", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq subsequence P binary"},
 CellID->622465561],
Cell[409097, 11200, 1558, 46, 70, "GlobalDeclaration",
 CellTags->{
  "ID:2032932287", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->2032932287],
Cell[410658, 11248, 1055, 29, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:525775183", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq transitive P I"},
 CellID->525775183],
Cell[411716, 11279, 1104, 31, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:397952331", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "setSeq transitive P II"},
 CellID->397952331],
Cell[412823, 11312, 65, 1, 70, "EndEnvironmentMarker",
 CellID->216509956]
}, Open  ]],
Cell[412903, 11316, 49, 1, 70, "CloseEnvironment",
 CellID->1092859258],
Cell[CellGroupData[{
Cell[412977, 11321, 3756, 100, 70, "ProofInfo",
 CellTags->{"Proof|ID:57707614", "Proof|ID:57707614-1"},
 CellID->240880461],
Cell[416736, 11423, 478, 12, 70, "ProofInfoBody",
 CellID->61395463]
}, Closed]],
Cell[CellGroupData[{
Cell[417251, 11440, 11267, 262, 70, "ProofInfo",
 CellTags->{"Proof|ID:710393364", "Proof|ID:710393364-1"},
 CellID->127172224],
Cell[428521, 11704, 481, 12, 70, "ProofInfoBody",
 CellID->1754240357]
}, Closed]],
Cell[CellGroupData[{
Cell[429039, 11721, 11224, 262, 70, "ProofInfo",
 CellTags->{"Proof|ID:622465561", "Proof|ID:622465561-1"},
 CellID->1443092268],
Cell[440266, 11985, 481, 12, 70, "ProofInfoBody",
 CellID->1086243377]
}, Closed]],
Cell[CellGroupData[{
Cell[440784, 12002, 10071, 236, 70, "ProofInfo",
 CellTags->{"Proof|ID:525775183", "Proof|ID:525775183-1"},
 CellID->143657730],
Cell[450858, 12240, 480, 12, 70, "ProofInfoBody",
 CellID->103241608]
}, Closed]],
Cell[CellGroupData[{
Cell[451375, 12257, 10237, 240, 70, "ProofInfo",
 CellTags->{"Proof|ID:397952331", "Proof|ID:397952331-1"},
 CellID->825469030],
Cell[461615, 12499, 481, 12, 70, "ProofInfoBody",
 CellID->1841738698]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[462145, 12517, 242, 4, 22, "Subsubsection",
 CellID->979798864],
Cell[462390, 12523, 47, 1, 70, "OpenEnvironment",
 CellID->875877332],
Cell[CellGroupData[{
Cell[462462, 12528, 452, 10, 70, "EnvironmentHeader",
 CellID->1290937647],
Cell[462917, 12540, 673, 16, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1448839763", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1448839763],
Cell[463593, 12558, 793, 19, 70, "GlobalDeclaration",
 CellTags->{
  "ID:1803197151", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->1803197151],
Cell[464389, 12579, 1799, 53, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:571239857", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "DomainSequences natRec1", "IR"},
 CellID->571239857],
Cell[466191, 12634, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1264693290]
}, Open  ]],
Cell[466272, 12638, 48, 1, 70, "CloseEnvironment",
 CellID->851206410],
Cell[CellGroupData[{
Cell[466345, 12643, 5502, 138, 70, "ProofInfo",
 CellTags->{"Proof|ID:571239857", "Proof|ID:571239857-1"},
 CellID->1151616933],
Cell[471850, 12783, 481, 12, 70, "ProofInfoBody",
 CellID->1250697138]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[472380, 12801, 225, 5, 22, "Subsubsection",
 CellID->1533920470],
Cell[472608, 12808, 791, 23, 33, "GlobalDeclaration",
 CellTags->{
  "ID:646368107", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb"},
 CellID->646368107],
Cell[473402, 12833, 48, 1, 12, "OpenEnvironment",
 CellID->1976234692],
Cell[CellGroupData[{
Cell[473475, 12838, 453, 10, 43, "EnvironmentHeader",
 CellID->144716839],
Cell[473931, 12850, 1737, 54, 53, "FormalTextInputFormula",
 CellTags->{
  "ID:1140411407", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isNoetherian alternative \[DoubleRightArrow]"},
 CellID->1140411407],
Cell[475671, 12906, 1737, 55, 53, "FormalTextInputFormula",
 CellTags->{
  "ID:199914937", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isNoetherian alternative \[DoubleLeftArrow]"},
 CellID->199914937],
Cell[477411, 12963, 1716, 54, 53, "FormalTextInputFormula",
 CellTags->{
  "ID:1370074896", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "isNoetherian alternative", "IR"},
 CellID->1370074896],
Cell[479130, 13019, 66, 1, 26, "EndEnvironmentMarker",
 CellID->1985690430]
}, Open  ]],
Cell[479211, 13023, 48, 1, 16, "CloseEnvironment",
 CellID->266751900],
Cell[CellGroupData[{
Cell[479284, 13028, 5150, 134, 28, "ProofInfo",
 CellTags->{"Proof|ID:1140411407", "Proof|ID:1140411407-1"},
 CellID->1132196675],
Cell[484437, 13164, 481, 12, 70, "ProofInfoBody",
 CellID->426882134]
}, Closed]],
Cell[CellGroupData[{
Cell[484955, 13181, 5102, 130, 26, "ProofInfo",
 CellTags->{"Proof|ID:199914937", "Proof|ID:199914937-1"},
 CellID->1848022108],
Cell[490060, 13313, 480, 12, 70, "ProofInfoBody",
 CellID->747427303]
}, Closed]],
Cell[CellGroupData[{
Cell[490577, 13330, 5120, 132, 26, "ProofInfo",
 CellTags->{"Proof|ID:1370074896", "Proof|ID:1370074896-1"},
 CellID->2015968322],
Cell[495700, 13464, 482, 12, 70, "ProofInfoBody",
 CellID->1932073843]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[496255, 13484, 242, 4, 43, "Section",
 CellID->1470860699],
Cell[CellGroupData[{
Cell[496522, 13492, 128, 2, 38, "Subsection",
 CellID->638816316],
Cell[496653, 13496, 1319, 41, 70, "Text",
 CellID->1469052720]
}, Closed]],
Cell[CellGroupData[{
Cell[498009, 13542, 118, 2, 30, "Subsection",
 CellID->562649382],
Cell[498130, 13546, 48, 1, 70, "OpenEnvironment",
 CellID->1973229411],
Cell[CellGroupData[{
Cell[498203, 13551, 380, 9, 70, "EnvironmentHeader",
 CellID->1054407908],
Cell[498586, 13562, 2181, 71, 70, "FormalTextInputFormula",
 CellTags->{
  "ID:610667129", 
   "Source:/home/amaletzk/Theorema Notebooks/ElementaryTheories/Sequences.nb",
    "Dickson domain"},
 CellID->610667129],
Cell[500770, 13635, 66, 1, 70, "EndEnvironmentMarker",
 CellID->1499268482]
}, Open  ]],
Cell[500851, 13639, 48, 1, 70, "CloseEnvironment",
 CellID->833346990]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
